/* $Id: mixer.h,v 1.3 2003/06/23 18:19:05 cochran Exp $
 *
 *  Copyright (c) 2003 Richard Cochran (cochran@cs.umass.edu)
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of the
 *  License, or (at your option) any later version.
 */
#ifndef _HAVE_MIXER_H
#define _HAVE_MIXER_H

struct mixerchannel {
  u16 osschannel;   /* Type of OSS channel */
  u16 value;        /* Current OSS value */
  u8  volctl;       /* Feature unit id for VOLUME */
  u8  mutectl;      /* Feature unit id for MUTE */
  u8  leftch;       /* Feature unit channel number, where zero means */
  u8  rightch;      /*  a mono control using the master FU channel   */
  s16 min;          /* USB min value */
  s16 max;          /* USB max value */
  s16 step;         /* USB resolution */
};

struct mixerdev {
  struct list_head list;
  struct extigy *state;
  unsigned char type;         /* RECORD or PLAYBACK */
  unsigned short selector;    /* For setting the recording source */
  int ossmixer;               /* soundcore stuff */
  unsigned char iface;        /* interface number of AudioControl interface */
  unsigned int numch, modcnt; /* USB format descriptions */
  struct mixerchannel ch[0];  /* mixch is last and gets allocated dynamically */
};

void exaudio_init_mixers(struct extigy *s,unsigned int ctrlif);

#endif
