#ifndef _MGABES_H
#define _MGABES_H

#define BES_HFILTER 	1
#define BES_VFILTER 	2
#define BES_ACC2XZOOM  	4
#define BES_DITHER 	8
#define BES_BW 		16
#define BES_DEINTERLACE	64
#define BES_BLANK       128
#define BES_MIRROR      256
/* Uh ! Find a better name for this ?
(this means, when we do not deinterlace, we
ignore window switches to a top field : we wait
the window switch for the bottom field and display
everything then. so interlaced/deinterlaced feature
is in the BES only) */
#define BES_WAITFIELD2  512

#define BES_FRAME_A	0
#define BES_FIELD_A1	0
#define BES_FIELD_A2	1

#define BES_FRAME_B	2
#define BES_FIELD_B1	2
#define BES_FIELD_B2	3

#define BES_FRAME_AUTO	4

void mgabes_attach(struct mga_dev_s *mga);
void mgabes_deattach(struct mga_bes_s *mga);
void mgabes_set_window(struct mga_bes_s *bes, int x, int y, int width, int height);
void mgabes_set_source(struct mga_bes_s *bes, int x, int y, int width, int height);
void mgabes_set_buffers(struct mga_bes_s *bes, u32 base_a, u32 base_b, int width, int height, int dataformat);
void mgabes_set_crop(struct mga_bes_s *bes, int left, int right, int top, int bottom);
void mgabes_set_keymode(struct mga_bes_s *bes, int mode);
void mgabes_set_colorkey(struct mga_bes_s *bes, u32 chromakey);
void mgabes_set_frame(struct mga_bes_s *bes, int frame);
void mgabes_quick_set_frame(struct mga_bes_s *bes, int frame, u32 buffer);
void mgabes_set_mode(struct mga_bes_s *bes, int mode);
void mgabes_activate(struct mga_bes_s* bes);
void mgabes_desactivate(struct mga_bes_s* bes);

/*
 * helper functions
 */
unsigned int mgabes_pitch_rounding(struct mga_bes_s *bes, int width);

#endif /* _MGABES_H */
