/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
*  *****   *****  **   ** **   **  *****  **   **    **   **
* **   ** **   ** *** *** *** *** **   ** ***  **    **   **
* **      **   ** ******* ******* **   ** **** **    **   **
* **      **   ** ** * ** ** * ** **   ** ** ****    *******
* **      **   ** **   ** **   ** **   ** **  ***    **   **
* **   ** **   ** **   ** **   ** **   ** **   **    **   **
*  *****   *****  **   ** **   **  *****  **   ** ** **   **
*
*****************************************************************************
*
* Declaration of functions shared between two or more UDIs.
*
* THESE FUNCTIONS ARE FOR INTERNAL USE ONLY, but need to be declared for
* the type definition of the UDI data space, UDI_DATA_T.
*
*****************************************************************************
*
* Copyright (C) 1996-98 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/









RETCODE_T UDT_INTER_MODULE
common_compare(
    IN    P_UDI_DATA_T                 udids_ptr,
    IN    PCLIENT_BYTE_T               string1,
    IN    PCLIENT_BYTE_T               string2,
    IN    UINT_T                       length);




VOID_T UDT_INTER_MODULE
common_copy(
    IN    P_UDI_DATA_T                 udids_ptr,
    OUT   PCLIENT_BYTE_T               dest,
    IN    PCLIENT_BYTE_T               src,
    IN    UINT_T                       length);




BOOLEAN_T UDT_INTER_MODULE
common_check_for_unknown(
    IN    P_UDI_DATA_T                 udids_ptr);







typedef WORD_T
(UDT_INDIRECT * HC46_READ_WORD_T)(
    IN P_UDI_DATA_T    udids_ptr,
    BYTE_T             addr);




typedef RETCODE_T
(UDT_INDIRECT * HC46_WRITE_WORD_T)(
    IN P_UDI_DATA_T    udids_ptr,
    BYTE_T             addr,
    WORD_T             data_word);



typedef BOOLEAN_T
(UDT_INDIRECT *COMMON_CHECK_ADAPTER_IS_PRESENT_T)(
    INOUT P_UDI_DATA_T udids_ptr);



typedef RETCODE_T
(UDT_INDIRECT *COMMON_DISPATCH_COMMAND_T)(
    INOUT P_UDI_DATA_T               udids_ptr,
    IN    P_ASYNC_COMMAND_PACKET_T   queue_element_pointer);




VOID_T UDT_INTER_MODULE
common_command_complete(
    INOUT P_UDI_DATA_T                       udids_ptr,
    OUT   PCLIENT_UPCALL_COMMAND_COMPLETE_T  completion_ptr,
    OUT   PCLIENT_UDT_ARGUMENT_T             argument_ptr);



VOID_T UDT_INTER_MODULE
common_dequeue_command_if_possible(
    INOUT P_UDI_DATA_T                       udids_ptr);




#if defined(STRAIGHTBLUEISA_UDI) || \
    defined(STRAIGHTBLUEMC_UDI)  || \
    defined(BLUEPLUS_UDI)

RETCODE_T UDT_INTER_MODULE
common_transmit_dir_frame(
    INOUT P_UDI_DATA_T                       udids_ptr);

#endif




#ifdef UDT_ADAPTER_CONFIGURATION

BOOLEAN_T UDT_INTER_MODULE
common_can_configure(
    IN P_UDI_DATA_T                          udids_ptr);

#endif




UINT_T UDT_INDIRECT
common_null_read_interrupt_status(
    INOUT P_UDI_DATA_T              udids_ptr);



#ifdef UDT_REGENERATE_INTERRUPTS

RETCODE_T UDT_INDIRECT
common_null_regenerate_adapter_interrupt(
    INOUT P_UDI_DATA_T udids_ptr);

#endif 





#   define COMMON_COMPARE(_p, _a, _b, _c)                                   \
           common_compare(_p, _a, _b, _c)

#   define COMMON_COPY(_p, _a, _b, _c)                                      \
           common_copy(_p, _a, _b, _c)

#   define COMMON_CHECK_FOR_UNKNOWN(_p)                                     \
           common_check_for_unknown(_p)




#   define COMMON_COMMAND_COMPLETE(_p, _a, _b)                              \
           common_command_complete(_p, _a, _b)

#   define COMMON_DEQUEUE_COMMAND_IF_POSSIBLE(_p)                           \
           common_dequeue_command_if_possible(_p)

#if defined(STRAIGHTBLUEISA_UDI) ||                                         \
    defined(STRAIGHTBLUEMC_UDI)  ||                                         \
    defined(BLUEPLUS_UDI)

#   define COMMON_TRANSMIT_DIR_FRAME(_p)                                    \
           common_transmit_dir_frame(_p)

#endif

#ifdef UDT_ADAPTER_CONFIGURATION

#   define UDI_CAN_CONFIGURE(_p)                                            \
           common_can_configure(_p)

#endif




typedef struct _COMMON_RES_T
{

    

    COMMON_CHECK_ADAPTER_IS_PRESENT_T   common_check_adapter_is_present;

#   define COMMON_CHECK_ADAPTER_IS_PRESENT(_p)                              \
           (COMMON_RES_FROM_UDIDS(_p).common_check_adapter_is_present(      \
                                   (_p)))

    

    COMMON_DISPATCH_COMMAND_T           common_dispatch_command;

#   define COMMON_DISPATCH_COMMAND(_p, _a)                                  \
           (COMMON_RES_FROM_UDIDS(_p).common_dispatch_command(              \
                                   (_p),                                    \
                                   (_a)))

    

    HC46_READ_WORD_T                    hc46_read_word;

#   define UDI_HC46_READ_WORD(_p, _a)                                       \
           (COMMON_RES_FROM_UDIDS(_p).hc46_read_word(                       \
                                   (_p),                                    \
                                   (_a)))

    HC46_WRITE_WORD_T                   hc46_write_word;

#   define UDI_HC46_WRITE_WORD(_p, _a, _b)                                  \
           (COMMON_RES_FROM_UDIDS(_p).hc46_write_word(                      \
                                   (_p),                                    \
                                   (_a),                                    \
                                   (_b)))

} COMMON_RES_T,
  FAR_DATA  *P_COMMON_RES_T;




