/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
*  *****   *****  **   ** ******* ****  *****      *****
* **   ** **   ** ***  **  **   *  **  **   **    **   **
* **      **   ** **** **  ** *    **  **   **    **
* **      **   ** ** ****  ****    **  **         **
* **      **   ** **  ***  ** *    **  ** ****    **
* **   ** **   ** **   **  **      **  **   **    **   **
*  *****   *****  **   ** ****    ****  *****  **  *****
*
*****************************************************************************
*
* Configuration functions common to all UDIs.
*
*****************************************************************************
*
* Copyright (C) 1996-98 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/



#define UDI_MODULE

#include "udt_driver.h"


#ifdef UDI_ENABLED




RETCODE_T UDT_INTER_MODULE
common_compare(
    IN    P_UDI_DATA_T               udids_ptr,
    IN    PCLIENT_BYTE_T             string1,
    IN    PCLIENT_BYTE_T             string2,
    IN    UINT_T                     length)
{
    UINT_T   count;

    for(count = 0; count < length; count++)
    {
        if(*(string1++) != *(string2++))
        {
            return 1;
        }
    }

    return 0;
}



VOID_T UDT_INTER_MODULE
common_copy(
    IN    P_UDI_DATA_T               udids_ptr,
    OUT   PCLIENT_BYTE_T             dest,
    IN    PCLIENT_BYTE_T             src,
    IN    UINT_T                     length)
{
    UINT_T                count;

    for(count=0;count<length;count++)
    {
        *(dest++) = *(src++);
    }

    return;
}



BOOLEAN_T UDT_INTER_MODULE
common_check_for_unknown(
    IN P_UDI_DATA_T       udids_ptr)
{
    UINT_T                i;
    P_STATIC_PARAMETERS_T sparams    = STATIC_FROM_UDIDS(udids_ptr);
    P_CONFIG_PARAMETERS_T cparams    = CONFIG_FROM_UDIDS(udids_ptr);

    if (sparams->static_complete == FALSE)
    {
        return FALSE;
    }



#define CONFIG_CHECK(field_c, message)                                      \
        if(GET_CONFIG_STATUS(cparams, field_c) == STATUS_UNKNOWN)           \
        {                                                                   \
            POKE_CFG(PO_WHITE, "Config unknown:" message);                  \
            return FALSE;                                                   \
        }



#define CONFIG_IF_STATIC_CHECK(field_s, field_c, message)                   \
        if((GET_STATIC_STATUS(sparams, field_s) != STATUS_UNKNOWN) &&       \
           (GET_CONFIG_STATUS(cparams, field_c) == STATUS_UNKNOWN))         \
        {                                                                   \
            POKE_CFG(PO_WHITE, "Config unknown:" message);                  \
            return FALSE;                                                   \
        }

    CONFIG_IF_STATIC_CHECK(
        irq_mask,
        irq,
        "irq");

    CONFIG_IF_STATIC_CHECK(
        dma_channel_mask,
        dma_channel,
        "dma_channel");

    CONFIG_IF_STATIC_CHECK(
        shared_override_mask,
        shared_override,
        "shared_override");

    CONFIG_IF_STATIC_CHECK(
        xfer_method_mask,
        xfer_method,
        "xfer_method");

    CONFIG_IF_STATIC_CHECK(
        ring_speed_mask,
        ring_speed,
        "ring_speed");

    CONFIG_IF_STATIC_CHECK(
        dtr_options_mask,
        dtr_options,
        "dtr_options");

#   ifdef UDT_USE_WATCHDOG
    CONFIG_IF_STATIC_CHECK(
        max_watchdog_period,
        watchdog_period,
        "watchdog_period");
#   endif

    for(i = 0; i < MAX_IO_REGIONS; i++)
    {
       CONFIG_IF_STATIC_CHECK(
           io_base[i],
           io_handle[i],
           "io_handle");
    }

    CONFIG_IF_STATIC_CHECK(
        pci_number,
        pci_handle,
        "pci_handle");

    for(i = 0; i < MAX_SHARED_REGIONS; i++)
    {
       CONFIG_IF_STATIC_CHECK(
           shared_phys[i],
           shared_handle[i],
           "shared_handle");


       CONFIG_IF_STATIC_CHECK(
           shared_phys[i],
           init_shared_handle[i],
           "init shared_handle");

    }

    for(i = 0; i < MAX_FRAG_REGIONS; i++)
    {
       CONFIG_IF_STATIC_CHECK(
           frag_length[i],
           frag_handle[i],
           "frag_handle");

    }

    CONFIG_CHECK(
        tx_slots,
        "tx_slots");

    CONFIG_CHECK(
        rx_slots,
        "rx_slots");

#   ifdef UDT_LIMIT_RX_LOOPS

    CONFIG_CHECK(
        max_rx_loops,
        "max_rx_loops");

#   endif 

    CONFIG_CHECK(
        requested_max_frame_size,
        "requested_max_frame_size");

    CONFIG_CHECK(
        tx_completion_status_required,
        "tx_completion_status_required");

    return TRUE;
}


#endif



