/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
* *****   ******* *******  ****     **  **
*  ** **   **   *  **   * **  **    **  **
*  **  **  ** *    ** *   ***       **  **
*  **  **  ****    ****    ***      ******
*  **  **  ** *    ** *      ***    **  **
*  ** **   **   *  **     **  ** ** **  **
* *****   ******* ****     ****  ** **  **
*
*****************************************************************************
*
* Miscellaneous definitions required by the toolkit.
*
*****************************************************************************
*
* Copyright (C) 1996-1999 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/

#define FAR_CODE _FAR

#ifdef CODE_MODEL_LARGE

#    ifdef UDT_NO_SSI_PROTECT


#            define UDT_LOCAL_PROTECTED
#            define UDT_INTER_MODULE    FAR_CODE
#            define UDT_INDIRECT        FAR_CODE
#            define UDT_PUBLIC          FAR_CODE
#            define UDT_PSSI            FAR_CODE
#            define UDT_SSI             FAR_CODE

#    else


#            define UDT_LOCAL_PROTECTED FAR_CODE
#            define UDT_INTER_MODULE    FAR_CODE
#            define UDT_INDIRECT        FAR_CODE
#            define UDT_PUBLIC          FAR_CODE
#            define UDT_PSSI            FAR_CODE
#            define UDT_SSI             FAR_CODE

#    endif

#else

#    ifdef CODE_MODEL_TWO

#        ifdef UDT_NO_SSI_PROTECT


#            define UDT_LOCAL_PROTECTED
#            define UDT_INTER_MODULE
#            define UDT_INDIRECT        FAR_CODE
#            define UDT_PUBLIC          FAR_CODE
#            define UDT_PSSI            FAR_CODE
#            define UDT_SSI             FAR_CODE

#        else


#            define UDT_LOCAL_PROTECTED FAR_CODE
#            define UDT_INTER_MODULE
#            define UDT_INDIRECT        FAR_CODE
#            define UDT_PUBLIC          FAR_CODE
#            define UDT_PSSI            FAR_CODE
#            define UDT_SSI             FAR_CODE

#        endif

#    else

#        ifdef CODE_MODEL_FLAT

#            define UDT_LOCAL_PROTECTED
#            define UDT_INTER_MODULE
#            define UDT_INDIRECT
#            define UDT_PUBLIC
#            define UDT_PSSI
#            define UDT_SSI

#        endif

#    endif

#endif


#ifndef MAX_PROBE_ADAPTERS
# define MAX_PROBE_ADAPTERS                            10
#endif


#ifndef UDT_INIT_DATA
# define UDT_INIT_DATA
#endif


#ifndef BOOL_T_DEFINED
#define BOOL_T_DEFINED

#ifndef TRUE

   typedef enum
   {
       FALSE = 0,
       TRUE
   } BOOLEAN_T;

#else


    typedef int BOOLEAN_T;

#endif
#endif

typedef BOOLEAN_T FAR_DATA *P_BOOLEAN_T, FAR_CLIENT * PCLIENT_BOOLEAN_T;


typedef enum
{
    FLAG_ABSENT = 0,
    FLAG_FALSE,
    FLAG_TRUE
} OPTIONAL_FLAG_T;


typedef enum
{
    ADAPTER_STATE_UNKNOWN                       = 0,

    ADAPTER_STATE_RUNNING,

    ADAPTER_STATE_RESET

} ADAPTER_STATE_T,
  FAR_DATA  *P_ADAPTER_STATE_T;


typedef enum
{

    REGISTERED                                  = 1,

    COMMIT_PENDING,

    CONFIGURED,

    READY,

    OPEN_PENDING,

    OPEN,

    CLOSE_PENDING

} UDI_STATE_T,
  FAR_DATA  *P_UDI_STATE_T;


#define    UDT_BUS_TYPE_INVALID                0x0000

#define    UDT_BUS_TYPE_ISA                    0x0001

#define    UDT_BUS_TYPE_EISA                   0x0002

#define    UDT_BUS_TYPE_MC                     0x0004

#define    UDT_BUS_TYPE_PCMCIA                 0x0008

#define    UDT_BUS_TYPE_PCI                    0x0010

#define    UDT_BUS_TYPE_PNP                    0x0020

#define    UDT_BUS_TYPE_ALL                  ( UDT_BUS_TYPE_ISA    |   \
                                               UDT_BUS_TYPE_EISA   |   \
                                               UDT_BUS_TYPE_MC     |   \
                                               UDT_BUS_TYPE_PCMCIA |   \
                                               UDT_BUS_TYPE_PCI    |   \
                                               UDT_BUS_TYPE_PNP)

typedef UINT_T UDT_BUS_TYPE_T;
typedef UDT_BUS_TYPE_T  FAR_DATA  *P_UDT_BUS_TYPE_T;



typedef enum
{
    ADAPTER_TYPE_INVALID                        = 0,

    ADAPTER_TYPE_STRAIGHTBLUEISA                = 1,

    ADAPTER_TYPE_STRAIGHTBLUEMC                 = 2,

    ADAPTER_TYPE_BLUEPLUS                       = 3,

    ADAPTER_TYPE_ATULA                          = 4,

    ADAPTER_TYPE_ISACPNP                        = 5,

    ADAPTER_TYPE_EISA                           = 6,

    ADAPTER_TYPE_PCMCIA                         = 7,

    ADAPTER_TYPE_PCI1B                          = 8,

    ADAPTER_TYPE_PCIBM1                         = 9,

    ADAPTER_TYPE_PCIBM2                         = 10,


    ADAPTER_TYPE_KNOSSOS                        = 11,

    ADAPTER_TYPE_CARDBUS                        = 12,

    ADAPTER_TYPE_SMART16                        = 13,

    ADAPTER_TYPE_MC16                           = 14,

    ADAPTER_TYPE_MC32                           = 15,

    ADAPTER_TYPE_IBM_PCI                        = 16,
    
    ADAPTER_TYPE_KNOSSOS_CARDBUS                = 17,

    ADAPTER_TYPE_COMPAQ_ISA                     = 100,

    ADAPTER_TYPE_COMPAQ_PCI                     = 101,

    ADAPTER_TYPE_OLD_CARDS                      = 200,

    ADAPTER_TYPE_OLICOM_PCI                     = 210,

    ADAPTER_TYPE_HAWKEYE_OLICOM_PCI             = 211,

    ADAPTER_TYPE_BULLSEYE_OLICOM_PCI            = 212,

    ADAPTER_TYPE_OLICOM_EISA_3133               = 213,

    ADAPTER_TYPE_OLICOM_EISA_3135               = 214,

    ADAPTER_TYPE_OLICOM_ISAPNP                  = 215,

    ADAPTER_TYPE_OLICOM_ISA                     = 216,

    ADAPTER_TYPE_OLICOM_PCMCIA                  = 217,

    ADAPTER_TYPE_OLICOM_CARDBUS                 = 218,

} ADAPTER_TYPE_T,
  FAR_DATA  *P_ADAPTER_TYPE_T;



typedef enum
{

    ADAPTER_SUBTYPE_INVALID                  = 0,
#define CARD_NAME_INVALID         ""


    ADAPTER_SUBTYPE_IBM,

#if defined(STRAIGHTBLUEISA_UDI) || defined(STRAIGHTBLUEISA_UPI)
#define CARD_NAME_IBM             "IBM/Compatible ISA Adapter"
#else
#define CARD_NAME_IBM CARD_NAME_INVALID
#endif


    ADAPTER_SUBTYPE_STRAIGHTBLUE,

#if defined(STRAIGHTBLUEISA_UDI) || defined(STRAIGHTBLUEISA_UPI)
#define CARD_NAME_STRAIGHTBLUE    "Madge Straight Blue ISA Adapter"
#else
#define CARD_NAME_STRAIGHTBLUE CARD_NAME_INVALID
#endif


    ADAPTER_SUBTYPE_BLUE_MC,

#if defined(STRAIGHTBLUEMC_UDI) || defined(STRAIGHTBLUEMC_UPI)
#define CARD_NAME_BLUE_MC         "IBM/Straight Blue MC Adapter"
#else
#define CARD_NAME_BLUE_MC CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_BLUE_PLUS,

#if defined(BLUEPLUS_UDI) || defined(BLUEPLUS_UPI)
#define CARD_NAME_BLUE_PLUS       "Madge Blue+ 16/4 ISA Adapter"
#else
#define CARD_NAME_BLUE_PLUS CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_BLUE_PNP,

#if defined(BLUEPLUS_UDI) || defined(BLUEPLUS_UPI)
#define CARD_NAME_BLUE_PNP        "Madge Blue+ 16/4 ISA PnP Adapter"
#else
#define CARD_NAME_BLUE_PNP CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_AT,

#if defined(ATULA_UDI) || defined(ATULA_UPI)
#define CARD_NAME_AT              "Madge Smart 16/4 AT Ringnode"
#else
#define CARD_NAME_AT CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_FIBER,

#if defined(ATULA_UDI) || defined(ATULA_UPI)
#define CARD_NAME_FIBER           "Madge Smart 16/4 Fiber AT Ringnode"
#else
#define CARD_NAME_FIBER CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_BRIDGE,

#if defined(ATULA_UDI) || defined(ATULA_UPI)
#define CARD_NAME_BRIDGE          "Madge Smart 16/4 AT Bridgenode"
#else
#define CARD_NAME_BRIDGE CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_ISAC,

#if defined(ATULA_UDI) || defined(ATULA_UPI)
#define CARD_NAME_ISAC            "Madge Smart 16/4 ISA Client Ringnode"
#else
#define CARD_NAME_ISAC CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_ATP,

#if defined(ATULA_UDI) || defined(ATULA_UPI)
#define CARD_NAME_ATP             "Madge Smart 16/4 AT Plus Ringnode"
#else
#define CARD_NAME_ATP CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_ISACP,

#if defined(ATULA_UDI) || defined(ATULA_UPI)
#define CARD_NAME_ISACP           "Madge Smart 16/4 ISA Client Plus Ringnode"
#else
#define CARD_NAME_ISACP CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_ATPNP,

#if defined(ATULA_UDI) || defined(ATULA_UPI)
#define CARD_NAME_ATPNP           "Madge Smart 16/4 AT PnP Ringnode"
#else
#define CARD_NAME_ATPNP CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_ISACPNP,

#if defined(ISACPNP_UDI) || defined(ISACPNP_UPI)
#define CARD_NAME_ISACPNP         "Madge Smart 16/4 ISA Client PnP Ringnode"
#else
#define CARD_NAME_ISACPNP CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_EISA_MK1,

#if defined(EISA_UDI) || defined(EISA_UPI)
#define CARD_NAME_EISA_MK1        "Madge Smart 16/4 EISA Ringnode"
#else
#define CARD_NAME_EISA_MK1 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_EISA_MK2,

#if defined(EISA_UDI) || defined(EISA_UPI)
#define CARD_NAME_EISA_MK2        "Madge Smart 16/4 EISA Ringnode"
#else
#define CARD_NAME_EISA_MK2 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_EISA_MK3,

#if defined(EISA_UDI) || defined(EISA_UPI)
#define CARD_NAME_EISA_MK3        "Madge Smart 16/4 EISA Ringnode"
#else
#define CARD_NAME_EISA_MK3 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_EISA_BRIDGE,

#if defined(EISA_UDI) || defined(EISA_UPI)
#define CARD_NAME_EISA_BRIDGE     "Madge Smart 16/4 EISA Bridgenode"
#else
#define CARD_NAME_EISA_BRIDGE CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_PCMCIA,

#if defined(PCMCIA_UDI) || defined(PCMCIA_UPI)
#define CARD_NAME_PCMCIA          "Madge Smart 16/4 PCMCIA Ringnode"
#else
#define CARD_NAME_PCMCIA CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_PCMCIA_2,

#if defined(PCMCIA_UDI) || defined(PCMCIA_UPI)
#define CARD_NAME_PCMCIA_2        "Smart 16/4 PCMCIA MK2"
#else
#define CARD_NAME_PCMCIA_2 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_PCI1B,

#if defined(PCI1B_UDI) || defined(PCI1B_UPI)
#define CARD_NAME_PCI1B           "Madge Smart 16/4 PCI Ringnode"
#else
#define CARD_NAME_PCI1B CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_PCIBM1,

#if defined(PCIBM1_UDI) || defined(PCIBM1_UPI)
#define CARD_NAME_PCIBM1          "Madge Smart 16/4 PCI Ringnode Mk1"
#else
#define CARD_NAME_PCIBM1 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_PCIBM2,

#if defined(PCIBM2_UDI) || defined(PCIBM2_UPI)
#define CARD_NAME_PCIBM2          "Madge Smart 16/4 PCI Ringnode Mk2"
#else
#define CARD_NAME_PCIBM2 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_PRESTO,

#if defined(PRESTO_UDI) || defined(PRESTO_UPI)
#define CARD_NAME_PRESTO          "Madge Presto PCI Adapter"
#else
#define CARD_NAME_PRESTO CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_PCI3,

#if defined(PCI3_UDI) || defined(PCI3_UPI)
#define CARD_NAME_PCI3            "Madge Smart 16/4 PCI Ringnode Mk3"
#else
#define CARD_NAME_PCI3  CARD_NAME_INVALID
#endif


    ADAPTER_SUBTYPE_COMPAQ_PCI3,

#if defined(KNOSSOS_UDI) || defined(KNOSSOS_UPI)
#define CARD_NAME_COMPAQ_PCI3     "Compaq NC4621 PCI, 4/16, WOL"
#else
#define CARD_NAME_COMPAQ_PCI3  CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_PRESTO2,

#if defined(PRESTO2_UDI) || defined(PRESTO2_UPI)
#define CARD_NAME_PRESTO2          "Madge Presto PCI Plus Adapter"
#else
#define CARD_NAME_PRESTO2 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_PRESTO2000,

#if defined(PRESTO2000_UDI) || defined(PRESTO2000_UPI)
#define CARD_NAME_PRESTO2000       "Madge Presto PCI 2000 Adapter"
#else
#define CARD_NAME_PRESTO2000 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_CARDBUS2,

#if defined(CARDBUS2_UDI) || defined(CARDBUS2_UPI)
#define CARD_NAME_CARDBUS2          "Smart 16/4 CardBus Mk2"
#else
#define CARD_NAME_CARDBUS2 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_PCI4,

#if defined(PCI4_UDI) || defined(PCI4_UPI)
#define CARD_NAME_PCI4            "Madge Smart 100/16/4 PCI-HS Ringnode"
#else
#define CARD_NAME_PCI4  CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_PCI4_MK2,

#if defined(PCI4_UDI) || defined(PCI4_UPI)
#define CARD_NAME_PCI4_MK2        "Smart MK4 PCI Adapter"
#else
#define CARD_NAME_PCI4_MK2 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_CARDBUS,

#if defined(CARDBUS_UDI) || defined(CARDBUS_UPI)
#define CARD_NAME_CARDBUS         "Madge 16/4 CardBus Adapter"
#else
#define CARD_NAME_CARDBUS CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_SMART16,

#if defined(SMART16_UDI) || defined(SMART16_UPI)
#define CARD_NAME_SMART16          "Madge Smart 16 Ringnode"
#else
#define CARD_NAME_SMART16 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_MC16,

#if defined(MC16_UDI) || defined(MC16_UPI)
#define CARD_NAME_MC16          "Madge Smart 16/4 MC Ringnode"
#else
#define CARD_NAME_MC16 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_MC32,

#if defined(MC16_UDI) || defined(MC16_UPI)
#define CARD_NAME_MC32          "Madge Smart 16/4 MC32 Ringnode"
#else
#define CARD_NAME_MC32 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_IBMPCI_LANSTREAMER,
    
#if defined(IBMPCI_UPI)
#define CARD_NAME_IBMPCI_LANSTREAMER        "IBM LAN Streamer PCI Card"
#else
#define CARD_NAME_IBMPCI_LANSTREAMER CARD_NAME_INVALID
#endif



    ADAPTER_SUBTYPE_COMPAQ_TC_ISA,

#if defined(COMPAQ_ISA_UDI) || defined(COMPAQ_ISA_UPI)
#define CARD_NAME_COMPAQ_TC_ISA \
    "Thomas-Conrad TC4045 ISA Token Ring Adapter"
#else
#define CARD_NAME_COMPAQ_TC_ISA CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_COMPAQ_TC_PNP,

#if defined(COMPAQ_ISA_UDI) || defined(COMPAQ_ISA_UDI)
#define CARD_NAME_COMPAQ_TC_PNP \
    "Thomas-Conrad TC4145 ISA Token Ring Adapter"
#else
#define CARD_NAME_COMPAQ_TC_PNP CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_COMPAQ_PNP,

#if defined(COMPAQ_ISA_UDI) || defined(COMPAQ_ISA_UDI)
#define CARD_NAME_COMPAQ_PNP \
    "Compaq Netelligent 4/16 TR ISA UTP/STP"
#else
#define CARD_NAME_COMPAQ_PNP CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_COMPAQ_TC_PCI,

#if defined(COMPAQ_PCI_UDI) || defined(COMPAQ_PCI_UPI)
#define CARD_NAME_COMPAQ_TC_PCI \
    "Thomas-Conrad TC4048 PCI Token Ring Adapter"
#else
#define CARD_NAME_COMPAQ_TC_PCI CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_COMPAQ_PCI,

#if defined(COMPAQ_PCI_UDI) || defined(COMPAQ_PCI_UPI)
#define CARD_NAME_COMPAQ_PCI \
    "Compaq Netelligent 4/16 TR PCI UTP/STP"
#else
#define CARD_NAME_COMPAQ_PCI CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_FOUR_MEG,

#if defined(OLDCARDS_UPI)
#define CARD_NAME_FOUR_MEG \
    "Madge Four Megabit Adapter"
#else
#define CARD_NAME_FOUR_MEG CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_MAXY,

#if defined(OLDCARDS_UPI)
#define CARD_NAME_MAXY \
    "Madge Smart 16/4 MAXY Ring Node"
#else
#define CARD_NAME_MAXY CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_PC,

#if defined(OLDCARDS_UPI)
#define CARD_NAME_PC \
    "Madge Smart 16/4 PC Ring Node"
#else
#define CARD_NAME_PC CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_SMART100,

#if defined(OLDCARDS_UPI)
#define CARD_NAME_SMART100 \
    "Madge EISA Smart 100 Adapter"
#else
#define CARD_NAME_SMART100 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_IBMPCMCIA,

#if defined(OLDCARDS_UPI)
#define CARD_NAME_IBMPCMCIA \
    "IBM PCMCIA Token Ring Adapter"
#else
#define CARD_NAME_IBMPCMCIA CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_XIRCOM_PCMCIA,

#if defined(OLDCARDS_UPI)
#define CARD_NAME_XIRCOM_PCMCIA \
    "XIRCOM Token Ring CreditCard Adapter"
#else
#define CARD_NAME_XIRCOM_PCMCIA CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_THREECOM,

#if defined(OLDCARDS_UPI)
#define CARD_NAME_THREECOM \
    "3Com Token Ring Adapter"
#else
#define CARD_NAME_THREECOM CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_IBMAUTOISA,

#if defined(OLDCARDS_UPI)
#define CARD_NAME_IBMAUTOISA \
    "IBM Auto ISA Token Ring Adapter"
#else
#define CARD_NAME_IBMAUTOISA CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_IBMAUTOPNP,

#if defined(OLDCARDS_UPI)
#define CARD_NAME_IBMAUTOPNP \
    "IBM Auto PNP Token Ring Adapter"
#else
#define CARD_NAME_IBMAUTOPNP CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_IBMUNKNOWN,

#if defined(OLDCARDS_UPI)
#define CARD_NAME_IBMUNKNOWN \
    "IBM Compatible Token Ring Adapter (Unknown Manufacturer)"
#else
#define CARD_NAME_IBMUNKNOWN CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_OLICOM_PCI_3136,

#if defined(OLICOM_PCI_UPI) || defined(OLICOM_PCI_UDI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_PCI_3136 \
    "Olicom PCI 16/4 Adapter (OC-3136)"
#   else
#   define CARD_NAME_OLICOM_PCI_3136 \
    "Olicom Token-Ring PCI 16/4 Adapter (OC-3136)"
#   endif
#else
#   define CARD_NAME_OLICOM_PCI_3136 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_OLICOM_PCI_3137,

#if defined(OLICOM_PCI_UPI) || defined(OLICOM_PCI_UDI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_PCI_3137 \
    "Olicom PCI/II 16/4 Adapter (OC-3137)"
#   else
#   define CARD_NAME_OLICOM_PCI_3137 \
    "Olicom Token-Ring PCI/II 16/4 Adapter (OC-3137)"
#   endif
#else
#   define CARD_NAME_OLICOM_PCI_3137 CARD_NAME_INVALID
#endif


    ADAPTER_SUBTYPE_OLICOM_EISA_3133,

#if defined(OLICOM_EISA_UPI) || defined(OLICOM_EISA_UDI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_EISA_3133 \
    "Olicom EISA 16/4 Adapter (OC-3133)"
#   else
#   define CARD_NAME_OLICOM_EISA_3133 \
    "Olicom Token-Ring EISA 16/4 Adapter (OC-3133)"
#   endif
#else
#   define CARD_NAME_OLICOM_EISA_3133 CARD_NAME_INVALID
#endif


    ADAPTER_SUBTYPE_OLICOM_EISA_3135,

#if defined(OLICOM_EISA_UPI) || defined(OLICOM_EISA_UDI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_EISA_3135 \
    "Olicom EISA 16/4 Server Adapter (OC-3135)"
#   else
#   define CARD_NAME_OLICOM_EISA_3135 \
    "Olicom Token-Ring EISA 16/4 Server Adapter (OC-3135)"
#   endif
#else
#   define CARD_NAME_OLICOM_EISA_3135 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_OLICOM_ISA_3117,

#if defined(OLICOM_ISA_UPI) || defined(OLICOM_ISA_UDI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_ISA_3117 \
    "Olicom ISA 16/4 Adapter (OC-3117)"
#   else
#   define CARD_NAME_OLICOM_ISA_3117 \
    "Olicom Token-Ring ISA 16/4 Adapter (OC-3117)"
#   endif
#else
#   define CARD_NAME_OLICOM_ISA_3117 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_OLICOM_ISA_3118,

#if defined(OLICOM_ISAPNP_UPI) || defined(OLICOM_ISAPNP_UDI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_ISA_3118 \
    "Olicom ISA 16/4 Adapter (OC-3118)"
#   else
#   define CARD_NAME_OLICOM_ISA_3118 \
    "Olicom Token-Ring ISA 16/4 Adapter (OC-3118)"
#   endif
#else
#   define CARD_NAME_OLICOM_ISA_3118 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_OLICOM_PCMCIA_3221,

#if defined(OLICOM_PCMCIA_UPI) || defined(OLICOM_PCMCIA_UDI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_PCMCIA_3221 \
    "GoCard Token-Ring C30 PC Card"
#   else
#   define CARD_NAME_OLICOM_PCMCIA_3221 \
    "GoCard Token-Ring C30 PC Card"
#   endif
#else
#   define CARD_NAME_OLICOM_PCMCIA_3221 CARD_NAME_INVALID
#endif

#if 0 

    ADAPTER_SUBTYPE_OLICOM_PCMCIA_3230,

#if defined(OLICOM_PCMCIA_UPI) || defined(OLICOM_PCMCIA_UDI)
#define CARD_NAME_OLICOM_PCMCIA_3230 \
    "Olicom GoCard TR/Modem 144 PC Card (OC-3230)"
#else
#define CARD_NAME_OLICOM_PCMCIA_3230 CARD_NAME_INVALID
#endif


    ADAPTER_SUBTYPE_OLICOM_PCMCIA_3232,

#if defined(OLICOM_PCMCIA_UPI) || defined(OLICOM_PCMCIA_UDI)
#define CARD_NAME_OLICOM_PCMCIA_3232 \
    "Olicom GoCard TRN/Modem 336 PC Card (OC-3232)"
#else
#define CARD_NAME_OLICOM_PCMCIA_3232 CARD_NAME_INVALID
#endif

#endif 

    ADAPTER_SUBTYPE_OLICOM_CARDBUS_3250,

#if defined(OLICOM_CARDBUS_UPI) || defined(OLICOM_CARDBUS_UDI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_CARDBUS_3250 \
    "Olicom GC-3250 16/4 CardBus PC Card"
#   else
#   define CARD_NAME_OLICOM_CARDBUS_3250 \
    "Olicom GoCard 3250 Token-Ring 16/4 CardBus PC Card"
#   endif
#else
#   define CARD_NAME_OLICOM_CARDBUS_3250 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_OLICOM_PCI_3139,

#if defined(OLICOM_3139_UPI) || defined(OLICOM_3139_UDI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_PCI_3139 \
    "Olicom RF-3139 16/4 PCI Adapter"
#   else
#   define CARD_NAME_OLICOM_PCI_3139 \
    "Olicom RapidFire 3139 Token-Ring 16/4 PCI Adapter"
#   endif
#else
#   define CARD_NAME_OLICOM_PCI_3139 CARD_NAME_INVALID
#endif


    ADAPTER_SUBTYPE_OLICOM_PCI_3140,

#if defined(OLICOM_314X_UPI) || defined(OLICOM_314X_UDI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_PCI_3140 \
    "RapidFire 3140 16/4 TR PCI Adapter"
#   else
#   define CARD_NAME_OLICOM_PCI_3140 \
    "RapidFire 3140 16/4 TR PCI Adapter"
#   endif
#else
#   define CARD_NAME_OLICOM_PCI_3140 CARD_NAME_INVALID
#endif



    ADAPTER_SUBTYPE_OLICOM_PCI_3141,

#if defined(OLICOM_314X_UPI) || defined(OLICOM_314X_UDI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_PCI_3141 \
    "RapidFire 3141 16/4 TR PCI Fiber Adapter"
#   else
#   define CARD_NAME_OLICOM_PCI_3141 \
    "RapidFire 3141 16/4 TR PCI Fiber Adapter"
#   endif
#else
#   define CARD_NAME_OLICOM_PCI_3141 CARD_NAME_INVALID
#endif


    ADAPTER_SUBTYPE_OLICOM_PCI_3540,

#if defined(OLICOM_3540_UPI) || defined(OLICOM_3540_UDI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_PCI_3540 \
    "Olicom RF-3540 HSTR 100/16/4 PCI Adapter"
#   else
#   define CARD_NAME_OLICOM_PCI_3540 \
    "Olicom RapidFire 3540 HSTR 100/16/4 PCI Adapter"
#   endif
#else
#   define CARD_NAME_OLICOM_PCI_3540 CARD_NAME_INVALID
#endif

    ADAPTER_SUBTYPE_OLICOM_PCI_3140_V2,

#if defined(OLICOM_3140V2_UDI) || defined(OLICOM_3140V2_UPI)
#   if defined(UDT_SHORT_CARD_NAMES)
#   define CARD_NAME_OLICOM_PCI_3140_V2 \
    "RapidFire 3140V2 16/4 TR PCI Adapter"
#   else
#   define CARD_NAME_OLICOM_PCI_3140_V2 \
    "RapidFire 3140V2 16/4 TR PCI Adapter"
#   endif
#else
#   define CARD_NAME_OLICOM_PCI_3140_V2 CARD_NAME_INVALID
#endif

} ADAPTER_SUBTYPE_T,
  FAR_DATA * P_ADAPTER_SUBTYPE_T,
  FAR_CLIENT * PCLIENT_ADAPTER_SUBTYPE_T;

#define CARD_NAME_STRINGS                                                   \
{                                                                           \
    CARD_NAME_INVALID,                                                      \
    CARD_NAME_IBM,                                                          \
    CARD_NAME_STRAIGHTBLUE,                                                 \
    CARD_NAME_BLUE_MC,                                                      \
    CARD_NAME_BLUE_PLUS,                                                    \
    CARD_NAME_BLUE_PNP,                                                     \
    CARD_NAME_AT,                                                           \
    CARD_NAME_FIBER,                                                        \
    CARD_NAME_BRIDGE,                                                       \
    CARD_NAME_ISAC,                                                         \
    CARD_NAME_ATP,                                                          \
    CARD_NAME_ISACP,                                                        \
    CARD_NAME_ATPNP,                                                        \
    CARD_NAME_ISACPNP,                                                      \
    CARD_NAME_EISA_MK1,                                                     \
    CARD_NAME_EISA_MK2,                                                     \
    CARD_NAME_EISA_MK3,                                                     \
    CARD_NAME_EISA_BRIDGE,                                                  \
    CARD_NAME_PCMCIA,                                                       \
    CARD_NAME_PCMCIA_2,                                                     \
    CARD_NAME_PCI1B,                                                        \
    CARD_NAME_PCIBM1,                                                       \
    CARD_NAME_PCIBM2,                                                       \
    CARD_NAME_PRESTO,                                                       \
    CARD_NAME_PCI3,                                                         \
    CARD_NAME_COMPAQ_PCI3,                                                  \
    CARD_NAME_PRESTO2,                                                      \
    CARD_NAME_PRESTO2000,                                                   \
    CARD_NAME_CARDBUS2,                                                     \
    CARD_NAME_PCI4,                                                         \
    CARD_NAME_PCI4_MK2,                                                     \
    CARD_NAME_CARDBUS,                                                      \
    CARD_NAME_SMART16,                                                      \
    CARD_NAME_MC16,                                                         \
    CARD_NAME_MC32,                                                         \
    CARD_NAME_IBMPCI_LANSTREAMER,                                           \
    CARD_NAME_COMPAQ_TC_ISA,                                                \
    CARD_NAME_COMPAQ_TC_PNP,                                                \
    CARD_NAME_COMPAQ_PNP,                                                   \
    CARD_NAME_COMPAQ_TC_PCI,                                                \
    CARD_NAME_COMPAQ_PCI,                                                   \
    CARD_NAME_FOUR_MEG,                                                     \
    CARD_NAME_MAXY,                                                         \
    CARD_NAME_PC,                                                           \
    CARD_NAME_SMART100,                                                     \
    CARD_NAME_IBMPCMCIA,                                                    \
    CARD_NAME_XIRCOM_PCMCIA,                                                \
    CARD_NAME_THREECOM,                                                     \
    CARD_NAME_IBMAUTOISA,                                                   \
    CARD_NAME_IBMAUTOPNP,                                                   \
    CARD_NAME_IBMUNKNOWN,                                                   \
    CARD_NAME_OLICOM_PCI_3136,                                              \
    CARD_NAME_OLICOM_PCI_3137,                                              \
    CARD_NAME_OLICOM_EISA_3133,                                             \
    CARD_NAME_OLICOM_EISA_3135,                                             \
    CARD_NAME_OLICOM_ISA_3117,                                              \
    CARD_NAME_OLICOM_ISA_3118,                                              \
    CARD_NAME_OLICOM_PCMCIA_3221,                                           \
    /*CARD_NAME_OLICOM_PCMCIA_3230,*/                                       \
    /*CARD_NAME_OLICOM_PCMCIA_3232,*/                                       \
    CARD_NAME_OLICOM_CARDBUS_3250,                                          \
    CARD_NAME_OLICOM_PCI_3139,                                              \
    CARD_NAME_OLICOM_PCI_3140,                                              \
    CARD_NAME_OLICOM_PCI_3141,                                              \
    CARD_NAME_OLICOM_PCI_3540,                                              \
    CARD_NAME_OLICOM_PCI_3140_V2,                                           \
}


#define PCI_CARD_NAME_STRINGS                                               \
{                                                                           \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    CARD_NAME_PCI1B,                                                        \
    CARD_NAME_PCIBM1,                                                       \
    CARD_NAME_PCIBM2,                                                       \
    CARD_NAME_PRESTO,                                                       \
    CARD_NAME_PCI3,                                                         \
    CARD_NAME_COMPAQ_PCI3,                                                  \
    CARD_NAME_PRESTO2,                                                      \
    CARD_NAME_PRESTO2000,                                                   \
    NULL,                                                                   \
    CARD_NAME_PCI4,                                                         \
    CARD_NAME_PCI4_MK2,                                                     \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    CARD_NAME_IBMPCI_LANSTREAMER,                                           \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    CARD_NAME_COMPAQ_TC_PCI,                                                \
    CARD_NAME_COMPAQ_PCI,                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    CARD_NAME_OLICOM_PCI_3136,                                              \
    CARD_NAME_OLICOM_PCI_3137,                                              \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    NULL,                                                                   \
    /*NULL,*/                                                               \
    /*NULL,*/                                                               \
    NULL,                                                                   \
    CARD_NAME_OLICOM_PCI_3139,                                              \
    CARD_NAME_OLICOM_PCI_3140,                                              \
    CARD_NAME_OLICOM_PCI_3141,                                              \
    CARD_NAME_OLICOM_PCI_3540,                                              \
    CARD_NAME_OLICOM_PCI_3140_V2,                                           \
}

typedef enum
{
    PIO_16BIT                                   = 1,

    PIO_32BIT,

    MMIO,

    BUS_MASTER,

    SHARED_RAM


} XFER_METHOD_T,
  FAR_DATA  *P_XFER_METHOD_T;



typedef enum
{
    FASTMAC_PLUS                                = 1,

    S_BLUE,

    F_BLUE,

    KNOSSOS_DMA,

    HEBE_DMA

} ADAPTER_IF_T,
  FAR_DATA  *P_ADAPTER_IF_T;



typedef enum
{
    RS_UNKNOWN                                  = 0,

    RS_AUTO,

    RS_ADAPTER,

    RS_4M,

    RS_16M,

    RS_100M

} RING_SPEED_T,
  FAR_DATA  *P_RING_SPEED_T;



typedef enum
{
    IO_REGION                                   = 1,

    SLOT_RANGE,

    PCI_NUMBER_RANGE


} IDENTIFIER_TYPE_T,
  FAR_INIT_DATA  *P_IDENTIFIER_TYPE_T;



typedef enum
{
    RX_HOST                                     = 1,

    RX_ADAPTER,

    RX_ADAPTER_WITH_EI


} RX_CLASS_T,
  FAR_DATA  *P_RX_CLASS_T;



typedef enum
{
    RX                                          = 0x01,

    TX                                          = 0x02,

    LOW_PRIORITY_INTS                           = 0x04


} INTERRUPT_FILTER_T,
  FAR_DATA  *P_INTERRUPT_FILTER_T;



typedef enum
{
    OPEN_DEFAULT                    = 0,

    OPEN_LOOPBACK                   = 1,

    OPEN_CLASSIC                    = 2,

    OPEN_DTR                        = 4,

    OPEN_ORIGINAL_RINGSPEED         = 8


} OPEN_OPTION_T,
  FAR_DATA  *P_OPEN_OPTION_T;



typedef enum
{
    LLC                                         = 0,

    LLC_AND_MAC,

    ALL_LLC,

    ALL_LLC_AND_MAC


} PROMISCUOUS_LEVEL_T,
  FAR_DATA  *P_PROMISCUOUS_LEVEL_T;

#define MAX_FRAME_SIZE_UNKNOWN                  0
#define MAX_FRAME_SIZE_4M                       4520
#define MAX_FRAME_SIZE_16M                      17848

#define MAX_FRAME_SIZE_100M                     MAX_FRAME_SIZE_16M 


#define MAX_TX_FRAGMENTS                        64

#define MAX_RX_FRAGMENTS                        64

#define MAX_TX_FRAG_LENGTH                      MAX_FRAME_SIZE_16M

#define MAX_RX_FRAG_LENGTH                      MAX_FRAME_SIZE_16M


#define STATUS_UNKNOWN                          0

#define STATUS_SET                              1

#define STATUS_TELL_ME                          2



typedef enum
{
    OPEN_SUCCESS                                = 0x00,


    OPEN_FUNCTION_FAILURE                       = 0x01,

    OPEN_SIGNAL_LOSS                            = 0x02,


    OPEN_FREQUENCY                              = 0x04,

    OPEN_TIMEOUT                                = 0x05,


    OPEN_RING_FAILURE                           = 0x06,


    OPEN_RING_BEACONING                         = 0x07,


    OPEN_DUPLICATE_ADDRESS                      = 0x08,


    OPEN_PARAMETER_REQUEST                      = 0x09,

    OPEN_REMOVE_RECEIVED                        = 0x0A,

    OPEN_IMPL_FORCE_RECEIVED                    = 0x0B,

    OPEN_DUPLICATE_MODIFIER                     = 0x0C,

    OPEN_NO_MONITOR                             = 0x0D,

    OPEN_MONITOR_FAILED                         = 0x0E,

    OPEN_PROTOCOL_ERROR                         = 0x0F,


    OPEN_REFUSED_CLASSIC_OPEN_AT_100MBPS        = 0x0101,

    OPEN_NO_LINK_STATUS                         = 0x1002

} OPEN_ERROR_T,
  FAR_DATA  *P_OPEN_ERROR_T;



typedef enum
{
    GENERAL_ERROR_PHASE                         = 0x00,

    LOBE_MEDIA_TEST                             = 0x01,

    PHYSICAL_INSERTION                          = 0x02,

    ADDRESS_VERIFICATION                        = 0x03,

    NEIGHBOUR_NOTIFICATION                      = 0x04,

    REQUEST_PARAMETERS                          = 0x05,

    DTR_REGISTRATION                            = 0x06,


} OPEN_PHASE_T,
  FAR_DATA  *P_OPEN_PHASE_T;


typedef enum
{

    OPEN_MODE_UNKNOWN                           = 0x00,

    OPEN_MODE_CLASSIC                           = 0x01,

    OPEN_MODE_DTR                               = 0x02,

    OPEN_MODE_SINGLE                            = 0x03


} OPEN_MODE_T,
  FAR_DATA  *P_OPEN_MODE_T;



typedef enum
{
    CLASSIC_ONLY                                = 1,

    DTR_ONLY,

    DTR_AND_CLASSIC


} DTR_OPTIONS_T,
  FAR_DATA  *P_DTR_OPTIONS_T;


typedef enum
{
    RING_STATUS                                 = 1,

    ADAPTER_DEAD,


    ADAPTER_CLOSED,


    ADAPTER_REMOVED,


    ADAPTER_MAC_REMOVED


} ADAPTER_EVENT_T,
  FAR_DATA  *P_ADAPTER_EVENT_T;



typedef enum
{
    FRAME_NOT_ACTIVE                            = 0,

    FRAME_ABORTED,


    FRAME_INCOMPLETE,


    FRAME_COMPLETE


} FRAME_STATUS_T,
  FAR_DATA  *P_FRAME_STATUS_T;



typedef enum
{
    FRAG_TYPE_PHYS_LE,

    FRAG_TYPE_VIRT_LE,

    FRAG_TYPE_PHYS_BE,

    FRAG_TYPE_VIRT_BE


} FRAG_TYPE_T,
  FAR_DATA  *P_FRAG_TYPE_T;


#define RING_STATUS_PRESTO_WATCHDOG             0x0001
#define RING_STATUS_RING_RECOVERY               0x0020
#define RING_STATUS_SINGLE_STATION              0x0040
#define RING_STATUS_COUNTER_OVERFLOW            0x0080
#define RING_STATUS_REMOVE_RECEIVED             0x0100
#define RING_STATUS_AUTO_REMOVAL                0x0400
#define RING_STATUS_LOBE_FAULT                  0x0800
#define RING_STATUS_TX_BEACON                   0x1000
#define RING_STATUS_SOFT_ERROR                  0x2000
#define RING_STATUS_HARD_ERROR                  0x4000
#define RING_STATUS_SIGNAL_LOSS                 0x8000

