/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
* ******* ******  ******    ***   ******   ****     **  **
*  **   *  **  **  **  **  ** **   **  ** **  **    **  **
*  ** *    **  **  **  ** **   **  **  ** ***       **  **
*  ****    *****   *****  **   **  *****   ***      ******
*  ** *    ** **   ** **  **   **  ** **     ***    **  **
*  **   *  **  **  **  **  ** **   **  ** **  ** ** **  **
* ******* ***  ** ***  **   ***   ***  **  ****  ** **  **
*
*****************************************************************************
*
* Declaration of error codes for the UDI and UPI interfaces
*
*****************************************************************************
*
* Copyright (C) 1996-98 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/









#ifndef UDT_ERROR

typedef UINT_T RETCODE_T;

#endif



    

#define    SUCCESS 0x0000
#define    STR_SUCCESS "Internal state: Success"

    

#define    FAILURE 0x0001
#define    STR_FAILURE "Non-specific internal failure"




    

#define    WRONG_STATE                  0x0002
#define    STR_WRONG_STATE "Illegal internal state"

    

#define    NULL_FUNCTION                0x0003
#define    STR_NULL_FUNCTION "Internal error: NULL function called"

    

#define    FUNCTION_POINTER_WAS_NULL    0x0004
#define    STR_FUNCTION_POINTER_WAS_NULL "Internal error: NULL function pointer"

    

#define    UNSUPPORTED_FUNCTION         0x0005
#define    STR_UNSUPPORTED_FUNCTION "Internal error: Unsupported UDI function"

    

#define    COMMAND_PENDING              0x0006
#define    STR_COMMAND_PENDING "Internal error: Command pending"

    

#define    COMMAND_FAILED               0x0007
#define    STR_COMMAND_FAILED "Internal error: Unable to issue command to adapter"

    

#define    BAD_ADAPTER_ID               0x0008
#define    STR_BAD_ADAPTER_ID "Internal error: Bad adapter ID structure"

    

#define    BAD_ADAPTER_ID_IO            0x0009
#define    STR_BAD_ADAPTER_ID_IO "Given IO location is illegal for given adapter type"

    

#define    BAD_ADAPTER_ID_NO_CARD_AT_IO 0x0010
#define    STR_BAD_ADAPTER_ID_NO_CARD_AT_IO "No adapter of given type at IO location"

    

#define    BAD_ADAPTER_ID_NO_PCI_CARD 0x0011
#define    STR_BAD_ADAPTER_ID_NO_PCI_CARD "No adapter of given type at PCI number"

    

#define    UNSUPPORTED_BUS_TYPE         0x0015
#define    STR_UNSUPPORTED_BUS_TYPE "Internal error: Bad bus type"

    

#define    BAD_BUS_NUMBER               0x0016
#define    STR_BAD_BUS_NUMBER "Bad bus number"

    

#define    BAD_PCI_NUMBER               0x0017
#define    STR_BAD_PCI_NUMBER "Bad PCI bus/device/function number"

    

#define    BAD_CONFIG_PARAMETER         0x0018
#define    STR_BAD_CONFIG_PARAMETER "Internal error: Bad config parameter"

    

#define    CONFIG_PARAMETER_NOT_REQUIRED 0x0019
#define    STR_CONFIG_PARAMETER_NOT_REQUIRED "Internal error: Config parameter set when not needed"

    

#define    CONFIG_PARAMETER_IN_ERROR    0x0030
#define    STR_CONFIG_PARAMETER_IN_ERROR "Internal error: Config parameter in error"

    

#define    CONFIG_PARAMETER_MISMATCH    0x0031
#define    STR_CONFIG_PARAMETER_MISMATCH "Internal error: Config parameter does not match staic parameter"

    

#define    CONFIG_PARAMETER_UNKNOWN     0x0032
#define    STR_CONFIG_PARAMETER_UNKNOWN "Internal error: Config parameter not filled in"

    

#define    UDTI_REG_FAILED              0x0033
#define    STR_UDTI_REG_FAILED "Internal error: UDTI registration failed"

    

#define    NO_ACTIVE_FRAME              0x0034
#define    STR_NO_ACTIVE_FRAME "Internal error: No active frame"

    

#define    BAD_RX_RESOURCE              0x0035
#define    STR_BAD_RX_RESOURCE "Internal error: Bad receive resource"

    

#define    CORRUPT_SLOT_CHAIN           0x0040
#define    STR_CORRUPT_SLOT_CHAIN "Internal error: Corrupt slot chain"

    

#define    OUT_OF_BUFFER_RAM            0x0041
#define    STR_OUT_OF_BUFFER_RAM "Insufficient adapter memory for requested maximum frame size"

    

#define    BAD_LOOKAHEAD_SIZE           0x0044
#define    STR_BAD_LOOKAHEAD_SIZE "Lookahead size out of range"

    

#define    NO_PCI_CONFIGURATION_SPACE   0x0050
#define    STR_NO_PCI_CONFIGURATION_SPACE "Internal error: No PCI config space"

    

#define    NO_PCI_BUSES                 0x0051
#define    STR_NO_PCI_BUSES "Internal error: No PCI buses"

    

#define    COMMAND_COMPLETED                 0x0080
#define    STR_COMMAND_COMPLETED "Internal state: Command issued immediately"





    

#define    CARD_NOT_SUPPORTED           0x0100
#define    STR_CARD_NOT_SUPPORTED "The adapter found is not supported by this software"

    

#define    SWITCHES_MOVED_SO_DISABLED   0x0101
#define    STR_SWITCHES_MOVED_SO_DISABLED "The adapter switches have been moved since the adapter was last software-configured, and hence is currently disabled. Run the software configuration program on the adapter to correct this"

    

#define    BIA_DOES_NOT_CHECKSUM        0x0102
#define    STR_BIA_DOES_NOT_CHECKSUM "The adapter's built in node address is invalid"

    

#define    SOFT_CONFIGURATION_CORRUPT   0x0103
#define    STR_SOFT_CONFIGURATION_CORRUPT "The adapter's soft configuration has become corrupt. Reconfigure the adapter."

    

#define    MC_NEED_ARBITRATION_LEVEL   0x0104
#define    STR_MC_NEED_ARBITRATION_LEVEL "Only DMA is supported on this adapter. Reconfigure the adapter so that the 'arbitration level' is not 'disabled', to allow DMA to be used."

    

#define    CANNOT_REGISTER_IO           0x0110
#define    STR_CANNOT_REGISTER_IO "Access to adapter IO region refused by operating system"

    

#define    CANNOT_REGISTER_RAM          0x0111
#define    STR_CANNOT_REGISTER_RAM "Access to RAM region refused by operating system"

    

#define    CANNOT_REGISTER_PCI          0x0112
#define    STR_CANNOT_REGISTER_PCI "Access to PCI configuration space refused by operating system"

    

#define    FAILED_TO_OPEN_ADAPTER_CODE  0x0115
#define    STR_FAILED_TO_OPEN_ADAPTER_CODE "Unable to open adapter code file, which may be missing or corrupt"

    

#define    WRONG_ADAPTER_CODE_TYPE      0x0116
#define    STR_WRONG_ADAPTER_CODE_TYPE "Adapter code file is corrupt"

    

#define    WRONG_ADAPTER_CODE_VERSION   0x0117
#define    STR_WRONG_ADAPTER_CODE_VERSION "Wrong version of adapter code file"

    

#define    BAD_ADAPTER_CODE             0x0118
#define    STR_BAD_ADAPTER_CODE         "Adapter code file is corrupt"

    

#define    BAD_IO                       0x0120
#define    STR_BAD_IO "Invalid IO location"

    

#define    BAD_IRQ                      0x0121
#define    STR_BAD_IRQ "Invalid IRQ"

    

#define    BAD_BIA                      0x0122
#define    STR_BAD_BIA "Invalid BIA"

    

#define    SBLUE_IF_MMIO_SRAM_CLASH     0x0123
#define    STR_SBLUE_IF_MMIO_SRAM_CLASH "It is not possible to run the adapter using its 'Straight Blue' interface because the configured shared RAM location is the same as the configured ROM location. Either use the 'Fast Blue' interface, or change one of the configured addresses."

    

#define    BAD_ADAPTER                  0x0130
#define    STR_BAD_ADAPTER "Unable to use adapter"

    

#define    BPLUS_FDT_IF_FAILURE         0x0135
#define    STR_BPLUS_FDT_IF_FAILURE "Adapter hardware failure"

    

#define    ADAPTER_INIT_FAILED          0x0140
#define    STR_ADAPTER_INIT_FAILED "The adapter has failed to initialise"

    

#define    ADAPTER_TIMEDOUT             0x0141
#define    STR_ADAPTER_TIMEDOUT "Timed out waiting for response from adapter"

    

#define    OPEN_FAILED                  0x0145
#define    STR_OPEN_FAILED "Failed to open adapter"

    

#define    CLOSE_FAILED                 0x0146
#define    STR_CLOSE_FAILED "Failed to close adapter"

    

#define    CANNOT_DISABLE_PROMISC       0x0149
#define    STR_CANNOT_DISABLE_PROMISC "Promiscuous mode cannot be permanently disabled on this adapter"

    

#define    DMA_ENABLE_FAILED            0x0150
#define    STR_DMA_ENABLE_FAILED "Unable to enable DMA channel"

    

#define    BUD_FAILED_INITIAL_TEST      0x0160
#define    STR_BUD_FAILED_INITIAL_TEST "Bring up diagnostics failed"
#define    BUD_FAILED_SW_CHECKSUM       0x0161
#define    STR_BUD_FAILED_SW_CHECKSUM "Bring up diagnostics failed"
#define    BUD_FAILED_RAM_TEST          0x0162
#define    STR_BUD_FAILED_RAM_TEST "Bring up diagnostics failed: Adapter RAM test failed"
#define    BUD_FAILED_INSTRUCTION_TEST  0x0163
#define    STR_BUD_FAILED_INSTRUCTION_TEST "Bring up diagnostics failed: Instruction test failed"
#define    BUD_FAILED_CONTEXT_TEST      0x0164
#define    STR_BUD_FAILED_CONTEXT_TEST "Bring up diagnostics failed"
#define    BUD_FAILED_PH_TEST           0x0165
#define    STR_BUD_FAILED_PH_TEST "Bring up diagnostics failed"
#define    BUD_FAILED_SIF_REG_TEST      0x0166
#define    STR_BUD_FAILED_SIF_REG_TEST "Bring up diagnostics failed"
#define    BUD_FAILED_ILLEGALLY         0x0167
#define    STR_BUD_FAILED_ILLEGALLY "Bring up diagnostics failed"

    

#define    BUD_TIMED_OUT                0x0168
#define    STR_BUD_TIMED_OUT "Bring up diagnostics timed out without a specific error being reported"

    

#define    OUT_OF_ADAPTER_RAM           0x0170
#define    STR_OUT_OF_ADAPTER_RAM "Insufficient adapter RAM for code and data"

    

#define    PRESTO_CRC_FAILURE           0x0171
#define    STR_PRESTO_CRC_FAILURE "Checksum failed on data transferred to adapter"

    

#define    PRESTO_TXBM_FAIL_TO_START    0x0172
#define    STR_PRESTO_TXBM_FAIL_TO_START "Failed to start transmit mechanism"












#define UDT_ERR_CANNOT_FIND_INT     0x1002
#define UDT_STR_CANNOT_FIND_INT     \
        "Unable to determine interrupt number - probable interrupt clash"



#define UDT_ERR_NO_ADAPTER_AT_IO    0x1003
#define UDT_STR_NO_ADAPTER_AT_IO    "No adapter at specified I/O location"



#define UDT_ERR_NO_ADAPTER_FOUND    0x1004
#define UDT_STR_NO_ADAPTER_FOUND    "No adapter or incorrect type"



#define UDT_ERR_BAD_IRQ             0x1005
#define UDT_STR_BAD_IRQ             "Invalid interrupt number specified"



#define UDT_ERR_BAD_DMA             0x1006
#define UDT_STR_BAD_DMA             "Invalid DMA channel specified"



#define UDT_ERR_MC_INTS_DISABLED    0x1007
#define UDT_STR_MC_INTS_DISABLED    "No interrupt number has been configured for this MC adapter."



#define UDT_ERR_GOOD_IO_BAD_SLOT    0x1009
#define UDT_STR_GOOD_IO_BAD_SLOT    "No adapter with specified I/O location and slot"



#define UDT_ERR_BAD_XFER            0x1010
#define UDT_STR_BAD_XFER            "Invalid transfer method specified"



#define UDT_ERR_BAD_MMIO            0x1012
#define UDT_STR_BAD_MMIO            "Invalid memory range specified"



#define UDT_ERR_NO_SPEED_SELECTED   0x1017
#define UDT_STR_NO_SPEED_SELECTED   "Adapter has not had its ringspeed configured"



#define UDT_ERR_ADAPTER_DISABLED    0x1018
#define UDT_STR_ADAPTER_DISABLED    "Adapter is disabled and hence cannot be used"



#define UDT_ERR_NO_ADAPTER_AT_SLOT  0x1020
#define UDT_STR_NO_ADAPTER_AT_SLOT  "No adapter at specified slot"



#define UDT_ERR_PCMC_REQ_IO_FAIL    0x1027
#define UDT_STR_PCMC_REQ_IO_FAIL    "Unable to obtain an IO location from Card Services"



#define UDT_ERR_PCMC_REQ_IRQ_FAIL   0x1028
#define UDT_STR_PCMC_REQ_IRQ_FAIL   "Unable to obtain an IRQ from Card Services"



#define UDT_ERR_PCMC_REQ_CONFIG_FAIL 0x1029
#define UDT_STR_PCMC_REQ_CONFIG_FAIL "Failed to configure card using Card Services"



#define UDT_ERR_DOWNLOAD_WORD_CHECK 0x1036
#define UDT_STR_DOWNLOAD_WORD_CHECK "Failed to download code to the adapter"



#define UDT_ERR_NO_ADAPTER_AT_BIA   0x1037
#define UDT_STR_NO_ADAPTER_AT_BIA   "No adapter with specified burnt-in address"



#define UDT_ERR_GOOD_IO_BAD_BIA     0x1038
#define UDT_STR_GOOD_IO_BAD_BIA     "No adapter at specified I/O location with specified burnt-in address"



#define UDT_ERR_PCMC_BAD_AUTO_CONFIG 0x1041
#define UDT_STR_PCMC_BAD_AUTO_CONFIG "Adapter resources badly configured"



#define UDT_ERR_GOOD_SLOT_BAD_BIA   0x1042
#define UDT_STR_GOOD_SLOT_BAD_BIA   "No adapter at specified slot with specified burnt-in address"




#define UDT_ERR_TEST_TRANSFER_FAILED 0x1112
#define UDT_STR_TEST_TRANSFER_FAILED "Initialization failed - transfer test failed"



#define UDT_ERR_INIT_TIMED_OUT      0x1113
#define UDT_STR_INIT_TIMED_OUT      "Initialization timed-out - possible interrupt clash"



#define UDT_ERR_MAC_MDG_INIT_BLOCK              0x1114  
#define UDT_STR_MAC_MDG_INIT_BLOCK              "Initialisation error"
#define UDT_ERR_MAC_MDG_INIT_OPTIONS            0x1115  
#define UDT_STR_MAC_MDG_INIT_OPTIONS            "Initialisation error"
#define UDT_ERR_MAC_MDG_INIT_BAD_BIA            0x1116  
#define UDT_STR_MAC_MDG_INIT_BAD_BIA            "Initialisation error"
#define UDT_ERR_MAC_MDG_INIT_OUT_OF_MEM         0x1117  
#define UDT_STR_MAC_MDG_INIT_OUT_OF_MEM         "Initialisation error"
#define UDT_ERR_MAC_MDG_INIT_DMA_THRESH         0x1118  
#define UDT_STR_MAC_MDG_INIT_DMA_THRESH         "Initialisation error"
#define UDT_ERR_MAC_MDG_INIT_ODD_SCB            0x1119  
#define UDT_STR_MAC_MDG_INIT_ODD_SCB            "Initialisation error"

#define UDT_ERR_MAC_MDG_INIT_ODD_SSB            0x1120  
#define UDT_STR_MAC_MDG_INIT_ODD_SSB            "Initialisation error"
#define UDT_ERR_MAC_MDG_INIT_DIO_PARITY         0x1121  
#define UDT_STR_MAC_MDG_INIT_DIO_PARITY         "Initialisation parity error"
#define UDT_ERR_MAC_MDG_INIT_DMA_TIMEOUT        0x1122  
#define UDT_STR_MAC_MDG_INIT_DMA_TIMEOUT        "Initialisation error - DMA timed out"
#define UDT_ERR_MAC_MDG_INIT_DMA_PARITY         0x1123  
#define UDT_STR_MAC_MDG_INIT_DMA_PARITY         "Initialisation error - DMA parity error"
#define UDT_ERR_MAC_MDG_INIT_DMA_BUS            0x1124  
#define UDT_STR_MAC_MDG_INIT_DMA_BUS            "Initialisation error - DMA bus error"
#define UDT_ERR_MAC_MDG_INIT_DMA_DATA           0x1125  
#define UDT_STR_MAC_MDG_INIT_DMA_DATA           "Initialisation error - DMA failed"
#define UDT_ERR_MAC_MDG_INIT_ADAPTER_CHK        0x1126  
#define UDT_STR_MAC_MDG_INIT_ADAPTER_CHK        "Initialisation error"
#define UDT_ERR_MAC_MDG_INIT_NO_MEMORY          0x1127  
#define UDT_STR_MAC_MDG_INIT_NO_MEMORY          "Initialisation error"
#define UDT_ERR_MAC_MDG_INIT_RESERVED           0x1128  
#define UDT_STR_MAC_MDG_INIT_RESERVED           "Initialisation error"



#define UDT_ERR_OPEN_FAILED_LOBE    0x1130
#define UDT_STR_OPEN_FAILED_LOBE    "Open failed - lobe cable fault"



#define UDT_ERR_OPEN_FAILED_DUP_NA  0x1131
#define UDT_STR_OPEN_FAILED_DUP_NA  "Open failed - duplicate node address"



#define UDT_ERR_OPEN_FAILED_MISC    0x1139
#define UDT_STR_OPEN_FAILED_MISC    "Open failed - run diagnostics"







#define UDT_ERR_NO_MATCHING_ADAPTER 0x1200
#define UDT_STR_NO_MATCHING_ADAPTER "No matching adapter found"



#define UDT_ERR_INIT_FAILED         0x1201
#define UDT_STR_INIT_FAILED         "Initialization failed - run diagnostics"






#define CHSM_ERR_MISC_ERROR                 0x2000
#define CHSM_STR_MISC_ERROR                 "Miscellaneous error during initialization"



#define CHSM_ERR_REGISTER_MLID_FAILED       0x2003
#define CHSM_STR_REGISTER_MLID_FAILED       "Failed to register MLID with LSL"



#define CHSM_ERR_MALLOC_FAILED              0x2007
#define CHSM_STR_MALLOC_FAILED              "Failed to allocate memory"




#define CHSM_ERR_SET_IRQ_FAILED             0x2012
#define CHSM_STR_SET_IRQ_FAILED             "Failed to enable interrupt"



#define CHSM_ERR_CONFIG_FAILED              0x2035
#define CHSM_STR_CONFIG_FAILED              "Failed to determine adapter configuration"



#define CHSM_ERR_MIRROR_ONLY_ON_SERVER      0x2040
#define CHSM_STR_MIRROR_ONLY_ON_SERVER      "Mirroring is only supported on NetWare servers"



#define CHSM_ERR_NO_MATCHING_MIRROR_ADAPTER 0x2041
#define CHSM_STR_NO_MATCHING_MIRROR_ADAPTER "The specified mirror slave adapter is not available"



#define CHSM_ERR_MIRRORING_NEEDS_LAA        0x2042
#define CHSM_STR_MIRRORING_NEEDS_LAA        "A node address override (LAA) must be given when using mirroring"



#define CHSM_ERR_MSM_INCOMPATIBLE_WITH_MIRRORING    0x2043
#define CHSM_STR_MSM_INCOMPATIBLE_WITH_MIRRORING    "MSM.NLM 3.80 or higher is required for mirroring"



#define CHSM_ERR_BAD_MIRROR_MASTER          0x2044
#define CHSM_STR_BAD_MIRROR_MASTER          "The specified master adapter does not support mirroring"



#define CHSM_ERR_BAD_MIRROR_SLAVE           0x2045
#define CHSM_STR_BAD_MIRROR_SLAVE           "The specified slave adapter does not support mirroring"




#define TRINSERT_ERR_UNKNOWN_COMMAND        0x8500
#define TRINSERT_ERR_INT_2F_RECHAINED       0x8501
#define TRINSERT_ERR_IRQ_RECHAINED          0x8502







#define NDIS2_INFO_REGISTER_SUCCESS         0x9000  
#define NDIS2_INFO_INIT_ON_LOAD             0x9001
#define NDIS2_INFO_PIO_FORCED               0x9002
#define NDIS2_INFO_IRQ_FORCED               0x9003
#define NDIS2_INFO_DMA_FORCED               0x9004
#define NDIS2_INFO_RING_SPEED_FORCED        0x9005
#define NDIS2_INFO_BIND_SUCCESS             0x9006
#define NDIS2_INFO_OPEN_SUCCESS             0x9007  
#define NDIS2_INFO_INSERTION_EVENT          0x9008
#define NDIS2_INFO_EJECTION_EVENT           0x9009  
#define NDIS2_INFO_INSERTION_SUCCESS        0x9010
#define NDIS2_INFO_EJECTION_FAIL            0x9011
#define NDIS2_INFO_FMP_DEFINED              0x9012
#define NDIS2_INFO_REMOTE_BOOT              0x9013
#define NDIS2_INFO_INIT_ON_BIND             0x9014
#define NDIS2_INFO_PROMISCUOUS_MODE_ENABLED 0x9015  



#define NDIS2_WARN_TOO_MANY_SECTIONS        0x9100
#define NDIS2_WARN_INVALID_LAA              0x9101
#define NDIS2_WARN_INVALID_IO               0x9102
#define NDIS2_WARN_BAD_PARM                 0x9103
#define NDIS2_WARN_DUPLICATE_PARM           0x9104
#define NDIS2_WARN_TOO_MANY_VALUES          0x9105
#define NDIS2_WARN_NEED_NUM_VALUE           0x9106
#define NDIS2_WARN_NUM_OUT_OF_RANGE         0x9107
#define NDIS2_WARN_NEED_BOOL_VALUE          0x9108
#define NDIS2_WARN_NEED_STR_VALUE           0x9109
#define NDIS2_WARN_STR_OUT_OF_RANGE         0x9110
#define NDIS2_WARN_IRQ_NOT_SET              0x9111
#define NDIS2_WARN_DMA_NOT_PIO              0x9112
#define NDIS2_WARN_DMA_NOT_SET              0x9113
#define NDIS2_WARN_DMA_SET_TO_PIO           0x9114
#define NDIS2_WARN_RING_SPEED_NOT_SET       0x9115
#define NDIS2_WARN_BAD_BIA_PARM             0x9116
#define NDIS2_WARN_PIO_SET_TO_MMIO          0x9117
#define NDIS2_WARN_DMA_SET_TO_MMIO          0x9118
#define NDIS2_WARN_REGISTER_PC_CARD         0x9119
#define NDIS2_WARN_FMP_REDEFINED            0x9120
#define NDIS2_WARN_MSG_FILE_ABSENT          0x9121
#define NDIS2_WARN_MSG_FILE_TOO_OLD         0x9122
#define NDIS2_WARN_MSG_FILE_TOO_NEW         0x9123
#define NDIS2_WARN_ADAPTER_CLOSED           0x9124  
#define NDIS2_WARN_ADAP_OPEN_FAILED         0x9125  
#define NDIS2_WARN_ADAP_NO_LINK_STATUS      0x9126  
#define NDIS2_WARN_ADAP_CLASSIC_DENIED      0x9127  
#define NDIS2_WARN_ADAP_OPEN_DENIED         0x9128  




#define NDIS2_ERR_REGISTER_FAIL             0x9200  
#define NDIS2_ERR_PROTMAN_OPEN_FAILED       0x9201  
#define NDIS2_ERR_PROTMAN_IOCTL_FAILED      0x9202  
#define NDIS2_ERR_NO_RINGNODES              0x9203  
#define NDIS2_ERR_PINI_NO_MODULES           0x9204  
#define NDIS2_ERR_NO_ADAPTER_MEMORY         0x9205
#define NDIS2_ERR_STRUCT_CHECK_FAIL         0x9206
#define NDIS2_ERR_IRQ_CHECK_FAIL            0x9207
#define NDIS2_ERR_DMA_CHECK_FAIL            0x9208
#define NDIS2_ERR_FMP_ALLOC_FAIL            0x9209
#define NDIS2_ERR_IRQ_SET_FAIL              0x9210  
#define NDIS2_ERR_DMA_SET_FAIL              0x9211
#define NDIS2_ERR_BUF_TOO_LARGE             0x9212
#define NDIS2_ERR_FMP_CORRUPT               0x9213
#define NDIS2_ERR_ADAP_NOT_RECOGNISED       0x9214
#define NDIS2_ERR_ALLOC_SELS_FAIL           0x9215
#define NDIS2_ERR_ALLOC_DRV_SELS_FAIL       0x9216
#define NDIS2_ERR_ADAP_OPEN_FAILED          0x9217  
#define NDIS2_ERR_MODULE_BIND_FAIL          0x9218
#define NDIS2_ERR_NOT_REGISTERED            0x9219  
#define NDIS2_ERR_NO_FREE_MODULE            0x9220
#define NDIS2_ERR_INSERTION_FAIL            0x9221
#define NDIS2_ERR_FMP_OPEN_FAIL             0x9222
#define NDIS2_ERR_FMP_READ_FAIL             0x9223
#define NDIS2_ERR_DTR_NOT_SUPPORTED         0x9224
#define NDIS2_ERR_FMP_VER_INCORRECT         0x9225
#define NDIS2_ERR_HEAP_FULL                 0x9226  
#define NDIS2_ERR_PINI_TOO_MANY_MODULES     0x9228  
#define NDIS2_ERR_DPMS_MALLOC_FAILED        0x9229  
#define NDIS2_ERR_OS2_MALLOC_FAILED         0x9230  
#define NDIS2_ERR_NO_USABLE_MODULE          0x9231  
#define NDIS2_ERR_NO_MATCHED_MODULE         0x9232  
#define NDIS2_ERR_NO_CONFIGURED_MODULE      0x9233  
#define NDIS2_ERR_NO_REGISTERED_MODULE      0x9234  
#define NDIS2_ERR_DPMS_NOT_AVAILABLE        0x9235  
#define NDIS2_ERR_NOT_LOADED                0x9236  
#define NDIS2_ERR_NO_ADAPTER_FOR_MODULE     0x9237  
#define NDIS2_ERR_INVALID_BIA               0x9238  
#define NDIS2_ERR_ADAPTER_CLOSED            0x9239  
#define NDIS2_ERR_ADAPTER_DEAD              0x9240  
#define NDIS2_ERR_INVALID_LAA               0x9241  
#define NDIS2_ERR_CANNOT_SET_LAA            0x9242  
#define NDIS2_ERR_ADAP_NO_LINK_STATUS       0x9243  
#define NDIS2_ERR_ADAP_CLASSIC_DENIED       0x9244  
#define NDIS2_ERR_ADAP_OPEN_DENIED          0x9245  








#define WRAP_ERR_NOT_80386_OR_ABOVE              0x9300



#define WRAP_ERR_PARSE_BAD_CHAR                  0x9310
#define WRAP_ERR_PARSE_BAD_STR                   0x9311
#define WRAP_ERR_PARSE_OUT_OF_RANGE              0x9312
#define WRAP_ERR_PARSE_NOT_BOOL                  0x9313
#define WRAP_ERR_PARSE_NOT_NUMERIC               0x9314
#define WRAP_ERR_PARSE_NOT_STRING                0x9315
#define WRAP_ERR_PARSE_NO_SUCH_KEYWORD           0x9316
#define WRAP_ERR_PARSE_DUPLICATE_GLOBAL_KEYWORD  0x9317
#define WRAP_ERR_PARSE_DUPLICATE_ADAPTER_KEYWORD 0x9318
#define WRAP_ERR_PARSE_MISSING_EQ                0x9319



#define WRAP_ERR_RUN_OUT_OF_STUBS           0x9330



#define WRAP_ERR_TOO_MANY_RX_SLOTS          0x9335
#define WRAP_ERR_TOO_FEW_RX_SLOTS           0x9336



#define WRAP_ERR_BADC_NO_IO_RANGE           0x9340
#define WRAP_ERR_BADC_IO_RANGE_TOO_SMALL    0x9341
#define WRAP_ERR_BADC_NO_IRQ                0x9342



#define WRAP_ERR_CS_MADGECS_TOO_OLD         0x9350
#define WRAP_ERR_CS_MADGECS_TOO_NEW         0x9351



#define WRAP_ERR_CANT_REGISTER_UPI          0x9400


#define WRAP_ERR_CANT_REGISTER_UDI          0x9401  

#define WRAP_ERR_NO_FIELDS_UPDATED          0x9405



#define WRAP_WARN_TOO_MANY_ADAPTERS         0x9500



#define WRAP_WARN_PARSE_NO_SUCH_KEYWORD     0x9516



#define WRAP_ERR_DOWNLOAD_OPEN_FAILED       0x9600
#define WRAP_ERR_DOWNLOAD_WRONG_TYPE        0x9601
#define WRAP_ERR_DOWNLOAD_WRONG_VERSION     0x9602



#define TEMPORARY_ERROR_CODES_BASE          0x9900
#define MAXIMUM_TEMPORARY_ERROR_CODE        0x9999



#define ILLEGAL_ERROR_CODE                  0xFFFF



#ifndef UDT_ERROR

typedef struct _ERROR_TABLE_T
{
  RETCODE_T adapter_error_code;
  STRING_T  adapter_error_str;
} ERROR_TABLE_T;

#ifdef INTERNAL_UDT_ERRORS_IN_ERROR_TABLE
# define UDT_INTERNAL_ERR_ENTRY(_err) {_err, STR_##_err},
#else
# define UDT_INTERNAL_ERR_ENTRY(_err)
#endif

#define UDT_VISIBLE_ERR_ENTRY(_err) {_err, STR_##_err},

#define UDT_ERR_ENTRY(_err)   {UDT_ERR_##_err, UDT_STR_##_err},


#define ERROR_TABLE                                                         \
                                                                            \
   UDT_INTERNAL_ERR_ENTRY(SUCCESS)                                          \
   UDT_INTERNAL_ERR_ENTRY(FAILURE)                                          \
                                                                            \
   UDT_INTERNAL_ERR_ENTRY(WRONG_STATE)                                      \
   UDT_INTERNAL_ERR_ENTRY(NULL_FUNCTION)                                    \
   UDT_INTERNAL_ERR_ENTRY(FUNCTION_POINTER_WAS_NULL)                        \
   UDT_INTERNAL_ERR_ENTRY(UNSUPPORTED_FUNCTION)                             \
   UDT_INTERNAL_ERR_ENTRY(COMMAND_PENDING)                                  \
   UDT_INTERNAL_ERR_ENTRY(COMMAND_FAILED)                                   \
   UDT_INTERNAL_ERR_ENTRY(BAD_ADAPTER_ID)                                   \
   UDT_INTERNAL_ERR_ENTRY(BAD_ADAPTER_ID_IO)                                \
   UDT_INTERNAL_ERR_ENTRY(BAD_ADAPTER_ID_NO_CARD_AT_IO)                     \
   UDT_INTERNAL_ERR_ENTRY(BAD_ADAPTER_ID_NO_PCI_CARD)                       \
   UDT_INTERNAL_ERR_ENTRY(UNSUPPORTED_BUS_TYPE)                             \
   UDT_INTERNAL_ERR_ENTRY(BAD_BUS_NUMBER)                                   \
   UDT_INTERNAL_ERR_ENTRY(BAD_PCI_NUMBER)                                   \
   UDT_INTERNAL_ERR_ENTRY(BAD_CONFIG_PARAMETER)                             \
   UDT_INTERNAL_ERR_ENTRY(CONFIG_PARAMETER_NOT_REQUIRED)                    \
   UDT_INTERNAL_ERR_ENTRY(CONFIG_PARAMETER_IN_ERROR)                        \
   UDT_INTERNAL_ERR_ENTRY(CONFIG_PARAMETER_MISMATCH)                        \
   UDT_INTERNAL_ERR_ENTRY(CONFIG_PARAMETER_UNKNOWN)                         \
   UDT_INTERNAL_ERR_ENTRY(UDTI_REG_FAILED)                                  \
   UDT_INTERNAL_ERR_ENTRY(NO_ACTIVE_FRAME)                                  \
   UDT_INTERNAL_ERR_ENTRY(BAD_RX_RESOURCE)                                  \
   UDT_INTERNAL_ERR_ENTRY(CORRUPT_SLOT_CHAIN)                               \
   UDT_INTERNAL_ERR_ENTRY(OUT_OF_BUFFER_RAM)                                \
   UDT_INTERNAL_ERR_ENTRY(BAD_LOOKAHEAD_SIZE)                               \
   UDT_INTERNAL_ERR_ENTRY(NO_PCI_CONFIGURATION_SPACE)                       \
   UDT_INTERNAL_ERR_ENTRY(NO_PCI_BUSES)                                     \
   UDT_INTERNAL_ERR_ENTRY(COMMAND_COMPLETED)                                \
                                                                            \
   UDT_VISIBLE_ERR_ENTRY(CARD_NOT_SUPPORTED)                                \
   UDT_VISIBLE_ERR_ENTRY(SWITCHES_MOVED_SO_DISABLED)                        \
   UDT_VISIBLE_ERR_ENTRY(BIA_DOES_NOT_CHECKSUM)                             \
   UDT_VISIBLE_ERR_ENTRY(SOFT_CONFIGURATION_CORRUPT)                        \
   UDT_VISIBLE_ERR_ENTRY(MC_NEED_ARBITRATION_LEVEL)                         \
   UDT_VISIBLE_ERR_ENTRY(CANNOT_REGISTER_IO)                                \
   UDT_VISIBLE_ERR_ENTRY(CANNOT_REGISTER_RAM)                               \
   UDT_VISIBLE_ERR_ENTRY(CANNOT_REGISTER_PCI)                               \
   UDT_VISIBLE_ERR_ENTRY(FAILED_TO_OPEN_ADAPTER_CODE)                       \
   UDT_VISIBLE_ERR_ENTRY(WRONG_ADAPTER_CODE_TYPE)                           \
   UDT_VISIBLE_ERR_ENTRY(WRONG_ADAPTER_CODE_VERSION)                        \
   UDT_VISIBLE_ERR_ENTRY(BAD_ADAPTER_CODE)                                  \
   UDT_VISIBLE_ERR_ENTRY(BAD_IO)                                            \
   UDT_VISIBLE_ERR_ENTRY(BAD_IRQ)                                           \
   UDT_VISIBLE_ERR_ENTRY(BAD_BIA)                                           \
   UDT_VISIBLE_ERR_ENTRY(SBLUE_IF_MMIO_SRAM_CLASH)                          \
   UDT_VISIBLE_ERR_ENTRY(BAD_ADAPTER)                                       \
   UDT_VISIBLE_ERR_ENTRY(BPLUS_FDT_IF_FAILURE)                              \
   UDT_VISIBLE_ERR_ENTRY(ADAPTER_INIT_FAILED)                               \
   UDT_VISIBLE_ERR_ENTRY(ADAPTER_TIMEDOUT)                                  \
   UDT_VISIBLE_ERR_ENTRY(OPEN_FAILED)                                       \
   UDT_VISIBLE_ERR_ENTRY(CLOSE_FAILED)                                      \
   UDT_VISIBLE_ERR_ENTRY(CANNOT_DISABLE_PROMISC)                            \
   UDT_VISIBLE_ERR_ENTRY(DMA_ENABLE_FAILED)                                 \
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_INITIAL_TEST)                           \
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_SW_CHECKSUM)                            \
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_RAM_TEST)                               \
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_INSTRUCTION_TEST)                       \
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_CONTEXT_TEST)                           \
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_PH_TEST)                                \
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_SIF_REG_TEST)                           \
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_ILLEGALLY)                              \
   UDT_VISIBLE_ERR_ENTRY(BUD_TIMED_OUT)                                     \
   UDT_VISIBLE_ERR_ENTRY(OUT_OF_ADAPTER_RAM)                                \
   UDT_VISIBLE_ERR_ENTRY(PRESTO_CRC_FAILURE)                                \
   UDT_VISIBLE_ERR_ENTRY(PRESTO_TXBM_FAIL_TO_START)                         \
                                                                            \
   UDT_ERR_ENTRY(CANNOT_FIND_INT)                                           \
   UDT_ERR_ENTRY(NO_ADAPTER_AT_IO)                                          \
   UDT_ERR_ENTRY(NO_ADAPTER_FOUND)                                          \
   UDT_ERR_ENTRY(BAD_IRQ)                                                   \
   UDT_ERR_ENTRY(BAD_DMA)                                                   \
   UDT_ERR_ENTRY(MC_INTS_DISABLED)                                          \
   UDT_ERR_ENTRY(GOOD_IO_BAD_SLOT)                                          \
   UDT_ERR_ENTRY(BAD_XFER)                                                  \
   UDT_ERR_ENTRY(BAD_MMIO)                                                  \
   UDT_ERR_ENTRY(NO_SPEED_SELECTED)                                         \
   UDT_ERR_ENTRY(ADAPTER_DISABLED)                                          \
   UDT_ERR_ENTRY(NO_ADAPTER_AT_SLOT)                                        \
   UDT_ERR_ENTRY(DOWNLOAD_WORD_CHECK)                                       \
   UDT_ERR_ENTRY(NO_ADAPTER_AT_BIA)                                         \
   UDT_ERR_ENTRY(GOOD_IO_BAD_BIA)                                           \
   UDT_ERR_ENTRY(PCMC_BAD_AUTO_CONFIG)                                      \
   UDT_ERR_ENTRY(GOOD_SLOT_BAD_BIA)                                         \
   UDT_ERR_ENTRY(TEST_TRANSFER_FAILED)                                      \
   UDT_ERR_ENTRY(INIT_TIMED_OUT)                                            \
   UDT_ERR_ENTRY(OPEN_FAILED_LOBE)                                          \
   UDT_ERR_ENTRY(OPEN_FAILED_DUP_NA)                                        \
   UDT_ERR_ENTRY(OPEN_FAILED_MISC)                                          \
   UDT_ERR_ENTRY(NO_MATCHING_ADAPTER)                                       \
   UDT_ERR_ENTRY(INIT_FAILED)                                               \
                                                                            \
   {ILLEGAL_ERROR_CODE, "Unknown error code"}

#else

#ifdef INTERNAL_UDT_ERRORS_IN_ERROR_TABLE
# define UDT_INTERNAL_ERR_ENTRY(_err) UDT_ERROR(_err, STR_##_err)
#else
# define UDT_INTERNAL_ERR_ENTRY(_err)
#endif

#define UDT_VISIBLE_ERR_ENTRY(_err) UDT_ERROR(_err, STR_##_err)

#define UDT_ERR_ENTRY(_err) UDT_ERROR(UDT_ERR_##_err, UDT_STR_##_err)

   UDT_INTERNAL_ERR_ENTRY(SUCCESS)
   UDT_INTERNAL_ERR_ENTRY(FAILURE)

   UDT_INTERNAL_ERR_ENTRY(WRONG_STATE)
   UDT_INTERNAL_ERR_ENTRY(NULL_FUNCTION)
   UDT_INTERNAL_ERR_ENTRY(FUNCTION_POINTER_WAS_NULL)
   UDT_INTERNAL_ERR_ENTRY(UNSUPPORTED_FUNCTION)
   UDT_INTERNAL_ERR_ENTRY(COMMAND_PENDING)
   UDT_INTERNAL_ERR_ENTRY(COMMAND_FAILED)
   UDT_INTERNAL_ERR_ENTRY(BAD_ADAPTER_ID)
   UDT_INTERNAL_ERR_ENTRY(BAD_ADAPTER_ID_IO)
   UDT_INTERNAL_ERR_ENTRY(BAD_ADAPTER_ID_NO_CARD_AT_IO)
   UDT_INTERNAL_ERR_ENTRY(BAD_ADAPTER_ID_NO_PCI_CARD)
   UDT_INTERNAL_ERR_ENTRY(UNSUPPORTED_BUS_TYPE)
   UDT_INTERNAL_ERR_ENTRY(BAD_BUS_NUMBER)
   UDT_INTERNAL_ERR_ENTRY(BAD_PCI_NUMBER)
   UDT_INTERNAL_ERR_ENTRY(BAD_CONFIG_PARAMETER)
   UDT_INTERNAL_ERR_ENTRY(CONFIG_PARAMETER_NOT_REQUIRED)
   UDT_INTERNAL_ERR_ENTRY(CONFIG_PARAMETER_IN_ERROR)
   UDT_INTERNAL_ERR_ENTRY(CONFIG_PARAMETER_MISMATCH)
   UDT_INTERNAL_ERR_ENTRY(CONFIG_PARAMETER_UNKNOWN)
   UDT_INTERNAL_ERR_ENTRY(UDTI_REG_FAILED)
   UDT_INTERNAL_ERR_ENTRY(NO_ACTIVE_FRAME)
   UDT_INTERNAL_ERR_ENTRY(BAD_RX_RESOURCE)
   UDT_INTERNAL_ERR_ENTRY(CORRUPT_SLOT_CHAIN)
   UDT_INTERNAL_ERR_ENTRY(OUT_OF_BUFFER_RAM)
   UDT_INTERNAL_ERR_ENTRY(OUT_OF_ADAPTER_RAM)
   UDT_INTERNAL_ERR_ENTRY(BAD_LOOKAHEAD_SIZE)
   UDT_INTERNAL_ERR_ENTRY(NO_PCI_CONFIGURATION_SPACE)
   UDT_INTERNAL_ERR_ENTRY(NO_PCI_BUSES)
   UDT_INTERNAL_ERR_ENTRY(COMMAND_COMPLETED)

   UDT_VISIBLE_ERR_ENTRY(CARD_NOT_SUPPORTED)
   UDT_VISIBLE_ERR_ENTRY(SWITCHES_MOVED_SO_DISABLED)
   UDT_VISIBLE_ERR_ENTRY(BIA_DOES_NOT_CHECKSUM)
   UDT_VISIBLE_ERR_ENTRY(SOFT_CONFIGURATION_CORRUPT)
   UDT_VISIBLE_ERR_ENTRY(MC_NEED_ARBITRATION_LEVEL)
   UDT_VISIBLE_ERR_ENTRY(CANNOT_REGISTER_IO)
   UDT_VISIBLE_ERR_ENTRY(CANNOT_REGISTER_RAM)
   UDT_VISIBLE_ERR_ENTRY(CANNOT_REGISTER_PCI)
   UDT_VISIBLE_ERR_ENTRY(FAILED_TO_OPEN_ADAPTER_CODE)
   UDT_VISIBLE_ERR_ENTRY(WRONG_ADAPTER_CODE_TYPE)
   UDT_VISIBLE_ERR_ENTRY(WRONG_ADAPTER_CODE_VERSION)
   UDT_VISIBLE_ERR_ENTRY(BAD_ADAPTER_CODE)
   UDT_VISIBLE_ERR_ENTRY(BAD_IO)
   UDT_VISIBLE_ERR_ENTRY(BAD_IRQ)
   UDT_VISIBLE_ERR_ENTRY(BAD_BIA)
   UDT_VISIBLE_ERR_ENTRY(SBLUE_IF_MMIO_SRAM_CLASH)
   UDT_VISIBLE_ERR_ENTRY(BAD_ADAPTER)
   UDT_VISIBLE_ERR_ENTRY(BPLUS_FDT_IF_FAILURE)
   UDT_VISIBLE_ERR_ENTRY(ADAPTER_INIT_FAILED)
   UDT_VISIBLE_ERR_ENTRY(ADAPTER_TIMEDOUT)
   UDT_VISIBLE_ERR_ENTRY(OPEN_FAILED)
   UDT_VISIBLE_ERR_ENTRY(CLOSE_FAILED)
   UDT_VISIBLE_ERR_ENTRY(CANNOT_DISABLE_PROMISC)
   UDT_VISIBLE_ERR_ENTRY(DMA_ENABLE_FAILED)
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_INITIAL_TEST)
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_SW_CHECKSUM)
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_RAM_TEST)
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_INSTRUCTION_TEST)
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_CONTEXT_TEST)
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_PH_TEST)
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_SIF_REG_TEST)
   UDT_VISIBLE_ERR_ENTRY(BUD_FAILED_ILLEGALLY)
   UDT_VISIBLE_ERR_ENTRY(BUD_TIMED_OUT)
   UDT_VISIBLE_ERR_ENTRY(OUT_OF_ADAPTER_RAM)
   UDT_VISIBLE_ERR_ENTRY(PRESTO_CRC_FAILURE)
   UDT_VISIBLE_ERR_ENTRY(PRESTO_TXBM_FAIL_TO_START)

   UDT_ERR_ENTRY(MC_INTS_DISABLED)
   UDT_ERR_ENTRY(NO_SPEED_SELECTED)
   UDT_ERR_ENTRY(ADAPTER_DISABLED)
   UDT_ERR_ENTRY(DOWNLOAD_WORD_CHECK)
   UDT_ERR_ENTRY(INIT_TIMED_OUT)
   UDT_ERR_ENTRY(MAC_MDG_INIT_BLOCK)
   UDT_ERR_ENTRY(MAC_MDG_INIT_OPTIONS)
   UDT_ERR_ENTRY(MAC_MDG_INIT_BAD_BIA)
   UDT_ERR_ENTRY(MAC_MDG_INIT_OUT_OF_MEM)
   UDT_ERR_ENTRY(MAC_MDG_INIT_DMA_THRESH)
   UDT_ERR_ENTRY(MAC_MDG_INIT_ODD_SCB)
   UDT_ERR_ENTRY(MAC_MDG_INIT_ODD_SSB)
   UDT_ERR_ENTRY(MAC_MDG_INIT_DIO_PARITY)
   UDT_ERR_ENTRY(MAC_MDG_INIT_DMA_TIMEOUT)
   UDT_ERR_ENTRY(MAC_MDG_INIT_DMA_PARITY)
   UDT_ERR_ENTRY(MAC_MDG_INIT_DMA_BUS)
   UDT_ERR_ENTRY(MAC_MDG_INIT_DMA_DATA)
   UDT_ERR_ENTRY(MAC_MDG_INIT_ADAPTER_CHK)
   UDT_ERR_ENTRY(MAC_MDG_INIT_NO_MEMORY)
   UDT_ERR_ENTRY(MAC_MDG_INIT_RESERVED)

#endif





