/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/*****************************************************************************
*
* **  ** ****** ******  ******    **  **
* **  ** **      **  ** **        **  **
* **  ** **      **  ** **        **  **
* ****** ****    *****  ****      ******
* **  ** **      **  ** **        **  **
* **  ** **      **  ** **     ** **  **
* **  ** ****** ******  ****** ** **  **
*
******************************************************************************
*
* Data structures and defines for Olicom Hawkeye / Bullseye Adapters.
*
******************************************************************************
*
* Copyright (C) 1999 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
******************************************************************************
*/









#define HEBE_TX_STRUCTURE_FRAGMENT_INDEX        0
#define HEBE_RX_STRUCTURE_FRAGMENT_INDEX        1
#define BE_DRAIN_FRAGMENT_INDEX                 2
#define HE_CRC_FRAGMENT_INDEX                   2

#define HEBE_MAX_DESC_PER_TX                    10
#define HEBE_MAX_OUTSTANDING_TX                 32


#define OM_BIT0     0x0001   
#define OM_BIT1     0x0002   
#define OM_BIT2     0x0004   
#define OM_BIT3     0x0008   
#define OM_BIT4     0x0010   
#define OM_BIT5     0x0020   
#define OM_BIT6     0x0040   
#define OM_BIT7     0x0080   
#define OM_BIT8     0x0100   
#define OM_BIT9     0x0200   
#define OM_BIT10    0x0400   
#define OM_BIT11    0x0800   
#define OM_BIT12    0x1000   
#define OM_BIT13    0x2000   
#define OM_BIT14    0x4000   
#define OM_BIT15    0x8000   



#ifdef UDT_PACK_ON
#pragma UDT_PACK_ON
#else
#ifdef UDT_ALT_PACK
#pragma pack 1
#else
#pragma pack(1)
#endif
#endif



#define HEMAC_INTERNAL_DATA_BASE            0x300
#define HEMAC_VERSION_INFO                  0x380

#define HEMAC_READY_TIME                    1000        
#define HEMAC_COMMAND_WAIT                  500         



#define HEMAC_NOP_COMMAND                   0x0000
#define HEMAC_TEST_COMMAND                  0x0001
#define HEMAC_CONFIG_COMMAND                0x0002
#define HEMAC_OPEN_COMMAND                  0x0003
#define HEMAC_CLOSE_COMMAND                 0x0004
#define HEMAC_SFA_COMMAND                   0x0005
#define HEMAC_SGA_COMMAND                   0x0006
#define HEMAC_GET_ERROR_COUNTS_COMMAND      0x0007
#define HEMAC_MODIFY_OPEN_COMMAND           0x0008
#define HEMAC_MODIFY_RB_NUM_COMMAND         0x0009
#define HEMAC_DTR_RESPONSE                  0x000A
#define HEMAC_GET_STAT_COUNTS_COMMAND       0x000B
#define HEMAC_SEND_FRAME_COMMAND            0x000C
#define HEMAC_MODIFY_SRB_COMMAND            0x000D
#define HEMAC_RESET_MAC_COMMAND             0x000E
#define HEMAC_ENABLE_WAKEUP_COMMAND         0x000F
#define HEMAC_SET_GLOBAL_RESET_COMMAND      0x0010



#define HEMAC_NOP_CMD_LENGTH                8
#define HEMAC_TEST_CMD_LENGTH               28
#define HEMAC_CONFIG_CMD_LENGTH             28
#define HEMAC_OPEN_CMD_LENGTH               42
#define HEMAC_CLOSE_CMD_LENGTH              8
#define HEMAC_SFA_CMD_LENGTH                12
#define HEMAC_SGA_CMD_LENGTH                12
#define HEMAC_GET_ERR_CNT_CMD_LENGTH        18
#define HEMAC_MODIFY_OPEN_CMD_LENGTH        10
#define HEMAC_MODIFY_RB_NUM_CMD_LENGTH      10
#define HEMAC_DTR_RESPONSE_CMD_LENGTH       10
#define HEMAC_GET_STAT_CNT_CMD_LENGTH       32
#define HEMAC_SEND_FRAME_CMD_LENGTH         8
#define HEMAC_MODIFY_SRB_CMD_LENGTH         12
#define HEMAC_SET_GLOBAL_RESET_LENGTH       12
#define HEMAC_SET_WAKEUP_LENGTH             12



#define HEMAC_READY_STATUS                  0x0001
#define HEMAC_CONNECT_STATUS                0x0002
#define HEMAC_CLOSED_STATUS                 0x0003
#define HEMAC_RING_STATUS                   0x0004
#define HEMAC_LIST_CHANGE_STATUS            0x0005
#define HEMAC_WATCHDOG_STATUS               0x0006
#define HEMAC_TRM_QUEUE                     0x0007
#define HEMAC_INT_RESPONSE_STATUS           0x0008

#define HEMAC_STATUS_DONE                   0x80000000
#define HEMAC_COMMAND_DONE                  0x00000080



#define HEMAC_COMMAND_OK                    0x2000
#define MAC_WRONG_STATE                     0x0100



#define HEMAC_NOT_INIT                      0
#define HEMAC_CLOSED                        1
#define HEMAC_OPENING                       2
#define HEMAC_OPENED                        3
#define HEMAC_CLOSING                       4



#define MAC_NO_WAIT                         0
#define MAC_BUSY_WAIT                       1



#define HE_OPT_WRAP_ON_LOBE                 OM_BIT15
#define HE_OPT_DI_HARD_ERROR                OM_BIT14
#define HE_OPT_DI_SOFT_ERROR                OM_BIT13
#define HE_OPT_PASS_UNSUPPORTED             OM_BIT12
#define HE_OPT_PASS_ATTENTION               OM_BIT11
#define HE_OPT_WRAP_ON_ADAPTER              OM_BIT10
#define HE_OPT_REOPEN                       OM_BIT9
#define HE_OPT_CLAIM_CONTENDER              OM_BIT8
#define HE_OPT_PASS_BEACON                  OM_BIT7
#define HE_OPT_EARLY_RELEASE                OM_BIT4
#define HE_OPT_COPY_ALL_MAC                 OM_BIT2
#define HE_OPT_COPY_ALL_LLC                 OM_BIT1

#define HE_OPT_COPY_ALL_FRAMES              OM_BIT1 + OM_BIT2
#define HE_PRESERVE_OPEN_OPTIONS            0xFFFF &                        \
                                                ~(HE_OPT_COPY_ALL_MAC +     \
                                                  HE_OPT_COPY_ALL_LLC +     \
                                                  HE_OPT_PASS_BEACON  +     \
                                                  HE_OPT_PASS_UNSUPPORTED+  \
                                                  HE_OPT_PASS_ATTENTION)

#define HE_LEGAL_OPEN_OPTIONS               0xFFFF &                        \
                                                ~(HE_OPT_WRAP_ON_LOBE+      \
                                                  HE_OPT_WRAP_ON_ADAPTER)



typedef struct
{
    WORD_T                          HEMAC_BA_Ptr;
    WORD_T                          HEMAC_Address_Table_Ptr;
    WORD_T                          HEMAC_Adapter_Status_Ptr;
    WORD_T                          HEMAC_Command_Buf_Ptr;
    WORD_T                          HEMAC_Status_Buf_Ptr;
    WORD_T                          HEMAC_TRM_Queue_Ptr;
    WORD_T                          HEMAC_Station_List_Ptr;
    WORD_T                          HEMAC_Statistics_Ptr;
    WORD_T                          HEMAC_10ms_Counter_Ptr;
    WORD_T                          HEMAC_Int_Request;
    WORD_T                          HEMAC_pwr_cnt;
    WORD_T                          HEMAC_dummy_00;
    WORD_T                          HEMAC_WakeUpFrameFilter;

} HEMAC_INTERNAL_DATA_T;



typedef struct
{
    MAC_ADDRESS_T                   HEMAC_Node_Address;
    MAC_ADDRESS_T                   HEMAC_Group_Address;
    MAC_ADDRESS_T                   HEMAC_Functional_Address;

} HEMAC_ADDRESS_TABLE_T;



typedef struct
{
    DWORD_T                         Physical_Drop_Nr;
    MAC_ADDRESS_T                   Upstream_Address;
    DWORD_T                         Upstream_Drop_Nr;
    MAC_ADDRESS_T                   Last_Poll_Address;
    WORD_T                          Reserved_1;
    WORD_T                          Authorized_Access_Priority;
    WORD_T                          Function_Class_Authorization;
    WORD_T                          Last_Attention_Code;
    MAC_ADDRESS_T                   Last_Beacon_Address;
    WORD_T                          Last_Beacon_Type;
    WORD_T                          Last_Major_Vector;
    WORD_T                          Token_Ring_Status;
    WORD_T                          Soft_Error_Timer;
    WORD_T                          Front_End_Errors;
    WORD_T                          Ring_Number;
    WORD_T                          Monitor_Error;
    WORD_T                          Beacon_Tx_Type;
    WORD_T                          Beacon_Rx_Type;
    WORD_T                          Last_Frame_Correlator;
    MAC_ADDRESS_T                   Beaconing_Station_NAUN;
    DWORD_T                         Reserved_2;
    DWORD_T                         Beacon_Station_Drop_Nr;
    WORD_T                          Phantom_Support;
    WORD_T                          Access_Protocol_Request;
    WORD_T                          Access_Protocol_Response;
    WORD_T                          Protocol_Event_Status;
    WORD_T                          Policy_Flags;
    WORD_T                          Protocol_Join_State;
    WORD_T                          Protocol_Monitor_State;
    WORD_T                          Control_Ring_State;
    WORD_T                          Last_Connect_Status;

} HEMAC_ADAPTER_STATUS_T;



typedef struct
{
    WORD_T                          Command_Code;
    WORD_T                          Command_Response;
    WORD_T                          Reserved_3;
    WORD_T                          Command_Length;

} HEMAC_COMMAND_T,
  _FAR* P_HEMAC_COMMAND_T;




typedef struct
{
    WORD_T                          Status_Code;
    WORD_T                          Reserved_3;
    WORD_T                          Status_Length;
    WORD_T                          Status_Data;

} HEMAC_STATUS_T;



typedef struct
{
    WORD_T                          Received_Frames;
    WORD_T                          Received_Bytes;
    WORD_T                          Ring_Purge_Events;
    WORD_T                          Ring_Purge_Frames;
    WORD_T                          Beacon_Events;
    WORD_T                          Beacon_Time;
    WORD_T                          Beacon_Frames;
    WORD_T                          Claim_Token_Events;
    WORD_T                          Claim_Token_Frames;
    WORD_T                          NAUN_Changes;
    WORD_T                          Ring_Poll_Events;
    WORD_T                          Soft_Error_Reports;

} HEMAC_STATISTICS_T;



typedef struct
{
    BYTE_T                          Reserved_4;
    BYTE_T                          MAC_Major_Version;
    BYTE_T                          MAC_Minor_Version;
    WORD_T                          Interface_Type;
    WORD_T                          Interface_Version;
    BYTE_T                          ASIC_Type;
    BYTE_T                          ASIC_Revision;
    BYTE_T                          ASIC_ID;

} HEMAC_VERSION_T;

typedef struct
{
    HEMAC_COMMAND_T                 Config_Header;
    WORD_T                          Port_Mode_Options;
    WORD_T                          Config_Options;
    MAC_ADDRESS_T                   Config_BIA;
    WORD_T                          Config_Max_Frame_Size;
    WORD_T                          Config_RB_Num;
    WORD_T                          Config_SRB_Ctrl;
    WORD_T                          Config_AsicType_Revid;
    WORD_T                          Config_Reserved;

} HEMAC_CONFIG_COMMAND_T;

typedef struct
{
    HEMAC_COMMAND_T                 Open_Header;
    WORD_T                          Open_Options;
    MAC_ADDRESS_T                   Open_MAC_Address;
    GROUP_ADDRESS_T                 Group_Address;
    FUNCTIONAL_ADDRESS_T            Functional_Address;
    BYTE_T                          Product_ID[18];

} HEMAC_OPEN_COMMAND_T;

typedef struct
{
    HEMAC_COMMAND_T                 SFA_Header;
    FUNCTIONAL_ADDRESS_T            Functional_Address;

} HEMAC_FUNC_COMMAND_T;

typedef struct
{
    HEMAC_COMMAND_T                 SGA_Header;
    GROUP_ADDRESS_T                 Group_Address;

} HEMAC_GROUP_COMMAND_T;

typedef struct
{
    HEMAC_COMMAND_T                 MOO_Header;
    WORD_T                          New_Open_Options;

} HEMAC_MOD_OPEN_COMMAND_T;

typedef struct
{
    HEMAC_COMMAND_T                 GEC_Header;
    DWORD_T                         HE_Error_1;
    DWORD_T                         HE_Error_2;
    DWORD_T                         HE_Error_3;

} HEMAC_GET_ERRORS_COMMAND_T;


typedef struct
{
    HEMAC_COMMAND_T                 WKU_Header;
    BYTE_T                          Cable_wakeup;
    BYTE_T                          VitualConnected_wakeup;
    WORD_T                          reserved_wku;

} HEMAC_WAKEUP_COMMAND_T;


typedef struct
{
    HEMAC_COMMAND_T                 GST_Header;
    WORD_T                          HE_Received_Frames;
    WORD_T                          HE_Received_Bytes;
    WORD_T                          HE_Ring_Purge_Events;
    WORD_T                          HE_Ring_Purge_Frames;
    WORD_T                          HE_Beacon_Events;
    WORD_T                          HE_Beacon_Time;
    WORD_T                          HE_Beacon_Frames;
    WORD_T                          HE_Claim_Ecents;
    WORD_T                          HE_Claim_Frames;
    WORD_T                          HE_NAUN_Changes;
    WORD_T                          HE_Ring_Poll_Events;
    WORD_T                          HE_Soft_Error_Reports;

} HEMAC_GET_STAT_COMMAND_T;

typedef struct
{
    HEMAC_COMMAND_T                 SGR_Header;
    WORD_T                          Global_Reset_Value;
    WORD_T                          Global_Reset_Mask;

} HEMAC_SET_GLOBAL_COMMAND_T;


#ifdef UDT_PACK_OFF
#pragma UDT_PACK_OFF
#else
#ifdef UDT_ALT_PACK
#pragma pack 0
#else
#pragma pack()
#endif
#endif



#ifdef OLICOM_BE_UDI

#ifdef UDT_PACK_ON
#pragma UDT_PACK_ON
#else
#ifdef UDT_ALT_PACK
#pragma pack 1
#else
#pragma pack(1)
#endif
#endif



typedef struct
{
    BYTE_T                          mask;
    BYTE_T                          samples[7];

} BE_WAKEUP_LINE_T;

typedef struct
{
    BYTE_T                          reserved;
    BYTE_T                          lengths[7];

} BE_WAKEUP_LENGTH_T;

typedef struct
{
    BYTE_T                          reserved[5];
    BYTE_T                          config;

} BE_WAKEUP_CONFIG_T;

typedef struct
{
    BE_WAKEUP_CONFIG_T              line_config;
    BE_WAKEUP_LENGTH_T              line_lengths;

    

    BE_WAKEUP_LINE_T                debug_lines[4];

    

    BE_WAKEUP_LINE_T                acfc_lines[2];
    BE_WAKEUP_LINE_T                lines[143];

} BE_WAKEUP_FRAME_T;



typedef struct
{
    WORD_T      BE_xmbuflen;    
    WORD_T      BE_xmRinglnNum; 

    WORD_T      BE_xmcmplstat;  
    WORD_T      BE_xmctrl;      

    DWORD_T     BE_xmbuffer;    
    DWORD_T     BE_xmfwdptr;    

} BE_TX_DESC_T;

typedef struct
{
    WORD_T      BE_rxbuflen;    
    WORD_T      BE_rxctrl;      

    WORD_T      BE_rxcmplstat;  
    WORD_T      BE_rxbrgd;      

    DWORD_T     BE_rxbuffer;    
    DWORD_T     BE_rxfwdptr;    

} BE_RX_DESC_T;

typedef struct 
{
    VOLATILE BE_TX_DESC_T   TX_rb[5];
    VOLATILE BE_RX_DESC_T   RX_rb[5];
    VOLATILE BYTE_T         TX_frame_data[16];
    VOLATILE BYTE_T         RX_frame_data[24];
    VOLATILE BYTE_T         padding[4];

} BE_DRAIN_AREA_T;

#ifdef UDT_PACK_OFF
#pragma UDT_PACK_OFF
#else
#ifdef UDT_ALT_PACK
#pragma pack 0
#else
#pragma pack()
#endif
#endif

#define DRAIN_AREA_SIZE     sizeof(BE_DRAIN_AREA_T)

#endif  



#define READ_HEBE_BYTE(_p, _r)                                           \
   (INB( (_p), 0, (UINT_T)(_r)))

#define READ_HEBE_WORD(_p, _r)                                           \
   (INW( (_p), 0, (UINT_T)(_r)))

#define READ_HEBE_DWORD(_p, _r)                                          \
   (IND( (_p), 0, (UINT_T)(_r)))

#define WRITE_HEBE_BYTE(_p, _r, _d)                                      \
   (OUTB( (_p), 0, (UINT_T)(_r), (BYTE_T)(_d)))

#define WRITE_HEBE_WORD(_p, _r, _d)                                      \
   (OUTW( (_p), 0, (UINT_T)(_r), (WORD_T)(_d)))

#define WRITE_HEBE_DWORD(_p, _r, _d)                                     \
   (OUTD( (_p), 0, (UINT_T)(_r), (DWORD_T)(_d)))




#ifdef UDT_PACK_ON
#pragma UDT_PACK_ON
#else
#ifdef UDT_ALT_PACK
#pragma pack 1
#else
#pragma pack(1)
#endif
#endif



typedef VOLATILE struct _HEBE_TX_FRAG_INFO
{
    WORD_T              tx_bufferlen;
    WORD_T              tx_ringninnumber;
    WORD_T              tx_completion_status;
    WORD_T              tx_control;
    DWORD_T             tx_databuffer_ptr;
    DWORD_T             tx_fwd_ptr;

    

    WORD_T              tx_prev_index_ptr;
    WORD_T              tx_next_index_ptr;

    DWORD_T             tx_local_buffer;

} HEBE_TX_FRAG_INFO_T,
  FAR_DATA* P_HEBE_TX_FRAG_INFO_T;




typedef VOLATILE struct _HEBE_RX_FRAG_INFO
{
    WORD_T              rx_bufferlen;
    WORD_T              rx_control;
    WORD_T              rx_completion_status;
    WORD_T              rx_bridging_status;
    DWORD_T             rx_databuffer_ptr;
    DWORD_T             rx_fwd_ptr;

    

    WORD_T              rx_prev_index_ptr;  
    WORD_T              rx_next_index_ptr;

} HEBE_RX_FRAG_INFO_T,
  FAR_DATA* P_HEBE_RX_FRAG_INFO_T;


typedef struct _HEBE_SHARED
{
    

    BYTE_T               pokeout_method;

} HEBE_SHARED_T,
  FAR_DATA   * P_HEBE_SHARED_T,
  FAR_CLIENT * PCLIENT_HEBE_SHARED_T;



#ifdef UDT_PACK_OFF
#pragma UDT_PACK_OFF
#else
#ifdef UDT_ALT_PACK
#pragma pack 0
#else
#pragma pack()
#endif
#endif



#if defined(OLICOM_HEBE_UDI)

#define HEBE_INIT_FROM_UDIDS(_p) (ADAPTER_INIT_FROM_UDIDS(_p).hebe)
#define HEBE_RES_FROM_UDIDS(_p)  (ADAPTER_RES_FROM_UDIDS(_p).hebe)

#define HEBE_INIT_INFO_FROM_UDIDS(_p)                                    \
        (ADAPTER_INIT_INFO_FROM_UDIDS(_p).hebe)
#define HEBE_PERSISTENT_RES_INFO_FROM_UDIDS(_p)                          \
        (ADAPTER_PERSISTENT_RES_INFO_FROM_UDIDS(_p).hebe)
#define HEBE_RES_INFO_FROM_UDIDS(_p)                                     \
        (ADAPTER_RES_INFO_FROM_UDIDS(_p).hebe)




#ifdef UDT_INDIRECT_INTER_MODULE_CALLS

#define D_HEBE_RES_T

typedef RETCODE_T
(UDT_INTER_MODULE *HEBE_CONFIGURE_T)(
    INOUT P_UDI_DATA_T                  udids_ptr,
    IN    OPEN_OPTION_T                 open_mode);

typedef VOID_T
(UDT_INTER_MODULE *HEBE_RESET_ASIC_T)(
    INOUT P_UDI_DATA_T                  udids_ptr,
    IN      WORD_T                      reset_value);

typedef struct _HEBE_RES_T
{
    HEBE_CONFIGURE_T                    hebe_configure;

#   define HEBE_CONFIGURE(_p, _a)                                           \
        (HEBE_RES_FROM_UDIDS(_p).hebe_configure(                            \
                                        (_p),                               \
                                        (_a)))

    HEBE_RESET_ASIC_T                   hebe_reset_asic;

#   define HEBE_RESET_ASIC(_p, _a)                                          \
        (HEBE_RES_FROM_UDIDS(_p).hebe_reset_asic(                           \
                                        (_p),                               \
                                        (_a)))
} HEBE_RES_T;

#else  

#   define HEBE_CONFIGURE(_p, _a)                                           \
        (hebe_configure(                                                    \
                                        (_p),                               \
                                        (_a)))
#   define HEBE_RESET_ASIC(_p, _a)                                          \
        (hebe_reset_asic(                                                   \
                                        (_p),                               \
                                        (_a)))

#endif 



#define D_HEBE_RES_INFO_T         


typedef struct _HEBE_DEVICE_DEPENDANT_INFO_T
{
    

    WORD_T                          tx_dsa_reg_addr;

    

    WORD_T                          tx_imm_pol_mask;

    

    WORD_T                          tx_idle_mask;

    

    WORD_T                          tx_suspend_state_mask;

    

    WORD_T                          tx_null_desc_ctrl;


    

    BYTE_T                          tx_ack_position;    

} HEBE_DEVICE_DEPENDANT_INFO_T;




typedef struct _HEBE_PERSISTENT_RES_INFO_T
{

    HEBE_DEVICE_DEPENDANT_INFO_T    device_specific;

    

    WORD_T                          eeprom_utility_contents;

    

    WORD_T                          pci_command_reg;

    

    BYTE_T                          pci_cache_line_size;

    

    WORD_T                          configured_tx_desc_count;

    

    WORD_T                          configured_rx_desc_count;

    

    BOOLEAN_T                       rf3139;

    

    BOOLEAN_T                       bullseyebased;


} HEBE_PERSISTENT_RES_INFO_T,
  FAR_DATA * P_HEBE_PERSISTENT_RES_INFO_T;

typedef struct _HEBE_TX_CONFIRM_INFO_T
{
    

    P_FRAME_T                       tx_confirm;         

    

    WORD_T                          tx_start_desc_ptr;

    

    WORD_T                          tx_desc_count;

} HEBE_TX_CONFIRM_INFO_T;



typedef struct _HEBE_RES_INFO_T
{
    HEMAC_INTERNAL_DATA_T           HE_Pointer_Lst;

    WORD_T                          interrupt_mask_value;

    

    

    WORD_T                          tx_free_desc_count;

    

    WORD_T                          tx_free_desc_ptr;

    
    
    HEBE_TX_CONFIRM_INFO_T          tx_confirm_info[HEBE_MAX_OUTSTANDING_TX];

    

    WORD_T                          tx_free_confirm_index;

    

    WORD_T                          tx_free_confirm_count;

    

    WORD_T                          tx_pending_confirm_index;

    

    WORD_T                          tx_pending_confirm_count;

    

    

    WORD_T                          rx_free_desc_count;

    

    WORD_T                          rx_first_ptr;

    

    WORD_T                          rx_first_free_ptr;

    

    WORD_T                          rx_used_desc_count;

    

    P_FRAME_T                       rx_frame_list;

    

    P_FRAME_T                       rx_last_frame_list_entry;

    

    BOOLEAN_T                       rx_dma_started;

    

    BYTE_T                          status_command;

    

    WORD_T                          command;


    

    OPEN_OPTION_T                   open_mode;


    RING_SPEED_T                    original_ringspeed;


    BOOLEAN_T                       open_in_progress;

#ifdef UDT_UDI_SLEEP_COMMAND
    BOOLEAN_T                       sleep_in_progress;

    HEMAC_WAKEUP_COMMAND_T          CmdWku;
#endif

    

    

    BOOLEAN_T                       check_rfo;

    

    BYTE_T                          check_rfo_counts;

    

    BYTE_T                          pending_rx_ovfl_recover_cnt;

    

    BOOLEAN_T                       check_rx_overflow;

    

    WORD_T                          saved_open_options; 

    

    WORD_T                          pending_int_status;

    

    DWORD_T                         watchdog_counter;

#ifdef UDT_LIMIT_RX_LOOPS

    

    UINT_T                          remaining_reception_quota;


    BOOLEAN_T                       preserve_rx_int_status;

    BOOLEAN_T                       last_preserve_rx_int_status;


#endif 

#ifdef UDT_NO_SSI_PROTECT

  

    BOOLEAN_T                       tx_data_protected;

    

    BOOLEAN_T                       ignored_possible_tx_complete;

#endif 

} HEBE_RES_INFO_T,
  FAR_DATA   * P_HEBE_RES_INFO_T;




#define HEBE_INIT_FROM_UDIDS(_p) (ADAPTER_INIT_FROM_UDIDS(_p).hebe)

#define D_HEBE_INIT_T

typedef BYTE_T
(UDT_INDIRECT *HEBE_AT24_READB_T)(
    INOUT P_UDI_DATA_T udids_ptr,
          BYTE_T       addr);

typedef RETCODE_T
(UDT_INDIRECT *HEBE_AT24_WRITEB_T)(
    INOUT P_UDI_DATA_T udids_ptr,
          BYTE_T       addr,
          BYTE_T       data_byte);

typedef struct _HEBE_INIT_T
{
    HEBE_AT24_READB_T               hebe_at24_readb;

#define HEBE_AT24_READB(_p, _a)                                             \
        (HEBE_INIT_FROM_UDIDS(_p).hebe_at24_readb(                          \
                                       (_p),                                \
                                       (_a)))

    HEBE_AT24_WRITEB_T              hebe_at24_writeb;

#define HEBE_AT24_WRITEB(_p, _a, _b)                                        \
        (HEBE_INIT_FROM_UDIDS(_p).hebe_at24_writeb(                         \
                                       (_p),                                \
                                       (_a),                                \
                                       (_b)))

} HEBE_INIT_T,
  FAR_INIT_DATA  * P_HEBE_INIT_T;


#endif 





#define HEBE_IO_SPACE_RANGE                     0x40




#define BE_ASIC_POLL                            0x00
#define HE_ASIC_POLL                            0x1E

#define POLL_FREQUENCY_SHIFT                    4
#define POLL_RETRY_SHIFT                        8



#define BE_ASIC_CLOCK                           0x02
#define BE_CLOCK_INIT                           0x06
#define BE_POWER_DOWN_MAC_CPU                   0x10



#define HEBE_ASIC_RX_SHORTAGE                   0x03




#define BE_ASIC_INT_PACE                        0x04
#define HE_ASIC_INT_PACE                        0x06



#define BE_PACE_TX_LOW_MASK                     0x0000001F
#define BE_PACE_TX_HIGH_MASK                    0x000003E0
#define BE_PACE_RX_MASK                         0x00007C00
#define BE_PACE_TIMEOUT_MASK                    0x1FFF0000
#define BE_PACE_TX_LOW_SHIFT                    0
#define BE_PACE_TX_HIGH_SHIFT                   5
#define BE_PACE_RX_SHIFT                        10
#define BE_PACE_TIMEOUT_SHIFT                   16
#define BE_PACE_TX_MASK                         BE_PACE_TX_LOW_MASK
#define BE_PACE_TX_SHIFT                        BE_PACE_TX_LOW_SHIFT



#define HE_PACE_TX_LOW_MASK                     0x0007
#define HE_PACE_TX_HIGH_MASK                    0x0038
#define HE_PACE_RX_MASK                         0x01C0
#define HE_PACE_TIMEOUT_MASK                    0xFE00
#define HE_PACE_TX_LOW_SHIFT                    0
#define HE_PACE_TX_HIGH_SHIFT                   3
#define HE_PACE_RX_SHIFT                        6
#define HE_PACE_TIMEOUT_SHIFT                   9
#define HE_PACE_TX_MASK                         HE_PACE_TX_HIGH_MASK
#define HE_PACE_TX_SHIFT                        HE_PACE_TX_HIGH_SHIFT



#define HEBE_ASIC_HOST_INT_ACK                  0x08

#define HEBE_HOST_RX_ACK_SHIFT                  26
#define HEBE_HOST_TXL_ACK_SHIFT                 20
#define HEBE_HOST_TXH_ACK_SHIFT                 14



#define BE_ASIC_RX_THRESHOLD                    0x0C
#define BE_ASIC_TX_HIGH_THRESHOLD               0x1C
#define BE_ASIC_TX_LOW_THRESHOLD                0x20
#define BE_ALMOST_EMPTY_MASK                    0x07FF0000
#define BE_ALMOST_FULL_MASK                     0x000007FF


#define HE_ASIC_PH_THRESHOLD                    0x20    
#define HE_ASIC_DMA_THRESHOLD                   0x22    
#define HE_RX_THRESHOLD_MASK                    0xff00
#define HE_TX_THRESHOLD_MASK                    0x00ff


#define BE_TX_FIFO_SIZE                         0x800
#define BE_RX_FIFO_SIZE                         0x800



#define HE_TX_FIFO_SIZE                         0x100
#define HE_RX_FIFO_SIZE                         0x80



#define ASIC_HOST_INT_STATUS                    0x10

#define HEBE_STATUS_RX_OVERFLOW                 0x0001
#define HEBE_STATUS_RX_EARLY_INTERRUPT          0x0002
#define HEBE_STATUS_RX_FRAME_INTERRUPT          0x0004
#define HEBE_STATUS_EXEC_INTERRUPT              0x0008
#define HEBE_STATUS_ADAPTER_CHECK               0x0010
#define HEBE_STATUS_POLL_ERROR                  0x0020
#define HEBE_STATUS_TX_LOW_INTERRUPT            0x0040
#define HEBE_STATUS_TX_HIGH_INTERRUPT           0x0080
#define HEBE_STATUS_MODEM_IRQ                   0x0100
#define HEBE_STATUS_RX_EOC                      0x0200
#define HEBE_STATUS_TX_LOW_EOC                  0x0400
#define HEBE_STATUS_TX_HIGH_EOC                 0x0800
#define HEBE_STATUS_COMMAND_INTERRUPT           0x2000
#define HEBE_STATUS_GEN_RX_INTERRUPT            0x4000

#define HEBE_STS_INTERRUPT_MASK                 0x00006EFF



#define HEBE_ASIC_UTILITY                       0x12

#define HEBE_UTILITY_FP_ENABLE                  0x8000
#define HEBE_UTILITY_MEM_READ_LINE              0x1000
#define HEBE_UTILITY_MEM_READ_MULTIBLE          0x0800
#define HEBE_UTILITY_MEM_WRITE_INVALIDATE       0x0400
#define HE_UTILITY_BIG_TX_FIFO                  0x0200  
#define HEBE_UTILITY_FP_TO_MEM                  0x0080
#define HEBE_UTILITY_GLOBALMASK                 0x0040
#define HEBE_UTILITY_EE_ENABLE                  0x0020
#define HEBE_UTILITY_CLR_INT_RD                 0x0010
#define HEBE_UTILITY_BURST                      0x000F

#define BE_UTILITY_BURST_MAX                    11
#define HE_UTILITY_BURST_MAX                    7

#define HE_ASIC2_BURST                          1



#define HEBE_ASIC_SRAM_ADDRESS                  0x14
#define HEBE_SRAM_ADDRESS_AUTOINCREMENT         0x80000000
#define HEBE_ASIC_SRAM_DATA                     0x18




#define HEBE_ASIC_DMA_CONTROL                   0x24

#define HEBE_DMA_TX_POLLING                     0x00000001  
#define HEBE_DMA_STRIP_CRC                      0x00000002

#define BE_DMA_STATE_SUSPEND_TX_LOW             0x00000004
#define BE_DMA_STATE_SUSPEND_TX_HIGH            0x00000008
#define BE_DMA_STATE_SUSPEND_RX                 0x00000010
#define BE_DMA_SUSPEND_INIT                     0x00000000  

#define HE_DMA_SUSPEND_TX_LOW                   0x00000004
#define HE_DMA_SUSPEND_TX_HIGH                  0x00000008
#define HE_DMA_SUSPEND_RX                       0x00000010
#define HE_DMA_SUSPEND_INIT                     0x0000001C  

#define HEBE_DMA_SUSPEND_STATE                  0x0000001C
#define HEBE_DMA_LINK_LIST                      0x00000040
#define HEBE_DMA_DEBUG                          0x00000080  
#define HEBE_DMA_DEBUG_RX_START                 0x00000100  
#define HEBE_DMA_DEBUG_RX_END                   0x00000200  
#define HEBE_DMA_RX_FIFO_FULL                   0x00000400
#define HEBE_DMA_TX_HIGH_FIFO_FULL              0x00000800
#define HEBE_DMA_TX_LOW_FIFO_FULL               0x00001000
#define HEBE_DMA_RX_FIFO_EMPTY                  0x00002000
#define HEBE_DMA_TX_HIGH_FIFO_EMPTY             0x00004000
#define HEBE_DMA_TX_LOW_FIFO_EMPTY              0x00008000
#define HEBE_DMA_RING_DSC_FILL_MASK             0x001F0000
#define HEBE_DMA_RING_DSC_FILL_SHIFT            16

#define BE_DMA_LEAVE_SUSPEND_TX_LOW             0x00200000
#define BE_DMA_LEAVE_SUSPEND_TX_HIGH            0x00400000
#define BE_DMA_LEAVE_SUSPEND_RX                 0x00800000
#define BE_DMA_ENTER_SUSPEND_TX_LOW             0x01000000
#define BE_DMA_ENTER_SUSPEND_TX_HIGH            0x02000000
#define BE_DMA_ENTER_SUSPEND_RX                 0x04000000
#define BE_DMA_LEAVE_SUSPEND                    0x07000000

#define HE_DMA_DEBUG_TX_HIGH_START              0x00200000
#define HE_DMA_DEBUG_TX_HIGH_END                0x00400000
#define HE_DMA_DEBUG_TX_LOW_START               0x00800000
#define HE_DMA_DEBUG_TX_LOW_END                 0x01000000
#define HE_DMA_DEBUG_DIRECTION                  0x02000000
#define HE_DMA_DEBUG_BE_MASK                    0x3C000000
#define HE_DMA_DEBUG_BE_SHIFT                   26



#define HEBE_ASIC_IMMEDIATE_POLL                0x28

#define HEBE_ASIC_TYPE_MASK                     0xF0
#define HEBE_IMM_POLL_RX                        0x04
#define HEBE_IMM_POLL_TX_HIGH                   0x02
#define HEBE_IMM_POLL_TX_LOW                    0x01



#define HEBE_ASIC_ENGINE_IDLE                   0x29
#define HEBE_ASIC_REVISION_MASK                 0xF0
#define HEBE_RX_IDLE                            0x04
#define HEBE_TX_HIGH_IDLE                       0x02
#define HEBE_TX_LOW_IDLE                        0x01



#define HEBE_ASIC_EARLY_RECEIVE_THRESHOLD       0x2A
 


#define HEBE_ASIC_LLCSTOP                       0x2C



#define HEBE_ASIC_PAGE                          0x2E



#define HEBE_ASIC_RESET                         0x32

#define HEBE_RESET_CHIP                         0x0001
#define HEBE_RESET_MAC                          0x0002
#define HEBE_RESET_RADAR                        0x0004
#define HEBE_RESET_PROTOCOL                     0x0008
#define HEBE_RESET_CLASSIC                      0x0010
#define HEBE_RESET_HSTR                         0x0020
#define HEBE_RESET_SELECT_PROTOCOL              0x0040  
#define HEBE_RESET_MII_POWERDOWN                0x0080
#define HEBE_RESET_VCWAKE                       0x0100
#define HEBE_RESET_CABLEWAKE                    0x0200
#define HEBE_RESET_MPWAKE                       0x0400
#define HEBE_RESET_SELECT_PHY                   0x4000
#define HEBE_RESET_RECEIVE_DISABLE              0x8000
#define HEBE_RESET_BITS                         0x000F



#define HEBE_ASIC_TX_HIGH_ADDRESS               0x34
#define HEBE_ASIC_TX_LOW_ADDRESS                0x38
#define HEBE_ASIC_RX_ADDRESS                    0x3C



#define ASIC_PROTOCOL_HANDLER_CONTROL_1         0x00
#define ASIC_PROTOCOL_HANDLER_CONTROL_2         0x02

#define ASIC_INTERRUPT_MASK                     0x04
#define ASIC_INTERRUPT_STATUS                   0x08
#define IS_MAILBOX_INT                          0x01000000
#define IS_CMD_DONE                             0x00040000  
#define IS_TX_FIFO                              0x00020000
#define IS_RX_FIFO                              0x00010000
#define IS_TX_IDLE                              0x00008000
#define IS_RATE_MISMATCH                        0x00004000
#define IS_LOCAL_RX                             0x00002000
#define IS_LOCAL_TX                             0x00001000
#define IS_WIRE_FAULT                           0x00000800
#define IS_MAILBOX_INT_LATCH                    0x00000400
#define IS_SIGNAL_LOSS                          0x00000200
#define IS_TOKEN_ERROR                          0x00000100
#define IS_LOST_FRAME                           0x00000080
#define IS_LINE_ERROR                           0x00000040
#define IS_FREQUENCY_ERROR                      0x00000020
#define IS_COPY_ERROR                           0x00000010
#define IS_CONGESTION_ERROR                     0x00000008
#define IS_BURST_ERROR                          0x00000004
#define IS_PHANTOM_DETECT                       0x00000002
#define IS_ABORT                                0x00000001

#define ASIC_MAC_CPU_TRANSMIT_CONTROL           0x0C
#define ASIC_AC_BIT_CONTROL                     0x0E
#define ASIC_MAC_CPU_RECEIVE_CONTROL            0x10
#define ASIC_MAX_FRAME_LENGTH                   0x12
#define ASIC_PROTOCOL_HANDLER_STATUS            0x14
#define ASIC_DISCARDED_TX_FRAMES                0x16
#define ASIC_DISCARDED_RX_FRAMES                0x18

#define ASIC_CONGESTION_COUNT                   0x1A
#define RFO_MASK                                0x0F00
#define CC_MASK                                 0x00FF
#define RFO_SHIFT                               8

#define ASIC_FIRE_TOKEN                         0x1C
#define ASIC_NODE_ADDRESS1                      0x1E
#define ASIC_NODE_ADDRESS2                      0x20
#define ASIC_NODE_ADDRESS3                      0x22
#define ASIC_FUNCTIONAL_ADDRESS_LOW             0x24
#define ASIC_FUNCTIONAL_ADDRESS_HIGH            0x26
#define ASIC_SRB_CONTROL                        0x28
#define ASIC_RING_NUMBER                        0x2A
#define ASIC_TRANSMIT_BASE                      0x2C
#define ASIC_RECEIVE_BASE                       0x30
#define ASIC_WF_COUNT                           0x32
#define ASIC_RECEIVE_LOWER_LIMIT                0x34
#define ASIC_RECEIVE_UPPER_LIMIT                0x36
#define ASIC_RECEIVE_STOP_LIMIT                 0x38
#define ASIC_GROUP_ADDRESS_1                    0x3A
#define ASIC_GROUP_ADDRESS_2                    0x3C
#define ASIC_GROUP_ADDRESS_3                    0x3E



#define BE_ASIC_T_POWERMAN                      0x00
#define BE_ASIC_T_POWERMAN_RP                   2

#define HE_ASIC_T_POWERMAN                      0x1C
#define HE_ASIC_T_POWERMAN_RP                   0



#define BE_ASIC_DEBUG_SELECT                    0x08
#define BE_ASIC_DEBUG_ASSERT                    0x0A
#define BE_ASIC_DEBUG_RP                        2

#define HE_ASIC_DEBUG_SELECT                    0x0C
#define HE_ASIC_DEBUG_ASSERT                    0x0E
#define HE_ASIC_DEBUG_RP                        0

#define BE_ASIC_HSTR_PH_CONTROL1                0x0C
#define BE_ASIC_HSTR_PH_CONTROL2                0x0E
#define BE_ASIC_HSTR_RCV_CONTROL                0x10
#define BE_ASIC_HSTR_MII                        0x12
#define BE_ASIC_HSTR_PH_STATUS                  0x14

#define BE_ASIC_SH_CONTROL                      0x16
#define BE_SH_CONTROL_DMA_FIFO_RESET            0x10
#define BE_SH_CONTROL_WUFF_ENABLE               0x08
#define BE_SH_CONTROL_WUFF_DISABLE              0x04
#define BE_SH_CONTROL_WUFF_SET                  0x02
#define BE_SH_CONTROL_WUFF_CLEAR                0x01
#define BE_ASIC_SH_CONTROL_RP                   2

#define BE_ASIC_TX_DMA_FIFO_ADDRESS             0x24
#define BE_ASIC_RX_DMA_FIFO_ADDRESS             0x28



#define BE_ASIC_EEPROM                          0x30
#define BE_ASIC_EEPROM_RP                       2
#define HE_ASIC_EEPROM                          0x00
#define HE_ASIC_EEPROM_RP                       0



#define SRAM_TABLE                              0x00000300
#define SRAM_CLOCK                              0x00006000
#define SRAM_RESET_START                        0x0000BFF0

#define SRAM_RESET_CODE1                        0x0050EA90
#define SRAM_RESET_CODE2                        0x00000000

#define COMMAND_DONE                            0x80
#define COMMAND_MASK                            0x7F
#define CMD_NO_OPERATION                        0x00
#define CMD_FAULT_TEST                          0x01
#define CMD_CONFIGURE                           0x02
#define CMD_OPEN                                0x03
#define CMD_CLOSE                               0x04
#define CMD_SET_FUNCTIONAL_ADDRESS              0x05
#define CMD_SET_GROUP_ADDRESS                   0x06
#define CMD_GET_ERROR_COUNTERS                  0x07
#define CMD_MODIFY_OPEN_OPTIONS                 0x08
#define CMD_MODIFY_RING_NUMBER                  0x09
#define CMD_DTR_REG_RESPONSE                    0x0A
#define CMD_GET_STATISTICS                      0x0B
#define CMD_SEND_HOST_FRAME                     0x0C
#define CMD_MODIFY_SRB_OPTIONS                  0x0D
#define CMD_RESET                               0x0E
#define CMD_START_RECEIVE                       0x10

#define STATUS_DONE                             0x8000
#define STATUS_LOST                             0x0100
#define STATUS_MASK                             0x00FF
#define STATUS_READY                            1
#define STATUS_CONNECT                          2
#define STATUS_CLOSED                           3
#define STATUS_RINGSTATUS                       4
#define STATUS_RING_LIST_CHANGED                5
#define STATUS_WATCHDOG                         6
#define STATUS_TRM_BUFFER                       7
#define STATUS_INT_RESPONSE                     8
#define STATUS_REGISTRATION_REQ                 9   

#define COMMAND_FAULT_TEST_LENGTH               28



#define PORT_MODE_100                           0x4000
#define PORT_MODE_TXI                           0x2000
#define PORT_MODE_TKP                           0x1000
#define PORT_MODE_NO_PHANTOM                    0x0200
#define PORT_MODE_PHANTOM                       0x0100
#define PORT_MODE_AC_MODE1                      0x0080
#define PORT_MODE_AC_MODE3                      0x0040
#define PORT_MODE_AC_MODE4                      0x0020
#define PORT_MODE_LED2_MASK                     0x0018
#define LED2_ACCESS                             0x0010  
#define LED2_ACTIVITY                           0x0008
#define LED2_SPEED                              0x0000
#define PORT_MODE_FIBER                         0x0004
#define PORT_MODE_LED1                          0x0002
#define PORT_MODE_DEFAULT                       0x7300



#define CO_FECO                                 0x8000  
#define CO_FBHO                                 0x4000  
#define CO_WIRE_FAULT                           0x2000  

#define BE_CO_AUTOSPEED_BE                      0x1000  
#define BE_CO_DELAYREQ                          0x0800
#define BE_CO_SPEED_MASK                        0x0300
#define BE_CO_SPEED_100                         0x0200
#define BE_CO_SPEED_16_BE                       0x0100
#define BE_CO_SPEED_4                           0x0000
#define BE_CO_TRADEUP                           0x0020


#define HE_CO_AUTOSPEED_HE                      0x0200
#define HE_CO_SPEED_16_HE                       0x0100

#define CO_REGISTRATION                         0x0080  
#define CO_REG_QUERY                            0x0040
#define CO_REJECT_REMOVE                        0x0010
#define CO_WATCHDOG                             0x0008
#define CO_STATION_LIST                         0x0004
#define CO_STATUS_CHANGE                        0x0002  
#define CO_TR_MGMT                              0x0001
#define CO_DEFAULT                              0x00C2

#define COMMAND_OPEN_LENGTH                     42

#define OO_WRAP_LOBE                            0x8000
#define OO_DISABLE_HARD_ERROR                   0x4000
#define OO_DISABLE_SOFT_ERROR                   0x2000
#define OO_PASS_UNSUP_MAC_FRAMES                0x1000
#define OO_PASS_ATTENTION_MAC_FRAMES            0x0800
#define OO_WRAP_ADAPTER                         0x0400
#define OO_AUTO_REOPEN                          0x0200
#define OO_CLAIM_TOKEN_CONTENTION               0x0100
#define OO_PASS_BEACON_MAC_FRAMES               0x0080
#define OO_EARLY_TOKEN_RELEASE                  0x0010
#define OO_COPY_ALL_MAC_FRAMES                  0x0004
#define OO_COPY_ALL_NON_MAC_FRAMES              0x0002
#define OO_FAST_OPEN                            0x0001  

#define COMMAND_NO_OPERATION_LENGTH             8
#define COMMAND_CLOSE_LENGTH                    8
#define COMMAND_RESET_LENGTH                    8
#define COMMAND_FUNCTIONAL_LENGTH               10
#define COMMAND_GROUP_LENGTH                    10
#define COMMAND_ERROR_LENGTH                    18
#define COMMAND_MODIFY_OPEN_LENGTH              10
#define COMMAND_MODIFY_OPEN_LENGTH              10
#define COMMAND_START_RECEIVE_LENGTH            12

#define RESPONSE_INVALID                        0x8000
#define RESPONSE_OK                             0x2000
#define RESPONSE_STATE                          0x1000
#define RESPONSE_BUSY                           0x0800

#define CS_OK                                   0x8000
#define CS_100                                  0x0800
#define CS_PORT_MODE                            0x0400
#define CS_ACCESS_PROTOCOL                      0x0200
#define CS_16                                   0x0100
#define CS_PHASE                                0x00F0
#define CS_ERROR                                0x000F

#define CS_SPEED(cs) (((cs) & CS_100) ? TRLLD_SPEED_100MBPS \
                        : ((cs) & CS_16) ? TRLLD_SPEED_16MBPS \
                            : TRLLD_SPEED_4MBPS)


#define CS_ERROR_FUNCTION_FAILURE               1
#define CS_ERROR_SIGNAL_LOSS                    2
#define CS_ERROR_TXI_REMOVE_ALERT               3
#define CS_ERROR_TXI_TRADEUP_FAILED             4
#define CS_ERROR_TIMEOUT                        5
#define CS_ERROR_TKP_RING_FAILURE               6
#define CS_ERROR_TXI_PROTOCOL_ERROR             6
#define CS_ERROR_RING_BEACONING                 7
#define CS_ERROR_TKP_DUP_ADDRESS                8
#define CS_ERROR_TXI_INSERT_DENIED              8
#define CS_ERROR_TKP_REQ_INIT                   9
#define CS_ERROR_TXI_HB_FAILURE                 9
#define CS_ERROR_REMOVE_RECEIVED                10
#define CS_ERROR_TXI_ADDRESS_CHANGED            11
#define CS_ERROR_TKP_WIRE_FAULT                 12
#define CS_ERROR_TKP_AUTOSPEED                  13
#define CS_ERROR_SPEED_SENSE_FAILED             14
#define CS_ERROR_HOST_CLOSE                     15



#define HE_TCNTRL_MODIFY_EXPLORER               0x8000
#define HE_TCNTRL_CRC_INCLUDED                  0x4000
#define HE_TCNTRL_LF_MASK                       0x3800
#define HE_TCNTRL_START_FRAME                   0x0400
#define HE_TCNTRL_END_FRAME                     0x0200
#define HE_TCNTRL_END_DESCRIPTOR                0x0100
#define HE_TCNTRL_GEN_TX_INT                    0x0080
#define HE_TCNTRL_PRIORITY_MASK                 0x0070

#define HE_TCMPLT_OWN                           0x8000
#define HE_TCMPLT_COMPLETED                     0x4000
#define HE_TCMPLT_UNDERRUN                      0x2000
#define HE_TCMPLT_ABORT                         0x0080



#define HE_RCNTRL_GEN_RX_INT                    0x0400
#define HE_RCNTRL_NOT_NEW                       0x0200
#define HE_RCNTRL_END_DESCRIPTOR                0x0100

#define HE_RCMPLT_OWN                           0x8000
#define HE_RCMPLT_COMPLETED                     0x4000
#define HE_RCMPLT_NO_BUFFERS                    0x2000
#define HE_RCMPLT_LONG_FRAME                    0x1000
#define HE_RCMPLT_CORRUPT                       0x0800
#define HE_RCMPLT_START_FRAME                   0x0400
#define HE_RCMPLT_END_FRAME                     0x0200
#define HE_RCMPLT_CRC_ERROR                     0x0100
#define HE_RCMPLT_OVERFLOW                      0x0080
#define HE_RCMPLT_OWN_XMIT                      0x0040
#define HE_RCMPLT_TAG_MASK                      0x003C
#define HE_RCMPLT_LEARN                         0x0002
#define HE_RCMPLT_DIRECTION                     0x0001
#define HE_RCMPLT_ERROR                         0x1980

#define HE_BRIDGE_SR_DETECT_MASK                0x000F
#define HE_BRIDGE_MAC_FRAME                     0x0010
#define HE_BRIDGE_ROUTLAST                      0x0020
#define HE_BRIDGE_RINLAST                       0x0040
#define HE_BRIDGE_SR_DETECT                     0x0080
#define HE_BRIDGE_SR_EXPLORER                   0x0100
#define HE_BRIDGE_SR_MATCH                      0x0200
#define HE_BRIDGE_EXT_COPY                      0x0400
#define HE_BRIDGE_TR_COPY                       0x0800
#define HE_BRIDGE_GROUP_MATCH                   0x1000
#define HE_BRIDGE_BROADCAST_MATCH               0x2000
#define HE_BRIDGE_FUNCTIONAL_MATCH              0x4000
#define HE_BRIDGE_ADDRESS_MATCH                 0x8000
#define HE_BRIDGE_INTERNAL_MATCH                0xF000




