/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
* **** ***    ***  *****   ****  ******    **  **
*  **  ****  **** **   ** **  ** **   *    **  **
*  **  ** **** ** **   ** **     **        **  **
*  **  **  **  ** ******* ** *** ****      ******
*  **  **      ** **   ** **  ** **        **  **
*  **  **      ** **   ** **  ** **   * ** **  **
* **** **      ** **   **  ****  ****** ** **  **
*
*****************************************************************************
*
* Declaration of miscellaneous types required by the toolkit.
*
*****************************************************************************
*
* Copyright (C) 1996-1999 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/




typedef enum
{
    

    FASTMAC_PLUS_CODE                  = 0,

    

    KNOSSOS2_ADAP_CODE,


    

    HEBE_ADAP_CODE,

} CODE_TYPE_T;




#ifdef EMBEDDED_MICRO_CODE
#  ifdef UDT_NO_MVER_STRINGS
#    define UDT_NO_IMAGE_HEADERS
#  endif
#endif

#ifndef UDT_NO_IMAGE_HEADERS

typedef struct _IMAGE_HEADER_T
{

#ifndef EMBEDDED_MICRO_CODE

    

    BYTE_T   code_type[2];

    

    BYTE_T   code_header_length[2];

    

    BYTE_T   code_maj_ver[2];
    BYTE_T   code_min_ver[2];
    BYTE_T   code_rev_ver[2];

    

    CHAR_T   code_prod_id[62];

#endif 

#ifndef UDT_NO_MVER_STRINGS

    

    CHAR_T   code_mver[64];

#endif 

#ifndef EMBEDDED_MICRO_CODE

    

    CHAR_T   code_csum[12];

#endif 

} IMAGE_HEADER_T;

#endif




#ifndef UDT_NO_IMAGE_HEADERS



#define FMPLUS_ADAPCODE_MAJ_VER                                             \
     2 

#define FMPLUS_ADAPCODE_MIN_VER                                             \
     19 

#define FMPLUS_ADAPCODE_REV_VER                                             \
     0 

#define FMPLUS_ADAPCODE_MVER                                                \
     "VeRsIoN=MAC:        Madge DTR Fastmac Plus v2.19" 




#ifdef EMBEDDED_MICRO_CODE

#define FMPLUS_IMAGE_HEADER                                                 \
{                                                                           \
                                                                         \
                                                                            \
    FMPLUS_ADAPCODE_MVER                                                    \
                                                                            \
}



#else 

#define FMPLUS_IMAGE_HEADER                                                 \
{                                                                           \
                                                                         \
                                                                            \
    {FASTMAC_PLUS_CODE, 0},                                                 \
                                                                            \
                                                                         \
                                                                            \
    {sizeof(IMAGE_HEADER_T), 0},                                            \
                                                                            \
                                                                         \
                                                                            \
    {FMPLUS_ADAPCODE_MAJ_VER, 0},                                           \
                                                                            \
                                                                         \
                                                                            \
    {FMPLUS_ADAPCODE_MIN_VER, 0},                                           \
                                                                            \
                                                                         \
                                                                            \
    {FMPLUS_ADAPCODE_REV_VER, 0},                                           \
                                                                            \
                                                                         \
                                                                            \
    " "                                                                     \
                                                                            \
                                                                         \
                                                                            \
    FMPLUS_ADAPCODE_MVER,                                                   \
                                                                            \
                                                                         \
                                                                            \
    " "                                                                     \
                                                                            \
}

#endif 

#endif 



#ifndef UDT_NO_IMAGE_HEADERS



#define KNOSSOS_ADAPCODE_MAJ_VER                                            \
     3 

#define KNOSSOS_ADAPCODE_MIN_VER                                            \
     11 

#define KNOSSOS_ADAPCODE_REV_VER                                            \
     0 

#define KNOSSOS_ADAPCODE_MVER                                               \
     "VeRsIoN=MAC:        MadgeMac Plus v3.11" 




#ifdef EMBEDDED_MICRO_CODE

#define KNOSSOS_IMAGE_HEADER                                                \
{                                                                           \
                                                                         \
                                                                            \
    KNOSSOS_ADAPCODE_MVER                                                   \
                                                                            \
}



#else 

#define KNOSSOS_IMAGE_HEADER                                                \
{                                                                           \
                                                                         \
                                                                            \
    {KNOSSOS2_ADAP_CODE, 0},                                                \
                                                                            \
                                                                         \
                                                                            \
    {sizeof(IMAGE_HEADER_T), 0},                                            \
                                                                            \
                                                                         \
                                                                            \
    {KNOSSOS_ADAPCODE_MAJ_VER, 0},                                          \
                                                                            \
                                                                         \
                                                                            \
    {KNOSSOS_ADAPCODE_MIN_VER, 0},                                          \
                                                                            \
                                                                         \
                                                                            \
    {KNOSSOS_ADAPCODE_REV_VER, 0},                                          \
                                                                            \
                                                                         \
                                                                            \
    " "                                                                     \
                                                                            \
                                                                         \
                                                                            \
    KNOSSOS_ADAPCODE_MVER,                                                  \
                                                                            \
                                                                         \
                                                                            \
    " "                                                                     \
                                                                            \
}

#endif 

#endif 



#ifndef UDT_NO_IMAGE_HEADERS



#define HEBE_ADAPCODE_MAJ_VER                                             \
     2 

#define HEBE_ADAPCODE_MIN_VER                                             \
     9 

#define HEBE_ADAPCODE_REV_VER                                             \
     0 

#define HEBE_ADAPCODE_MVER                                                \
     "VeRsIoN=MAC:        Olicom HE/BE Mac v2.09" 




#ifdef EMBEDDED_MICRO_CODE

#define HEBE_IMAGE_HEADER                                                   \
{                                                                           \
                                                                         \
                                                                            \
    HEBE_ADAPCODE_MVER                                                      \
                                                                            \
}



#else 

#define HEBE_IMAGE_HEADER                                                   \
{                                                                           \
                                                                         \
                                                                            \
    {HEBE_ADAP_CODE, 0},                                                    \
                                                                            \
                                                                         \
                                                                            \
    {sizeof(IMAGE_HEADER_T), 0},                                            \
                                                                            \
                                                                         \
                                                                            \
    {HEBE_ADAPCODE_MAJ_VER, 0},                                             \
                                                                            \
                                                                         \
                                                                            \
    {HEBE_ADAPCODE_MIN_VER, 0},                                             \
                                                                            \
                                                                         \
                                                                            \
    {HEBE_ADAPCODE_REV_VER, 0},                                             \
                                                                            \
                                                                         \
                                                                            \
    " "                                                                     \
                                                                            \
                                                                         \
                                                                            \
    HEBE_ADAPCODE_MVER,                                                     \
                                                                            \
                                                                         \
                                                                            \
    " "                                                                     \
                                                                            \
}

#endif 

#endif 



