/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
*  **   ** **   **  *****   *****   *****  ******      *****  
*  **  **  ***  ** **   ** **   ** **   **  **  **    **   ** 
*  ** **   **** ** **   ** **           **  **  **    **      
*  ****    ** **** **   **  *****      **   *****     **      
*  ** **   **  *** **   **      **   **     **  **    **      
*  **  **  **   ** **   ** **   **  **      **  **    **   ** 
*  **   ** **   **  *****   *****  ******* ***  ** **  *****  
*                                                             
*****************************************************************************
*
* Functions comprising the resident functions of the UDI for all Knossos 1
* and Knossos 2 adapters. These are:
*
*    - Presto.
*    - Presto 2.
*    - PCI-3 (both Madge and Compaq versions).
*    - CardBus 2.
*
*****************************************************************************
*
* Copyright (C) 1996-1999 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/

    

#define UDI_MODULE

#include "udt_driver.h"


#ifdef KNOS2_UDI

#ifndef UDT_ONLY_GET_CARD_INFO





STATIC RETCODE_T UDT_INDIRECT
knos2_tx(
    IN P_UDI_DATA_T                    udids_ptr,
    IN P_FRAME_T                       frame);

#ifndef UDT_NO_SSI_PROTECT

STATIC RETCODE_T UDT_LOCAL_PROTECTED
knos2_protected_tx(
    IN P_UDI_DATA_T                    udids_ptr,
    IN PCLIENT_VOID_T                  frame_ptr_ptr,
    IN PCLIENT_VOID_T                  arg2);

#endif 

STATIC VOID_T UDT_INDIRECT
knos2_check_tx_complete(
    INOUT P_UDI_DATA_T                 udids_ptr);




STATIC RETCODE_T UDT_INDIRECT
knos2_udti_complete_rx(
    IN P_UDI_DATA_T                    udids_ptr,
    IN P_FRAME_T                       resource);

P_FRAME_T UDT_INDIRECT
knos2_provide_rx_descriptors(
    IN    P_UDI_DATA_T                 udids_ptr,
    INOUT P_FRAME_T                    rx_list);



STATIC VOID_T UDT_INDIRECT
knos2_process_interrupts(
    INOUT P_UDI_DATA_T                 udids_ptr);






STATIC VOID_T
knos2_process_received_data(
    INOUT P_UDI_DATA_T                 udids_ptr);

STATIC VOID_T
knos2_process_received_mac_frames(
    INOUT P_UDI_DATA_T                 udids_ptr);

STATIC VOID_T
knos2_report_mac_frame(
    INOUT P_UDI_DATA_T                 udids_ptr,
    IN    P_FRAME_T                    rx_frame);

#ifdef PRESTO_UDI
STATIC VOID_T
knos2_issue_event(
    IN P_UDI_DATA_T                    udids_ptr,
    IN BYTE_T                          event_bitmap);
#endif 






#ifndef UDT_INDIRECT_INTER_MODULE_CALLS

extern VOID_T UDT_INTER_MODULE
knossos_process_command_done(
    INOUT P_UDI_DATA_T                 udids_ptr);

extern VOID_T UDT_INTER_MODULE
knossos_process_event(
    INOUT P_UDI_DATA_T                 udids_ptr);

extern VOID_T UDT_INTER_MODULE
knossos_process_status(
    INOUT P_UDI_DATA_T                 udids_ptr);

#endif 



DECLARE_MODULE_START_FUNCTION(knos2r_start)
DECLARE_MODULE_END_FUNCTION(knos2r_end)



RETCODE_T UDT_INTER_MODULE
knos2r_register(
    IN P_UDI_DATA_T        udids_ptr)
{
    POKE_CFG(COLOUR_SUBFN, "RegKnos2Res");

    
     
    SSI_MODULE_REGISTERED(
        udids_ptr,
        knos2r_register,
        knos2r_start,
        knos2r_end,
        MOD_SCOPE_RUNTIME);

    
     
    UDI_RES_FROM_UDIDS(udids_ptr).udi_process_adapter_interrupts =
        knos2_process_interrupts;

    

    UDTI_FROM_UDIDS(udids_ptr).udti_complete_rx =
        knos2_udti_complete_rx;
        
    UDTI_FROM_UDIDS(udids_ptr).udti_provide_rx_descriptors =
        knos2_provide_rx_descriptors;

    UDTI_FROM_UDIDS(udids_ptr).udti_tx =
        knos2_tx;
 
    

    KNOSSOS_RES_FROM_UDIDS(udids_ptr).knossos_check_tx_complete =
        knos2_check_tx_complete;

    
     
    return SUCCESS;
}

BUILD_MODULE_START_FUNCTION(knos2r_start)



STATIC VOID_T UDT_INDIRECT
knos2_process_interrupts(
    INOUT P_UDI_DATA_T udids_ptr)
{
    BYTE_T interrupt_status;

    

    interrupt_status =
        READ_KNOSSOS_BYTE(udids_ptr, KNOSSOS_ADAP_2_HOST_INT);

    POKEB_TX(PO_BRIGHT_WHITE, "P:", interrupt_status);

    WRITE_KNOSSOS_BYTE(udids_ptr, KNOSSOS_ADAP_2_HOST_INT, interrupt_status);

    

#   if defined(UDT_NO_OFF_LEVEL_INTERRUPT_HANDLING)

    READ_KNOSSOS_BYTE(udids_ptr, KNOSSOS_ADAP_2_HOST_INT);

#   endif


    

    if(ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_type ==
           ADAPTER_TYPE_KNOSSOS_CARDBUS)
    {
        if(KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).fatal_events != 0
           ||
           (
               READ_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_MEM_MAP1)
               !=
               KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                   ff03_base_register_contents
           ))
        {
            

            UDI_STATE(udids_ptr) = REGISTERED;

            UPCALL_EVENT(udids_ptr, ADAPTER_REMOVED);

            

            return;
        }
    }


    

#   ifdef UDT_LIMIT_RX_LOOPS

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).remaining_reception_quota =
        GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr), max_rx_loops);

#   endif 


    


    

    if (KNOSSOS_R_PROCESS_FORCED_INTERRUPT)
    {
        KNOSSOS_R_PROCESS_FORCED_INTERRUPT = FALSE;

        POKE_ISR(COLOUR_INT_TYPE, "ForcedInt");

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).frame_for_mac!=NULL)
        {
            P_FRAME_T rx_frame;

            rx_frame = KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).frame_for_mac;
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).frame_for_mac = NULL;

            knos2_report_mac_frame(udids_ptr, rx_frame);

            

#           ifndef UDT_LIMIT_RX_LOOPS

            interrupt_status |= KNOSSOS12_INT_RX_HOST_MAC;

#           endif 
        }

        

#       ifdef UDT_LIMIT_RX_LOOPS

        interrupt_status |= KNOSSOS12_INT_RX_HOST_MAC | KNOSSOS12_INT_RX;

#       endif 

    }


    

    if (interrupt_status & KNOSSOS12_INT_RX)
    {
        POKE_ISR(COLOUR_INT_TYPE, "Rx");

        knos2_process_received_data(udids_ptr);
    }

    

    if (interrupt_status & KNOSSOS12_INT_RX_HOST_MAC)
    {
        POKE_ISR(COLOUR_INT_TYPE, "RxMac");

        knos2_process_received_mac_frames(udids_ptr);
    }

    

    if (interrupt_status & KNOSSOS12_INT_TX_COMP)
    {
        POKE_ISR(COLOUR_INT_TYPE, "Tx Complete");

#       ifdef UDT_NO_LOCAL_FAR_CALLS
        KNOSSOS_CHECK_TX_COMPLETE(udids_ptr);
#       else
        knos2_check_tx_complete(udids_ptr);
#       endif
    }

    

    if (interrupt_status & KNOSSOS_ADAP2HOST_EVENTS)
    {
        POKE_ISR(COLOUR_INT_TYPE, "Event");

        KNOSSOS_PROCESS_EVENT(udids_ptr);
    }

    

    if (interrupt_status & KNOSSOS_INT_RING_STATUS_AVAILABLE)
    {
        POKE_ISR(COLOUR_INT_TYPE, "Ring Status");
                
        KNOSSOS_PROCESS_STATUS(udids_ptr);
    }

    

    if (interrupt_status & KNOSSOS_INT_COMMAND_PROCESSED)  
    {
        POKE_ISR(COLOUR_INT_TYPE, "CommandDone");
                
        KNOSSOS_PROCESS_COMMAND_DONE(udids_ptr);
    }

    

#   ifdef UDT_POKEOUTS_ON
    if (interrupt_status & KNOSSOS_INT_WATCHDOG)
    {
        POKE_ISR(COLOUR_INT_TYPE, "Wdog");

#       ifdef KNOSSOS_CHECK_STACK

#       endif 
    }
#   endif


    

#   if !defined(UDT_NO_OFF_LEVEL_INTERRUPT_HANDLING) && \
       !defined(UDT_CLIENT_INTERRUPT_CONTROL)

    WRITE_KNOSSOS_WORD(
        udids_ptr,
        KNOSSOS_HOST_INT_MASK,
        KNOSSOS12_ALL_INTERRUPTS_MASK | (WORD_T)KNOSSOS_R_CURRENT_FORCE_INT);

#   endif

    return;
}






STATIC RETCODE_T UDT_INDIRECT
knos2_tx(
    IN P_UDI_DATA_T udids_ptr,
    IN P_FRAME_T    frame)
{

#ifndef UDT_NO_SSI_PROTECT 

    return SSI_PROTECT(
               udids_ptr,
               knos2_protected_tx,
               (PCLIENT_VOID_T)&frame,
               NULL);
}



STATIC RETCODE_T UDT_LOCAL_PROTECTED
knos2_protected_tx(
    IN P_UDI_DATA_T      udids_ptr,
    IN PCLIENT_VOID_T    frame_ptr_ptr,
    IN PCLIENT_VOID_T    arg2)
{
    P_FRAME_T     frame = *(P_FRAME_T FAR_CLIENT *)frame_ptr_ptr;

#endif 

    DWORD_T       first_four_bytes;
    UINT_T        frag_array_length;
    UINT_T        fragment_length;
    BYTE_T        priority;
    WORD_T        tx_buffer_ptr; 
    FRAG_HANDLE_T tx_frag_handle;
    UINT_T        fragment_index;
    UINT_T        buffer_fragment_index;

    POKE_TX(COLOUR_TX, "Tx");


    

    if(UDI_STATE(udids_ptr) != OPEN)
    {
        

        RETURN(udids_ptr, WRONG_STATE);
    }


    

#   ifdef UDT_NO_SSI_PROTECT

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected = TRUE;

#   endif

    

    if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool_entries <
        KNOSSOS12_MAX_BUFFERS_PER_TX)
    {
        

        POKE_TX(COLOUR_UNLIKELY, "OutOfResources");

        ADD_TO_COUNTER(udids_ptr, tx_no_resources, 1);

        

        return OUT_OF_ADAPTER_RAM;
    }


    

    frag_array_length = frame->frag_array_length;

#   ifdef UDT_SANITY_CHECK

    if (frag_array_length > KNOSSOS12_MAX_TX_FRAGMENTS)
    {
        POKE_TX(COLOUR_INSANE, "TooManyFragments");
        UDT_INSANE;
    }

#   endif


    

    fragment_length = SSI_FRAG_LENGTH(
                          udids_ptr,
                          frame->frag_array_ptr[0]);

    fragment_index = 0;

    if (fragment_length == 0)
    {
        POKE_TX(PO_BLUE, "Skip0");

        fragment_length = SSI_FRAG_LENGTH(
                              udids_ptr,
                              frame->frag_array_ptr[1]);
        fragment_index = 1;
    }

#   ifdef UDT_SANITY_CHECK

    if (fragment_length < 4)
    {
        POKE_TX(COLOUR_INSANE, "TinyFirstFrag");
        UDT_INSANE;
    }

#   endif

    first_four_bytes =
        SSI_FRAG_READD(udids_ptr, frame->frag_array_ptr[fragment_index], 0);


    

#   ifdef UDT_CPU_IS_BIG_ENDIAN
    priority =
        SSI_FRAG_READB(udids_ptr, frame->frag_array_ptr[fragment_index], 0)
            >> 5;
#   else
    priority = (BYTE_T) (((BYTE_T)first_four_bytes) >> 5);
#   endif

    TPOKEB_TX(TT_TX, "P", priority);

    if (priority > KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL)
    {
        if (priority == 7)
        {
#           ifdef UDT_SANITY_CHECK

            POKE_TX(COLOUR_INSANE, "BadPriority");
            UDT_INSANE; 

#           endif

#           ifdef UDT_CPU_IS_BIG_ENDIAN
            first_four_bytes &= 0x1FFFFFFFL;
            first_four_bytes |= 0xC0000000L;
#           else
            first_four_bytes &= 0xFFFFFF1FL;
            first_four_bytes |= 0x000000C0L;
#           endif
        }

        priority = KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL;

        TPOKEB_TX(TT_TX, "->", priority);
    }


    

    tx_buffer_ptr =
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_buffer_ptr[priority];

    TPOKEW_TX(TT_BRIGHT, "Buff", tx_buffer_ptr);

    

    tx_frag_handle = GET_CONFIG_VALUE(
                         CONFIG_FROM_UDIDS(udids_ptr),
                         frag_handle[KNOSSOS_FF08_FRAGMENT_INDEX]);

    SSI_FRAG_WRITEW(
        udids_ptr,
        tx_frag_handle,
        tx_buffer_ptr + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.next),
        BYTE_SWAP(
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool));

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool_entries -= 2;

    

#   ifdef UDT_TRTEST_SPECIAL_CODE

    SSI_FRAG_WRITEW(
        udids_ptr,
        tx_frag_handle,
        tx_buffer_ptr + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.status),
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).first_tx_buffer_status |
            (parsed_no_crc_bool ? 0x0010 : 0));

#   else

    SSI_FRAG_WRITEW(
        udids_ptr,
        tx_frag_handle,
        tx_buffer_ptr + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.status),
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).first_tx_buffer_status);

#   endif

    SSI_FRAG_WRITEW(
        udids_ptr,
        tx_frag_handle,
        tx_buffer_ptr + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.length),
        BYTE_SWAP(4));

    TPOKEW_TX(TT_DULL, "L=", 4);

    SSI_FRAG_WRITED_MISALIGNED(
        udids_ptr,
        tx_frag_handle,
        tx_buffer_ptr + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.data[0]),
        first_four_bytes);

    

    tx_buffer_ptr =
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool;

    TPOKEW_TX(TT_BRIGHT, "Buff", tx_buffer_ptr);


    

    

#   ifdef UDT_SANITY_CHECK

    if (fragment_length < 5)
    {
        POKE_TX(COLOUR_INSANE, "4Byte");
        UDT_INSANE;
    }

#   endif

    SSI_FRAG_WRITEW(
        udids_ptr,
        tx_frag_handle,
        tx_buffer_ptr +
            UDT_OFFSET(KNOSSOS_TX_BUFFER_T, gather.fragment[0].length),
        BYTE_SWAP(fragment_length-4));

    TPOKEW_TX(TT_DULL, "L=", fragment_length-4);

    SSI_FRAG_WRITED(
        udids_ptr,
        tx_frag_handle,
        tx_buffer_ptr +
            UDT_OFFSET(KNOSSOS_TX_BUFFER_T, gather.fragment[0].phys_addr),
        SSI_FRAG_PHYS_ADDRESS(
            udids_ptr,
            frame->frag_array_ptr[fragment_index]) + 4);

    buffer_fragment_index = 1;
    fragment_index++;


    

    while (fragment_index < frag_array_length)
    {
        fragment_length = SSI_FRAG_LENGTH(
                              udids_ptr,
                              frame->frag_array_ptr[fragment_index]);

        if (fragment_length != 0)
        {
#           ifdef UDT_SANITY_CHECK

            if (buffer_fragment_index == KNOSSOS_MAX_TX_FRAGS_PER_BUFF)
            {
                POKE_TX(COLOUR_INSANE, "TooManyFrags");
                UDT_INSANE;
            }

#           endif

            POKE_TX(PO_BLUE, "o");

            SSI_FRAG_WRITEW(
                udids_ptr,
                tx_frag_handle,
                tx_buffer_ptr +
                    UDT_OFFSET(
                        KNOSSOS_TX_BUFFER_T,
                        gather.fragment[buffer_fragment_index].length),
                BYTE_SWAP(fragment_length));

            TPOKEW_TX(TT_DULL, "L=", fragment_length);

            SSI_FRAG_WRITED(
                udids_ptr,
                tx_frag_handle,
                tx_buffer_ptr +
                    UDT_OFFSET(
                        KNOSSOS_TX_BUFFER_T,
                        gather.fragment[buffer_fragment_index].phys_addr),
                SSI_FRAG_PHYS_ADDRESS(
                    udids_ptr,
                    frame->frag_array_ptr[fragment_index]));

            buffer_fragment_index++;
        }

        fragment_index++;
    }

    

    SSI_FRAG_WRITEB(
        udids_ptr,
        tx_frag_handle,
        tx_buffer_ptr + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, gather.num_frags),
        (BYTE_T) buffer_fragment_index);

    SSI_FRAG_WRITEW(
        udids_ptr,
        tx_frag_handle,
        tx_buffer_ptr + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, gather.status),
        KNOSSOS_TX_STATUS_BUSY +
            KNOSSOS_TX_STATUS_GATHER +
            KNOSSOS_TX_STATUS_LAST_BUFFER);

    

    tx_buffer_ptr =
        BYTE_SWAP(
            SSI_FRAG_READW(
                udids_ptr,
                tx_frag_handle,
                tx_buffer_ptr +
                    UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.next)));

    TPOKEW_TX(TT_BRIGHT, "Empty", tx_buffer_ptr);

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_buffer_ptr[priority] =
        tx_buffer_ptr;

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool =
        BYTE_SWAP(
            SSI_FRAG_READW(
                udids_ptr,
                tx_frag_handle,
                tx_buffer_ptr +
                    UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.next)));

    TPOKEW_TX(TT_BRIGHT, "Free",
                 KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool);


    

    if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_frame[priority] ==
            NULL)
    {
        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_frame[priority] =
            frame;
    }
    else
    {
        

        (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_frame[priority])
            ->next = frame;
    }

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_frame[priority] =
        frame;

    

    SSI_FRAG_WRITEB(
        udids_ptr,
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).shared_str_handle,
        KNOSSOS_SHARED_OFFSET(tx_or_sleep.tx.tx_ready_queue[
          KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_ready_queue_entry]),
        (BYTE_T) priority);

    

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_ready_queue_entry++;

    if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_ready_queue_entry ==
            KNOS_TX_QUEUE_SIZE)
    {
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_ready_queue_entry = 0;
    }


    

#   ifdef UDT_NO_SSI_PROTECT

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected = FALSE;

    while(KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).ignored_possible_tx_complete)
    {
        POKE_TX(PO_BRIGHT_WHITE, "!!ReprocessTxDone!!");

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).ignored_possible_tx_complete =
            FALSE;

#       ifdef UDT_NO_LOCAL_FAR_CALLS
        KNOSSOS_CHECK_TX_COMPLETE(udids_ptr);
#       else
        knos2_check_tx_complete(udids_ptr);
#       endif
    }

#   endif 


    

    WRITE_KNOSSOS_WORD(
        udids_ptr,
        KNOSSOS_COUNTER_1_TX_FILLED,
        1);

    

    WRITE_KNOSSOS_BYTE(
        udids_ptr,
        KNOSSOS_HOST_2_ADAP_INT,
        KNOSSOS_INT_TX_READY);


    return SUCCESS;
}



STATIC VOID_T UDT_INDIRECT
knos2_check_tx_complete(
    INOUT P_UDI_DATA_T udids_ptr)
{
    UINT_T        priority;
    P_FRAME_T     frame;
    WORD_T        last_buffer_ptr;
    WORD_T        original_buffer_queue_start;
    FRAG_HANDLE_T tx_frag_handle;


    

#   ifdef UDT_NO_SSI_PROTECT

    if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected)
    {
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).ignored_possible_tx_complete =
            TRUE;

        return;
    }
    else
    {
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected = TRUE;
    }

#   endif 


    
    
    while (READ_KNOSSOS_WORD(udids_ptr, KNOSSOS_COUNTER_2_TX_COMPLETE))
    {
        POKE_TX(COLOUR_TX, "TxDone");

        

        if (KNOSSOS_ADAPTER_REMOVED)
        {
#           ifdef UDT_NO_SSI_PROTECT
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected = FALSE;
#           endif 

            UDI_STATE(udids_ptr) = REGISTERED;

            UPCALL_EVENT(udids_ptr, ADAPTER_REMOVED);

            return;
        }

        

#       ifdef UDT_SANITY_CHECK
        if (READ_KNOSSOS_WORD(udids_ptr, KNOSSOS_COUNTER_2_TX_COMPLETE) >
                KNOS_TX_QUEUE_SIZE)
        {
            POKE_TX(COLOUR_INSANE, "BadCounter2");
            UDT_INSANE;
        }
#       endif

        

        priority =
            SSI_FRAG_READB(
                udids_ptr,
                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).shared_str_handle,
                KNOSSOS_SHARED_OFFSET(
                    tx_or_sleep.tx.tx_comp_queue[
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                            next_tx_comp_queue_entry])
                );

#       ifdef UDT_SANITY_CHECK

        

        if (priority>KNOSSOS_PRIORITY_LEVELS)
        {
            POKE_TX(COLOUR_INSANE, "BadPriority");
            UDT_INSANE;
        }

        SSI_FRAG_WRITEB(
            udids_ptr,
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).shared_str_handle,
            KNOSSOS_SHARED_OFFSET(
                tx_or_sleep.tx.tx_comp_queue[
                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                        next_tx_comp_queue_entry]),
            0xFF
            );

#       endif

        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_comp_queue_entry+=2;

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_comp_queue_entry
                == KNOS_TX_QUEUE_SIZE*2)
        {
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_comp_queue_entry =
                0;
        }

        

        WRITE_KNOSSOS_WORD(
            udids_ptr,
            KNOSSOS_COUNTER_2_TX_COMPLETE,
            0xFFFF);

        TPOKEB_TX(TT_TX, "P", priority);


        

        

#       ifdef UDT_SANITY_CHECK
        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                next_tx_buffer_ptr[priority] ==
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                last_tx_buffer_ptr[priority])
        {

            POKE_TX(COLOUR_INSANE, "EmptyList");

            TPOKEW_TX(
                TT_INFO,
                "1st=",
                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                    next_tx_buffer_ptr[priority]);

            TPOKEW_TX(
                TT_INFO,
                "Last=",
                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                    last_tx_buffer_ptr[priority]);

            UDT_INSANE;
        }
#       endif

        

        tx_frag_handle = GET_CONFIG_VALUE(
                             CONFIG_FROM_UDIDS(udids_ptr),
                             frag_handle[KNOSSOS_FF08_FRAGMENT_INDEX]);

        original_buffer_queue_start = KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                          next_tx_buffer_ptr[priority];

        last_buffer_ptr =
            BYTE_SWAP(
                SSI_FRAG_READW(
                    udids_ptr,
                    tx_frag_handle,
                    original_buffer_queue_start
                        + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.next)));

        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_buffer_ptr[priority] =
            BYTE_SWAP(
                SSI_FRAG_READW(
                    udids_ptr,
                    tx_frag_handle,
                    last_buffer_ptr +
                        UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.next)));

        

        SSI_FRAG_WRITEW(
            udids_ptr,
            tx_frag_handle,
            last_buffer_ptr + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.next),
            BYTE_SWAP(
                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool));

        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool =
            original_buffer_queue_start;

        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool_entries
            += 2;

        TPOKEB_TX(TT_TX, "Free=",
             KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                 free_tx_buffer_pool_entries);


        

        

#       ifdef UDT_SANITY_CHECK
        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_frame[priority] ==
            NULL)
        {
            POKE_TX(COLOUR_INSANE, "NoFrame");
            UDT_INSANE;
        }
#       endif

        frame = 
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_frame[priority];

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_frame[priority] ==
                frame)
        {
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_frame[priority] =
                NULL;
        }
        else
        {
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_frame[priority] =
                frame->next;
        }


        

        ADD_TO_COUNTER(udids_ptr, tx_bytes, frame->frame_length);
        ADD_TO_COUNTER(udids_ptr, tx_frames, 1);


        

        

        UPCALL_XFER_COMPLETE(udids_ptr, frame, 1);

        

        UPCALL_TX_COMPLETE(
            udids_ptr,
            0,
            TRUE,
            1);
    }

    

#   ifdef UDT_NO_SSI_PROTECT

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected = FALSE;

#   endif 

}




STATIC VOID_T
knos2_process_received_mac_frames(
    INOUT P_UDI_DATA_T udids_ptr)
{
    BYTE_T        response;
    FRAG_HANDLE_T rx_frag_handle;
    P_FRAME_T     rx_frame;

    rx_frag_handle = GET_CONFIG_VALUE(
                         CONFIG_FROM_UDIDS(udids_ptr),
                         frag_handle[KNOSSOS_FF0C_FRAGMENT_INDEX]);

    

    if (!KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).may_receive_mac_frames)
    {
        while (
                 SSI_FRAG_READW(
                     udids_ptr,
                     rx_frag_handle,
                     KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                         next_adapter_to_host_mac_buffer +
                             UDT_OFFSET(KNOSSOS_MAC_RX_BUFFER_T,length)
                     )!=0)
        {
            POKE_ISR(PO_BRIGHT_FLASHING_CYAN, "DiscardMac");

            

            SSI_FRAG_WRITEW(
                udids_ptr,
                rx_frag_handle,
                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                    next_adapter_to_host_mac_buffer +
                        UDT_OFFSET(KNOSSOS_MAC_RX_BUFFER_T,length),
                0);

            

            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                next_adapter_to_host_mac_buffer =
                SSI_FRAG_READW(
                    udids_ptr,
                    rx_frag_handle,
                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                        next_adapter_to_host_mac_buffer +
                            UDT_OFFSET(KNOSSOS_MAC_RX_BUFFER_T,next)
                    );

            

#           ifdef UDT_SANITY_CHECK

            POKE_ISR(COLOUR_INSANE, "UnexpectedMac");
            UDT_INSANE;

#           endif

        }

        return;
    }


    if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).pending_mac_rx
        ||
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).frame_for_mac!=NULL)
    {
        POKE_ISR(PO_MAGENTA, "Skip");
        return;
    }


    

    while (
        (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).pending_mac_rx_length =
            SSI_FRAG_READW(
                udids_ptr,
                rx_frag_handle,
                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                    next_adapter_to_host_mac_buffer +
                        UDT_OFFSET(KNOSSOS_MAC_RX_BUFFER_T,length)
                )
        ) != 0)
    {
        

#       ifdef UDT_LIMIT_RX_LOOPS

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).remaining_reception_quota
               == 0)
        {
            

            UDI_REQUEST_INTERRUPT_FROM_ADAPTER(udids_ptr);

            break;
        }

#       endif 


        

        TPOKEW_ISR(
            TT_RX_MAC,
            "MacBuff=",
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                next_adapter_to_host_mac_buffer);

        TPOKEW_ISR(
            TT_RX_MAC,
            "Len=",
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).pending_mac_rx_length);
            

        
 
        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count >= 3)
        {
            

            SSI_FRAG_WRITEB(
                udids_ptr,
                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).shared_str_handle,
                KNOSSOS_SHARED_OFFSET(unget_rx_buffer_information),
                KNOS_UNGET_RX_REQUEST
                );

            
    
            WRITE_KNOSSOS_BYTE(
                udids_ptr,
                KNOSSOS_HOST_2_ADAP_INT,
                KNOSSOS_INT_UNGET_RX_BUFFER);

            

            while (
                (response =
                    SSI_FRAG_READB(
                        udids_ptr,
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                            shared_str_handle,
                        KNOSSOS_SHARED_OFFSET(unget_rx_buffer_information))
                )
                == KNOS_UNGET_RX_REQUEST
                )
            {
                if (SSI_FRAG_READW(
                        udids_ptr,
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                            shared_str_handle,
                        KNOSSOS_SHARED_OFFSET(adapter_crash_reason)))
                {
#                    ifdef UDT_SANITY_CHECK

                     POKE_ISR(COLOUR_INSANE, "AdapterCrash");
                     UDT_INSANE;

#                    endif

                     return;
                }

                if (KNOSSOS_ADAPTER_REMOVED)
                {
                     UDI_STATE(udids_ptr) = REGISTERED;
                     UPCALL_EVENT(udids_ptr, ADAPTER_REMOVED);
                     return;
                }
            }
        }
        else
        {
            

            response = KNOS_UNGET_RX_FAILED;
        }

        

        if (response == KNOS_UNGET_RX_FAILED)
        {
            

            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).pending_mac_rx = TRUE;

            POKE_ISR(PO_BRIGHT_CYAN, "NoFreeBuffer");

            return;
        }

        

        POKE_ISR(PO_BRIGHT_CYAN, "ProcessNow");

#       ifdef UDT_SANITY_CHECK

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count < 2)
        {
            WRITE_KNOSSOS_WORD(
                udids_ptr,
                KNOSSOS_ADAPTER_CTRL,
                0x0000);

            POKE_ISR(COLOUR_INSANE, "AdapBadDecrement");

            UDT_INSANE;
        }

#       endif 

        

         if (
                (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                    next_uninitialised_rx_buffer_ptr -=
                        KNOSSOS12_RX_BUFFER_SIZE
                )
                <
                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).first_rx_buffer_ptr
            )
         {
             KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                 next_uninitialised_rx_buffer_ptr =
                     KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                         last_rx_buffer_ptr;
         }

        

        rx_frame = KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                       last_rx_frame_list_entry;

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_rx_frame_list_entry =
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).rx_frame_list;

        while (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                   last_rx_frame_list_entry ->
                       next
                   != rx_frame)
        {
#           ifdef UDT_SANITY_CHECK

            if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                   last_rx_frame_list_entry ->
                       next == 0)
            {
                WRITE_KNOSSOS_WORD(
                    udids_ptr,
                    KNOSSOS_ADAPTER_CTRL,
                    0x0000);

                POKE_ISR(COLOUR_INSANE, "BadRxLinkedList");

                UDT_INSANE;
            }

#           endif 

            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                last_rx_frame_list_entry =
                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                        last_rx_frame_list_entry ->
                            next;
        }

        

#       ifdef UDT_SANITY_CHECK

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count == 0)
        {
            POKE_ISR(COLOUR_INSANE, "TooManyRx");
            UDT_INSANE;
        }

#       endif

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count--;


        

        knos2_report_mac_frame(udids_ptr, rx_frame);

        
    }

    return;
}




STATIC VOID_T
knos2_report_mac_frame(
    INOUT P_UDI_DATA_T                 udids_ptr,
    IN    P_FRAME_T                    rx_frame)
{
    FRAG_HANDLE_T rx_frag_handle;

    rx_frag_handle = GET_CONFIG_VALUE(
                         CONFIG_FROM_UDIDS(udids_ptr),
                         frag_handle[KNOSSOS_FF0C_FRAGMENT_INDEX]);

    POKE_ISR(PO_BRIGHT_WHITE, "ReportMac");

    

    SSI_FRAG_TO_FRAG(
        udids_ptr,

        rx_frame->frag_array_ptr[0],
        0,

        rx_frag_handle,
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_adapter_to_host_mac_buffer
            + UDT_OFFSET(KNOSSOS_MAC_RX_BUFFER_T,data_area_start),

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).pending_mac_rx_length
        );

#   if 0
#   ifdef UDT_POKEOUTS_ON
        {
            

            UINT_T i;

            for (i=0;
                 i<KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                       pending_mac_rx_length;
                 i++)
            {
                POKEB_ISR(
                    PO_GREEN,
                    " ",
                    SSI_FRAG_READB
                        (
                            udids_ptr,
                            rx_frame->frag_array_ptr[0],
                            i
                        ));
            }
        }
#   endif
#   endif

    

    rx_frame->frame_length =
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).pending_mac_rx_length;


    

    SSI_FRAG_WRITEW(
        udids_ptr,
        rx_frag_handle,
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
            next_adapter_to_host_mac_buffer +
                UDT_OFFSET(KNOSSOS_MAC_RX_BUFFER_T,length),
        0);


    

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
        next_adapter_to_host_mac_buffer =
        SSI_FRAG_READW(
            udids_ptr,
            rx_frag_handle,
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                next_adapter_to_host_mac_buffer +
                    UDT_OFFSET(KNOSSOS_MAC_RX_BUFFER_T,next)
            );


    

    if(UDI_STATE(udids_ptr) != OPEN)
    {
        rx_frame->next = NULL;

#       ifdef UDT_NO_LOCAL_FAR_CALLS
        UDTI_PROVIDE_RX_DESCRIPTORS(udids_ptr, rx_frame);
#       else
        knos2_provide_rx_descriptors(udids_ptr, rx_frame);
#       endif
    }
    else
    {
        rx_frame->rx_status = FRAME_COMPLETE;

        ADD_TO_COUNTER(udids_ptr, rx_frames, 1);
        ADD_TO_COUNTER(udids_ptr, rx_bytes, rx_frame->frame_length);

        

        UPCALL_RX(udids_ptr, rx_frame);

        

#       ifdef UDT_LIMIT_RX_LOOPS

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
            remaining_reception_quota--;

#       endif 
    }

    return;
}




STATIC VOID_T
knos2_process_received_data(
    INOUT P_UDI_DATA_T udids_ptr)
{
    WORD_T        rx_status;
    P_FRAME_T     rx_frame;
    FRAG_HANDLE_T rx_frag_handle;
    WORD_T        rx_frame_length;
#   ifdef ONE_POOL_RX_POSSIBLE
    WORD_T        mac_frame_length;
#   endif 

    POKE_ISR(COLOUR_TX, "Rx?");

    rx_frag_handle = GET_CONFIG_VALUE(
                         CONFIG_FROM_UDIDS(udids_ptr),
                         frag_handle[KNOSSOS_FF0C_FRAGMENT_INDEX]);

    while (
        READ_KNOSSOS_WORD(
            udids_ptr,
            KNOSSOS_COUNTER_3_RX_ARRIVING))
    {
        

        if (KNOSSOS_ADAPTER_REMOVED)
        {
            UDI_STATE(udids_ptr) = REGISTERED;
            UPCALL_EVENT(udids_ptr, ADAPTER_REMOVED);
            return;
        }


        

#       ifdef UDT_LIMIT_RX_LOOPS

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).remaining_reception_quota
               == 0)
        {
            

            UDI_REQUEST_INTERRUPT_FROM_ADAPTER(udids_ptr);

            break;
        }

#       endif 

        
    
        TPOKEW_ISR(
            TT_INFO,
            "Buff=",
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_rx_buffer_ptr);

        rx_status =
            SSI_FRAG_READW
                (
                    udids_ptr,
                    rx_frag_handle,
                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                        next_rx_buffer_ptr
                            + UDT_OFFSET(KNOSSOS_RX_BUFFER_T, scatter.status)
                );

        TPOKEW_ISR(TT_INFO, "Stat=", BYTE_SWAP(rx_status));


        

#       ifdef PRESTO_UDI

        if (ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype ==
                ADAPTER_SUBTYPE_PRESTO)
        {
            

            while ((rx_status & KNOSSOS_RX_STATUS_BUSY)==0)
            {
                rx_status =
                    SSI_FRAG_READW
                        (
                            udids_ptr,
                            rx_frag_handle,
                            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                                next_rx_buffer_ptr
                                   + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,
                                            scatter.status)
                        );

                POKE_RX(PO_MAGENTA, "");

                if (
                    SSI_FRAG_READW(
                        udids_ptr,
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                            shared_str_handle,
                        KNOSSOS_SHARED_OFFSET(ring_status)
                        )
                    &
                        (
                        RING_STATUS_LOBE_FAULT |
                        RING_STATUS_AUTO_REMOVAL |
                        RING_STATUS_REMOVE_RECEIVED
                        )
                   )
                {
                    return;
                }
            }


            
                   
            if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).dma_overrun_countdown)
            {
                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                    dma_overrun_countdown--;

                if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                        dma_overrun_countdown
                            == 0
                    &&
                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                        in_interrupt_at_start_of_frame_mode)
                {
                    

                    POKE_ISR(PO_BRIGHT_FLASHING_RED,"NormalRxInterrupt");

                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                        dma_overrun_countdown
                            = UNACCEPTABLE_DMA_OVERRUN_INTERVAL;

                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                        in_interrupt_at_start_of_frame_mode
                            = FALSE;

                    SSI_FRAG_WRITEB(
                        udids_ptr,
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                            shared_str_handle,
                        KNOSSOS_SHARED_OFFSET(rx_int_mode),
                        KNOS_RX_INT_AT_EOF);

                    knos2_issue_event(udids_ptr, 0);
                }
            }
        }

#       endif 


        

        rx_frame_length =
            (
                BYTE_SWAP(
                    SSI_FRAG_READW
                        (
                            udids_ptr,
                            rx_frag_handle,
                            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                next_rx_buffer_ptr
                                    + UDT_OFFSET(
                                          KNOSSOS_RX_BUFFER_T, scatter.length)
                        )
                    )
                & 0x7FFF
            )
            - 4;

        TPOKEW_ISR(TT_INFO, "Len=", rx_frame_length);


        

#       ifdef UDT_SANITY_CHECK

        if ((rx_status & KNOSSOS_RX_STATUS_BUSY)==0)
        {
            UINT_T i;
            WORD_T local_status;

            WRITE_KNOSSOS_WORD(
                udids_ptr,
                KNOSSOS_ADAPTER_CTRL,
                0x0000);

            POKE_ISR(COLOUR_INSANE, "RxFrameNotThere");

            UDT_INSANE;

            

            for (i=1; i<50; i++)
            {
                TPOKEW_ISR(
                    TT_INFO,
                    "C4=",
                    READ_KNOSSOS_WORD(
                        udids_ptr,
                        KNOSSOS_COUNTER_3_RX_ARRIVING));

                local_status =
                    BYTE_SWAP(
                        SSI_FRAG_READW
                        (
                            udids_ptr,
                            rx_frag_handle,
                            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                next_rx_buffer_ptr
                                    + UDT_OFFSET(
                                          KNOSSOS_RX_BUFFER_T, scatter.status)
                        ));

                TPOKEW_ISR(TT_INFO, "Stat=", local_status);

                SSI_WAIT_AT_LEAST_MSEC(udids_ptr, i);
            }

            UDT_INSANE;

            rx_status = 0xFFFF;   
        }

#       endif

#       ifdef UDT_SANITY_CHECK

        rx_frame_length += 4;

        if (rx_frame_length < 18)
        {
            POKE_ISR(COLOUR_INSANE, "TinyFrame");
        }

        rx_frame_length -= 4;

#       endif


        

        WRITE_KNOSSOS_WORD(
            udids_ptr,
            KNOSSOS_COUNTER_3_RX_ARRIVING,
            0xFFFF);


        

        rx_frame = KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).rx_frame_list;

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).rx_frame_list =
            rx_frame->next;

#       if 0
#       ifdef UDT_POKEOUTS_ON
        {
            

            UINT_T i;

            for (i=0; i<rx_frame_length; i++)
            {
                POKEB_ISR(
                    PO_GREEN,
                    " ",
                    SSI_FRAG_READB
                        (
                            udids_ptr,
                            rx_frame->frag_array_ptr[0],
                            i
                        ));
            }
        }
#       endif
#       endif

        rx_frame->frame_length = rx_frame_length;


        

#       ifdef PRESTO_UDI

        if (ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype !=
                ADAPTER_SUBTYPE_PRESTO)

#       endif

        {
            if ((SSI_FRAG_READW(
                     udids_ptr,
                     rx_frag_handle,
                     KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                         next_rx_buffer_ptr
                             + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,
                                              scatter.reserved))
                 & 0x0700) == 0x0200)
            {
                rx_status |= KNOSSOS_RX_STATUS_RX_EDI;
            }
        }


        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_rx_buffer_ptr =
            BYTE_SWAP(
                SSI_FRAG_READW
                    (
                        udids_ptr,
                        rx_frag_handle,
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                            next_rx_buffer_ptr
                            + UDT_OFFSET(KNOSSOS_RX_BUFFER_T, scatter.next)
                    ))
            & 0xFFF8;

        

#       ifdef UDT_SANITY_CHECK

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count == 0)
        {
            POKE_ISR(COLOUR_INSANE, "TooManyRx");
            UDT_INSANE;
        }

#       endif

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count--;


        

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).discarding_frame ||
                (rx_status & KNOSSOS_RX_STATUS_LAST_BUFFER) == 0)
        {
#           ifdef UDT_SANITY_CHECK

            POKE_ISR(COLOUR_INSANE, "MultiBufferRx");

#           endif

            

            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).discarding_frame =
                ((rx_status & KNOSSOS_RX_STATUS_LAST_BUFFER) == 0);

            

            rx_frame->next = NULL;

#           ifdef UDT_NO_LOCAL_FAR_CALLS
            UDTI_PROVIDE_RX_DESCRIPTORS(udids_ptr, rx_frame);
#           else
            knos2_provide_rx_descriptors(udids_ptr, rx_frame);
#           endif

            return;
        }


        

        if (rx_status & (
                KNOSSOS_RX_STATUS_SP_COMPLETION |
                KNOSSOS_RX_STATUS_BM_COMPLETION |
                KNOSSOS_RX_STATUS_RX_EDI |
                KNOSSOS_RX_STATUS_LOCAL_EDI))
        {
            

            POKEW_ISR(PO_WHITE, "RxFailed", rx_status);

#           ifdef UDT_MAINTAIN_COUNTERS

#           ifdef UDT_EXTENDED_COUNTERS

            if (rx_status & KNOSSOS_RX_STATUS_LOCAL_EDI)
            {
                ADD_TO_COUNTER(udids_ptr, rx_aborts, 1);
            }
            else
            {
                ADD_TO_COUNTER(udids_ptr, rx_overruns, 1);
            }

#           else

            ADD_TO_COUNTER(udids_ptr, rx_aborts, 1);

#           endif

#           endif 

#           ifdef UDT_SANITY_CHECK

            if ((rx_status & KNOSSOS_RX_STATUS_SP_COMPLETION)!=
                    KNOSSOS_RX_STATUS_ABORTED)
            {
                POKE_ISR(COLOUR_INSANE, "NotRxAbort");
            }

            

            if ((rx_status & KNOSSOS_RX_STATUS_SP_COMPLETION)==
                    KNOSSOS_RX_STATUS_ABORTED
                &&
                ((rx_frame_length+4)&63)==0)
            {
                POKE_ISR(COLOUR_INSANE, "Danger!!Aborted&Multipleof64");
                 
            }

            

            if ((rx_frame_length+4) ==
                 SSI_FRAG_LENGTH(udids_ptr, rx_frame->frag_array_ptr[0]))
            {
                POKE_ISR(COLOUR_INSANE, "Danger!!ErrorOnMaxSizeFrame");
                UDT_INSANE; 
            }

#           endif 

            

#           ifdef PRESTO_UDI

            if (ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype ==
                    ADAPTER_SUBTYPE_PRESTO)
            {
                if ((rx_status & KNOSSOS_RX_STATUS_BM_COMPLETION)
                        == KNOSSOS_RX_STATUS_DMA_OVERRUUN)
                {
                    

                    if (!KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                           in_interrupt_at_start_of_frame_mode)
                    {
                        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                dma_overrun_countdown)
                        {
                            

                            TPOKEW_ISR(
                                TT_BRIGHT_FLASHING,
                                "ChangeRxToEarlyInterrupt,countdown=",
                                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                    dma_overrun_countdown);

                            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                in_interrupt_at_start_of_frame_mode
                                    = TRUE;

                            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                dma_overrun_countdown
                                    = INTERRUPT_AT_START_OF_FRAME_DURATION;

                            SSI_FRAG_WRITEB(
                                udids_ptr,
                                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                    shared_str_handle,
                                KNOSSOS_SHARED_OFFSET(rx_int_mode),
                                KNOS_RX_INT_AT_SOF);

                            knos2_issue_event(udids_ptr, 0);
                        }
                        else
                        {
                            

                            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                dma_overrun_countdown
                                    = UNACCEPTABLE_DMA_OVERRUN_INTERVAL;
                        }
                    }
                }
            }

#           endif 

            rx_frame->next = NULL;

#           ifdef UDT_NO_LOCAL_FAR_CALLS
            UDTI_PROVIDE_RX_DESCRIPTORS(udids_ptr, rx_frame);
#           else
            knos2_provide_rx_descriptors(udids_ptr, rx_frame);
#           endif
        } 
        else
        {
            

            POKE_ISR(PO_WHITE, "RxOk");

            

#           ifdef ONE_POOL_RX_POSSIBLE

            

#           ifdef UDT_SANITY_CHECK

            if (!KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).may_receive_mac_frames
                &&
                    (
                        SSI_FRAG_READB(
                            udids_ptr,
                            rx_frame->frag_array_ptr[0],
                            1)
                        & 0xC0
                    ) == 0x00
               )
            {
                POKE_ISR(COLOUR_INSANE, "UnexpectedMacFrame");
                UDT_INSANE;
            }

#           endif 

            if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).may_receive_mac_frames
                &&
                    (
                        SSI_FRAG_READB(
                            udids_ptr,
                            rx_frame->frag_array_ptr[0],
                            1)
                        & 0xC0
                    ) == 0x00
               )
            {
                

                POKE_ISR(PO_BRIGHT_MAGENTA,"Mac");

                

                if (SSI_FRAG_READW(
                        udids_ptr,
                        rx_frag_handle,
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                            next_free_host_to_adapter_mac_buffer
                                + UDT_OFFSET(
                                      KNOSSOS_RX_BUFFER_T, normal.status))
                    == 0x0000)
                {
                    mac_frame_length = rx_frame_length + 4;

                    if (mac_frame_length > (128-6))
                    {
                        mac_frame_length = 128-6;
                    }

                    

                    SSI_FRAG_TO_FRAG(
                        udids_ptr,

                        rx_frag_handle,
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                            next_free_host_to_adapter_mac_buffer
                                + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,
                                             normal.data_area_start),

                        rx_frame->frag_array_ptr[0],
                        0,

                        mac_frame_length
                        );

                    

                    SSI_FRAG_WRITEW(
                        udids_ptr,
                        rx_frag_handle,
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                            next_free_host_to_adapter_mac_buffer
                                + UDT_OFFSET(
                                      KNOSSOS_RX_BUFFER_T, normal.length),
                        mac_frame_length);

                    

                    SSI_FRAG_WRITEW(
                        udids_ptr,
                        rx_frag_handle,
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                            next_free_host_to_adapter_mac_buffer
                                + UDT_OFFSET(
                                      KNOSSOS_RX_BUFFER_T, normal.status),
                        rx_status);

                    

                    WRITE_KNOSSOS_BYTE(
                        udids_ptr,
                        KNOSSOS_HOST_2_ADAP_INT,
                        KNOSSOS_INT_RECEIVE_MAC);

                    

                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                        next_free_host_to_adapter_mac_buffer = 
                           BYTE_SWAP(
                               SSI_FRAG_READW(
                                   udids_ptr,
                                   rx_frag_handle,
                                   KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                                       next_free_host_to_adapter_mac_buffer
                                           + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,
                                                        normal.next)
                                   ))
                           & 0xFFF8;
                }
#               ifdef UDT_SANITY_CHECK
                else
                {
                    POKE_ISR(COLOUR_INSANE, "DroppingMacFrame");
                    UDT_INSANE; 
                }
#               endif 

            }

#           endif 

            

            if(UDI_STATE(udids_ptr) != OPEN)
            {
                rx_frame->next = NULL;

#               ifdef UDT_NO_LOCAL_FAR_CALLS
                UDTI_PROVIDE_RX_DESCRIPTORS(udids_ptr, rx_frame);
#               else
                knos2_provide_rx_descriptors(udids_ptr, rx_frame);
#               endif
            }
            else
            {
                rx_frame->rx_status = FRAME_COMPLETE;

                ADD_TO_COUNTER(udids_ptr, rx_frames, 1);
                ADD_TO_COUNTER(udids_ptr, rx_bytes, rx_frame_length);

                

                UPCALL_RX(udids_ptr, rx_frame);

                

#               ifdef UDT_LIMIT_RX_LOOPS

                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                    remaining_reception_quota--;

#               endif 

            }
        }

    }

    return;
}



STATIC RETCODE_T UDT_INDIRECT
knos2_udti_complete_rx(
    IN P_UDI_DATA_T udids_ptr,
    IN P_FRAME_T    rx_list)
{
    

#   ifdef UDT_NO_LOCAL_FAR_CALLS
    UDTI_PROVIDE_RX_DESCRIPTORS(udids_ptr, rx_list);
#   else
    knos2_provide_rx_descriptors(udids_ptr, rx_list);
#   endif

    return SUCCESS;
}



P_FRAME_T UDT_INDIRECT
knos2_provide_rx_descriptors(
    IN    P_UDI_DATA_T udids_ptr,
    INOUT P_FRAME_T    rx_list)
{
    WORD_T        base;
    FRAG_HANDLE_T rx_frag_handle;

    

    if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).pending_mac_rx
        &&
        rx_list!=NULL)
    {
        POKE_ISR(PO_RED, "ForMac");

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).pending_mac_rx = FALSE;
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).frame_for_mac = rx_list;

        rx_list = rx_list->next;

        

        UDI_REQUEST_INTERRUPT_FROM_ADAPTER(udids_ptr);
    }

    

    rx_frag_handle = GET_CONFIG_VALUE(
                         CONFIG_FROM_UDIDS(udids_ptr),
                         frag_handle[KNOSSOS_FF0C_FRAGMENT_INDEX]);

    

    if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).rx_frame_list == NULL)
    {
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).rx_frame_list = rx_list;
    }
    else
    {
        ((KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_rx_frame_list_entry)->
            next) = rx_list;
    }


    

    while (rx_list)
    {
        POKEW_ISR(COLOUR_PROV_RX, "ProvRx:",
            SSI_FRAG_LENGTH(udids_ptr, rx_list->frag_array_ptr[0]));

        POKED_ISR(COLOUR_PROV_RX, ",addr=",
            SSI_FRAG_PHYS_ADDRESS(udids_ptr, rx_list->frag_array_ptr[0]));

        

#       ifdef UDT_SANITY_CHECK

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count ==
               GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr),rx_slots))
        {
            POKE_ISR(COLOUR_INSANE, "TooManyRxFrames");
            UDT_INSANE;
        }

        if (SSI_FRAG_PHYS_ADDRESS(udids_ptr, rx_list->frag_array_ptr[0]) & 1)
        {
            POKE_ISR(COLOUR_INSANE, "RxNotWordAligned");
            UDT_INSANE;
        }

        if (SSI_FRAG_LENGTH(udids_ptr, rx_list->frag_array_ptr[0]) > 18050)
        {
            POKE_ISR(COLOUR_INSANE, "BigRxLen");
            UDT_INSANE;
        }

        

        if (rx_list->frag_array_length != 1)
        {
            POKE_ISR(COLOUR_INSANE, "Not1Frag");
            UDT_INSANE;
        }

#       endif 


        

        base = KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                   next_uninitialised_rx_buffer_ptr;

        SSI_FRAG_WRITEW(
            udids_ptr,
            rx_frag_handle,
            base + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,scatter.length),
            BYTE_SWAP(
                0x8000 +
                SSI_FRAG_LENGTH(udids_ptr, rx_list->frag_array_ptr[0])));

        SSI_FRAG_WRITED(
            udids_ptr,
            rx_frag_handle,
            base + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,scatter.frag_addr),
            SSI_FRAG_PHYS_ADDRESS(udids_ptr, rx_list->frag_array_ptr[0]));

        SSI_FRAG_WRITEW(
            udids_ptr,
            rx_frag_handle,
            base + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,scatter.status),
            0);

        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
            next_uninitialised_rx_buffer_ptr =
                BYTE_SWAP(
                    SSI_FRAG_READW(
                         udids_ptr,
                         rx_frag_handle,
                         base + UDT_OFFSET(KNOSSOS_TX_BUFFER_T,normal.next))
                         )
                & 0xFFF8;

        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_rx_frame_list_entry =
            rx_list;

        rx_list = rx_list->next;

        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count++;

        

        WRITE_KNOSSOS_WORD(udids_ptr, KNOSSOS_COUNTER_4_RX_AVAILABLE, 1);

#       ifdef KNOSSOS_INT_FOR_RX_AVAILABLE
#       ifndef USE_OLD_K2_IMAGE

        

        WRITE_KNOSSOS_BYTE(
            udids_ptr,
            KNOSSOS_HOST_2_ADAP_INT,
            KNOSSOS_INT_RX_BUFFER_AVAILABLE);

#       endif
#       endif

    }

    return NULL;
}
         

#ifdef PRESTO_UDI
STATIC VOID_T
knos2_issue_event(
    IN P_UDI_DATA_T udids_ptr,
    IN BYTE_T       event_bitmap)
{
    POKE_ISR(PO_BRIGHT_CYAN, "SendEvent");

    TPOKEB_ISR(TT_INFO, "Bmap=", event_bitmap);

    

    SSI_FRAG_WRITEB(
        udids_ptr,
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).shared_str_handle,
        KNOSSOS_SHARED_OFFSET(host_to_adapter_events),
        (BYTE_T) (SSI_FRAG_READB(
                    udids_ptr,
                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).shared_str_handle,
                    KNOSSOS_SHARED_OFFSET(host_to_adapter_events))
                    ^
                    event_bitmap));

    
    
    WRITE_KNOSSOS_BYTE(
        udids_ptr,
        KNOSSOS_HOST_2_ADAP_INT,
        KNOSSOS_HOST2ADAP_EVENTS);

    return;
}
#endif 



BUILD_MODULE_END_FUNCTION(knos2r_end)



#endif 

#endif 



