/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
*  **   ** **   **  *****   *****   *****  ******      *****  
*  **  **  ***  ** **   ** **   ** **   **  **  **    **   ** 
*  ** **   **** ** **   ** **           **  **  **    **      
*  ****    ** **** **   **  *****    ****   *****     **      
*  ** **   **  *** **   **      **      **  **  **    **      
*  **  **  **   ** **   ** **   ** **   **  **  **    **   ** 
*  **   ** **   **  *****   *****   *****  ***  ** **  *****  
*                                                             
*****************************************************************************
*
* Functions comprising the resident functions of the UDI for all Knossos 3
* adapters. These are:
*
*    - PCI-4.
*
*****************************************************************************
*
* Copyright (C) 1996-1999 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/

    

#define UDI_MODULE

#include "udt_driver.h"


#ifdef KNOS3_UDI

#ifndef UDT_ONLY_GET_CARD_INFO





STATIC RETCODE_T UDT_INDIRECT
knos3_tx(
    IN P_UDI_DATA_T                    udids_ptr,
    IN P_FRAME_T                       frame);

#ifndef UDT_NO_SSI_PROTECT

STATIC RETCODE_T UDT_LOCAL_PROTECTED
knos3_protected_tx(
    IN P_UDI_DATA_T                    udids_ptr,
    IN PCLIENT_VOID_T                  frame_ptr_ptr,
    IN PCLIENT_VOID_T                  arg2);

#endif 

STATIC VOID_T UDT_INDIRECT
knos3_check_tx_complete(
    INOUT P_UDI_DATA_T                 udids_ptr);




STATIC RETCODE_T UDT_INDIRECT
knos3_udti_complete_rx(
    IN P_UDI_DATA_T                    udids_ptr,
    IN P_FRAME_T                       resource);

P_FRAME_T UDT_INDIRECT
knos3_provide_rx_descriptors(
    IN    P_UDI_DATA_T                 udids_ptr,
    INOUT P_FRAME_T                    rx_list);



STATIC VOID_T UDT_INDIRECT
knos3_process_interrupts(
    INOUT P_UDI_DATA_T                 udids_ptr);






STATIC VOID_T
knos3_process_received_data(
    INOUT P_UDI_DATA_T                 udids_ptr);






#ifndef UDT_INDIRECT_INTER_MODULE_CALLS

extern VOID_T UDT_INTER_MODULE
knossos_process_command_done(
    INOUT P_UDI_DATA_T                 udids_ptr);

extern VOID_T UDT_INTER_MODULE
knossos_process_event(
    INOUT P_UDI_DATA_T                 udids_ptr);

extern VOID_T UDT_INTER_MODULE
knossos_process_status(
    INOUT P_UDI_DATA_T                 udids_ptr);

#endif 




DECLARE_MODULE_START_FUNCTION(knos3r_start)
DECLARE_MODULE_END_FUNCTION(knos3r_end)



RETCODE_T UDT_INTER_MODULE
knos3r_register(
    IN P_UDI_DATA_T        udids_ptr)
{
    POKE_CFG(COLOUR_SUBFN, "RegKnos3Res");

    
     
    SSI_MODULE_REGISTERED(
        udids_ptr,
        knos3r_register,
        knos3r_start,
        knos3r_end,
        MOD_SCOPE_RUNTIME);

    
     
    UDI_RES_FROM_UDIDS(udids_ptr).udi_process_adapter_interrupts =
        knos3_process_interrupts;

    

    UDTI_FROM_UDIDS(udids_ptr).udti_complete_rx =
        knos3_udti_complete_rx;
        
    UDTI_FROM_UDIDS(udids_ptr).udti_provide_rx_descriptors =
        knos3_provide_rx_descriptors;

    UDTI_FROM_UDIDS(udids_ptr).udti_tx =
        knos3_tx;
 
    

    KNOSSOS_RES_FROM_UDIDS(udids_ptr).knossos_check_tx_complete =
        knos3_check_tx_complete;

    
     
    return SUCCESS;
}

BUILD_MODULE_START_FUNCTION(knos3r_start)



STATIC VOID_T UDT_INDIRECT
knos3_process_interrupts(
    INOUT P_UDI_DATA_T udids_ptr)
{
    DWORD_T interrupt_status;
    UINT_T  i;
    UINT_T  j;
    WORD_T  q_of_2;
    UINT_T  queue_entries;
    WORD_T  pptr;
    WORD_T  before_pptr;
    DWORD_T queue_entry;

    

    interrupt_status =
        READ_KNOSSOS_DWORD(udids_ptr, KNOSSOS_ADAP_2_HOST_INT);

    POKED_TX(PO_BRIGHT_WHITE, "P:", interrupt_status);

    if (((BYTE_T)interrupt_status)!=0)
    {
        WRITE_KNOSSOS_BYTE(
            udids_ptr,
            KNOSSOS_ADAP_2_HOST_INT,
            (BYTE_T)interrupt_status);
    }

    

#   ifdef UDT_LIMIT_RX_LOOPS

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).remaining_reception_quota =
        GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr), max_rx_loops);

#   endif 


    

#   ifdef UDT_LIMIT_RX_LOOPS

    

#   endif 


    

    if (interrupt_status & KNOSSOS3_INT_RX)
    {
        POKE_ISR(COLOUR_INT_TYPE, "Rx");

        knos3_process_received_data(udids_ptr);
    }

    

    if (interrupt_status & (KNOSSOS3_INT_TX_COMP | KNOSSOS12_INT_TX_COMP))
    {
        POKE_ISR(COLOUR_INT_TYPE, "Tx Complete");

        if (interrupt_status & KNOSSOS12_INT_TX_COMP)
        {
            POKE_ISR(PO_BRIGHT_FLASHING_RED, "ALL");
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).check_all_tx_queues = TRUE;
        }

#       ifdef UDT_NO_LOCAL_FAR_CALLS
        KNOSSOS_CHECK_TX_COMPLETE(udids_ptr);
#       else
        knos3_check_tx_complete(udids_ptr);
#       endif
    }

    

    if (interrupt_status & KNOSSOS_ADAP2HOST_EVENTS)
    {
        POKE_ISR(COLOUR_INT_TYPE, "Event");

        KNOSSOS_PROCESS_EVENT(udids_ptr);
    }

    

    if (interrupt_status & KNOSSOS_INT_RING_STATUS_AVAILABLE)
    {
        POKE_ISR(COLOUR_INT_TYPE, "Ring Status");
                
        

        KNOSSOS_PROCESS_STATUS(udids_ptr);
    }

    

    if (interrupt_status & KNOSSOS_INT_COMMAND_PROCESSED)  
    {
        POKE_ISR(COLOUR_INT_TYPE, "CommandDone");
                
        KNOSSOS_PROCESS_COMMAND_DONE(udids_ptr);
    }

    

    if (interrupt_status & KNOSSOS_INT_WATCHDOG)
    {
        POKE_ISR(COLOUR_INT_TYPE, "Wdog");

        if (STATS_FROM_UDIDS(udids_ptr).open_info.ring_speed != RS_100M
            &&
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                tx_not_completed_since_tick
#           ifdef UDT_NO_SSI_PROTECT
            &&
            !KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected
#           endif
            )
        {
            

            for (i=0; i<KNOSSOS_MAX_PRIORITY_QUEUES; i++)
            {
                

                if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_frame[i]!=
                        NULL)
                {
                    

                    if ((KNOSSOS_SAFE_PIO_READ_BYTE(
                             (DWORD_T)
                                  (KNOSSOS_FF1F_SEG |
                                   KNOSSOS_TX_QUEUE_ACTIVITY_REG))
                         &
                         (0x01<<i)
                        ) == 0)
                    {
                        

                        q_of_2 = KNOSSOS_SAFE_PIO_READ_WORD(
                                     (DWORD_T)
                                         (KNOSSOS_FF1F_SEG |
                                          KNOSSOS_TX_QUEUE_STATUS_REG));

                        queue_entries = q_of_2 & 0x0003;

                        if (!(
                                 (queue_entries!=0 && q_of_2>>5 == i)
                                 ||
                                 (queue_entries==2 && q_of_2>>13 == i)
                             )
                           )
                        {
                                                        

                            if ((KNOSSOS_SAFE_PIO_READ_DWORD(
                                  (DWORD_T) (KNOSSOS_FF01_SEG |
                                      KNOSSOS_TX_ADAPTER_NEXT_PENDING_POINTER[
                                          i]))
                                & 0x80000000uL) == 0)
                            {
                                

                                TPOKEB_TX(
                                    TT_BRIGHT,
                                    "FixupStoppedTx! Priority=",
                                    i);

                                TPOKEB_TX(
                                    TT_BRIGHT,
                                    "NumberOfTxs=",
                                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                       tx_adapter_frame_count[i]);

#                               ifdef UDT_POKEOUTS_ON

                                for (j=0; j<8; j++)
                                {
                                    pptr = 0x1E00+0x20*i+j*4;
        
                                    POKEW_TX(
                                        PO_BRIGHT_MAGENTA,
                                        " ",
                                        pptr);
        
                                    POKED_TX(
                                        PO_BRIGHT_GREEN,
                                        "",
                                        KNOSSOS_SAFE_PIO_READ_DWORD(
                                            (DWORD_T)
                                                (KNOSSOS_FF01_SEG | pptr)));
                                }

#                               endif

                                pptr =
                                   KNOSSOS_TX_ADAPTER_NEXT_PENDING_POINTER[i];

                                before_pptr = pptr-4;

                                if ((before_pptr & 0x1F)==0x1C)
                                {
                                    before_pptr += 0x20;
                                }

                                KNOSSOS_TX_ADAPTER_NEXT_PENDING_POINTER[i] =
                                    before_pptr;

                                for (j=0;
                                     j<KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                          tx_adapter_frame_count[i];
                                     j++)
                                {
                                    queue_entry =
                                        KNOSSOS_SAFE_PIO_READ_DWORD(
                                            (DWORD_T)
                                                (KNOSSOS_FF01_SEG | pptr));

                                    KNOSSOS_SAFE_PIO_WRITE_DWORD(
                                        (DWORD_T)
                                            (KNOSSOS_FF01_SEG | pptr),
                                            0x80000000);

                                    KNOSSOS_SAFE_PIO_WRITE_DWORD(
                                        (DWORD_T)
                                            (KNOSSOS_FF01_SEG | before_pptr),
                                        queue_entry);

                                    before_pptr = pptr;

                                    pptr += 4;

                                    if ((pptr & 0x1F)==0)
                                    {
                                        pptr -= 0x20;
                                    }

                                }

                                KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[i] =
                                    before_pptr;

                                

                                KNOSSOS_SAFE_PIO_WRITE_BYTE(
                                    (DWORD_T)
                                        (KNOSSOS_FF1F_SEG |
                                            KNOSSOS_TX_QUEUE_ACTIVITY_REG),
                                    (BYTE_T) (0x01 << i));


#                               ifdef UDT_POKEOUTS_ON

                                for (j=0; j<8; j++)
                                {
                                    pptr = 0x1E00+0x20*i+j*4;
        
                                    POKEW_TX(
                                        PO_BRIGHT_MAGENTA,
                                        " ",
                                        pptr);
        
                                    POKED_TX(
                                        PO_BRIGHT_WHITE,
                                        "",
                                        KNOSSOS_SAFE_PIO_READ_DWORD(
                                            (DWORD_T)
                                                (KNOSSOS_FF01_SEG | pptr)));
                                }

#                               endif
                            }
                        }
                    }
                }
            }
        }


#       ifdef UDT_SANITY_CHECK

        if (STATS_FROM_UDIDS(udids_ptr).open_info.ring_speed == RS_100M
            &&
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                tx_not_completed_since_tick
#           ifdef UDT_NO_SSI_PROTECT
            &&
            !KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected
#           endif
            )
        {
            

            for (i=0; i<KNOSSOS_MAX_PRIORITY_QUEUES; i++)
            {
                

                if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_frame[i]!=
                        NULL)
                {
                    

                    if ((KNOSSOS_SAFE_PIO_READ_BYTE(
                             (DWORD_T)
                                  (KNOSSOS_FF1F_SEG |
                                   KNOSSOS_TX_QUEUE_ACTIVITY_REG))
                         &
                         (0x01<<i)
                        ) == 0)
                    {
                        

                        q_of_2 = KNOSSOS_SAFE_PIO_READ_WORD(
                                     (DWORD_T)
                                         (KNOSSOS_FF1F_SEG |
                                          KNOSSOS_TX_QUEUE_STATUS_REG));

                        queue_entries = q_of_2 & 0x0003;

                        if (!(
                                 (queue_entries!=0 && q_of_2>>5 == i)
                                 ||
                                 (queue_entries==2 && q_of_2>>13 == i)
                             )
                           )
                        {
                                                        

                            if ((KNOSSOS_SAFE_PIO_READ_DWORD(
                                  (DWORD_T) (KNOSSOS_FF01_SEG |
                                      KNOSSOS_TX_ADAPTER_NEXT_PENDING_POINTER[
                                          i]))
                                & 0x80000000uL) == 0)
                            {
                                

                                TPOKEB_TX(
                                    TT_BRIGHT,
                                    "FixupStoppedTx! Priority=",
                                    i);

                                TPOKEB_TX(
                                    TT_BRIGHT,
                                    "NumberOfTxs=",
                                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                       tx_adapter_frame_count[i]);

#                               ifdef UDT_POKEOUTS_ON

                                for (j=0; j<8; j++)
                                {
                                    pptr = 0x1E00+0x20*i+j*4;
        
                                    POKEW_TX(
                                        PO_BRIGHT_MAGENTA,
                                        " ",
                                        pptr);
        
                                    POKED_TX(
                                        PO_BRIGHT_GREEN,
                                        "",
                                        KNOSSOS_SAFE_PIO_READ_DWORD(
                                            (DWORD_T)
                                                (KNOSSOS_FF01_SEG | pptr)));
                                }

#                               endif

                                UDT_INSANE;
                            }
                        }
                    }
                }
            }
        }

#       endif 

#       ifdef KNOSSOS_CHECK_STACK

#       endif 

        

        for (i=0; i<KNOSSOS_MAX_PRIORITY_QUEUES; i++)
        {
            if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_frame[i]
                   != NULL)
            {
                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                    tx_not_completed_since_tick =
                        TRUE;
            }
        }
    }

    

#   if defined(UDT_NO_OFF_LEVEL_INTERRUPT_HANDLING)

    READ_KNOSSOS_BYTE(udids_ptr, KNOSSOS_ADAP_2_HOST_INT);

#   endif

    

#   if !defined(UDT_NO_OFF_LEVEL_INTERRUPT_HANDLING) && \
       !defined(UDT_CLIENT_INTERRUPT_CONTROL)

    WRITE_KNOSSOS_DWORD(
        udids_ptr,
        KNOSSOS_HOST_INT_MASK,
        KNOSSOS3_ALL_INTERRUPTS_MASK | KNOSSOS_R_CURRENT_FORCE_INT);

#   endif

    return;
}






STATIC RETCODE_T UDT_INDIRECT
knos3_tx(
    IN P_UDI_DATA_T udids_ptr,
    IN P_FRAME_T    frame)
{

#ifndef UDT_NO_SSI_PROTECT 

    return SSI_PROTECT(
               udids_ptr,
               knos3_protected_tx,
               (PCLIENT_VOID_T)&frame,
               NULL);
}



STATIC RETCODE_T UDT_LOCAL_PROTECTED
knos3_protected_tx(
    IN P_UDI_DATA_T      udids_ptr,
    IN PCLIENT_VOID_T    frame_ptr_ptr,
    IN PCLIENT_VOID_T    arg2)
{
    P_FRAME_T     frame = *(P_FRAME_T FAR_CLIENT *)frame_ptr_ptr;

#endif 

    UINT_T        frag_array_length;

#   if (KNOSSOS_MAX_PRIORITY_QUEUES!=1)

    BYTE_T        ac_byte;

#   endif

    BYTE_T        priority;
    FRAG_HANDLE_T tx_frag_handle;
    WORD_T        tx_buffer_ptr;

#   ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS
    BOOLEAN_T     two_buffers;
    WORD_T        first_tx_buffer_ptr;
#   endif

    UINT_T        fragment_length;
    UINT_T        fragment_index;
    UINT_T        buffer_fragment_index;

    POKE_TX(COLOUR_TX, "Tx");


    

    if(UDI_STATE(udids_ptr) != OPEN)
    {
        

        RETURN(udids_ptr, WRONG_STATE);
    }

    

#   ifdef UDT_NO_SSI_PROTECT

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected = TRUE;

#   endif


    

    if (

#       if defined(UDT_KNOSSOS3_OVER_8_TX_SLOTS) || \
           !defined(UDT_KNOSSOS3_30_TX_FRAGMENTS)

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool_entries <
            KNOSSOS3_MAX_BUFFERS_PER_TX

#       else

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_slots_in_use ==
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr),tx_slots)

#       endif
       )
    {
        

        POKE_TX(COLOUR_UNLIKELY, "OutOfResources");

        ADD_TO_COUNTER(udids_ptr, tx_no_resources, 1);

        

        return OUT_OF_ADAPTER_RAM;
    }


    

    frag_array_length = frame->frag_array_length;

#   ifdef UDT_SANITY_CHECK

    if (frag_array_length > KNOSSOS3_MAX_TX_FRAGMENTS)
    {
        POKE_TX(COLOUR_INSANE, "TooManyFragments");
        UDT_INSANE;
    }

#   endif


    

    fragment_index = 0;

#   if (KNOSSOS_MAX_PRIORITY_QUEUES!=1)

    fragment_length = SSI_FRAG_LENGTH(
                          udids_ptr,
                          frame->frag_array_ptr[0]);

    if (fragment_length == 0)
    {
        POKE_TX(PO_BLUE, "Skip0");

        fragment_index = 1;
    }

#   ifdef UDT_SANITY_CHECK

    if (fragment_length < 1)
    {
        POKE_TX(COLOUR_INSANE, "TwoEmpty");
        UDT_INSANE;
    }

#   endif 

#   endif 

    

#   if (KNOSSOS_MAX_PRIORITY_QUEUES==1)

    priority = 0;

#   else

    ac_byte =
        SSI_FRAG_READB(udids_ptr, frame->frag_array_ptr[fragment_index], 0);

    priority = ac_byte >> 5;

    TPOKEB_TX(TT_TX, "P", priority);

    if (priority > KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL)
    {
        if (priority == 7)
        {
#           ifdef UDT_SANITY_CHECK

            POKE_TX(COLOUR_INSANE, "BadPriority");
            UDT_INSANE; 

#           endif

            ac_byte &= 0x1F;
            ac_byte |= 6 << 5;

            SSI_FRAG_WRITEB(
                udids_ptr, frame->frag_array_ptr[fragment_index], 0, ac_byte);
        }

        priority = KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL;

        TPOKEB_TX(TT_TX, "->", priority);
    }

#   endif

    

    tx_frag_handle = GET_CONFIG_VALUE(
                         CONFIG_FROM_UDIDS(udids_ptr),
                         frag_handle[KNOSSOS_FF08_FRAGMENT_INDEX]);
    

    tx_buffer_ptr = 
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool;

#   ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS
    first_tx_buffer_ptr = tx_buffer_ptr;
#   endif

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool_entries--;

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool =
        BYTE_SWAP(
            SSI_FRAG_READW(
                udids_ptr,
                tx_frag_handle,
                tx_buffer_ptr +
                    UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.next)));

    

    TPOKEW_TX(TT_BRIGHT, "Buff", tx_buffer_ptr);

    buffer_fragment_index = 0;

#   ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS

    two_buffers = FALSE;

#   endif

    while (fragment_index < frag_array_length)
    {

        fragment_length = SSI_FRAG_LENGTH(
                              udids_ptr,
                              frame->frag_array_ptr[fragment_index]);

        if (fragment_length != 0)
        {
            

#           ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS

            if (buffer_fragment_index == KNOSSOS_MAX_TX_FRAGS_PER_BUFF)
            {
                

                two_buffers = TRUE;

                tx_buffer_ptr = 
                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                        free_tx_buffer_pool;

                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                    free_tx_buffer_pool_entries--;

                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool =
                    BYTE_SWAP(
                        SSI_FRAG_READW(
                            udids_ptr,
                            tx_frag_handle,
                            tx_buffer_ptr +
                                UDT_OFFSET(
                                    KNOSSOS_TX_BUFFER_T,
                                    normal.next)));
            }

#           endif

#           ifdef UDT_SANITY_CHECK

            if (buffer_fragment_index == KNOSSOS_MAX_TX_FRAGS_PER_BUFF)
            {
                POKE_TX(COLOUR_INSANE, "TooManyFrags");
                UDT_INSANE;
            }

#           endif

            POKE_TX(PO_BLUE, "o");

            SSI_FRAG_WRITEW(
                udids_ptr,
                tx_frag_handle,
                tx_buffer_ptr +
                    UDT_OFFSET(
                        KNOSSOS_TX_BUFFER_T,
                        gather.fragment[buffer_fragment_index].length),
                BYTE_SWAP(fragment_length));

            TPOKEW_TX(TT_DULL, "L=", fragment_length);

            SSI_FRAG_WRITED(
                udids_ptr,
                tx_frag_handle,
                tx_buffer_ptr +
                    UDT_OFFSET(
                        KNOSSOS_TX_BUFFER_T,
                        gather.fragment[buffer_fragment_index].phys_addr),
                SSI_FRAG_PHYS_ADDRESS(
                    udids_ptr,
                    frame->frag_array_ptr[fragment_index]));

            buffer_fragment_index++;
        }

        fragment_index++;
    }

    

#   ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS
    if (!two_buffers)
#   endif
    {
        

        SSI_FRAG_WRITEB(
            udids_ptr,
            tx_frag_handle,
            tx_buffer_ptr + UDT_OFFSET(KNOSSOS_TX_BUFFER_T,gather.num_frags),
            (BYTE_T) buffer_fragment_index);

        SSI_FRAG_WRITEW(
            udids_ptr,
            tx_frag_handle,
            tx_buffer_ptr + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, gather.status),
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).first_tx_buffer_status |
                (KNOSSOS_TX_STATUS_GATHER | KNOSSOS_TX_STATUS_LAST_BUFFER));
    }
#   ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS
    else
    {
        

        SSI_FRAG_WRITEB(
            udids_ptr,
            tx_frag_handle,
            first_tx_buffer_ptr +
                UDT_OFFSET(KNOSSOS_TX_BUFFER_T, gather.num_frags),
            KNOSSOS_MAX_TX_FRAGS_PER_BUFF);

        SSI_FRAG_WRITEW(
            udids_ptr,
            tx_frag_handle,
            first_tx_buffer_ptr +
                UDT_OFFSET(KNOSSOS_TX_BUFFER_T, gather.status),
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).first_tx_buffer_status |
                KNOSSOS_TX_STATUS_GATHER);

        SSI_FRAG_WRITEB(
            udids_ptr,
            tx_frag_handle,
            tx_buffer_ptr + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, gather.num_frags),
            (BYTE_T) buffer_fragment_index);

        SSI_FRAG_WRITEW(
            udids_ptr,
            tx_frag_handle,
            tx_buffer_ptr + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, gather.status),
            KNOSSOS_TX_STATUS_GATHER | KNOSSOS_TX_STATUS_LAST_BUFFER);

    }
#   endif 

    TPOKEW_TX(TT_BRIGHT, "Free",
                 KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool);


    

    if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_frame[priority] ==
            NULL)
    {
        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_frame[priority] =
            frame;
    }
    else
    {
        

        (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_frame[priority])
            ->next = frame;
    }

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_frame[priority] =
        frame;

    

#   ifdef UDT_KNOSSOS3_OVER_8_TX_SLOTS

    if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
            tx_adapter_frame_count[priority] == 7)
    {
        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
            tx_overflow_frame_count[priority]++;

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                next_tx_overflow_buffer_ptr == NULL)
        {
            

            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                next_tx_overflow_buffer_ptr[priority] =
#                   ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS
                    first_tx_buffer_ptr;
#                   else
                    tx_buffer_ptr;
#                   endif
        }
        else
        {
            

            (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                last_tx_overflow_buffer_ptr[priority])->next =
#                   ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS
                    first_tx_buffer_ptr;
#                   else
                    tx_buffer_ptr;
#                   endif
        }

        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
            last_overflow_buffer_ptr[priority] = tx_buffer_ptr;
    }
    else

#   endif 

    {
        

#       ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS

        KNOSSOS_SAFE_PIO_WRITE_DWORD(
            (DWORD_T) (KNOSSOS_FF01_SEG |
                          KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[priority]),
            (DWORD_T) 
                first_tx_buffer_ptr
            );

#       else

        KNOSSOS_SAFE_PIO_WRITE_DWORD(
            (DWORD_T) (KNOSSOS_FF01_SEG |
                          KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[priority]),
            (DWORD_T) 
                tx_buffer_ptr
            );

#       endif

        KNOSSOS_SAFE_PIO_WRITE_BYTE(
            (DWORD_T) (KNOSSOS_FF1F_SEG | KNOSSOS_TX_QUEUE_ACTIVITY_REG),
            (BYTE_T) (0x01 << priority));

        KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[priority] += 0x0004;

        if (!(KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[priority] & 0x001F))
        {
            KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[priority] -= 0x0020;
        }

        KNOSSOS_TX_ADAPTER_FRAME_COUNT[priority]++;
    }


    

#   ifdef UDT_NO_SSI_PROTECT

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected = FALSE;

    while(KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).ignored_possible_tx_complete)
    {
        POKE_TX(PO_BRIGHT_WHITE, "!!ReprocessTxDone!!");

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).ignored_possible_tx_complete =
            FALSE;

        knos3_check_tx_complete(udids_ptr);
    }

#   endif 

    return SUCCESS;
}



STATIC VOID_T UDT_INDIRECT
knos3_check_tx_complete(
    INOUT P_UDI_DATA_T udids_ptr)
{
    BYTE_T        completions;
    BYTE_T        priority;
    BYTE_T        two_to_the_power_priority;
    DWORD_T       status_and_buffer_ptr;
    WORD_T        first_buffer_ptr;
#   ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS
    WORD_T        last_buffer_ptr;
#   endif
#   ifdef UDT_SANITY_CHECK
    BOOLEAN_T     found_complete;
    BOOLEAN_T     this_entry_complete;
    WORD_T        pptr;
    UINT_T        i;
    UINT_T        blank_count;
#   endif 

    P_FRAME_T     frame;
    FRAG_HANDLE_T tx_frag_handle;

    

    tx_frag_handle = GET_CONFIG_VALUE(
                         CONFIG_FROM_UDIDS(udids_ptr),
                         frag_handle[KNOSSOS_FF08_FRAGMENT_INDEX]);

    

#   ifdef UDT_NO_SSI_PROTECT

    if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected)
    {
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).ignored_possible_tx_complete =
            TRUE;

        return;
    }
    else
    {
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected = TRUE;
    }

#   endif 


    

    if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).check_all_tx_queues)
    {
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).check_all_tx_queues = FALSE;
        completions = 0x7F;

        

        KNOSSOS_SAFE_PIO_WRITE_BYTE(
            (DWORD_T) (KNOSSOS_FF1F_SEG | KNOSSOS_TX_COMPLETIONS_REG),
            0x80);
    }
    else
    {
        

#       if (KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL != 0)

        completions =
            KNOSSOS_SAFE_PIO_READ_BYTE(
                (DWORD_T)
                    (KNOSSOS_FF1F_SEG | KNOSSOS_TX_COMPLETIONS_REG)) & 0x7F;

        

        WRITE_KNOSSOS_BYTE(
             udids_ptr,
             KNOSSOS_HOST_PIO_DATA,
             (BYTE_T) ~completions);

#       else

        completions = 0x01;

        KNOSSOS_SAFE_PIO_WRITE_BYTE(
            (DWORD_T) (KNOSSOS_FF1F_SEG | KNOSSOS_TX_COMPLETIONS_REG),
            0xFE);

#       endif

    }


    

    priority = KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL;
    two_to_the_power_priority = 1 << KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL;

    

#   if (KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL > 0)

    if (completions < 0x02)
    {
        
        
        priority = 0;
        two_to_the_power_priority = 1;
    }

#   if (KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL > 3)

    else
    {
        

        if (completions < 0x10)
        {
            priority = 3;
            two_to_the_power_priority = 1<<3;
        }
    }

#   endif
#   endif

    

#   if (KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL != 0)

    for (; two_to_the_power_priority != 0; priority--)

#   endif

    {
        if (completions & two_to_the_power_priority)
        {
            


            

#           ifdef UDT_SANITY_CHECK

            if (KNOSSOS_TX_ADAPTER_FRAME_COUNT[priority]>=2)
            {
                found_complete = FALSE;
                blank_count = 0;

                pptr = KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[
                                           priority];

                for(i=0; i<KNOSSOS_TX_ADAPTER_FRAME_COUNT[priority]; i++)
                {
                    pptr -= 4;

                    if ((pptr & 0x1F)==0x1C)
                    {
                       pptr += 0x20;
                    }

                    this_entry_complete =
                        (
                            KNOSSOS_SAFE_PIO_READ_DWORD(
                                (DWORD_T) (KNOSSOS_FF01_SEG | pptr))
                            & 0x80000000uL
                        ) != 0;

                    if (!this_entry_complete && blank_count!=0)
                    
                    {
                        

                        WRITE_KNOSSOS_WORD(
                            udids_ptr, KNOSSOS_ADAPTER_CTRL, 0x47C2);

                        POKEW_TX(
                            COLOUR_INSANE,
                            "OutOfOrderTxComplete",
                            KNOSSOS_TX_ADAPTER_FRAME_COUNT[priority]-i);

                        TPOKEW_TX(
                            TT_BRIGHT,
                            "Outstanding=",
                            KNOSSOS_TX_ADAPTER_FRAME_COUNT[priority]);

                        TPOKEW_TX(
                            TT_BRIGHT,
                            "First=",
                            KNOSSOS_TX_ADAPTER_NEXT_PENDING_POINTER[
                                priority]);

                        for (i=0; i<8; i++)
                        {
                            pptr = 0x1E00+0x20*priority+i*4;

                            POKEW_TX(
                                PO_BRIGHT_BLUE,
                                " ",
                                pptr);

                            POKED_TX(
                                PO_BRIGHT_GREEN,
                                "",
                                KNOSSOS_SAFE_PIO_READ_DWORD(
                                    (DWORD_T) (KNOSSOS_FF01_SEG | pptr)));
                        }

                        UDT_INSANE;
                    }

                    if (this_entry_complete)
                    {
                        found_complete = TRUE;
                    }
                    else
                    {
                        if (found_complete)
                        {
                            blank_count++;
                        }
                    }
                }
            }

#           endif 

            while (
                      (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                          last_tx_frame[priority] !=
                              NULL)
                      &&
                      ((status_and_buffer_ptr =
                          KNOSSOS_SAFE_PIO_READ_DWORD(
                              (DWORD_T) (KNOSSOS_FF01_SEG |
                                   KNOSSOS_TX_ADAPTER_NEXT_PENDING_POINTER[
                                       priority]))
                      ) & 0x80000000uL)
                  )
            {
                

                TPOKEB_TX(TT_TX, "P", priority);

                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                    tx_not_completed_since_tick =
                        FALSE;

                

#               ifdef UDT_SANITY_CHECK

                if ((status_and_buffer_ptr & 0xFF000000uL)!=0x89000000uL &&
                    (status_and_buffer_ptr & 0xFF000000uL)!=0x87000000uL)
                {
                    POKED_TX(
                        COLOUR_INSANE, "BadTxStatus", status_and_buffer_ptr);

                }

#               endif 

                

                if (KNOSSOS_ABORTING_TX)
                {
                    

                    if (KNOSSOS_TX_UNUSED_POINTER_CHANGED[priority] == FALSE
                        &&
                        (status_and_buffer_ptr & 0xFFFF0000uL)==0x87000000uL)
                    {
                        KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[priority] =
                            KNOSSOS_TX_ADAPTER_NEXT_PENDING_POINTER[priority];

                        KNOSSOS_TX_UNUSED_POINTER_CHANGED[priority] = TRUE;
                    }
                }

                

                KNOSSOS_TX_ADAPTER_NEXT_PENDING_POINTER[priority] += 0x0004;

                if (!(KNOSSOS_TX_ADAPTER_NEXT_PENDING_POINTER[priority] &
                          0x001F))
                {
                    KNOSSOS_TX_ADAPTER_NEXT_PENDING_POINTER[priority] -=
                        0x0020;
                }

                KNOSSOS_TX_ADAPTER_FRAME_COUNT[priority]--;


                

                

                first_buffer_ptr = (WORD_T) status_and_buffer_ptr;

#               ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS

                last_buffer_ptr =
                    (
                        SSI_FRAG_READW(
                            udids_ptr,
                            tx_frag_handle,
                            first_buffer_ptr +
                                UDT_OFFSET(KNOSSOS_TX_BUFFER_T, gather.status)
                            )
                        &
                        KNOSSOS_TX_STATUS_LAST_BUFFER
                    )
                    ?
                        first_buffer_ptr
                    :
                        

                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                            free_tx_buffer_pool_entries ++,

                        BYTE_SWAP(
                            SSI_FRAG_READW(
                                udids_ptr,
                                tx_frag_handle,
                                first_buffer_ptr +
                                    UDT_OFFSET(
                                        KNOSSOS_TX_BUFFER_T, normal.next))
                                 );

#               endif 

                

#               ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS

                SSI_FRAG_WRITEW(
                    udids_ptr,
                    tx_frag_handle,
                    last_buffer_ptr
                        + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.next),
                    BYTE_SWAP(
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                            free_tx_buffer_pool));
#               else

                SSI_FRAG_WRITEW(
                    udids_ptr,
                    tx_frag_handle,
                    first_buffer_ptr
                        + UDT_OFFSET(KNOSSOS_TX_BUFFER_T, normal.next),
                    BYTE_SWAP(
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                            free_tx_buffer_pool));

#               endif

                

                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool =
                    first_buffer_ptr;

                

                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                    free_tx_buffer_pool_entries ++;

                TPOKEB_TX(TT_TX, "Free=",
                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                        free_tx_buffer_pool_entries);


                

                

#               ifdef UDT_SANITY_CHECK
                if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                       last_tx_frame[priority] ==
                           NULL)
                {
                    POKE_TX(COLOUR_INSANE, "NoFrame");
                    UDT_INSANE;
                }
#               endif

                frame = KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                            next_tx_frame[priority];

                if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                       last_tx_frame[priority] ==
                           frame)
                {
                    

                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                        last_tx_frame[priority] =
                            NULL;
                }
                else
                {
                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                        next_tx_frame[priority] =
                        frame->next;
                }


                

                ADD_TO_COUNTER(udids_ptr, tx_bytes, frame->frame_length);
                ADD_TO_COUNTER(udids_ptr, tx_frames, 1);


                

#               ifdef UDT_KNOSSOS3_OVER_8_TX_SLOTS

                if (KNOSSOS_NEXT_TX_OVERFLOW_BUFFER_PTR[priority] != NULL)
                {
                    

                    first_buffer_ptr =
                        KNOSSOS_NEXT_TX_OVERFLOW_BUFFER_PTR[priority];

#                   ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS

                    last_buffer_ptr =
                        (
                            SSI_FRAG_READW(
                                udids_ptr,
                                tx_frag_handle,
                                first_buffer_ptr +
                                    UDT_OFFSET(
                                       KNOSSOS_TX_BUFFER_T, gather.status)
                                )
                            &
                            KNOSSOS_TX_STATUS_LAST_BUFFER
                        )
                        ?
                            first_buffer_ptr
                        :
                            

                            BYTE_SWAP(
                                SSI_FRAG_READW(
                                    udids_ptr,
                                    tx_frag_handle,
                                    first_buffer_ptr +
                                        UDT_OFFSET(KNOSSOS_TX_BUFFER_T,
                                               normal.next))
                                     );

#                   endif 

                    

                    if (
#                          ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS
                           last_buffer_ptr
#                          else
                           first_buffer_ptr
#                          endif
                               ==
                               KNOSSOS_LAST_TX_OVERFLOW_BUFFER_PTR[priority]
                       )
                    {
                        

                        KNOSSOS_NEXT_TX_OVERFLOW_BUFFER_PTR[priority] = NULL;
                    }
                    else
                    {
                        KNOSSOS_NEXT_TX_OVERFLOW_BUFFER_PTR[priority] =
                            BYTE_SWAP(
                                SSI_FRAG_READW(
                                    udids_ptr,
                                    tx_frag_handle,
#                                   ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS
                                    last_buffer_ptr
#                                   else
                                    first_buffer_ptr
#                                   endif
                                        + UDT_OFFSET(KNOSSOS_TX_BUFFER_T,
                                                 normal.next))
                                    );
                    }

                    

                    KNOSSOS_SAFE_PIO_WRITE_DWORD(
                        (DWORD_T)
                           (KNOSSOS_FF01_SEG |
                            KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[priority]),
                        (DWORD_T) first_buffer_ptr
                        );

                    KNOSSOS_SAFE_PIO_WRITE_BYTE(
                        (DWORD_T) (KNOSSOS_FF1F_SEG |
                                   KNOSSOS_TX_QUEUE_ACTIVITY_REG),
                        (BYTE_T) (0x01 << priority));

                    KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[priority] +=
                        0x0004;

                    if (!(KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[priority] &
                          0x001F))
                    {
                        KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[priority] -=
                            0x0020;
                    }

                    KNOSSOS_TX_ADAPTER_FRAME_COUNT[priority]++;
                }

#               endif 


                

                

                UPCALL_XFER_COMPLETE(udids_ptr, frame, 1);

                

                UPCALL_TX_COMPLETE(
                    udids_ptr,
                    0,
                    TRUE,
                    1);
            }

            

#           if (KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL != 0)

            if (!(completions ^= two_to_the_power_priority))
            {
                break;
            }

#           endif
        }

#       if (KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL != 0)

        two_to_the_power_priority >>= 1;

#       endif

    }


    

#   ifdef UDT_NO_SSI_PROTECT

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).tx_data_protected = FALSE;

#   endif 

}




STATIC VOID_T
knos3_process_received_data(
    INOUT P_UDI_DATA_T udids_ptr)
{
    WORD_T        rx_status;
    P_FRAME_T     rx_frame;
    FRAG_HANDLE_T rx_frag_handle;
    WORD_T        rx_frame_length;
#   ifdef ONE_POOL_RX_POSSIBLE
    WORD_T        mac_frame_length;
#   endif 

    POKE_ISR(COLOUR_TX, "Rx?");

    rx_frag_handle = GET_CONFIG_VALUE(
                         CONFIG_FROM_UDIDS(udids_ptr),
                         frag_handle[KNOSSOS_FF0C_FRAGMENT_INDEX]);

    while (READ_KNOSSOS_BYTE(udids_ptr, KNOSSOS_ADAP_2_HOST_EXT_INT)
               & KNOSSOS3_INT_EXT_RX)
    {
        

#       ifdef UDT_LIMIT_RX_LOOPS

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).remaining_reception_quota
               == 0)
        {
            break;
        }

#       endif 

        
    
        TPOKEW_ISR(
            TT_INFO,
            "Buff=",
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_rx_buffer_ptr);

        rx_status =
            SSI_FRAG_READW
                (
                    udids_ptr,
                    rx_frag_handle,
                    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                        next_rx_buffer_ptr
                            + UDT_OFFSET(KNOSSOS_RX_BUFFER_T, scatter.status)
                );

        TPOKEW_ISR(TT_INFO, "Stat=", BYTE_SWAP(rx_status));


        

        rx_frame_length =
            (
                BYTE_SWAP(
                    SSI_FRAG_READW
                        (
                            udids_ptr,
                            rx_frag_handle,
                            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                                next_rx_buffer_ptr
                                + UDT_OFFSET(
                                      KNOSSOS_RX_BUFFER_T, scatter.length)
                        )
                    )
                & 0x7FFF
            )
            - 4;

        TPOKEW_ISR(TT_INFO, "Len=", rx_frame_length);


        

#       ifdef UDT_SANITY_CHECK

        if ((rx_status & KNOSSOS_RX_STATUS_BUSY)==0)
        {
            WRITE_KNOSSOS_WORD(
                udids_ptr,
                KNOSSOS_ADAPTER_CTRL,
                0x0000);

            POKE_ISR(COLOUR_INSANE, "RxFrameNotThere");

            UDT_INSANE;

            rx_status = 0xFFFF;   
        }

#       endif

#       ifdef UDT_SANITY_CHECK

        rx_frame_length += 4;

        if (rx_frame_length < 18)
        {
            POKE_ISR(COLOUR_INSANE, "TinyFrame");
        }

        rx_frame_length -= 4;

#       endif


        

        WRITE_KNOSSOS_BYTE(
            udids_ptr,
            KNOSSOS_ADAP_2_HOST_EXT_INT,
            0xFE);


        

        rx_frame = KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).rx_frame_list;

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).rx_frame_list =
            rx_frame->next;

#       if 0
#       ifdef UDT_POKEOUTS_ON
        {
            

            UINT_T i;

            for (i=0; i<rx_frame_length; i++)
            {
                POKEB_ISR(
                    PO_GREEN,
                    " ",
                    SSI_FRAG_READB
                        (
                            udids_ptr,
                            rx_frame->frag_array_ptr[0],
                            i
                        ));
            }
        }
#       endif
#       endif

        rx_frame->frame_length = rx_frame_length;


        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_rx_buffer_ptr =
            BYTE_SWAP(
                SSI_FRAG_READW
                    (
                        udids_ptr,
                        rx_frag_handle,
                        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). 
                            next_rx_buffer_ptr
                            + UDT_OFFSET(KNOSSOS_RX_BUFFER_T, scatter.next)
                    ))
            & 0xFFF8;

        

#       ifdef UDT_SANITY_CHECK

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count == 0)
        {
            POKE_ISR(COLOUR_INSANE, "TooManyRx");
            UDT_INSANE;
        }

#       endif

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count--;


        

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).discarding_frame ||
                (rx_status & KNOSSOS_RX_STATUS_LAST_BUFFER) == 0)
        {
#           ifdef UDT_SANITY_CHECK

            POKE_ISR(COLOUR_INSANE, "MultiBufferRx");

#           endif

            

            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).discarding_frame =
                ((rx_status & KNOSSOS_RX_STATUS_LAST_BUFFER) == 0);

            

            rx_frame->next = NULL;

#           ifdef UDT_NO_LOCAL_FAR_CALLS
            UDTI_PROVIDE_RX_DESCRIPTORS(udids_ptr, rx_frame);
#           else
            knos3_provide_rx_descriptors(udids_ptr, rx_frame);
#           endif

            return;
        }


        

        if (rx_status & (
                KNOSSOS_RX_STATUS_SP_COMPLETION |
                KNOSSOS_RX_STATUS_BM_COMPLETION |
                KNOSSOS_RX_STATUS_RX_EDI |
                KNOSSOS_RX_STATUS_LOCAL_EDI))
        {
            

            POKE_ISR(PO_WHITE, "RxFailed");

#           ifdef UDT_MAINTAIN_COUNTERS

#           ifdef UDT_EXTENDED_COUNTERS

            if (rx_status & KNOSSOS_RX_STATUS_LOCAL_EDI)
            {
                ADD_TO_COUNTER(udids_ptr, rx_aborts, 1);
            }
            else
            {
                ADD_TO_COUNTER(udids_ptr, rx_overruns, 1);
            }

#           else

            ADD_TO_COUNTER(udids_ptr, rx_aborts, 1);

#           endif

#           endif 

#           ifdef UDT_SANITY_CHECK

            if ((rx_status & KNOSSOS_RX_STATUS_SP_COMPLETION)!=
                    KNOSSOS_RX_STATUS_ABORTED)
            {
                POKE_ISR(COLOUR_INSANE, "NotRxAbort");
            }

#           endif 

            rx_frame->next = NULL;

#           ifdef UDT_NO_LOCAL_FAR_CALLS
            UDTI_PROVIDE_RX_DESCRIPTORS(udids_ptr, rx_frame);
#           else
            knos3_provide_rx_descriptors(udids_ptr, rx_frame);
#           endif
        } 
        else
        {
            

            POKE_ISR(PO_WHITE, "RxOk");


            

            if(UDI_STATE(udids_ptr) != OPEN)
            {
                rx_frame->next = NULL;

#               ifdef UDT_NO_LOCAL_FAR_CALLS
                UDTI_PROVIDE_RX_DESCRIPTORS(udids_ptr, rx_frame);
#               else
                knos3_provide_rx_descriptors(udids_ptr, rx_frame);
#               endif
            }
            else
            {
                rx_frame->rx_status = FRAME_COMPLETE;

                ADD_TO_COUNTER(udids_ptr, rx_frames, 1);
                ADD_TO_COUNTER(udids_ptr, rx_bytes, rx_frame_length);

                

                UPCALL_RX(udids_ptr, rx_frame);

                

#               ifdef UDT_LIMIT_RX_LOOPS

                KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                    remaining_reception_quota--;

#               endif 

            }
        }

    }

    return;
}



STATIC RETCODE_T UDT_INDIRECT
knos3_udti_complete_rx(
    IN P_UDI_DATA_T udids_ptr,
    IN P_FRAME_T    rx_list)
{
    

#   ifdef UDT_NO_LOCAL_FAR_CALLS
    UDTI_PROVIDE_RX_DESCRIPTORS(udids_ptr, rx_list);
#   else
    knos3_provide_rx_descriptors(udids_ptr, rx_list);
#   endif

    return SUCCESS;
}



P_FRAME_T UDT_INDIRECT
knos3_provide_rx_descriptors(
    IN    P_UDI_DATA_T udids_ptr,
    INOUT P_FRAME_T    rx_list)
{
    WORD_T        base;
    FRAG_HANDLE_T rx_frag_handle;

#   if (UDT_KNOSSOS3_MAX_RX_FRAGMENTS > 1)

    UINT_T        i;

#   endif

    

    rx_frag_handle = GET_CONFIG_VALUE(
                         CONFIG_FROM_UDIDS(udids_ptr),
                         frag_handle[KNOSSOS_FF0C_FRAGMENT_INDEX]);

    

    if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).rx_frame_list == NULL)
    {
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).rx_frame_list = rx_list;
    }
    else
    {
        ((KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_rx_frame_list_entry)->
            next) = rx_list;
    }


    

    while (rx_list)
    {
        POKEW_ISR(COLOUR_PROV_RX, "ProvRx:",
            SSI_FRAG_LENGTH(udids_ptr, rx_list->frag_array_ptr[0]));

        POKED_ISR(COLOUR_PROV_RX, ",addr=",
            SSI_FRAG_PHYS_ADDRESS(udids_ptr, rx_list->frag_array_ptr[0]));

        

#       ifdef UDT_SANITY_CHECK

        if (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count ==
               GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr),rx_slots))
        {
            POKE_ISR(COLOUR_INSANE, "TooManyRxFrames");
            UDT_INSANE;
        }

#       if (UDT_KNOSSOS3_MAX_RX_FRAGMENTS > 1)

        for (i=0; i<rx_list->frag_array_length; i++)
        {
            if (SSI_FRAG_PHYS_ADDRESS(udids_ptr, rx_list->frag_array_ptr[i])
                    & 1)
            {
                POKE_ISR(COLOUR_INSANE, "RxNotWordAligned");
                UDT_INSANE;
            }

            if (SSI_FRAG_LENGTH(udids_ptr, rx_list->frag_array_ptr[0])
                    > 18050)
            {
                POKE_ISR(COLOUR_INSANE, "BigRxLen");
                UDT_INSANE;
            }
        }

#       endif

        

        if (rx_list->frag_array_length > UDT_KNOSSOS3_MAX_RX_FRAGMENTS)
        {
            POKE_ISR(COLOUR_INSANE, "TooManyFrags");
            UDT_INSANE;
        }

        if (rx_list->frag_array_length == 0)
        {
            POKE_ISR(COLOUR_INSANE, "NoFrags");
            UDT_INSANE;
        }

#       endif 


        

        base = KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                   next_uninitialised_rx_buffer_ptr;

#       if (UDT_KNOSSOS3_MAX_RX_FRAGMENTS == 1)

        

        SSI_FRAG_WRITEW(
            udids_ptr,
            rx_frag_handle,
            base + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,scatter.length),
            BYTE_SWAP(
                0x8000 +
                SSI_FRAG_LENGTH(udids_ptr, rx_list->frag_array_ptr[0])));

        SSI_FRAG_WRITED(
            udids_ptr,
            rx_frag_handle,
            base + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,scatter.frag_addr),
            SSI_FRAG_PHYS_ADDRESS(udids_ptr, rx_list->frag_array_ptr[0]));

        SSI_FRAG_WRITEW(
            udids_ptr,
            rx_frag_handle,
            base + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,scatter.status),
            0);

#       else 

        

        for (i=0; i<rx_list->frag_array_length; i++)
        {
            SSI_FRAG_WRITEW(
                udids_ptr,
                rx_frag_handle,
                base + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,scatter.length) + i*8,
                BYTE_SWAP(
                    (i<rx_list->frag_array_length) ?
                        0x8000 +
                            SSI_FRAG_LENGTH(udids_ptr,
                                rx_list->frag_array_ptr[i])
                        :
                        SSI_FRAG_LENGTH(udids_ptr,
                                rx_list->frag_array_ptr[i])
                         )
                );

            SSI_FRAG_WRITED(
                udids_ptr,
                rx_frag_handle,
                base +
                    UDT_OFFSET(KNOSSOS_RX_BUFFER_T,scatter.frag_addr) + i*8,
                SSI_FRAG_PHYS_ADDRESS(udids_ptr, rx_list->frag_array_ptr[i]));
        }

        SSI_FRAG_WRITEW(
            udids_ptr,
            rx_frag_handle,
            base + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,scatter.status),
            KNOSSOS3_RX_STATUS_MULTIFRAGMENT);

#       endif 

        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
            next_uninitialised_rx_buffer_ptr =
                BYTE_SWAP(
                    SSI_FRAG_READW(
                         udids_ptr,
                         rx_frag_handle,
                         base + UDT_OFFSET(KNOSSOS_TX_BUFFER_T,normal.next))
                         )
                & 0xFFF8;

        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_rx_frame_list_entry =
            rx_list;

        rx_list = rx_list->next;

        

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count++;

        

#       ifdef KNOSSOS3_USE_COUNTER_4_FOR_RX

        WRITE_KNOSSOS_WORD(udids_ptr, KNOSSOS_COUNTER_4_RX_AVAILABLE, 1);

#       ifdef KNOSSOS_INT_FOR_RX_AVAILABLE
#       ifndef USE_OLD_K2_IMAGE

        

        WRITE_KNOSSOS_BYTE(
            udids_ptr,
            KNOSSOS_HOST_2_ADAP_INT,
            KNOSSOS_INT_RX_BUFFER_AVAILABLE);

#       endif
#       endif

#       else

        KNOSSOS_SAFE_PIO_WRITE_DWORD(
            (DWORD_T) (KNOSSOS_FF1F_SEG | KNOSSOS_RX_NORMAL_BUF_COUNT), 1);

#       endif

    }

    return NULL;
}



BUILD_MODULE_END_FUNCTION(knos3r_end)



#endif 

#endif 



