/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/*****************************************************************************
*
* **   ** **   **  *****   *****   *****   *****   *****     **   **
* **  **  ***  ** **   ** **   ** **   ** **   ** **   **    **   **
* ** **   **** ** **   ** **      **      **   ** **         **   **
* ****    ** **** **   **  *****   *****  **   **  *****     *******
* ** **   **  *** **   **      **      ** **   **      **    **   **
* **  **  **   ** **   ** **   ** **   ** **   ** **   **    **   **
* **   ** **   **  *****   *****   *****   *****   *****  ** **   **
*
******************************************************************************
*
* Declaration of the structures required to use Knossos-based PCI and CardBus
* adapters in general.
*
******************************************************************************
*
* Copyright (C) 1996-1999 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
******************************************************************************
*/

#define KNOSSOS3_USE_COUNTER_4_FOR_RX
#define KNOSSOS_INT_FOR_RX_AVAILABLE


#define KNOSSOS_CHECK_STACK




#define KNOSSOS_IO_SPACE_SIZE                  0x80



#define KNOSSOS_ADAPTER_CTRL_W                 0x00
#define     ADAPTER_CTRL_WORD_PROC_RESET       0x0001
#define     ADAPTER_CTRL_WORD_CHIP_CORE_RESET  0x0002


#define KNOSSOS_SEEPROM_CTRL_B                 0x02

#define     SEEPROM_DI                         0x01
#define     SEEPROM_DO                         0x02
#define     SEEPROM_SK                         0x04
#define     SEEPROM_CS                         0x08


#define     SEEPROM_OFF_SUBS_ADAP_ID              0
#define     SEEPROM_OFF_SUBS_VEND_ID              1
#define     SEEPROM_OFF_AD_REV_ETC                2
#define     SEEPROM_OFF_MAX_LATENCY_MIN_GRANT     3
#define     SEEPROM_OFF_LAST_SPEED                4
#define     SEEPROM_OFF_FORCE_SPEED               5
#define     SEEPROM_OFF_BIA_START                 6
#define     SEEPROM_OFF_DESIGN_REVISION           9


#define     SEEPROM_OFF_HF1                      10
#define       HF1_PROMISCUOUS_MODE_ENABLED   0x0004
#define       HF1_LAA_PRESENT                0x0008
#define       HF1_LSS_601_SAFE_PRESTO2       0x0080
#define       HF1_LSS_601_SAFE_CARDBUS2      0x0100
#define       HF1_LSS_REQUIRED               0x1C00
#define       HF1_100MBPS_ONLY               0x8000

#define     SEEPROM_OFF_YEAR                     11
#define     SEEPROM_OFF_MONTH                    12
#define     SEEPROM_OFF_DAY                      13
#define     SEEPROM_OFF_HOUR                     14
#define     SEEPROM_OFF_MINUTE                   15

#define     SEEPROM_OFF_EBIA_LOW                 16
#define     SEEPROM_OFF_EBIA_HIGH                17

#define     SEEPROM_OFF_PBIA_LOW                 18
#define     SEEPROM_OFF_PBIA_HIGH                19

#define     SEEPROM_OFF_LAA                      20

#define     SEEPROM_SIZE                         64


#define KNOSSOS_RXBM_STATUS_B                  0x03


#define KNOSSOS_ADAP_2_HOST_INT_B              0x04
#define KNOSSOS_ADAP_2_HOST_INT_D              0x04

#define KNOSSOS_ADAP_2_HOST_EXT_INT_B          0x06


#define     KNOSSOS12_INT_RX                   0x01
#define     KNOSSOS12_INT_RX_HOST_MAC          0x02
#define     KNOSSOS12_INT_TX_COMP              0x04

#define     KNOSSOS_ADAP2HOST_EVENTS           0x08
#define     KNOSSOS_INT_RING_STATUS_AVAILABLE  0x10
#define     KNOSSOS_INT_COMMAND_PROCESSED      0x20
#define     KNOSSOS_INT_WATCHDOG               0x40
#define     KNOSSOS_ADAP2HOST_DEBUG            0x80

#define     KNOSSOS3_INT_RX                    0x00010000
#define     KNOSSOS3_INT_RX_EARLY              0x00020000
#define     KNOSSOS3_INT_TX_COMP               0x00040000

#define     KNOSSOS3_INT_EXT_RX                0x01
#define     KNOSSOS3_INT_EXT_RX_EARLY          0x02
#define     KNOSSOS3_INT_EXT_TX_COMP           0x04


#define     KNOSSOS_ADAP_2_HOST_MASK           0xFF

#define KNOSSOS_HOST_2_ADAP_INT_B              0x05


#define     KNOSSOS_HOST2ADAP_EVENTS           0x01
#define     KNOSSOS_INT_UNGET_RX_BUFFER        0x08
#define     KNOSSOS_INT_RECEIVE_MAC            0x10
#define     KNOSSOS_INT_TX_READY               0x20
#define     KNOSSOS_INT_RX_BUFFER_AVAILABLE    0x40
#define     KNOSSOS_COMMAND_TO_PROCESS         0x80

#define KNOSSOS_HOST_INT_MASK_B                0x08
#define KNOSSOS_HOST_INT_MASK_W                0x08
#define KNOSSOS_HOST_INT_MASK_D                0x08


#ifndef UDT_KNOSSOS_NO_WATCHDOG_INTERRUPTS

#define KNOSSOS3_HOST_INT_MASK_USEFUL_BITS     0x00050078
#define KNOSSOS12_ALL_INTERRUPTS_MASK          0x000000FF
#define KNOSSOS3_ALL_INTERRUPTS_MASK           0x000500FF

#else

#define KNOSSOS3_HOST_INT_MASK_USEFUL_BITS     (0x00050078 & \
                                                ~KNOSSOS_INT_WATCHDOG)
#define KNOSSOS12_ALL_INTERRUPTS_MASK          (0x000000FF & \
                                                ~KNOSSOS_INT_WATCHDOG)
#define KNOSSOS3_ALL_INTERRUPTS_MASK           (0x000500FF & \
                                                ~KNOSSOS_INT_WATCHDOG)
#endif


#define KNOSSOS_FORCE_INT_B                    0x09
#define     KNOSSOS_FORCE_HOST_INT             0x02


#define KNOSSOS_INT_STATUS_FORCED_INTERRUPT    0x0100


#define KNOSSOS_COUNTER_1_TX_FILLED_W          0x0C


#define KNOSSOS_COUNTER_2_TX_COMPLETE_W        0x0E


#define KNOSSOS_HOST_PIO_ADDR_D                0x10

#define KNOSSOS_HOST_PIO_DATA_B                0x14
#define KNOSSOS_HOST_PIO_DATA_W                0x14
#define KNOSSOS_HOST_PIO_DATA_D                0x14

#define KNOSSOS_HOST_PIO_DATA_INCR_B           0x18
#define KNOSSOS_HOST_PIO_DATA_INCR_W           0x18
#define KNOSSOS_HOST_PIO_DATA_INCR_D           0x18


#define KNOSSOS_HOST_TX_POOL_BASE_D            0x1C
#define     KNOSSOS_HOST_TX_POOL_SIZE_8K       0x00000001uL
#define     KNOSSOS_HOST_TX_POOL_SIZE_16K      0x00000002uL
#define     KNOSSOS_HOST_TX_POOL_SIZE_32K      0x00000003uL
#define     KNOSSOS_HOST_TX_POOL_SIZE_64K      0x00000004uL
#define     KNOSSOS_HOST_TX_POOL_SIZE_128K     0x00000005uL
#define     KNOSSOS_HOST_TX_POOL_SIZE_196K     0x00000006uL
#define     KNOSSOS_HOST_TX_POOL_SIZE_256K     0x00000007uL
#define     KNOSSOS_HOST_TX_POOL_READ_ONLY     0x00000008uL


#define KNOSSOS_HOST_RX_POOL_BASE_D            0x20
#define     KNOSSOS_HOST_RX_POOL_SIZE_8K       0x00000001uL
#define     KNOSSOS_HOST_RX_POOL_SIZE_16K      0x00000002uL
#define     KNOSSOS_HOST_RX_POOL_SIZE_32K      0x00000003uL
#define     KNOSSOS_HOST_RX_POOL_SIZE_64K      0x00000004uL
#define     KNOSSOS_HOST_RX_POOL_SIZE_128K     0x00000005uL
#define     KNOSSOS_HOST_RX_POOL_SIZE_196K     0x00000006uL
#define     KNOSSOS_HOST_RX_POOL_SIZE_256K     0x00000007uL
#define     KNOSSOS_HOST_RX_POOL_READ_ONLY     0x00000008uL


#define KNOSSOS_COUNTER_3_RX_ARRIVING_W        0x24


#define PRESTO_WATCHDOG_TIMER_W                0x26
#define     PRESTO_WATCHDOG_TIMER_W_MSK        0x03FF


#define KNOSSOS_COUNTER_4_RX_AVAILABLE_W       0x26


#define KNOSSOS_HOST_MEM_MAP0_D                0x40
#define     KNOSSOS_HOST_MEM_MAP_SIZE_2K       0x00000001uL
#define     KNOSSOS_HOST_MEM_MAP_SIZE_4K       0x00000002uL
#define     KNOSSOS_HOST_MEM_MAP_SIZE_8K       0x00000003uL
#define     KNOSSOS_HOST_MEM_MAP_SIZE_16K      0x00000004uL
#define     KNOSSOS_HOST_MEM_MAP_SIZE_32K      0x00000005uL
#define     KNOSSOS_HOST_MEM_MAP_SIZE_48K      0x00000006uL
#define     KNOSSOS_HOST_MEM_MAP_SIZE_64K      0x00000007uL
#define     KNOSSOS_HOST_MEM_MAP_READ_ONLY     0x00000008uL

#define KNOSSOS_HOST_MEM_MAP1_D                0x44

#define KNOSSOS_HOST_MEM_MAP2_D                0x48

#define KNOSSOS_HOST_MEM_MAP3_D                0x4C

#define KNOSSOS_HOST_MEM_MAP4_D                0x50
#define     KNOSSOS_HOST_MEM_MAP4_SIZE_1K      0x00000001uL
#define     KNOSSOS_HOST_MEM_MAP4_SIZE_2K      0x00000002uL
#define     KNOSSOS_HOST_MEM_MAP4_SIZE_4K      0x00000003uL
#define     KNOSSOS_HOST_MEM_MAP4_SIZE_8K      0x00000004uL
#define     KNOSSOS_HOST_MEM_MAP4_SIZE_16K     0x00000005uL
#define     KNOSSOS_HOST_MEM_MAP4_SIZE_32K     0x00000006uL
#define     KNOSSOS_HOST_MEM_MAP4_SIZE_60K     0x00000007uL
#define     KNOSSOS_HOST_MEM_MAP4_READ_ONLY    0x00000008uL


#define KNOSSOS_FUNCTION_EVENT_REGISTER         0x60
#define KNOSSOS_FUNCTION_MASK_REGISTER          0x64
#define KNOSSOS_FUNCTION_PRESENT_STATE_REGISTER 0x68
#define KNOSSOS_FUNCTION_FORCE_EVENT_REGISTER   0x6C



#define READ_KNOSSOS_BYTE(_p, _r)                                           \
   (INB( (_p), 0, (UINT_T)(_r##_B)))

#define READ_KNOSSOS_WORD(_p, _r)                                           \
   (INW( (_p), 0, (UINT_T)(_r##_W)))

#define READ_KNOSSOS_DWORD(_p, _r)                                          \
   (IND( (_p), 0, (UINT_T)(_r##_D)))

#define WRITE_KNOSSOS_BYTE(_p, _r, _d)                                      \
   (OUTB( (_p), 0, (UINT_T)(_r##_B), (BYTE_T)(_d)))

#define WRITE_KNOSSOS_WORD(_p, _r, _d)                                      \
   (OUTW( (_p), 0, (UINT_T)(_r##_W), (WORD_T)(_d)))

#define WRITE_KNOSSOS_DWORD(_p, _r, _d)                                     \
   (OUTD( (_p), 0, (UINT_T)(_r##_D), (DWORD_T)(_d)))


#define SET_ADAPTER_CTRL_WORD_BITS(_p, _a)                                  \
    WRITE_KNOSSOS_WORD((_p), KNOSSOS_ADAPTER_CTRL,                          \
                   (READ_KNOSSOS_WORD((_p), KNOSSOS_ADAPTER_CTRL) | (_a)))

#define CLEAR_ADAPTER_CTRL_WORD_BITS(_p, _a)                                \
    WRITE_KNOSSOS_WORD((_p), KNOSSOS_ADAPTER_CTRL,                          \
                   (READ_KNOSSOS_WORD((_p), KNOSSOS_ADAPTER_CTRL) & ~(_a)))

#define KNOSSOS_ADAPTER_REMOVED                                             \
            (                                                               \
                ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_type ==          \
                    ADAPTER_TYPE_KNOSSOS_CARDBUS                            \
                &&                                                          \
                (                                                           \
                     READ_KNOSSOS_DWORD(                                    \
                         udids_ptr,                                         \
                         KNOSSOS_HOST_MEM_MAP1)                             \
                     !=                                                     \
                     KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).                \
                         ff03_base_register_contents                        \
                )                                                           \
            )



#ifdef UDT_NO_SSI_PROTECT
#define KNOSSOS_STORE_PIO_ADDRESS(_a) (KNOSSOS_PIO_ADDRESS=(_a))
#endif


#define KNOSSOS_RESTORE_PIO_ADDRESS                                        \
            WRITE_KNOSSOS_DWORD(                                           \
                udids_ptr,                                                 \
                KNOSSOS_HOST_PIO_ADDR,                                     \
                KNOSSOS_PIO_ADDRESS)


#define KNOSSOS_PIO_WRITE_DWORD(_a,_d)                                     \
            (                                                              \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_ADDR, _a), \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_DATA, _d)  \
            )

#define KNOSSOS_PIO_WRITE_WORD(_a,_d)                                      \
            (                                                              \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_ADDR, _a), \
                WRITE_KNOSSOS_WORD(udids_ptr, KNOSSOS_HOST_PIO_DATA, _d)   \
            )

#define KNOSSOS_PIO_WRITE_BYTE(_a,_d)                                      \
            (                                                              \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_ADDR, _a), \
                WRITE_KNOSSOS_BYTE(udids_ptr, KNOSSOS_HOST_PIO_DATA, _d)   \
            )


#ifdef UDT_NO_SSI_PROTECT

#define KNOSSOS_SAFE_PIO_WRITE_DWORD(_a,_d)                                \
            (                                                              \
                KNOSSOS_STORE_PIO_ADDRESS(_a),                             \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_ADDR, _a), \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_DATA, _d)  \
            )

#define KNOSSOS_SAFE_PIO_WRITE_WORD(_a,_d)                                 \
            (                                                              \
                KNOSSOS_STORE_PIO_ADDRESS(_a),                             \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_ADDR, _a), \
                WRITE_KNOSSOS_WORD(udids_ptr, KNOSSOS_HOST_PIO_DATA, _d)   \
            )

#define KNOSSOS_SAFE_PIO_WRITE_BYTE(_a,_d)                                 \
            (                                                              \
                KNOSSOS_STORE_PIO_ADDRESS(_a),                             \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_ADDR, _a), \
                WRITE_KNOSSOS_BYTE(udids_ptr, KNOSSOS_HOST_PIO_DATA, _d)   \
            )
#else

#define KNOSSOS_SAFE_PIO_WRITE_DWORD(_a,_d)                                \
             KNOSSOS_PIO_WRITE_DWORD(_a,_d)

#define KNOSSOS_SAFE_PIO_WRITE_WORD(_a,_d)                                 \
             KNOSSOS_PIO_WRITE_WORD(_a,_d)

#define KNOSSOS_SAFE_PIO_WRITE_BYTE(_a,_d)                                 \
             KNOSSOS_PIO_WRITE_BYTE(_a,_d)

#endif



#ifdef UDT_SSI_SYNCHRONISE_IO

#   define KNOSSOS_SYNC_IO SSI_SYNCHRONISE_IO(udids_ptr),

#else

#   define KNOSSOS_SYNC_IO

#endif

#define KNOSSOS_PIO_READ_DWORD(_a)                                         \
            (                                                              \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_ADDR, _a), \
                KNOSSOS_SYNC_IO                                            \
                READ_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_DATA)       \
            )

#define KNOSSOS_PIO_READ_WORD(_a)                                          \
            (                                                              \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_ADDR, _a), \
                KNOSSOS_SYNC_IO                                            \
                READ_KNOSSOS_WORD(udids_ptr, KNOSSOS_HOST_PIO_DATA)        \
            )

#define KNOSSOS_PIO_READ_BYTE(_a)                                          \
            (                                                              \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_ADDR, _a), \
                KNOSSOS_SYNC_IO                                            \
                READ_KNOSSOS_BYTE(udids_ptr, KNOSSOS_HOST_PIO_DATA)        \
            )


#ifdef UDT_NO_SSI_PROTECT

#define KNOSSOS_SAFE_PIO_READ_DWORD(_a)                                    \
            (                                                              \
                KNOSSOS_STORE_PIO_ADDRESS(_a),                             \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_ADDR, _a), \
                KNOSSOS_SYNC_IO                                            \
                READ_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_DATA)       \
            )

#define KNOSSOS_SAFE_PIO_READ_WORD(_a)                                     \
            (                                                              \
                KNOSSOS_STORE_PIO_ADDRESS(_a),                             \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_ADDR, _a), \
                KNOSSOS_SYNC_IO                                            \
                READ_KNOSSOS_WORD(udids_ptr, KNOSSOS_HOST_PIO_DATA)        \
            )

#define KNOSSOS_SAFE_PIO_READ_BYTE(_a)                                     \
            (                                                              \
                KNOSSOS_STORE_PIO_ADDRESS(_a),                             \
                WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_PIO_ADDR, _a), \
                KNOSSOS_SYNC_IO                                            \
                READ_KNOSSOS_BYTE(udids_ptr, KNOSSOS_HOST_PIO_DATA)        \
            )
#else

#define KNOSSOS_SAFE_PIO_READ_DWORD(_a)                                    \
             KNOSSOS_PIO_READ_DWORD(_a)

#define KNOSSOS_SAFE_PIO_READ_WORD(_a)                                     \
             KNOSSOS_PIO_READ_WORD(_a)

#define KNOSSOS_SAFE_PIO_READ_BYTE(_a)                                     \
             KNOSSOS_PIO_READ_BYTE(_a)

#endif


#define KNOSSOS_FF01_SEG                     0x00010000uL
#define KNOSSOS_FF1F_SEG                     0x001F0000uL



#define     KNOSSOS_TX_QUEUE_ACTIVITY_REG    0x0208

#define     KNOSSOS_TX_COMPLETIONS_REG       0x020A

#define     KNOSSOS_TX_QUEUE_STATUS_REG      0x020C



#define     KNOSSOS_RX_NORMAL_BUF_COUNT      0x030A


#define     KNOSSOS_RX_FILLED_NORMAL_BUF_COUNT  0x030C


#define     KNOSSOS_RX_FRAME_MAXLEN          0x0324


#define     KNOSSOS_RX_PRIORITY_CONTROL      0x0326



#define KNOSSOS_FF02_FRAGMENT_INDEX 0
#define KNOSSOS_FF08_FRAGMENT_INDEX 1
#define KNOSSOS_FF0C_FRAGMENT_INDEX 2


#define KNOSSOS_FF02_SEGMENT_SIZE       ((KNOSSOS_SHARED_STRUCTURE_BASE + \
                                          sizeof(KNOSSOS_SHARED_T) +      \
                                          32) & 0xFFE0)

#define KNOSSOS_FF02_SEGMENT_SIZE_CODE  KNOSSOS_HOST_MEM_MAP_SIZE_4K



#define KNOSSOS_PRIORITY_LEVELS 7

#ifdef DRIVER_MAXIMUM_PRIORITY_LEVEL
#define KNOSSOS_MAX_PRIORITY_QUEUES (DRIVER_MAXIMUM_PRIORITY_LEVEL+1)
#else
#define KNOSSOS_MAX_PRIORITY_QUEUES 7
#endif

#define KNOSSOS_MAX_PRIORITY_QUEUE_TO_FILL (KNOSSOS_MAX_PRIORITY_QUEUES-1)


#ifdef UDT_KNOSSOS_RX_SIZE_OVERRIDE
#define KNOSSOS_RX_POOL_SIZE           UDT_KNOSSOS_RX_SIZE_OVERRIDE
#else
#define KNOSSOS_RX_POOL_SIZE           0x1000
#endif

#ifdef UDT_KNOSSOS_TX_SIZE_OVERRIDE
#define KNOSSOS_TX_POOL_SIZE           UDT_KNOSSOS_TX_SIZE_OVERRIDE
#else
#define KNOSSOS_TX_POOL_SIZE           0x1000
#endif



#define KNOSSOS_TX_POOL_HEADER_LENGTH 8
#define KNOSSOS_RX_POOL_HEADER_LENGTH 8



#define KNOSSOS_TX_BUFFER_SIZE         128


#define KNOSSOS_MAX_TX_FRAGS_PER_BUFF  15

#if KNOSSOS_TX_POOL_SIZE>=0x2000
#define KNOSSOS12_MAX_BUFFERS_PER_TX     3
#else
#define KNOSSOS12_MAX_BUFFERS_PER_TX     2
#endif

#define KNOSSOS12_MAX_TX_FRAGMENTS     (KNOSSOS_MAX_TX_FRAGS_PER_BUFF *     \
                                       (KNOSSOS12_MAX_BUFFERS_PER_TX-1))

#ifdef UDT_KNOSSOS3_30_TX_FRAGMENTS
#define KNOSSOS3_MAX_BUFFERS_PER_TX    2
#else
#define KNOSSOS3_MAX_BUFFERS_PER_TX    1
#endif

#define KNOSSOS3_MAX_TX_FRAGMENTS      (KNOSSOS_MAX_TX_FRAGS_PER_BUFF *     \
                                        KNOSSOS3_MAX_BUFFERS_PER_TX)


#define KNOSSOS1_TX_MAC_BUFFER_SIZE    128
#define KNOSSOS1_NUM_TX_MAC_BUFFERS    4

#define KNOSSOS1_TX_MAC_BUFFER_AREA    (KNOSSOS1_NUM_TX_MAC_BUFFERS*        \
                                        KNOSSOS1_TX_MAC_BUFFER_SIZE)

#define KNOSSOS3_TX_MAC_BUFFER_SIZE    128
#define KNOSSOS3_NUM_TX_MAC_BUFFERS    1

#define KNOSSOS3_TX_MAC_BUFFER_AREA    (KNOSSOS3_NUM_TX_MAC_BUFFERS*        \
                                        KNOSSOS3_TX_MAC_BUFFER_SIZE)


#define KNOSSOS_MIN_TX_SLOTS           2


#define KNOSSOS1_MEM_MAX_TX_SLOTS                                           \
            (                                                               \
                (                                                           \
                    (                                                       \
                        (                                                   \
                             KNOSSOS_TX_POOL_SIZE -                         \
                             KNOSSOS_TX_POOL_HEADER_LENGTH -                \
                             KNOSSOS1_TX_MAC_BUFFER_AREA                    \
                        )                                                   \
                        / KNOSSOS_TX_BUFFER_SIZE                            \
                    )                                                       \
                    - KNOSSOS_PRIORITY_LEVELS                               \
                )                                                           \
                / KNOSSOS12_MAX_BUFFERS_PER_TX                              \
            )

#define KNOSSOS2_MEM_MAX_TX_SLOTS                                           \
            (                                                               \
                (                                                           \
                    (                                                       \
                        (                                                   \
                             KNOSSOS_TX_POOL_SIZE -                         \
                             KNOSSOS_TX_POOL_HEADER_LENGTH                  \
                        )                                                   \
                        / KNOSSOS_TX_BUFFER_SIZE                            \
                    )                                                       \
                    - KNOSSOS_PRIORITY_LEVELS                               \
                )                                                           \
                / KNOSSOS12_MAX_BUFFERS_PER_TX                              \
            )

#define KNOSSOS3_MEM_MAX_TX_SLOTS                                           \
            (                                                               \
                (                                                           \
                    (                                                       \
                         KNOSSOS_TX_POOL_SIZE -                             \
                         KNOSSOS_TX_POOL_HEADER_LENGTH                      \
                    )                                                       \
                    / KNOSSOS_TX_BUFFER_SIZE                                \
                )                                                           \
                / KNOSSOS3_MAX_BUFFERS_PER_TX                               \
            )


#define KNOSSOS_TX_CEILING 128


#ifndef UDT_KNOSSOS3_OVER_8_TX_SLOTS
#define KNOSSOS3_TX_CEILING 7
#else
#define KNOSSOS3_TX_CEILING KNOSSOS_TX_CEILING
#endif

#if (KNOSSOS1_MEM_MAX_TX_SLOTS < KNOSSOS_TX_CEILING)
#   define KNOSSOS1_MAX_TX_SLOTS KNOSSOS1_MEM_MAX_TX_SLOTS
#else
#   define KNOSSOS1_MAX_TX_SLOTS KNOSSOS_TX_CEILING
#endif

#if (KNOSSOS2_MEM_MAX_TX_SLOTS < KNOSSOS_TX_CEILING)
#   define KNOSSOS2_MAX_TX_SLOTS KNOSSOS2_MEM_MAX_TX_SLOTS
#else
#   define KNOSSOS2_MAX_TX_SLOTS KNOSSOS_TX_CEILING
#endif

#if (KNOSSOS3_MEM_MAX_TX_SLOTS < KNOSSOS3_TX_CEILING)
#   define KNOSSOS3_MAX_TX_SLOTS KNOSSOS3_MEM_MAX_TX_SLOTS
#else
#   define KNOSSOS3_MAX_TX_SLOTS KNOSSOS3_TX_CEILING
#endif



#define KNOSSOS12_RX_MAC_BUFFER_SIZE     128
#define KNOSSOS12_RX_BUFFER_SIZE         16

#define KNOSSOS3_RX_MAC_BUFFER_SIZE      128

#ifndef UDT_KNOSSOS3_MAX_RX_FRAGMENTS
#define UDT_KNOSSOS3_MAX_RX_FRAGMENTS 1
#endif

#define KNOSSOS3_RX_BUFFER_SIZE (((4+8*UDT_KNOSSOS3_MAX_RX_FRAGMENTS)+15)&~15)


#define KNOSSOS12_NUM_RX_MAC_BUFFERS   16

#define KNOSSOS12_RX_MAC_BUFFER_AREA   (KNOSSOS_RX_POOL_HEADER_LENGTH +     \
                                        (KNOSSOS12_NUM_RX_MAC_BUFFERS*      \
                                         KNOSSOS12_RX_MAC_BUFFER_SIZE))

#define KNOSSOS23_RX_MAC_BUFFER_AREA    KNOSSOS_RX_POOL_HEADER_LENGTH


#define KNOSSOS12_NUM_ADAP_TO_HOST_MAC_BUFFERS  10

#define KNOSSOS12_NUM_PROMISC_MAC_BUFFERS \
            KNOSSOS12_NUM_ADAP_TO_HOST_MAC_BUFFERS

#define KNOSSOS12_PROMISC_MAC_BUFFER_AREA \
            (KNOSSOS12_NUM_PROMISC_MAC_BUFFERS * \
             KNOSSOS12_RX_MAC_BUFFER_SIZE)

             
#ifndef UDT_UDI_MODIFY_OPEN_OPTIONS

#define KNOSSOS3_NUM_ADAP_TO_HOST_MAC_BUFFERS  0

#define KNOSSOS3_HOST_MAC_BUFFER_AREA          0

#else

#define KNOSSOS3_NUM_ADAP_TO_HOST_MAC_BUFFERS  4

#define KNOSSOS3_HOST_MAC_BUFFER_AREA \
            (KNOSSOS3_NUM_ADAP_TO_HOST_MAC_BUFFERS * \
             KNOSSOS3_RX_MAC_BUFFER_SIZE)
             
#endif 
#define KNOSSOS_MIN_RX_SLOTS           3

#define KNOSSOS12_MEM_MAX_RX_SLOTS                                           \
            (                                                                \
                (                                                            \
                    KNOSSOS_RX_POOL_SIZE -                                   \
                    KNOSSOS_RX_POOL_HEADER_LENGTH -                          \
                    KNOSSOS12_RX_MAC_BUFFER_AREA -                           \
                    KNOSSOS12_PROMISC_MAC_BUFFER_AREA                        \
                )                                                            \
                /                                                            \
                KNOSSOS12_RX_BUFFER_SIZE                                     \
            )

#define KNOSSOS2_MEM_MAX_RX_SLOTS                                            \
            (                                                                \
                (                                                            \
                    KNOSSOS_RX_POOL_SIZE -                                   \
                    KNOSSOS_RX_POOL_HEADER_LENGTH -                          \
                    KNOSSOS12_PROMISC_MAC_BUFFER_AREA                        \
                )                                                            \
                /                                                            \
                KNOSSOS12_RX_BUFFER_SIZE                                     \
            )

#define KNOSSOS3_MEM_MAX_RX_SLOTS                                            \
            (                                                                \
                (                                                            \
                    KNOSSOS_RX_POOL_SIZE -                                   \
                    KNOSSOS_RX_POOL_HEADER_LENGTH -                          \
                    KNOSSOS3_HOST_MAC_BUFFER_AREA                            \
                )                                                            \
                /                                                            \
                KNOSSOS3_RX_BUFFER_SIZE                                      \
            )


#define KNOSSOS_RX_CEILING 128

#if (KNOSSOS12_MEM_MAX_RX_SLOTS < KNOSSOS_RX_CEILING)
#   define KNOSSOS12_MAX_RX_SLOTS KNOSSOS12_MEM_MAX_RX_SLOTS
#else
#   define KNOSSOS12_MAX_RX_SLOTS KNOSSOS_RX_CEILING
#endif

#if (KNOSSOS2_MEM_MAX_RX_SLOTS < KNOSSOS_RX_CEILING)
#   define KNOSSOS2_MAX_RX_SLOTS KNOSSOS2_MEM_MAX_RX_SLOTS
#else
#   define KNOSSOS2_MAX_RX_SLOTS KNOSSOS_RX_CEILING
#endif

#if (KNOSSOS3_MEM_MAX_RX_SLOTS < KNOSSOS_RX_CEILING)
#   define KNOSSOS3_MAX_RX_SLOTS KNOSSOS3_MEM_MAX_RX_SLOTS
#else
#   define KNOSSOS3_MAX_RX_SLOTS KNOSSOS_RX_CEILING
#endif


#ifdef UDT_PACK_ON
#pragma UDT_PACK_ON
#else
#ifdef UDT_ALT_PACK
#pragma pack 1
#else
#pragma pack(1)
#endif
#endif

typedef WORD_T KNOSSOS_BUFFER_PTR_T;

typedef struct _KNOSSOS_FRAG_INFO
{
  WORD_T                  length;            

  WORD_T                  phys_addr;         
  WORD_T                  phys_address_high_word;
  WORD_T                  reserved;

} KNOSSOS_FRAG_INFO_T;

typedef VOLATILE union _UNION_KNOSSOS_TX_BUFFER
{
  struct
  {
    KNOSSOS_BUFFER_PTR_T  next;             
    WORD_T                status;           
    WORD_T                length;           
    BYTE_T                data[120];
  } normal;
  struct
  {
    KNOSSOS_BUFFER_PTR_T  next;             
    WORD_T                status;           
    BYTE_T                num_frags;        
    BYTE_T                reserved1;
    KNOSSOS_FRAG_INFO_T   fragment[15];
  } gather;
} KNOSSOS_TX_BUFFER_T,
  FAR_DATA * P_KNOSSOS_TX_BUFFER_T;

typedef VOLATILE union _UNION_KNOSSOS_RX_BUFFER
{
  struct
  {
    KNOSSOS_BUFFER_PTR_T  next;             
    WORD_T                status;           
                                            
    WORD_T                length;           
    WORD_T                data_area_start;
  } normal;

  struct
  {
    KNOSSOS_BUFFER_PTR_T  next;             
    WORD_T                status;           
                                            
    WORD_T                length;           
    WORD_T                reserved;
    DWORD_T               frag_addr;        
  } scatter;

  struct
  {
    KNOSSOS_BUFFER_PTR_T  next;             
    WORD_T                status;           
                                            
                                            
    struct
    {
      WORD_T                length;         
                                            
      WORD_T                reserved;
      DWORD_T               frag_addr;      
    } fragments[1];
  } multifragment;

} KNOSSOS_RX_BUFFER_T,
  FAR_DATA * P_KNOSSOS_RX_BUFFER_T;

typedef VOLATILE struct
{
    WORD_T                next;             
    WORD_T                length;           
    WORD_T                data_area_start;
} KNOSSOS_MAC_RX_BUFFER_T;

#ifdef UDT_PACK_OFF
#pragma UDT_PACK_OFF
#else
#ifdef UDT_ALT_PACK
#pragma pack 0
#else
#pragma pack()
#endif
#endif



#define KNOSSOS_TX_STATUS_LAST_BUFFER   0x0001


#define KNOSSOS_TX_NO_PH_COMPLETION     0x0004


#define KNOSSOS_TX_IMMEDIATE_FRAME      0x0008


#define KNOSSOS_TX_STATUS_GATHER        0x0040


#define KNOSSOS_TX_STATUS_BUSY          0x0080


#define KNOSSOS3_TX_COMPLETE            0x8000



#define KNOSSOS_RX_STATUS_LAST_BUFFER     0x0001

#define KNOSSOS_RX_STATUS_SP_COMPLETION   0x0006
#define    KNOSSOS_RX_STATUS_ABORTED      0x0004

#define KNOSSOS_RX_STATUS_BM_COMPLETION   0x0018
#define    KNOSSOS_RX_STATUS_DMA_OVERRUUN 0x0010
#define    KNOSSOS_RX_STATUS_NEXT_UNAVAIL 0x0018

#define KNOSSOS_RX_STATUS_RX_EDI          0x0020

#define KNOSSOS_RX_STATUS_LOCAL_EDI       0x0040

#define KNOSSOS_RX_STATUS_BUSY            0x0080


#define TXBM_PTR_TO_ADDR(_p,_a) (WORD_T)(BYTE_SWAP(_a) & 0xFFF8)

#define ADDR_TO_TXBM_PTR(_p, _a) BYTE_SWAP(((WORD_T)                        \
               ((DWORD_T)(_a)-KNOSSOS_RES_INFO_FROM_UDIDS(_p).tx_buf_base)) \
                & 0xFFF8)

#define RXBM_PTR_TO_ADDR(_p,_a) (WORD_T)(BYTE_SWAP(_a) & 0xFFF8)

#define ADDR_TO_RXBM_PTR(_p, _a) BYTE_SWAP(((WORD_T)                        \
               ((DWORD_T)(_a)-KNOSSOS_RES_INFO_FROM_UDIDS(_p).rx_buf_base)) \
                & 0xFFF8)




#define COPY_ADAPCODE_TO_HOST_MEM(_p, _a, _b, _c, _d)                       \
   copy_adapcode_to_host_mem ( (_p), (_a), (_b), (_c), (_d) )

#define WRITE_TO_HOST_MEM(_p, _a, _b, _c, _d)                               \
   write_to_host_mem ( (_p), (_a), (_b), (_c), (_d) )

#define WRITE_WORD_TO_HOST_MEM(_p, _a, _b, _c)                              \
   write_word_to_host_mem ( (_p), (_a), (_b), (_c) )

#define WRITE_DWORD_TO_HOST_MEM(_p, _a, _b, _c)                             \
   write_dword_to_host_mem ( (_p), (_a), (_b), (_c) )



#ifdef UDT_PACK_ON
#pragma UDT_PACK_ON
#else
#ifdef UDT_ALT_PACK
#pragma pack 1
#else
#pragma pack(1)
#endif
#endif

#ifdef UDT_ALIGN_KNOSSOS_STRUCTURES

	#pragma align 1

#endif

typedef struct
{
    BYTE_T                  bootstrap[5];
    BYTE_T                  status;
    WORD_T                  signature;
    DWORD_T                 image_size;
    WORD_T                  stage;
    WORD_T                  block_size;
    WORD_T                  config_ptr;
    WORD_T                  comment_ptr;
    WORD_T                  host_loader_ptr;
    WORD_T                  adapcode_ptr;
    WORD_T                  adap_loader_len;
    WORD_T                  ext_ram_len;
    WORD_T                  fast_ram_len;

} KNOSSOS_LOADER_HEADER_T;

#ifdef UDT_ALIGN_KNOSSOS_STRUCTURES

	#pragma align 0

#endif

#ifdef UDT_PACK_OFF
#pragma UDT_PACK_OFF
#else
#ifdef UDT_ALT_PACK
#pragma pack 0
#else
#pragma pack()
#endif
#endif


#define KNOS_IN_LOADING          0xFF
#define KNOS_LOADED_OK           0x00
#define KNOS_WAIT_FOR_BLOCK      0x01
#define KNOS_WRONG_CARD          0x02
#define KNOS_TXBM_FAIL_TO_START  0x03
#define KNOS_CRC_ERROR           0x04
#define KNOS_NO_SRAM             0x05


typedef struct
{
    WORD_T                  minimum_card_revision_supported;
    BYTE_T                  major_version;
    BYTE_T                  minor_version;
    BYTE_T                  revision;
    BYTE_T                  pokeout;

} KNOSSOS_CONFIG_HEADER_T;



#ifdef UDT_PACK_ON
#pragma UDT_PACK_ON
#else
#ifdef UDT_ALT_PACK
#pragma pack 1
#else
#pragma pack(1)
#endif
#endif

#ifdef UDT_ALIGN_KNOSSOS_STRUCTURES

	#pragma align 1

#endif


typedef struct _MADGE_MAC_PARMS_T
{
  BYTE_T                phys_location[4];
  MAC_ADDRESS_T         stored_upstream_address;
  BYTE_T                stored_upstream_location[4];
  MAC_ADDRESS_T         last_nbr_notified;
  BYTE_T                reserved1[2];
  WORD_T                allowed_access_priority;
  WORD_T                enabled_func_classes;
  WORD_T                last_attention_code;
  MAC_ADDRESS_T         last_source_address;
  WORD_T                last_beacon_type;
  WORD_T                last_mvid;
  WORD_T                ring_status;
  WORD_T                soft_error_timeout;
  WORD_T                front_end_error_counter;
  WORD_T                ring_number;
  WORD_T                active_mon_error_code;
  WORD_T                tx_beacon_type;
  WORD_T                rx_beacon_type;
  WORD_T                last_correlator;
  MAC_ADDRESS_T         beacon_naun;
  BYTE_T                reserved2[4];
  BYTE_T                beacon_phys_location[4];
} MADGE_MAC_PARMS_T;



#define KNOSSOS_SHARED_STRUCTURE_BASE 32


#define KNOSSOS_SHARED_OFFSET(_a) (KNOSSOS_SHARED_STRUCTURE_BASE + \
                                   UDT_OFFSET(KNOSSOS_SHARED_T, _a))



typedef struct _KNOSSOS_SHARED
{

    BYTE_T               pokeout_method;
    BYTE_T               card_type;
    WORD_T               poke_size;
    MAC_ADDRESS_T        bia;
    BYTE_T               reserved_1[2];
    DWORD_T              function_e_of_bia;
    DWORD_T              function_p_of_bia;
    WORD_T               sleep_mode_requirements;
    BYTE_T               reserved_2[6];


    WORD_T               sleep_pattern_space;
    BYTE_T               reserved_3[2];


    BYTE_T               command;
    BYTE_T               return_code;


    MAC_ADDRESS_T        group_address_list_change;
    FUNCTIONAL_ADDRESS_T functional_addr;
    DWORD_T              source_route_match_data;
    BYTE_T               receive_mode;
    BYTE_T               wake_up_events;
    BYTE_T               sleep_mode_control;
    BYTE_T               reserved_4[3];


    MAC_ADDRESS_T        node_addr;
    WORD_T               open_opts;
    WORD_T               dtr_options;
    BYTE_T               product_id[18];
    WORD_T               ring_speed_to_force;
    WORD_T               favoured_auto_ring_speed;
    BYTE_T               reserved_5[10];


    WORD_T               open_status;
    WORD_T               open_error_code;
    WORD_T               ring_speed_opened_at;
    BYTE_T               reserved_6[10];


    WORD_T               ring_status;
    BYTE_T               error_log[14];
    MADGE_MAC_PARMS_T    mac_parms;
    BYTE_T               reserved_7[12];


    BYTE_T               host_to_adapter_events;
    BYTE_T               rx_int_mode;
    WORD_T               host_wdog_timeout_in_sec;


    BYTE_T               unget_rx_buffer_information;
    BYTE_T               reserved_8[11];


    BYTE_T               adapter_to_host_events;
    BYTE_T               tx_flag;
    WORD_T               adapter_crash_reason;
    DWORD_T              adapter_crash_location;

#   define KNOS_NUM_DEBUG_EVENT_COUNTERS 4

    BYTE_T               debug_event_counters[KNOS_NUM_DEBUG_EVENT_COUNTERS];
    BYTE_T               reserved_9[4];


    WORD_T               num_mac_rx_buffers;
    WORD_T               num_adapter_to_host_mac_rx_buffers;
    WORD_T               num_host_to_adapter_mac_rx_buffers;
    BYTE_T               reserved_10[2];


    WORD_T               num_mac_tx_buffers;
    WORD_T               first_tx_queue_buf_ptr[KNOSSOS_PRIORITY_LEVELS];
    BYTE_T               reserved_11[8];


#   define KNOS_TX_QUEUE_SIZE 128

    union
    {
        struct
        {
            BYTE_T       tx_ready_queue[KNOS_TX_QUEUE_SIZE];
            BYTE_T       tx_comp_queue[KNOS_TX_QUEUE_SIZE*2];
        } tx;

        struct
        {
            WORD_T       template_data_length;
            BYTE_T       template_data[KNOS_TX_QUEUE_SIZE*3-2];
        } sleep;

    } tx_or_sleep;


    WORD_T               signature;
    WORD_T               reserved_12;

#   ifdef UDT_KNOSSOS_DEBUG_ADAPTER_CODE

    BYTE_T               debugging_space[128];

    DWORD_T              res_tx_info_pointer;

#   endif 

} KNOSSOS_SHARED_T,
  FAR_DATA   * P_KNOSSOS_SHARED_T,
  FAR_CLIENT * PCLIENT_KNOSSOS_SHARED_T;

#ifdef UDT_ALIGN_KNOSSOS_STRUCTURES

	#pragma align 0

#endif

#ifdef UDT_PACK_OFF
#pragma UDT_PACK_OFF
#else
#ifdef UDT_ALT_PACK
#pragma pack 0
#else
#pragma pack()
#endif
#endif


#define KNOS_SCREEN_POKE                         0x01
#define KNOS_MEM_POKE                            0x02
#define KNOS_HOST_POKE                           0x04
#define KNOS_ADAPTER_POKE                        0x08



#define KNOSSOS_INTERRUPT                        0x00
#define KNOSSOS_OPEN_ADAPTER                     0x01
#define KNOSSOS_CLOSE_ADAPTER                    0x02
#define KNOSSOS_SET_GROUP_ADDRESS                0x03
#define KNOSSOS_SET_FUNCTIONAL_ADDRESS           0x04
#define KNOSSOS_READ_LOG                         0x05
#define KNOSSOS_SET_RECEIVE_MODE                 0x06
#define KNOSSOS_ENTER_SLEEP_MODE                 0x07
#define KNOSSOS_MODIFY_OPEN_OPTIONS              0x08


#define KNOSSOS_CMND_INITIALISE                  0x90


#define WAKE_UP_ON_MAGIC_PACKET                  0x01
#define WAKE_UP_ON_PATTERN                       0x02
#define WAKE_UP_ON_CABLE_ABSENT                  0x04
#define WAKE_UP_ON_CABLE_PRESENT                 0x08


#define SLEEP_USE_NORMAL_BUS_POWER               0x01


#define KNOSSOS_ERR_CANT_PROCESS_CMD_NOW         0x58


#define KNOS_ALLOW_CLASSIC                       0x0001
#define KNOS_ALLOW_DTR                           0x0002


#define KNOS_ADAPTER_COPY_ALL_MAC_TO_HOST        0x01
#define KNOS_ONE_RX_POOL_IN_HOST                 0x02
#define KNOS_PROMISCUOUS_MODE                    0x04
#define KNOS_SOURCE_ROUTE_MATCHING               0x08
#define KNOS_IGNORE_DESTINATION_RING_NUMBER      0x10
#define KNOS_MATCH_SINGLE_ROUTE_BROADCAST        0x20


#define KNOS_UNGET_RX_FAILED                     0x00
#define KNOS_UNGET_RX_SUCCEEDED                  0x01
#define KNOS_UNGET_RX_REQUEST                    0x02


#define KNOS_RX_INT_AT_EOF                       0x00
#define KNOS_RX_INT_AT_SOF                       0x01


#define KNOS_NO_MORE_MAC_FRAMES_FROM_HOST        0x01
#define KNOS_ABORT_TX                            0x04
#define KNOS_TX_FLAG_CHANGED                     0x08


#define KNOS_TX_ABORT_COMPLETE                   0x04
#define KNOS_CHANGE_TX_FLAG                      0x08



#if defined(KNOSSOS_UDI)


#define KNOSSOS_INIT_FROM_UDIDS(_p) (ADAPTER_INIT_FROM_UDIDS(_p).knossos)
#define KNOSSOS_RES_FROM_UDIDS(_p)  (ADAPTER_RES_FROM_UDIDS(_p).knossos)

#define KNOSSOS_INIT_INFO_FROM_UDIDS(_p)                                    \
        (ADAPTER_INIT_INFO_FROM_UDIDS(_p).knossos)
#define KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(_p)                          \
        (ADAPTER_PERSISTENT_RES_INFO_FROM_UDIDS(_p).knossos)
#define KNOSSOS_RES_INFO_FROM_UDIDS(_p)                                     \
        (ADAPTER_RES_INFO_FROM_UDIDS(_p).knossos)





typedef VOID_T
(UDT_INDIRECT *KNOSSOS_CHECK_TX_COMPLETE_T)(
    INOUT P_UDI_DATA_T udids_ptr);

#define D_KNOSSOS_RES_T

#ifdef UDT_INDIRECT_INTER_MODULE_CALLS

typedef VOID_T
(UDT_INTER_MODULE *KNOSSOS_PROCESS_COMMAND_DONE_T)(
    INOUT P_UDI_DATA_T                 udids_ptr);

typedef VOID_T
(UDT_INTER_MODULE *KNOSSOS_PROCESS_EVENT_T)(
    INOUT P_UDI_DATA_T                 udids_ptr);

typedef VOID_T
(UDT_INTER_MODULE *KNOSSOS_PROCESS_STATUS_T)(
    INOUT P_UDI_DATA_T                 udids_ptr);

#endif 

typedef struct _KNOSSOS_RES_T
{

    KNOSSOS_CHECK_TX_COMPLETE_T           knossos_check_tx_complete;

#   define KNOSSOS_CHECK_TX_COMPLETE(_p)                                    \
        (KNOSSOS_RES_FROM_UDIDS(_p).knossos_check_tx_complete(              \
                                        (_p)))

#ifdef UDT_INDIRECT_INTER_MODULE_CALLS

    KNOSSOS_PROCESS_COMMAND_DONE_T        knossos_process_command_done;

#   define KNOSSOS_PROCESS_COMMAND_DONE(_p)                                 \
        (KNOSSOS_RES_FROM_UDIDS(_p).knossos_process_command_done(           \
                                        (_p)))

    KNOSSOS_PROCESS_EVENT_T               knossos_process_event;

#   define KNOSSOS_PROCESS_EVENT(_p)                                        \
        (KNOSSOS_RES_FROM_UDIDS(_p).knossos_process_event(                  \
                                        (_p)))

    KNOSSOS_PROCESS_STATUS_T              knossos_process_status;

#   define KNOSSOS_PROCESS_STATUS(_p)                                       \
        (KNOSSOS_RES_FROM_UDIDS(_p).knossos_process_status(                 \
                                        (_p)))

#else  

#   define KNOSSOS_PROCESS_COMMAND_DONE(_p)                                 \
        (knossos_process_command_done(                                      \
                                        (_p)))

#   define KNOSSOS_PROCESS_EVENT(_p)                                        \
        (knossos_process_event(                                             \
                                        (_p)))
#   define KNOSSOS_PROCESS_STATUS(_p)                                       \
        (knossos_process_status(                                            \
                                        (_p)))

#endif 

} KNOSSOS_RES_T;



#define D_KNOSSOS_INIT_INFO_T

typedef struct _KNOSSOS_INIT_INFO_T
{
    DWORD_T             config_space_f8_dword;

} KNOSSOS_INIT_INFO_T,
  FAR_INIT_DATA  * P_KNOSSOS_INIT_INFO_T;



#define D_KNOSSOS_RES_INFO_T         


typedef struct _KNOSSOS_PERSISTENT_RES_INFO_T
{

    BOOLEAN_T           knossos_3;


    WORD_T              last_ringspeed;

} KNOSSOS_PERSISTENT_RES_INFO_T,
  FAR_DATA * P_KNOSSOS_PERSISTENT_RES_INFO_T;


typedef struct _KNOSSOS_RES_INFO_T
{

    FRAG_HANDLE_T       shared_str_handle;


    BYTE_T              command;

BYTE_T fillertemp[3]; 


    DWORD_T             pio_address;

#   define KNOSSOS_PIO_ADDRESS \
               (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). \
                   pio_address)


    DWORD_T             ff03_base_register_contents;


    UINT_T              fatal_events;

#   define KNOSSOS_FATAL_EVENT_REMOVAL       1



    UINT_T              process_forced_interrupt;

#   define KNOSSOS_R_PROCESS_FORCED_INTERRUPT \
               (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). \
                   process_forced_interrupt)


    DWORD_T              current_force_int;

#   define KNOSSOS_R_CURRENT_FORCE_INT \
               (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). \
                   current_force_int)


#   ifdef UDT_SOURCE_ROUTE_MATCHING

    BOOLEAN_T            issued_set_sr;

#   endif 


    WORD_T              free_tx_buffer_pool;


    UINT_T              free_tx_buffer_pool_entries;

    UINT_T              max_free_tx_buffer_pool_entries;


    WORD_T              next_tx_buffer_ptr[
                            KNOSSOS_MAX_PRIORITY_QUEUES];
    WORD_T              last_tx_buffer_ptr[
                            KNOSSOS_MAX_PRIORITY_QUEUES];


    P_FRAME_T           next_tx_frame[KNOSSOS_MAX_PRIORITY_QUEUES];
    P_FRAME_T           last_tx_frame[KNOSSOS_MAX_PRIORITY_QUEUES];


    UINT_T              next_tx_ready_queue_entry;
    UINT_T              next_tx_comp_queue_entry;


    WORD_T              first_tx_buffer_status;

#   ifdef UDT_NO_SSI_PROTECT


    BOOLEAN_T           tx_data_protected;


    BOOLEAN_T           ignored_possible_tx_complete;

#   endif 



    UINT_T              tx_adapter_frame_count[
                            KNOSSOS_MAX_PRIORITY_QUEUES];

    WORD_T              tx_adapter_next_pending_pointer[
                            KNOSSOS_MAX_PRIORITY_QUEUES];
    WORD_T              tx_adapter_next_unused_pointer[
                            KNOSSOS_MAX_PRIORITY_QUEUES];

#define KNOSSOS_TX_ADAPTER_FRAME_COUNT \
            (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). \
                tx_adapter_frame_count)

#define KNOSSOS_TX_ADAPTER_NEXT_PENDING_POINTER \
            (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). \
                tx_adapter_next_pending_pointer)

#define KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER \
            (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). \
                tx_adapter_next_unused_pointer)

    BOOLEAN_T           tx_unused_pointer_changed[
                            KNOSSOS_MAX_PRIORITY_QUEUES];

#define KNOSSOS_TX_UNUSED_POINTER_CHANGED \
            (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). \
                tx_unused_pointer_changed)

    BOOLEAN_T           aborting_tx;

#define KNOSSOS_ABORTING_TX \
            (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). \
                aborting_tx)


    UINT_T              tx_overflow_frame_count[
                            KNOSSOS_MAX_PRIORITY_QUEUES];

    WORD_T              next_tx_overflow_buffer_ptr[
                            KNOSSOS_MAX_PRIORITY_QUEUES];
    WORD_T              last_tx_overflow_buffer_ptr[
                            KNOSSOS_MAX_PRIORITY_QUEUES];


#define KNOSSOS_NEXT_TX_OVERFLOW_BUFFER_PTR \
            (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). \
                next_tx_overflow_buffer_ptr)

#define KNOSSOS_LAST_TX_OVERFLOW_BUFFER_PTR \
            (KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr). \
                next_tx_overflow_buffer_ptr)


#   if !defined(UDT_KNOSSOS3_OVER_8_TX_SLOTS) && \
       defined(UDT_KNOSSOS3_30_TX_FRAGMENTS)

    UINT_T              tx_slots_in_use;

#   endif

    BOOLEAN_T           check_all_tx_queues;

    BOOLEAN_T           tx_not_completed_since_tick;



#   ifdef UDT_LIMIT_RX_LOOPS


    UINT_T              remaining_reception_quota;       

#   endif 

#   ifndef ONE_RX_POOL_POSSIBLE


    WORD_T              next_adapter_to_host_mac_buffer;

#   else 


    WORD_T              first_host_to_adapter_mac_buffer;


    WORD_T              next_free_host_to_adapter_mac_buffer;

#   endif 


    WORD_T              first_rx_buffer_ptr;
    WORD_T              last_rx_buffer_ptr;


    WORD_T              next_rx_buffer_ptr;


    WORD_T              next_uninitialised_rx_buffer_ptr;


    UINT_T              used_rx_buffer_count;


    P_FRAME_T           rx_frame_list;


    P_FRAME_T           last_rx_frame_list_entry;


    BOOLEAN_T           discarding_frame;


#   ifdef PRESTO_UDI

#   define UNACCEPTABLE_DMA_OVERRUN_INTERVAL    30
#   define INTERRUPT_AT_START_OF_FRAME_DURATION 10000  /* Limited to 65535 */


    UINT_T              dma_overrun_countdown;

    BOOLEAN_T           in_interrupt_at_start_of_frame_mode;

#   endif 

    BOOLEAN_T           may_receive_mac_frames;

#   ifdef ONE_RX_POOL_POSSIBLE

    BOOLEAN_T           changing_to_two_pools;

#   endif 

    PROMISCUOUS_LEVEL_T new_promiscuous_level;

#   ifndef ONE_RX_POOL_POSSIBLE

    BOOLEAN_T           pending_mac_rx;
    P_FRAME_T           frame_for_mac;
    WORD_T              pending_mac_rx_length;

#   endif 



    BYTE_T              last_adapter_to_host_events;


#   ifdef UDT_DEBUG
    BYTE_T           last_debug_event_counters[KNOS_NUM_DEBUG_EVENT_COUNTERS];
#   endif


#   ifdef UDT_NO_SSI_PROTECT
    BOOLEAN_T        tx_abort_completed;
#   endif 


} KNOSSOS_RES_INFO_T,
  FAR_DATA   * P_KNOSSOS_RES_INFO_T;


#endif 


#ifdef UDT_POKEOUTS_ON
#ifdef UDT_KNOS_DEBUGGER

VOID_T
knossos_debugger(
    INOUT P_UDI_DATA_T                 udids_ptr,
    INOUT PCLIENT_BYTE_T               buffer,
    WORD_T                             buf_size);

#endif 
#endif 
