/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
*  **   ** **   **  *****   *****   *****   *****   *****  ****     *****  
*  **  **  ***  ** **   ** **   ** **   ** **   ** **   **  **     **   ** 
*  ** **   **** ** **   ** **      **      **   ** **       **     **      
*  ****    ** **** **   **  *****   *****  **   **  *****   **     **      
*  ** **   **  *** **   **      **      ** **   **      **  **     **      
*  **  **  **   ** **   ** **   ** **   ** **   ** **   **  **     **   ** 
*  **   ** **   **  *****   *****   *****   *****   *****  **** **  *****  
*
*****************************************************************************
*
* Functions comprising the initialization functions of the UDI for all
* Knossoss adapters:
*
*    - Presto.
*    - Presto 2.
*    - Presto 2000.
*    - PCI-3 (both Madge and Compaq versions).
*    - Cardbus 2.
*    - PCI-4.
*    - PCI-4 Fibre.
*    - PCI-4 Mk2.
*
*****************************************************************************
*
* Copyright (C) 1996-1999 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/

#define UDI_MODULE

#include "udt_driver.h"


#ifdef UDT_KNOSSOS_DEBUG_ADAPTER_CODE

#define KNOSSOS_POKEOUT_TO_COLOUR_SCREEN

#endif 



#ifdef KNOSSOS_UDI



#ifdef UDT_DECOMPRESS_BIN_FILES
# define CODE_READW (decompress_a_word(decompression_workspace))
#else
# define CODE_READW (SSI_CODE_READW(udids_ptr, &handle))
#endif



#ifndef UDT_ONLY_GET_CARD_INFO

extern RETCODE_T UDT_INTER_MODULE
knossosr_register(
    INOUT P_UDI_DATA_T                   udids_ptr);

extern UINT_T UDT_INDIRECT
knossos_read_interrupt_status(
    INOUT P_UDI_DATA_T                   udids_ptr);

#endif 


#ifdef KNOS2_UDI
#ifndef UDT_ONLY_GET_CARD_INFO

extern RETCODE_T UDT_INTER_MODULE
knos2r_register(
    INOUT P_UDI_DATA_T                   udids_ptr);

#endif 
#endif 


#ifdef KNOS3_UDI
#ifndef UDT_ONLY_GET_CARD_INFO

extern RETCODE_T UDT_INTER_MODULE
knos3r_register(
    INOUT P_UDI_DATA_T                   udids_ptr);

#endif 
#endif 


extern RETCODE_T UDT_INTER_MODULE
hc46_register(
    INOUT P_UDI_DATA_T                   udids_ptr);

#ifdef UDT_DECOMPRESS_BIN_FILES

extern VOID_T UDT_INTER_MODULE
initialise_decompression(
    IN    P_UDI_DATA_T                   udids_ptr,
    IN    PCLIENT_CODE_HANDLE_T          code_handle_ptr,
    INOUT PCLIENT_DECOMPRESS_WORKSPACE_T w);

extern WORD_T UDT_INTER_MODULE
decompress_a_word(
    IN    PCLIENT_DECOMPRESS_WORKSPACE_T w);

#endif 



STATIC RETCODE_T UDT_INDIRECT
knossos_get_parameters(
    INOUT P_UDI_DATA_T                   udids_ptr,
    OUT   PCLIENT_BOOLEAN_T              completed);

#ifndef UDT_ONLY_GET_CARD_INFO

STATIC RETCODE_T UDT_INDIRECT
knossos_commit_parameters(
    INOUT P_UDI_DATA_T                   udids_ptr,
          BOOLEAN_T                      ints_on);

RETCODE_T UDT_INDIRECT 
knossos_register_udti(
    IN    P_UDI_DATA_T                   udids_ptr,
          UPCALL_TX_COMPLETE_T           tx_complete,
    IN    UPCALL_PRE_RX_T                early_rx,
    IN    UPCALL_RX_T                    receive,
    IN    P_FRAME_T                      receive_list);

#endif 


#ifndef EMBEDDED_MICRO_CODE

STATIC RETCODE_T
knossos_verify_image(
    IN    P_UDI_DATA_T                   udids_ptr);

#endif  

STATIC RETCODE_T
knossos_update_parameters(
    INOUT P_UDI_DATA_T                   udids_ptr);

STATIC RETCODE_T
knossos_update_parameters_using_pci_config(
    INOUT P_UDI_DATA_T                   udids_ptr);

STATIC RETCODE_T
knossos_update_parameters_using_io(
    INOUT P_UDI_DATA_T                   udids_ptr);

STATIC RETCODE_T
knossos_update_parameters_using_num_slots(
    INOUT P_UDI_DATA_T                   udids_ptr);

#ifndef UDT_ONLY_GET_CARD_INFO

STATIC RETCODE_T
knossos_initialize_adapter(
    IN P_UDI_DATA_T                      udids_ptr);
    
STATIC VOID_T
knossos_set_up_rx(
    IN    P_UDI_DATA_T                   udids_ptr,
    IN    P_FRAME_T                      receive_list);

#endif 



DECLARE_MODULE_START_FUNCTION(knossosi_start)
DECLARE_MODULE_END_FUNCTION(knossosi_end)


RETCODE_T UDT_INTER_MODULE
knossosi_register(
    IN P_UDI_DATA_T   udids_ptr,
    IN P_ADAPTER_ID_T id)
{
#   ifndef EMBEDDED_MICRO_CODE
    RETCODE_T rc;
#   endif

    POKE_CFG(COLOUR_FN, "RegKnosInit");


#   ifndef EMBEDDED_MICRO_CODE

    rc = knossos_verify_image(udids_ptr);

    if (rc != SUCCESS)
    {
        RETURN(udids_ptr, rc);
    }

#   endif  

    

    SSI_MODULE_REGISTERED(
        udids_ptr,
        knossosi_register,
        knossosi_start,
        knossosi_end,
        MOD_SCOPE_INITIALISATION);



    ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_type = id->adapter_type;



    hc46_register(udids_ptr);

    GENERAL_RES_INFO_FROM_UDIDS(udids_ptr).hc46_eeprom_DO_IO_offset = 
        GENERAL_RES_INFO_FROM_UDIDS(udids_ptr).hc46_eeprom_IO_offset = 
            KNOSSOS_SEEPROM_CTRL_B;

    GENERAL_RES_INFO_FROM_UDIDS(udids_ptr).hc46_DO_mask = SEEPROM_DO;
    GENERAL_RES_INFO_FROM_UDIDS(udids_ptr).hc46_DO_posn = (BYTE_T)1;
    GENERAL_RES_INFO_FROM_UDIDS(udids_ptr).hc46_DI_mask = SEEPROM_DI;
    GENERAL_RES_INFO_FROM_UDIDS(udids_ptr).hc46_SK_mask = SEEPROM_SK;
    GENERAL_RES_INFO_FROM_UDIDS(udids_ptr).hc46_CS_mask = SEEPROM_CS;
    GENERAL_RES_INFO_FROM_UDIDS(udids_ptr).hc46_bits_to_remember = 0;
    GENERAL_RES_INFO_FROM_UDIDS(udids_ptr).hc46_bits_to_clear = 0;
    GENERAL_RES_INFO_FROM_UDIDS(udids_ptr).hc46_bits_to_set = 0;


#   ifdef CARDBUS2_UDI

    if (id->adapter_type == ADAPTER_TYPE_KNOSSOS_CARDBUS &&
        id->field_used_to_identify_card == USE_IO_BASE)
    {
     
        SET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            io_base[0],
            id->io_base);

        SET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            io_range[0],
            KNOSSOS_IO_SPACE_SIZE);

        SET_STATIC_VALUE( 
            STATIC_FROM_UDIDS(udids_ptr),
            irq_mask,
            (WORD_T)-1);

        SET_STATIC_STATUS( 
            STATIC_FROM_UDIDS(udids_ptr),
            preferred_irq,
            STATUS_TELL_ME);


        ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype =
            ADAPTER_SUBTYPE_CARDBUS2;


        SET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            supports_promiscuous,
            TRUE);

#       ifdef UDT_UDI_SLEEP_COMMAND

        SET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            supports_sleep_command,
            TRUE);

        SET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            auxilliary_power_detected,
            TRUE);

#       endif 

    }
    else

#   endif 

    {
     
        SET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            pci_number,
            (WORD_T) id->pci_number);
    }



    UDI_INIT_FROM_UDIDS(udids_ptr).udi_get_parameters =
        knossos_get_parameters;

#   ifndef UDT_ONLY_GET_CARD_INFO

    UDI_INIT_FROM_UDIDS(udids_ptr).udi_commit_parameters =
        knossos_commit_parameters;

    UDI_INIT_FROM_UDIDS(udids_ptr).udi_register_udti =
        knossos_register_udti;


    UDI_RES_FROM_UDIDS(udids_ptr).udi_read_adapter_interrupt_status =
        common_null_read_interrupt_status;

#   endif 


    UDI_STATE(udids_ptr) = REGISTERED;



#   ifndef UDT_ONLY_GET_CARD_INFO

    knossosr_register(udids_ptr);

#   endif 

    return SUCCESS;
}

BUILD_MODULE_START_FUNCTION(knossosi_start)


#ifndef EMBEDDED_MICRO_CODE

STATIC RETCODE_T
knossos_verify_image(
    IN    P_UDI_DATA_T            udids_ptr)
{
    CODE_HANDLE_T handle;
    WORD_T code_data;


    if (!(SSI_CODE_OPEN(udids_ptr, KNOSSOS2_ADAP_CODE, &handle)))
    {
         
        return FAILED_TO_OPEN_ADAPTER_CODE;
    }


    code_data = SSI_CODE_READW(udids_ptr, &handle);

    if (code_data != KNOSSOS2_ADAP_CODE)
    {
         
        SSI_CODE_CLOSE(udids_ptr, &handle);

        return WRONG_ADAPTER_CODE_TYPE;
    }


    code_data = SSI_CODE_READW(udids_ptr, &handle);


    code_data = SSI_CODE_READW(udids_ptr, &handle);

    if (code_data != KNOSSOS_ADAPCODE_MAJ_VER)
    {
         
        SSI_CODE_CLOSE(udids_ptr, &handle);

        return WRONG_ADAPTER_CODE_VERSION;
    }


    code_data = SSI_CODE_READW(udids_ptr, &handle);

    if (code_data != KNOSSOS_ADAPCODE_MIN_VER)
    {
         
        SSI_CODE_CLOSE(udids_ptr, &handle);

        return WRONG_ADAPTER_CODE_VERSION;
    }


    code_data = SSI_CODE_READW(udids_ptr, &handle);

    if (code_data != KNOSSOS_ADAPCODE_REV_VER)
    {
         
        SSI_CODE_CLOSE(udids_ptr, &handle);

        return WRONG_ADAPTER_CODE_VERSION;
    }


    SSI_CODE_CLOSE(udids_ptr, &handle);

    return SUCCESS;
}

#endif  


STATIC RETCODE_T UDT_INDIRECT
knossos_get_parameters(
    INOUT P_UDI_DATA_T                udids_ptr,
    OUT   PCLIENT_BOOLEAN_T           completed)
{
    RETCODE_T                        rc;

    POKE_CFG(COLOUR_FN, "[knossos_get_parameters");
            
    rc = knossos_update_parameters(udids_ptr);

    if (rc != SUCCESS)
    {
        RETURN(udids_ptr, rc);
    }
    
    
    if((GET_CONFIG_STATUS(
        CONFIG_FROM_UDIDS(udids_ptr),
        pci_handle) == STATUS_SET))
    {
         
        rc = knossos_update_parameters_using_pci_config(udids_ptr);

        if(rc != SUCCESS)
        {
            RETURN(udids_ptr, rc);
        }
    }

    
    if((GET_CONFIG_STATUS(
        CONFIG_FROM_UDIDS(udids_ptr),
        io_handle[0]) == STATUS_SET))
    {

#       ifndef UDT_ONLY_GET_CARD_INFO

#       if defined(KNOS2_UDI) && defined(KNOS3_UDI)
        if (KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).knossos_3)
#       endif
#       ifdef KNOS3_UDI
        {
            knos3r_register(udids_ptr);
        }
#       endif
#       if defined(KNOS2_UDI) && defined(KNOS3_UDI)
        else
#       endif
#       ifdef KNOS2_UDI
        {
            knos2r_register(udids_ptr);
        }
#       endif 

#       endif 



        rc = knossos_update_parameters_using_io(udids_ptr);

        if(rc != SUCCESS)
        {
            RETURN(udids_ptr, rc);
        }


        if( (GET_CONFIG_STATUS(
                 CONFIG_FROM_UDIDS(udids_ptr),
                 tx_slots) == STATUS_SET)
            &&
            (GET_CONFIG_STATUS(
                 CONFIG_FROM_UDIDS(udids_ptr),
                 rx_slots) == STATUS_SET)
          )
        {
         
            if((rc = knossos_update_parameters_using_num_slots(udids_ptr))
                  != SUCCESS)
            {
                RETURN(udids_ptr, rc);
            }


            STATIC_FROM_UDIDS(udids_ptr)->static_complete = TRUE;
        }
    }

     
    *completed = COMMON_CHECK_FOR_UNKNOWN(udids_ptr);
    
    POKE_CFG(COLOUR_FN, "]");

    return SUCCESS;
}


STATIC RETCODE_T
knossos_update_parameters(
    INOUT P_UDI_DATA_T udids_ptr)
{


#   ifdef UDT_USE_WATCHDOG

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        max_watchdog_period,
        0xFFFF);

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        preferred_watchdog_period,
        10);

#   endif

     
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        xfer_method_mask,
        MASK(BUS_MASTER));
            
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        preferred_xfer_method,
        BUS_MASTER);
            

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        edge_triggered_interrupts,
        FALSE);

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        shareable_interrupts,
        TRUE);
     
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        dtr_options_mask,
        MASK(DTR_AND_CLASSIC) |
        MASK(DTR_ONLY)        |
        MASK(CLASSIC_ONLY));

         
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        group_addresses,
        1);


    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        adapter_interface,
        KNOSSOS_DMA);


#   ifdef UDT_SOURCE_ROUTE_MATCHING

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        supports_source_route_matching,
        TRUE);

#   endif 

    return SUCCESS;
}

STATIC RETCODE_T
knossos_update_parameters_using_pci_config(
    INOUT P_UDI_DATA_T udids_ptr)
{
    WORD_T             vendor_id;
    WORD_T             device_id;
    BYTE_T             revision_id;
    WORD_T             subsystem_vendor_id;
    WORD_T             subsystem_device_id;
    ADAPTER_SUBTYPE_T  subtype;
    BOOLEAN_T          knossos_3;
    BOOLEAN_T          supports_promiscuous;
    BOOLEAN_T          supports_sleep_mode;
    DWORD_T            io_base;
    BYTE_T             irq;
    
     
    vendor_id =           PCI_READW(udids_ptr, PCI_VENDOR_ID_INDEX);
    device_id =           PCI_READW(udids_ptr, PCI_DEVICE_ID_INDEX);
    revision_id =         PCI_READB(udids_ptr, PCI_REVISION_ID_INDEX);
    subsystem_vendor_id = PCI_READW(udids_ptr, PCI_SUBSYSTEM_VENDOR_ID_INDEX);
    subsystem_device_id = PCI_READW(udids_ptr, PCI_SUBSYSTEM_DEVICE_ID_INDEX);
    
    TPOKEW_CFG(TT_INFO, "Vdr", vendor_id);
    TPOKEW_CFG(TT_INFO, "Dev", device_id);
    TPOKEB_CFG(TT_INFO, "Rev", revision_id);
    TPOKEW_CFG(TT_INFO, "SVdr", subsystem_vendor_id);
    TPOKEW_CFG(TT_INFO, "SDev", subsystem_device_id);

    subtype = ADAPTER_SUBTYPE_INVALID;
    knossos_3 = FALSE;
    supports_sleep_mode = FALSE;
    supports_promiscuous = TRUE;


    if(vendor_id == PCI_MADGE_VENDOR_ID)
    {

#       if defined(PRESTO_UDI)      || \
           defined(PRESTO2_UDI)     || \
           defined(PRESTO2000_UDI)  || \
           defined(PCI3_UDI)        || \
           defined(CARDBUS2_UDI)    || \
           defined(PCI4_UDI)        || \
           defined(OLICOM_3140V2_UDI)

        if(subsystem_vendor_id == PCI_MADGE_VENDOR_ID)
        {
#           ifdef PRESTO_UDI


            if(device_id == PRESTO_DEVICE_ID
               &&
               subsystem_device_id == PRESTO_SUBSYSTEM_ID)
            {
                subtype = ADAPTER_SUBTYPE_PRESTO;
                supports_promiscuous = FALSE;

                POKE_CFG(COLOUR_INFO, "Presto");
            }

#           endif

#           ifdef PCI3_UDI


            if(device_id == K2_DEVICE_ID
               &&
               subsystem_device_id == PCI3_SUBSYSTEM_ID)
            {
                subtype = ADAPTER_SUBTYPE_PCI3;
                supports_sleep_mode = TRUE;

                POKE_CFG(COLOUR_INFO, "PCI-3");
            }

#           endif

#           ifdef PRESTO2_UDI


            if(device_id == K2_DEVICE_ID
               &&
               subsystem_device_id == PRESTO_SUBSYSTEM_ID
               &&
               revision_id == PRESTO2_PCI_REVISION)
            {
                subtype = ADAPTER_SUBTYPE_PRESTO2;
                supports_promiscuous = FALSE;

                POKE_CFG(COLOUR_INFO, "Presto2");
            }

#           endif

#           ifdef PRESTO2000_UDI


            if(device_id == K2_DEVICE_ID
               &&
               subsystem_device_id == PRESTO_SUBSYSTEM_ID
               &&
               revision_id == PRESTO2000_PCI_REVISION)
            {
                subtype = ADAPTER_SUBTYPE_PRESTO2000;
                supports_sleep_mode = TRUE;

                POKE_CFG(COLOUR_INFO, "Presto2000");
            }

#           endif

#           ifdef CARDBUS2_UDI


            if(device_id == CARDBUS2_DEVICE_ID
               &&
               subsystem_device_id == CARDBUS2_SUBSYSTEM_ID)
            {
                subtype = ADAPTER_SUBTYPE_CARDBUS2;
                supports_sleep_mode = TRUE;

                POKE_CFG(COLOUR_INFO, "CardBus2");
            }

#           endif

#           ifdef PCI4_UDI


            if(device_id == PCI4_DEVICE_ID)
            {
                subtype = ADAPTER_SUBTYPE_PCI4;

#ifndef OLD_K_IF
                knossos_3 = TRUE;
#endif
                supports_sleep_mode = TRUE;

                POKE_CFG(COLOUR_INFO, "PCI-4");
            }


            if(device_id == PCI4_MK2_DEVICE_ID)
            {
                subtype = ADAPTER_SUBTYPE_PCI4_MK2;

#ifndef OLD_K_IF
                knossos_3 = TRUE;
#endif
                supports_sleep_mode = TRUE;

                POKE_CFG(COLOUR_INFO, "PCI-4 Mk2");
            }

#           endif

#           ifdef OLICOM_3140V2_UDI


            if(device_id == OLICOM_3140V2_DEVICE_ID)
            {
                subtype = ADAPTER_SUBTYPE_OLICOM_PCI_3140_V2;

#ifndef OLD_K_IF
                knossos_3 = TRUE;
#endif
                supports_sleep_mode = TRUE;

                POKE_CFG(COLOUR_INFO, "3140-V2");
            }

#           endif

        }
#       endif


#       ifdef COMPAQ_PCI3_UDI

        if(subsystem_vendor_id == PCI_COMPAQ_VENDOR_ID
           &&
           device_id == K2_DEVICE_ID
           &&
           subsystem_device_id == COMPAQ_PCI3_SUBSYSTEM_ID)
        {
            subtype = ADAPTER_SUBTYPE_COMPAQ_PCI3;
            supports_sleep_mode = TRUE;
        }

#       endif

    }

    if (subtype == ADAPTER_SUBTYPE_INVALID)
    {
        RETURN(udids_ptr, BAD_ADAPTER_ID_NO_PCI_CARD);
    }

    ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype = subtype;

    KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).knossos_3 = knossos_3;

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        supports_promiscuous,
        supports_promiscuous);



#   ifdef UDT_ACCESS_PCI_IO_VIA_MEMORY

    io_base = PCI_READD(udids_ptr, PCI_MEMORY_BASE_1_INDEX);

#   else

    io_base = PCI_READD(udids_ptr, PCI_IO_BASE_INDEX) & PCI_IO_BASE_MASK;
         
#   endif

    if (io_base==0)
    {
        RETURN(udids_ptr, BAD_IO);
    }
    
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        io_base[0],
        (IO_LOCATION_T)io_base);
        
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        io_range[0],
        KNOSSOS_IO_SPACE_SIZE);
        
    TPOKED_CFG(TT_INFO, "IO", io_base);


    irq = PCI_READB(udids_ptr, PCI_IRQ_LINE_INDEX);
    
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        irq_mask,
        MASK(irq));
        
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        preferred_irq,
        irq);
    
    TPOKEB_CFG(TT_INFO, "Irq", irq);



    PCI_WRITEW(
        udids_ptr,
        PCI_COMMAND_INDEX,
        (WORD_T)
             ((PCI_READW(udids_ptr, PCI_COMMAND_INDEX) & 0x0010) | 0x0007));



#   ifdef UDT_UDI_SLEEP_COMMAND
#   if defined(PCI3_UDI)        || \
       defined(PRESTO2000_UDI)  || \
       defined(COMPAQ_PCI3_UDI) || \
       defined(PCI4_UDI)        || \
       defined(CARDBUS2_UDI)    || \
       defined(OLICOM_3140V2_UDI)

    KNOSSOS_INIT_INFO_FROM_UDIDS(udids_ptr).config_space_f8_dword =
        PCI_READD(udids_ptr, 0xF8);

    if (supports_sleep_mode)
    {
        SET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            supports_sleep_command,
            TRUE);

        SET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            auxilliary_power_detected,
            (KNOSSOS_INIT_INFO_FROM_UDIDS(udids_ptr).config_space_f8_dword
            &
            0x80000000uL)!=0);
    }
    else
#   endif
    {
        SET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            supports_sleep_command,
            FALSE);
    }
#   endif

    return SUCCESS;
}

STATIC RETCODE_T
knossos_update_parameters_using_io(
    INOUT P_UDI_DATA_T udids_ptr)
{
    MAC_ADDRESS_T      bia;
    WORD_T             eeprom_data;
    UINT_T             i;
    ADAPTER_SUBTYPE_T  subtype;
    BOOLEAN_T          knossos_3;
    WORD_T             hf1;

    subtype = ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype;
    knossos_3 = KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).knossos_3;
    hf1 = UDI_HC46_READ_WORD(udids_ptr, SEEPROM_OFF_HF1);

    TPOKEW_CFG(TT_INFO, "Hf1=", hf1);


    if ((hf1 & HF1_LSS_REQUIRED)!=0)
    {
        return CARD_NOT_SUPPORTED;
    }


    for (i=0; i<3; i++)
    {
#       ifdef UDT_CPU_IS_BIG_ENDIAN
        {
            WORD_T bia_val = 
                UDI_HC46_READ_WORD( udids_ptr, 
                                    (BYTE_T)(SEEPROM_OFF_BIA_START+i));
            *((WORD_T *)&(bia.byte[i*2])) = BYTE_SWAP(bia_val);
        }
#       else
        *((WORD_T *)&(bia.byte[i*2])) =
            UDI_HC46_READ_WORD(udids_ptr, (BYTE_T)(SEEPROM_OFF_BIA_START+i));
#       endif

    }


#   ifndef UDT_NO_STRUCTURE_ASSIGNMENT

    STATS_FROM_UDIDS(udids_ptr).node_address = bia;

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        bia,
        bia);

#   else

    {
        MAC_ADDRESS_T *mac_addr;

        mac_addr = &STATS_FROM_UDIDS(udids_ptr).node_address;
        *mac_addr = bia;

        mac_addr = &STATIC_FROM_UDIDS(udids_ptr)->static_value.bia;
        *mac_addr = bia;
        STATIC_FROM_UDIDS(udids_ptr)->static_status.bia = STATUS_SET; 
    }

#   endif

    TPOKEB_CFG(TT_INFO, "Bia:",    bia.byte[0]);
    POKEB_CFG(TONE_B(TT_INFO), "", bia.byte[1]);
    POKEB_CFG(TONE_B(TT_INFO), "", bia.byte[2]);
    POKEB_CFG(TONE_B(TT_INFO), "", bia.byte[3]);
    POKEB_CFG(TONE_B(TT_INFO), "", bia.byte[4]);
    POKEB_CFG(TONE_B(TT_INFO), "", bia.byte[5]);



#   if defined(PCI3_UDI)        || \
       defined(PRESTO2000_UDI)  || \
       defined(COMPAQ_PCI3_UDI) || \
       defined(CARDBUS2_UDI)    || \
       defined(PCI4_UDI)        || \
       defined(OLICOM_3140V2_UDI)

    if (GET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            supports_promiscuous))
    {
        SET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            promiscuous_enabled,
            (hf1 &
                HF1_PROMISCUOUS_MODE_ENABLED)
                    ?
                    FLAG_TRUE:FLAG_FALSE
            );

        TPOKEW_CFG(
            TT_VALUE,
            "PromiscFlag=",
            hf1);



        if (hf1 & HF1_LAA_PRESENT)
        {
            for (i=0; i<3; i++)
            {
#               ifdef UDT_CPU_IS_BIG_ENDIAN
                {
                    WORD_T laa_val = UDI_HC46_READ_WORD(
                                        udids_ptr,
                                        (BYTE_T)(SEEPROM_OFF_LAA+i));

                    *((WORD_T *)&(bia.byte[i*2])) = BYTE_SWAP(laa_val);
                }
#               else
                *((WORD_T *)&(bia.byte[i*2])) =
                    UDI_HC46_READ_WORD(
                        udids_ptr,
                        (BYTE_T)(SEEPROM_OFF_LAA+i));
#               endif
            }
            SET_STATIC_VALUE(
                STATIC_FROM_UDIDS(udids_ptr),
                laa_present,
                TRUE);

#           ifndef UDT_NO_STRUCTURE_ASSIGNMENT

            SET_STATIC_VALUE(
                STATIC_FROM_UDIDS(udids_ptr),
                laa,
                bia);

#           else

            {
                MAC_ADDRESS_T *mac_addr;

                mac_addr = &STATIC_FROM_UDIDS(udids_ptr)->static_value.laa;
                *mac_addr = bia;
                STATIC_FROM_UDIDS(udids_ptr)->static_status.laa = STATUS_SET; 
            }

#           endif

            TPOKEB_CFG(TT_INFO, "Laa:",    bia.byte[0]);
            POKEB_CFG(TONE_B(TT_INFO), "", bia.byte[1]);
            POKEB_CFG(TONE_B(TT_INFO), "", bia.byte[2]);
            POKEB_CFG(TONE_B(TT_INFO), "", bia.byte[3]);
            POKEB_CFG(TONE_B(TT_INFO), "", bia.byte[4]);
            POKEB_CFG(TONE_B(TT_INFO), "", bia.byte[5]);
        }
    }

#   endif



    KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).last_ringspeed =
         UDI_HC46_READ_WORD(udids_ptr, SEEPROM_OFF_LAST_SPEED);

    TPOKEB_CFG(
        TT_INFO,
        "LastSpeed:",
        KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).last_ringspeed);


    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        ring_speed_mask,
        (hf1 & HF1_100MBPS_ONLY) ?
            MASK(RS_100M) :
            (knossos_3 && (subtype != ADAPTER_SUBTYPE_OLICOM_PCI_3140_V2)) ?
                MASK(RS_AUTO) | MASK(RS_4M) | MASK(RS_16M) | MASK(RS_100M) :
                MASK(RS_AUTO) | MASK(RS_4M) | MASK(RS_16M));

    eeprom_data = UDI_HC46_READ_WORD(udids_ptr, SEEPROM_OFF_FORCE_SPEED);

    TPOKEB_CFG(TT_INFO, "Speed:", eeprom_data);

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        preferred_ring_speed,
        (eeprom_data == 4)       ? RS_4M   :
            (eeprom_data == 16)  ? RS_16M  :
            (eeprom_data == 100) ? RS_100M :
                                   RS_AUTO
        );




    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        xfer_frag_type_tx,
        FRAG_TYPE_PHYS_LE);


    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        min_rx_slots,
        KNOSSOS_MIN_RX_SLOTS);

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        max_rx_slots,
        knossos_3 ? KNOSSOS3_MAX_RX_SLOTS :
            (subtype==ADAPTER_SUBTYPE_PRESTO ||
             subtype==ADAPTER_SUBTYPE_CARDBUS2) ?
                KNOSSOS12_MAX_RX_SLOTS:
                KNOSSOS2_MAX_RX_SLOTS
        );

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        xfer_frag_type_rx,
        FRAG_TYPE_PHYS_LE);


    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        min_tx_slots,
        KNOSSOS_MIN_TX_SLOTS);

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        max_tx_slots,
        knossos_3 ? KNOSSOS3_MAX_TX_SLOTS :
            (subtype==ADAPTER_SUBTYPE_PRESTO)?
                KNOSSOS1_MAX_TX_SLOTS:
                KNOSSOS2_MAX_TX_SLOTS
        );


    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        max_tx_slots_buffered,
        4
        );


    TPOKEI_CFG(TT_INFO, "RxSlots", GET_STATIC_VALUE(
                                       STATIC_FROM_UDIDS(udids_ptr),
                                       min_rx_slots));

    TPOKEI_CFG(TT_INFO, "-",       GET_STATIC_VALUE(
                                       STATIC_FROM_UDIDS(udids_ptr),
                                       max_rx_slots));

    TPOKEI_CFG(TT_INFO, "TxSlots", GET_STATIC_VALUE(
                                       STATIC_FROM_UDIDS(udids_ptr),
                                       min_tx_slots));

    TPOKEI_CFG(TT_INFO, "-",       GET_STATIC_VALUE(
                                       STATIC_FROM_UDIDS(udids_ptr),
                                       max_tx_slots));


    return SUCCESS;
}


STATIC RETCODE_T
knossos_update_parameters_using_num_slots(
    INOUT P_UDI_DATA_T udids_ptr)
{
    ADAPTER_SUBTYPE_T  subtype;
    BOOLEAN_T          knossos_3;

    subtype = ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype;
    knossos_3 = KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).knossos_3;


        
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        frag_type[KNOSSOS_FF02_FRAGMENT_INDEX],
        FRAG_TYPE_PHYS_LE);
    
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        frag_alignment[KNOSSOS_FF02_FRAGMENT_INDEX],
        0x20);

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        frag_length[KNOSSOS_FF02_FRAGMENT_INDEX],
        KNOSSOS_FF02_SEGMENT_SIZE);
    
    TPOKED_CFG(TT_INFO, "LenFF02/3/6:", KNOSSOS_FF02_SEGMENT_SIZE);



#   ifdef UDT_DEBUG
#   endif 


        
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        frag_type[KNOSSOS_FF08_FRAGMENT_INDEX],
        FRAG_TYPE_PHYS_LE);
        
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        frag_alignment[KNOSSOS_FF08_FRAGMENT_INDEX],
        0x20);

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        frag_length[KNOSSOS_FF08_FRAGMENT_INDEX],
        (
            KNOSSOS_TX_POOL_HEADER_LENGTH
            +
            (
                (subtype==ADAPTER_SUBTYPE_PRESTO) ?
                    KNOSSOS1_TX_MAC_BUFFER_AREA : 0
            )
            +
            (
                knossos_3 ?
                    KNOSSOS3_TX_MAC_BUFFER_AREA
                    :
                    KNOSSOS_MAX_PRIORITY_QUEUES * KNOSSOS_TX_BUFFER_SIZE
            )
            +
            (
                GET_CONFIG_VALUE(
                    CONFIG_FROM_UDIDS(udids_ptr),
                    tx_slots)
                        * KNOSSOS_TX_BUFFER_SIZE
                        * (
                              knossos_3 ?
                                  KNOSSOS3_MAX_BUFFERS_PER_TX
                                  :
                                  KNOSSOS12_MAX_BUFFERS_PER_TX
                          )
            )
        ));
    
    TPOKED_CFG(TT_USER, "TxSlots:", GET_CONFIG_VALUE(
                                        CONFIG_FROM_UDIDS(udids_ptr),
                                        tx_slots));
    TPOKED_CFG(
        TT_INFO,
        "LenTx:",
        GET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            frag_length[KNOSSOS_FF08_FRAGMENT_INDEX]));

        
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        frag_type[KNOSSOS_FF0C_FRAGMENT_INDEX],
        FRAG_TYPE_PHYS_LE);
        
    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        frag_alignment[KNOSSOS_FF0C_FRAGMENT_INDEX],
        0x20);

    SET_STATIC_VALUE(
        STATIC_FROM_UDIDS(udids_ptr),
        frag_length[KNOSSOS_FF0C_FRAGMENT_INDEX],
        (
            KNOSSOS_RX_POOL_HEADER_LENGTH
            +
            (
                (subtype==ADAPTER_SUBTYPE_PRESTO ||
                 subtype==ADAPTER_SUBTYPE_CARDBUS2) ?
                    KNOSSOS12_RX_MAC_BUFFER_AREA : 0
            )
            +
            (
                knossos_3 ? KNOSSOS3_HOST_MAC_BUFFER_AREA : 
                               KNOSSOS12_PROMISC_MAC_BUFFER_AREA
            )
            +
            (
                GET_CONFIG_VALUE(
                    CONFIG_FROM_UDIDS(udids_ptr),
                    rx_slots)
                        * (
                              knossos_3 ?
                                  KNOSSOS3_RX_BUFFER_SIZE
                                  :
                                  KNOSSOS12_RX_BUFFER_SIZE
                          )
            )
        )
        );
    
    TPOKED_CFG(TT_USER, "RxSlots:", GET_CONFIG_VALUE(
                                        CONFIG_FROM_UDIDS(udids_ptr),
                                        rx_slots));
    TPOKED_CFG(
        TT_INFO,
        "LenRx:",
        GET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            frag_length[KNOSSOS_FF0C_FRAGMENT_INDEX]));

    return SUCCESS;
}
    
   
#ifndef UDT_ONLY_GET_CARD_INFO

STATIC RETCODE_T UDT_INDIRECT
knossos_commit_parameters(
    INOUT P_UDI_DATA_T                udids_ptr,
          BOOLEAN_T                   ints_on)
{
    RETCODE_T rc;
    BOOLEAN_T          knossos_3;
    
    POKE_CFG(COLOUR_FN, "[knossos_commit_parameters");

    knossos_3 = KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).knossos_3;



    UDI_RES_FROM_UDIDS(udids_ptr).udi_read_adapter_interrupt_status =
        common_null_read_interrupt_status;


    rc = knossos_initialize_adapter(udids_ptr);

    if(rc != SUCCESS)
    {
        RETURN(udids_ptr, rc);
    }


    UDTI_INFO_FROM_UDIDS(udids_ptr).min_lookahead_frag_length = 0;

    UDTI_INFO_FROM_UDIDS(udids_ptr).can_dma_above_16meg = TRUE;



    UDTI_INFO_FROM_UDIDS(udids_ptr).max_tx_frags =
        knossos_3 ? KNOSSOS3_MAX_TX_FRAGMENTS : KNOSSOS12_MAX_TX_FRAGMENTS;


    UDTI_INFO_FROM_UDIDS(udids_ptr).min_first_tx_frag_length =
        knossos_3 ? 1 : 5;

    UDTI_INFO_FROM_UDIDS(udids_ptr).max_first_tx_frag_length =
        MAX_TX_FRAG_LENGTH;


    UDTI_INFO_FROM_UDIDS(udids_ptr).min_tx_frag_length = 
        0;

    UDTI_INFO_FROM_UDIDS(udids_ptr).max_tx_frag_length = 
        MAX_TX_FRAG_LENGTH;



    UDTI_INFO_FROM_UDIDS(udids_ptr).max_rx_frags =
#       if (UDT_KNOSSOS3_MAX_RX_FRAGMENTS==1)
        1;
#       else
        knossos_3 ? UDT_KNOSSOS3_MAX_RX_FRAGMENTS : 1;
#       endif

    UDTI_INFO_FROM_UDIDS(udids_ptr).min_first_rx_frag_length =
        0;

    UDTI_INFO_FROM_UDIDS(udids_ptr).max_first_rx_frag_length =
        MAX_RX_FRAG_LENGTH;

    UDTI_INFO_FROM_UDIDS(udids_ptr).min_rx_frag_length =
        0;

    UDTI_INFO_FROM_UDIDS(udids_ptr).max_rx_frag_length =
        MAX_RX_FRAG_LENGTH;


    UDTI_INFO_FROM_UDIDS(udids_ptr).rx_class = RX_ADAPTER;



    UDI_RES_FROM_UDIDS(udids_ptr).udi_read_adapter_interrupt_status =
        knossos_read_interrupt_status;

    WRITE_KNOSSOS_DWORD(
        udids_ptr,
        KNOSSOS_HOST_INT_MASK, 
        knossos_3 ? KNOSSOS3_ALL_INTERRUPTS_MASK :
                    KNOSSOS12_ALL_INTERRUPTS_MASK);


    POKE_CFG(COLOUR_FN, "]");

    return SUCCESS;
}


STATIC RETCODE_T
knossos_initialize_adapter(
    IN P_UDI_DATA_T udids_ptr)
{
    RETCODE_T                      rc;
    DWORD_T                        mem_phys;
    FRAG_HANDLE_T                  dest_frag_handle;
    UINT_T                         i;

#   ifdef UDT_DECOMPRESS_BIN_FILES
    PCLIENT_DECOMPRESS_WORKSPACE_T decompression_workspace;
#   endif
    CODE_HANDLE_T                  handle;
    WORD_T                         data;
    DWORD_T                        image_size;
    DWORD_T                        image_offset;
    WORD_T                         adapcode_ptr;
    WORD_T                         block_size;
    BYTE_T                         status;
    RETCODE_T                      download_error;
    UINT_T                         tx_start_attempts;
    UINT_T                         j;
    ADAPTER_SUBTYPE_T              subtype;
    FRAG_HANDLE_T                  tx_frag_handle;
    FRAG_HANDLE_T                  rx_frag_handle;
    WORD_T                         base;
    WORD_T                         original_base;
    UINT_T                         free_queue_entries;
    WORD_T                         control_word;
    BOOLEAN_T                      knossos_3;
    WORD_T                         rx_buffer_size;
    WORD_T                         fc_control_word;


    
    POKE_CFG(COLOUR_SUBFN, "Initialise");

    rc = SUCCESS;

    subtype = ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype;
    knossos_3 = KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).knossos_3;

#   ifdef UDT_DECOMPRESS_BIN_FILES

    decompression_workspace =
        &(INIT_UDIDS_FROM_UDIDS(udids_ptr)->decompression_workspace);

#   endif


    if (subtype!=ADAPTER_SUBTYPE_PRESTO)
    {

#       define KNOSSOS_PME_OCCURRED 0x8000
#       define KNOSSOS_PME_ENABLE   0x0100

        fc_control_word = PCI_READW(udids_ptr, 0xFC);

        STATS_FROM_UDIDS(udids_ptr).pme_occurred =
            ((fc_control_word & KNOSSOS_PME_OCCURRED) != 0);

        fc_control_word &= ~KNOSSOS_PME_OCCURRED;

        if (subtype == ADAPTER_SUBTYPE_CARDBUS2)
        {
            fc_control_word |= KNOSSOS_PME_ENABLE;
        }

        PCI_WRITEW(udids_ptr, 0xFC, fc_control_word);
        
#ifdef UDT_DEBUG
        fc_control_word = PCI_READW(udids_ptr, 0xFC);
        POKEW_CTRL(COLOUR_INSANE, " **BOB99** 0xFC=", fc_control_word);
#endif 
    }


    WRITE_KNOSSOS_WORD(udids_ptr, KNOSSOS_ADAPTER_CTRL, 0x0000);

    dest_frag_handle = GET_CONFIG_VALUE(
                            CONFIG_FROM_UDIDS(udids_ptr),
                            frag_handle[KNOSSOS_FF02_FRAGMENT_INDEX]);

    mem_phys = (DWORD_T)SSI_FRAG_PHYS_ADDRESS(
                    udids_ptr,
                    dest_frag_handle);


    TPOKED_CFG(TT_VALUE, "FF02:", mem_phys);

    WRITE_KNOSSOS_DWORD(
        udids_ptr,
        KNOSSOS_HOST_MEM_MAP0,
        0);

    WRITE_KNOSSOS_DWORD(
        udids_ptr,
        KNOSSOS_HOST_MEM_MAP0,
        mem_phys | KNOSSOS_FF02_SEGMENT_SIZE_CODE);

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).shared_str_handle =
        dest_frag_handle;

    TPOKED_CFG(TT_VALUE, "FF03:",mem_phys+KNOSSOS_SHARED_STRUCTURE_BASE);

    WRITE_KNOSSOS_DWORD(
        udids_ptr,
        KNOSSOS_HOST_MEM_MAP1,
        0);

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).ff03_base_register_contents =
        (mem_phys+KNOSSOS_SHARED_STRUCTURE_BASE) |
            KNOSSOS_FF02_SEGMENT_SIZE_CODE;

    WRITE_KNOSSOS_DWORD(
        udids_ptr,
        KNOSSOS_HOST_MEM_MAP1,
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).ff03_base_register_contents);

#   ifdef UDT_KNOSSOS_DEBUG_ADAPTER_CODE

#   ifdef KNOSSOS_POKEOUT_TO_MONO_SCREEN
    mem_phys = 0xB0000uL;          
#   else
#     ifdef KNOSSOS_POKEOUT_TO_COLOUR_SCREEN
    mem_phys = 0xB8000uL+80*2*35;  
#     endif
#   endif

    WRITE_KNOSSOS_DWORD(
        udids_ptr,
        KNOSSOS_HOST_MEM_MAP3,
        0);

    WRITE_KNOSSOS_DWORD(
        udids_ptr,
        KNOSSOS_HOST_MEM_MAP3,
        mem_phys | KNOSSOS_HOST_MEM_MAP_SIZE_4K);

#   endif


    tx_frag_handle = GET_CONFIG_VALUE(
                            CONFIG_FROM_UDIDS(udids_ptr),
                            frag_handle[KNOSSOS_FF08_FRAGMENT_INDEX]);

    mem_phys = (DWORD_T)SSI_FRAG_PHYS_ADDRESS(
                    udids_ptr,
                    tx_frag_handle);

    TPOKED_CFG(TT_VALUE, "Tx:", mem_phys);

    mem_phys |= KNOSSOS_HOST_TX_POOL_SIZE_64K;

    WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_TX_POOL_BASE, 0);

    WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_TX_POOL_BASE, mem_phys);



    rx_frag_handle = GET_CONFIG_VALUE(
                            CONFIG_FROM_UDIDS(udids_ptr),
                            frag_handle[KNOSSOS_FF0C_FRAGMENT_INDEX]);

    mem_phys = (DWORD_T)SSI_FRAG_PHYS_ADDRESS(
                    udids_ptr,
                    rx_frag_handle);

    TPOKED_CFG(TT_VALUE, "Rx:", mem_phys);

    mem_phys |= KNOSSOS_HOST_RX_POOL_SIZE_64K;

    WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_RX_POOL_BASE, 0);

    WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_RX_POOL_BASE, mem_phys);



    if (!(SSI_CODE_OPEN(udids_ptr, KNOSSOS2_ADAP_CODE, &handle)))
    {
         
        RETURN(udids_ptr, FAILED_TO_OPEN_ADAPTER_CODE);
    }


#   ifndef UDT_NO_IMAGE_HEADERS

    for (i=0; i<sizeof(IMAGE_HEADER_T); i+=2)
    {
        SSI_CODE_READW(udids_ptr, &handle);
    }

#   endif


#   ifdef UDT_DECOMPRESS_BIN_FILES

    initialise_decompression(
        udids_ptr,
        &handle,
        decompression_workspace);

#   endif


    POKE_CFG(COLOUR_ACTION, "Download:1stBlock");

    for (i=0; i<KNOSSOS_FF02_SEGMENT_SIZE; i+=2)
    {
        data = CODE_READW;

        SSI_FRAG_WRITEW(udids_ptr, dest_frag_handle, i, data);

#       ifdef UDT_DEBUG
        if (i<32)
        {
            BYTE_T colour;

            colour = PO_BRIGHT_WHITE;

            if (i == UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, image_size) ||
                i == UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, image_size) + 2 )
            {
                colour = PO_BRIGHT_YELLOW;
            }

            if (i == UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, adapcode_ptr))
            {
                colour = PO_BRIGHT_GREEN;
            }

            POKEW_CFG(colour, " ", data);
        }
#       endif

    }

    image_size = SSI_FRAG_READD(
                     udids_ptr,
                     dest_frag_handle,
                     UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, image_size));

    adapcode_ptr = SSI_FRAG_READW(
                       udids_ptr,
                       dest_frag_handle,
                       UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, adapcode_ptr));

    block_size = KNOSSOS_FF02_SEGMENT_SIZE - adapcode_ptr;

    image_offset = KNOSSOS_FF02_SEGMENT_SIZE;

    TPOKED_CFG(TT_VALUE, "ImageLen", image_size);
    TPOKED_CFG(TT_VALUE, "SoFar", image_offset);
    TPOKEW_CFG(TT_VALUE, "AdapCodePtr", adapcode_ptr);
    TPOKEW_CFG(TT_VALUE, "BlockSize", block_size);


    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, block_size),
        block_size);


#   ifdef UDT_KNOSSOS_DEBUG_ADAPTER_CODE
    {
        UINT_T config_ptr_offset;
        BYTE_T supported_pokeout_methods;
        BYTE_T required_pokeout_method;

        config_ptr_offset = 
            SSI_FRAG_READW(
                udids_ptr,
                dest_frag_handle,
                UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, config_ptr));

        supported_pokeout_methods = 
            SSI_FRAG_READW(
                udids_ptr,
                dest_frag_handle,
                config_ptr_offset +
                    UDT_OFFSET(KNOSSOS_CONFIG_HEADER_T, pokeout));

#       ifdef KNOSSOS_POKEOUT_TO_ADAPTER_MEMORY
        required_pokeout_method = KNOS_ADAPTER_POKE;
#       endif

#       ifdef KNOSSOS_POKEOUT_TO_MONO_SCREEN
        required_pokeout_method = KNOS_SCREEN_POKE;
#       endif

#       ifdef KNOSSOS_POKEOUT_TO_COLOUR_SCREEN
        required_pokeout_method = KNOS_SCREEN_POKE;
#       endif

        TPOKEW_CFG(TT_DULL2, "Pokes=", supported_pokeout_methods);
        TPOKEW_CFG(TT_DULL3, "Need:", required_pokeout_method);

        if ((required_pokeout_method & supported_pokeout_methods) == 0)
        {
            POKE_CFG(
                PO_BRIGHT_FLASHING_WHITE,
                "The selected adapter pokeout method will not work!");

            UDT_INSANE;

            SSI_WAIT_AT_LEAST_MSEC(udids_ptr, 5000);
        }
    }
#   endif


    control_word = (subtype==ADAPTER_SUBTYPE_PRESTO)   ? 0x0BC2 :
                   (subtype==ADAPTER_SUBTYPE_CARDBUS2) ? 0x0FE2 :
                   knossos_3                           ? 0x47C2 :
                                                         0x0FC2;

    tx_start_attempts = 20;

    do
    {
        POKE_CFG(COLOUR_ACTION, "JumpStart");

        WRITE_KNOSSOS_WORD(udids_ptr, KNOSSOS_ADAPTER_CTRL, 0x0000);


        WRITE_KNOSSOS_WORD(udids_ptr, KNOSSOS_ADAPTER_CTRL, control_word);

        SSI_WAIT_AT_LEAST_MSEC (udids_ptr, 10);



        WRITE_KNOSSOS_DWORD(udids_ptr, KNOSSOS_HOST_INT_MASK, 0x00000000);

        WRITE_KNOSSOS_BYTE(udids_ptr, KNOSSOS_ADAP_2_HOST_INT, 0xff); 



        WRITE_KNOSSOS_WORD(
            udids_ptr,
            KNOSSOS_ADAPTER_CTRL,
            control_word+ADAPTER_CTRL_WORD_PROC_RESET);



        download_error = ADAPTER_INIT_FAILED;

        for (i=0; i<5000 && download_error==ADAPTER_INIT_FAILED; i++)
        {
            status = SSI_FRAG_READB(
                     udids_ptr,
                     dest_frag_handle,
                         UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, status));

            /*

            POKE_CFG(PO_BRIGHT_BLUE, "-");

            POKEB_CFG(PO_BRIGHT_RED, " ", status);

            POKEW_CFG(PO_BRIGHT_MAGENTA, "",
                      SSI_FRAG_READW(
                         udids_ptr,
                         dest_frag_handle,
                         UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, stage)));

            POKEW_CFG(PO_BRIGHT_GREEN, "",
                      SSI_FRAG_READW(
                         udids_ptr,
                         dest_frag_handle,
                         UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, stage)+6));

            */

            switch (status)
            {

                case KNOS_LOADED_OK:

                    download_error = SUCCESS;
                    break;


                case KNOS_WAIT_FOR_BLOCK:

                    POKE_CFG(PO_BRIGHT_YELLOW, "-");


                    for (j=0;
                         j<block_size && image_offset<image_size;
                         j+=2)
                    {
                        data = CODE_READW;

                        SSI_FRAG_WRITEW(
                            udids_ptr,
                            dest_frag_handle,
                            adapcode_ptr + j,
                            data);

                        image_offset += 2;
                    }


                    SSI_FRAG_WRITEB(
                        udids_ptr,
                        dest_frag_handle,
                        UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, status),
                        KNOS_IN_LOADING);

                    break;


                case KNOS_TXBM_FAIL_TO_START:


                    SSI_FRAG_WRITEB(
                        udids_ptr,
                        dest_frag_handle,
                        UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, status),
                        KNOS_IN_LOADING);

                    download_error = PRESTO_TXBM_FAIL_TO_START;
                    break;

                case KNOS_WRONG_CARD:

                    download_error = FAILURE;
                    break;

                case KNOS_CRC_ERROR:


                    POKE_CFG(COLOUR_ERROR, "CRC failure");
                    download_error = PRESTO_CRC_FAILURE;
                    break;

                case KNOS_NO_SRAM:


                    POKE_CFG(COLOUR_ERROR, "No external RAM");
                    download_error = OUT_OF_ADAPTER_RAM;
                    break;
            }

            SSI_WAIT_AT_LEAST_MSEC (udids_ptr, 1);
        }


        tx_start_attempts--;

    } while (download_error == PRESTO_TXBM_FAIL_TO_START &&
             tx_start_attempts > 0);


    WRITE_KNOSSOS_WORD(udids_ptr, KNOSSOS_ADAPTER_CTRL, control_word);



    SSI_CODE_CLOSE(udids_ptr, &handle);

    if (download_error != SUCCESS)
    {
        RETURN (udids_ptr, download_error);
    }

    POKE_CFG(COLOUR_EVENT, "StartedOK");



    WRITE_KNOSSOS_WORD(
        udids_ptr,
        KNOSSOS_COUNTER_1_TX_FILLED,
        0 - READ_KNOSSOS_WORD(udids_ptr, KNOSSOS_COUNTER_1_TX_FILLED));

    WRITE_KNOSSOS_WORD(
        udids_ptr,
        KNOSSOS_COUNTER_4_RX_AVAILABLE,
        0 - READ_KNOSSOS_WORD(udids_ptr, KNOSSOS_COUNTER_4_RX_AVAILABLE));



    for (i=0; i<sizeof(KNOSSOS_SHARED_T); i++)
    {
        SSI_FRAG_WRITEB(
            udids_ptr,
            dest_frag_handle,
            KNOSSOS_SHARED_STRUCTURE_BASE + i,
            0);
    }


#   ifdef UDT_KNOSSOS_DEBUG_ADAPTER_CODE

#   ifdef KNOSSOS_POKEOUT_TO_ADAPTER_MEMORY
    SSI_FRAG_WRITEB(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(pokeout_method),
        KNOS_ADAPTER_POKE
        );
#   else
    SSI_FRAG_WRITEB(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(pokeout_method),
        KNOS_SCREEN_POKE
        );
#   endif

    POKEW_CFG(
        PO_GREEN,
        "PokeoutMethod",
        SSI_FRAG_READB(
            udids_ptr,
            dest_frag_handle,
            KNOSSOS_SHARED_OFFSET(pokeout_method))
        );


#   ifdef KNOSSOS_POKEOUT_TO_MONO_SCREEN
    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(poke_size),
        25*80*2
        );
#   else
#     ifdef KNOSSOS_POKEOUT_TO_COLOUR_SCREEN
    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(poke_size),
        15*80*2
        );
#     endif
#   endif

#   endif


    for (i=0; i<6; i++)
    {
        SSI_FRAG_WRITEB(
            udids_ptr,
            dest_frag_handle,
            KNOSSOS_SHARED_OFFSET(bia.byte[i]),
            GET_STATIC_VALUE(
                STATIC_FROM_UDIDS(udids_ptr),
                bia.byte[i])
            );
    }


#   ifdef UDT_SANITY_CHECK

    if (
           (UDI_HC46_READ_WORD(udids_ptr, SEEPROM_OFF_EBIA_LOW) ==0x0000
            &&
            UDI_HC46_READ_WORD(udids_ptr, SEEPROM_OFF_EBIA_HIGH)==0x0000)
           ||
           (UDI_HC46_READ_WORD(udids_ptr, SEEPROM_OFF_EBIA_LOW) ==0xFFFF
            &&
            UDI_HC46_READ_WORD(udids_ptr, SEEPROM_OFF_EBIA_HIGH)==0xFFFF)
       )
    {
        if (subtype!=ADAPTER_SUBTYPE_PRESTO)
        {
            POKE_CTRL(
                COLOUR_INSANE,
                "Inoperable: Old format serial device");

            UDT_INSANE;
        }
    }

#   endif

    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(function_e_of_bia),
        UDI_HC46_READ_WORD(udids_ptr, SEEPROM_OFF_EBIA_LOW)
        );

    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(function_e_of_bia)+2,
        UDI_HC46_READ_WORD(udids_ptr, SEEPROM_OFF_EBIA_HIGH)
        );

    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(function_p_of_bia),
        UDI_HC46_READ_WORD(udids_ptr, SEEPROM_OFF_PBIA_LOW)
        );

    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(function_p_of_bia)+2,
        UDI_HC46_READ_WORD(udids_ptr, SEEPROM_OFF_PBIA_HIGH)
        );


#   ifdef UDT_UDI_SLEEP_COMMAND

    if (GET_CONFIG_VALUE(
            CONFIG_FROM_UDIDS(udids_ptr),sleep_mode_may_be_used))
    {
        SSI_FRAG_WRITEW(
            udids_ptr,
            dest_frag_handle,
            KNOSSOS_SHARED_OFFSET(sleep_mode_requirements),
            0x0001
            );
    }

#   endif


# ifdef USE_OLD_K2_IMAGE 

    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(ring_speed_to_force),
            (
                (GET_CONFIG_VALUE(
                    CONFIG_FROM_UDIDS(udids_ptr),
                    ring_speed) == RS_4M) ? 4 :
                    (
                        (GET_CONFIG_VALUE(
                            CONFIG_FROM_UDIDS(udids_ptr),
                            ring_speed) == RS_16M) ? 16 : 0
                    )
            )
        );

# else

    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(ring_speed_to_force),
            (
                (GET_CONFIG_VALUE(
                    CONFIG_FROM_UDIDS(udids_ptr),
                    ring_speed) == RS_4M) ? 0 :
                    (
                        (GET_CONFIG_VALUE(
                            CONFIG_FROM_UDIDS(udids_ptr),
                            ring_speed) == RS_16M) ? 1 :
                            (
                                (GET_CONFIG_VALUE(
                                CONFIG_FROM_UDIDS(udids_ptr),
                                ring_speed) == RS_100M) ? 2 : 0xFFFF
                            )
                    )
            )
        );

# endif


# ifdef USE_OLD_K2_IMAGE 

    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(favoured_auto_ring_speed),
        KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).last_ringspeed
        );

# else

    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(favoured_auto_ring_speed),
        (
            KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).
                last_ringspeed == 4
        ) ? 0 :
            (
                KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).
                    last_ringspeed == 16
            ) ? 1 : 2
        );

# endif


    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(ring_speed_opened_at),
        0xFFFF);


    SSI_FRAG_WRITEB(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(rx_int_mode),
        KNOS_RX_INT_AT_EOF);


#   ifdef UDT_USE_WATCHDOG

#       ifdef UDT_DEBUG

    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(host_wdog_timeout_in_sec),
        0);


#       else

    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(host_wdog_timeout_in_sec),
        (WORD_T)
            (GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr),
                watchdog_period)));

#       endif

#   else

    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(host_wdog_timeout_in_sec),
        0);

#   endif



    POKE_CFG(PO_MAGENTA, "TxInit");


    for (i=0;
         i<GET_STATIC_VALUE(
               STATIC_FROM_UDIDS(udids_ptr),
               frag_length[KNOSSOS_FF08_FRAGMENT_INDEX]);
         i++)
    {
        SSI_FRAG_WRITEB(
            udids_ptr,
            tx_frag_handle,
            i,
            0);
    }

    if (!knossos_3)
    {

        base = (subtype==ADAPTER_SUBTYPE_PRESTO) ?
                   KNOSSOS_TX_POOL_HEADER_LENGTH +
                       KNOSSOS1_TX_MAC_BUFFER_SIZE *
                           KNOSSOS1_NUM_TX_MAC_BUFFERS:
                   KNOSSOS_TX_POOL_HEADER_LENGTH;


        SSI_FRAG_WRITEW(
            udids_ptr,
            dest_frag_handle,
            KNOSSOS_SHARED_OFFSET(num_mac_tx_buffers),
            (
                (subtype==ADAPTER_SUBTYPE_PRESTO) ?
                    KNOSSOS1_NUM_TX_MAC_BUFFERS : 0
            ));


        for (i=0; i<KNOSSOS_MAX_PRIORITY_QUEUES; i++)
        {
            POKEW_CFG(PO_BRIGHT_CYAN, " ", base);

            SSI_FRAG_WRITEW(
                udids_ptr,
                dest_frag_handle,
                KNOSSOS_SHARED_OFFSET(first_tx_queue_buf_ptr) + i*2,
                base);

            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_tx_buffer_ptr[i] =
                base;

            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_tx_buffer_ptr[i] =
                base;

            base += KNOSSOS_TX_BUFFER_SIZE;
        }


        free_queue_entries =
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr),tx_slots)
                * KNOSSOS12_MAX_BUFFERS_PER_TX;
    }
    else
    {

        for (i=0; i<KNOSSOS_MAX_PRIORITY_QUEUES; i++)
        {
            KNOSSOS_TX_ADAPTER_NEXT_PENDING_POINTER[i] =
                KNOSSOS_TX_ADAPTER_NEXT_UNUSED_POINTER[i] =
                    0x1E00 + 0x20*i;
        }


        base = KNOSSOS_TX_POOL_HEADER_LENGTH + KNOSSOS3_TX_MAC_BUFFER_AREA;

        free_queue_entries =
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr),tx_slots)
                * KNOSSOS3_MAX_BUFFERS_PER_TX;
    }


    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool = base;

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool_entries =
        free_queue_entries;

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
        max_free_tx_buffer_pool_entries =
            free_queue_entries;

    for (i=0; i<free_queue_entries; i++)
    {
        SSI_FRAG_WRITEW(
            udids_ptr,
            tx_frag_handle,
            base + UDT_OFFSET(KNOSSOS_TX_BUFFER_T,normal.next),
            BYTE_SWAP(base + KNOSSOS_TX_BUFFER_SIZE));

        base += KNOSSOS_TX_BUFFER_SIZE;
    }



    POKE_CFG(PO_MAGENTA, "RxInit");


    for (i=0;
         i<GET_STATIC_VALUE(
               STATIC_FROM_UDIDS(udids_ptr),
               frag_length[KNOSSOS_FF0C_FRAGMENT_INDEX]);
         i++)
    {
        SSI_FRAG_WRITEB(
            udids_ptr,
            rx_frag_handle,
            i,
            0);
    }


    base = (subtype==ADAPTER_SUBTYPE_PRESTO ||
            subtype==ADAPTER_SUBTYPE_CARDBUS2) ?
               KNOSSOS_TX_POOL_HEADER_LENGTH +
               KNOSSOS12_RX_MAC_BUFFER_SIZE * KNOSSOS12_NUM_RX_MAC_BUFFERS
               :
               KNOSSOS_TX_POOL_HEADER_LENGTH;



    if (!knossos_3)
    {
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
            next_adapter_to_host_mac_buffer =
                base;

        base += KNOSSOS12_RX_MAC_BUFFER_SIZE *
                    KNOSSOS12_NUM_ADAP_TO_HOST_MAC_BUFFERS;
    }
#   ifdef UDT_UDI_MODIFY_OPEN_OPTIONS
    else
    {
         
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
            next_adapter_to_host_mac_buffer =
                base;

        base += KNOSSOS3_RX_MAC_BUFFER_SIZE *
                    KNOSSOS3_NUM_ADAP_TO_HOST_MAC_BUFFERS;
    }
#   endif 


    original_base = base;

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).first_rx_buffer_ptr = base;


    rx_buffer_size = knossos_3 ?
                         KNOSSOS3_RX_BUFFER_SIZE :
                         KNOSSOS12_RX_BUFFER_SIZE;

    for (i = 0;
         i < GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr),rx_slots);
         i++)
    {
        POKEW_CFG(PO_BRIGHT_WHITE, " ", base);

        SSI_FRAG_WRITEW(
            udids_ptr,
            rx_frag_handle,
            base + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,normal.next),
            BYTE_SWAP(
                (i==GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr),rx_slots
                        - 1))?
                    (original_base + 0x0004) :
                    (base + rx_buffer_size + 0x0004)));

        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).last_rx_buffer_ptr = base;

        base += rx_buffer_size;
    }



    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(num_mac_rx_buffers),
            (
                (subtype==ADAPTER_SUBTYPE_PRESTO ||
                 subtype==ADAPTER_SUBTYPE_CARDBUS2) ?
                    KNOSSOS12_NUM_RX_MAC_BUFFERS : 0
            )
        );


    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(num_adapter_to_host_mac_rx_buffers),
        knossos_3 ? KNOSSOS3_NUM_ADAP_TO_HOST_MAC_BUFFERS : 
                        KNOSSOS12_NUM_ADAP_TO_HOST_MAC_BUFFERS
        );



#   ifdef UDT_KNOSSOS_DEBUG_ADAPTER_CODE

#   ifdef USE_OLD_K2_IMAGE
    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(signature),
        'K'*256 + '2'
        );
#   else
    SSI_FRAG_WRITEW(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(signature),
        'K'*256 + '3'
        );
#   endif


    SSI_FRAG_WRITED(
        udids_ptr,
        dest_frag_handle,
        KNOSSOS_SHARED_OFFSET(res_tx_info_pointer),
        (DWORD_T)&(KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).free_tx_buffer_pool)
        );

#   endif 

    POKEW_CFG(PO_BRIGHT_MAGENTA, "",
                  SSI_FRAG_READW(
                  udids_ptr,
                  dest_frag_handle,
                  UDT_OFFSET(KNOSSOS_LOADER_HEADER_T, stage)));

    STATS_FROM_UDIDS(udids_ptr).command_queue_in_use = 1;

    STATS_FROM_UDIDS(udids_ptr).command_queue_free = 1;

    STATS_FROM_UDIDS(udids_ptr).command_queue_next = 0;

    STATS_FROM_UDIDS(udids_ptr).command_pending = TRUE;

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).command = KNOSSOS_CMND_INITIALISE;

    STATS_FROM_UDIDS(udids_ptr).command_queue[0].completion = NULL;


    UDI_SET_GROUP_ADDRESS(
        udids_ptr,
        0,
        &STATS_FROM_UDIDS(udids_ptr).group_address[0],
        NULL,  
        NULL);

    UDI_SET_FUNCTIONAL_ADDRESS(
        udids_ptr,
        &STATS_FROM_UDIDS(udids_ptr).functional_address,
        NULL,  
        NULL);

    UDI_SET_PROMISCUOUS_MODE(
        udids_ptr,
        STATS_FROM_UDIDS(udids_ptr).promiscuous_level,
        NULL,  
        NULL);


    SET_ADAPTER_CTRL_WORD_BITS(udids_ptr, ADAPTER_CTRL_WORD_PROC_RESET);

    OUTW(
        udids_ptr,
        0,
        KNOSSOS_FUNCTION_MASK_REGISTER,
        0x8000);



    return rc;
}



RETCODE_T UDT_INDIRECT 
knossos_register_udti(
    IN    P_UDI_DATA_T            udids_ptr,
          UPCALL_TX_COMPLETE_T    tx_complete,
    IN    UPCALL_PRE_RX_T         early_rx,
    IN    UPCALL_RX_T             receive,
    IN    P_FRAME_T               receive_list)
{
    RETCODE_T   ret_code = SUCCESS;
    
    POKE_CFG(COLOUR_FN, "[register_udti");
        
     
    if(UDI_STATE(udids_ptr) != CONFIGURED)
    {
         
        RETURN(udids_ptr, WRONG_STATE);
    }
    
     
    UPCALL_TX_COMPLETE_FUNC(udids_ptr) = tx_complete;
    
    UPCALL_PRE_RX_FUNC(udids_ptr)      = early_rx;

    UPCALL_RX_FUNC(udids_ptr)          = receive;



    POKE_CFG(COLOUR_ACTION, "InitRx");

    knossos_set_up_rx(udids_ptr, receive_list);


    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).discarding_frame = FALSE;



    POKE_CFG(COLOUR_ACTION, "InitTx");



#   ifdef UDT_KNOSSOS3_PH_COMPLETIONS

    if (KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).knossos_3)
    {
        POKE_CFG(COLOUR_ACTION, "K3");
                
        if (GET_CONFIG_VALUE(
                CONFIG_FROM_UDIDS(udids_ptr),
                tx_completion_status_required))
        {
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).first_tx_buffer_status =
                KNOSSOS_TX_STATUS_BUSY;
                
            POKE_CFG(COLOUR_ACTION, "PH");
        }
        else
        {
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).first_tx_buffer_status =
                KNOSSOS_TX_STATUS_BUSY +
                KNOSSOS_TX_NO_PH_COMPLETION;
                
            POKE_CFG(COLOUR_ACTION, "NoPH");
        }
    }
    else
    
#   endif 

    {
        KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).first_tx_buffer_status =
            KNOSSOS_TX_STATUS_BUSY +
            KNOSSOS_TX_NO_PH_COMPLETION;
    }




    UDI_STATE(udids_ptr) = READY;

    POKE_CFG(COLOUR_FN, "]");

    return ret_code;
}



STATIC VOID_T
knossos_set_up_rx(
    IN    P_UDI_DATA_T            udids_ptr,
    IN    P_FRAME_T               receive_list)
{
    WORD_T base;
    UINT_T i;


    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).used_rx_buffer_count = 0;

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).rx_frame_list = NULL;


#   ifdef ONE_RX_POOL_POSSIBLE

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
        next_free_host_to_adapter_mac_buffer =
            KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).
                first_host_to_adapter_mac_buffer =

#   endif 


    base = KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).first_rx_buffer_ptr;

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_rx_buffer_ptr = base;

    KNOSSOS_RES_INFO_FROM_UDIDS(udids_ptr).next_uninitialised_rx_buffer_ptr =
        base;


    for (i = 0;
         i < GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr),rx_slots);
         i++)
    {
        POKEW_CFG(PO_BRIGHT_WHITE, " ", base);

        SSI_FRAG_WRITEW(
            udids_ptr,
            GET_CONFIG_VALUE(
                         CONFIG_FROM_UDIDS(udids_ptr),
                         frag_handle[KNOSSOS_FF0C_FRAGMENT_INDEX]),
            base + UDT_OFFSET(KNOSSOS_RX_BUFFER_T,normal.status),
            KNOSSOS_RX_STATUS_BUSY);

        base += KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).knossos_3 ?
                    KNOSSOS3_RX_BUFFER_SIZE:
                    KNOSSOS12_RX_BUFFER_SIZE;
    }


#   ifdef KNOS3_UDI

    if (KNOSSOS_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).knossos_3)
    {
        KNOSSOS_PIO_WRITE_WORD(
                (DWORD_T) (KNOSSOS_FF1F_SEG | KNOSSOS_RX_FRAME_MAXLEN),
                (WORD_T)
                    (
                        GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr),
                            requested_max_frame_size)
                        + 256
                    )
                );
    }

#   endif 

    UDTI_PROVIDE_RX_DESCRIPTORS(udids_ptr, receive_list);

    return;
}


#endif 


BUILD_MODULE_END_FUNCTION(knossosi_end)

#endif

