/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
* **   **  *****   *****  ******   *****   *****     **   **
* *** *** **   ** **   **  **  ** **   ** **   **    **   **
* ******* **   ** **       **  ** **   ** **         **   **
* ** * ** ******* **       *****  **   **  *****     *******
* **   ** **   ** **       **  ** **   **      **    **   **
* **   ** **   ** **   **  **  ** **   ** **   **    **   **
* **   ** **   **  *****  ***  **  *****   *****  ** **   **
*
*****************************************************************************
*
* Declaration of the following miscellaneious macros for UDT use:
*
*     - SET_STATIC_VALUE
*     - SET_STATIC_STATUS
*     - SET_CONFIG_STATUS
*     - SET_CONFIG_STATUS_IN_ERROR
*     - UPDATE_STATIC_MASK
*
*     - UPCALL_FN_FROM_UDIDS
*     - UPCALL_FROM_UDIDS
*     - ADAPTER_INFO_FROM_UDIDS
*     - ADAPTER_RES_INFO_FROM_UDIDS
*     - ADAPTER_PERSISTENT_RES_INFO_FROM_UDIDS
*     - ADAPTER_INIT_INFO_FROM_UDIDS
*     - GENERAL_RES_INFO_FROM_UDIDS
*
*     - UDI_STATE
*
*     - INB
*     - INW
*     - IND
*     - OUTB
*     - OUTW
*     - OUTD
*
*     - PROBE_INB
*     - PROBE_INW
*     - PROBE_OUTB
*     - PROBE_OUTW
*     - PROBE_SET_REG_BIT
*     - PROBE_CLEAR_REG_BIT
*
*     - PROBE_READB
*
*     - IO_TO_FRAG
*     - FRAG_TO_IO
*
*     - SET_REG_BIT
*     - CLEAR_REG_BIT
*     - SET_WORD_REG_BIT
*     - CLEAR_WORD_REG_BIT
*
*     - READB
*     - INIT_READB
*     - READW
*     - INIT_READW
*     - READD
*     - INIT_READD
*
*     - WRITEB
*     - WRITEW
*     - WRITED
*
*     - READ_SHARED_TO_FRAG
*     - WRITE_FRAG_TO_SHARED
*
*     - PCI_NUMBER
*     - PCI_BUS_NUMBER
*     - PCI_DEVICE_NUMBER
*     - PCI_FUNCTION_NUMBER
*     - PCI_READB
*     - PCI_READW
*     - PCI_READD
*     - PCI_WRITEB
*     - PCI_WRITEW
*     - PCI_WRITED
*
*     - SET_CONFIG_ON_MASK
*     - SET_CONFIG_ON_RANGE
*     - SET_CONFIG_ON_RAM_MASK
*     - SET_CONFIG_ON_VALUE
*     - SET_CONFIG_FOR_DRIVER
*
*     - ADD_TO_COUNTER
*
*     - MAKE_LOHI_WORD
*
*     - SET_CONFIG_VALUE
*     - GET_STATIC_VALUE
*     - GET_STATIC_STATUS
*     - GET_CONFIG_VALUE
*     - GET_CONFIG_STATUS
*
*     - IS_CONFIG_IN_ERROR
*
*     - MASK
*
*     - DDS_FROM_UPIDS
*     - UPI_FROM_UPIDS
*     - INIT_UDIDS_FROM_UDIDS
*     - RES_UDIDS_FROM_UDIDS
*     - INIT_FNS_FROM_UDIDS
*     - RES_FNS_FROM_UDIDS
*     - DDS_FROM_UDIDS
*     - UDI_INIT_FROM_UDIDS
*     - UDI_RES_FROM_UDIDS
*     - UDTI_FROM_UDIDS
*     - COMMON_RES_FROM_UDIDS
*     - ADAPTER_INIT_FROM_UDIDS
*     - ADAPTER_RES_FROM_UDIDS
*     - STATIC_FROM_UDIDS
*     - CONFIG_FROM_UDIDS
*     - UDTI_INFO_FROM_UDIDS
*     - STATS_FROM_UDIDS
*
*     - VERSION_FROM_STATS
*
*     - BYTE_SWAP
*
*     - UDT_OFFSET
*
*     - UDT_MEMSET
*
*****************************************************************************
*
* Copyright (C) 1996-98 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/






#define SET_STATIC_VALUE(_p, _field, _value)                                \
        (                                                                   \
            ((_p)->static_value)._field  = (_value),                        \
            ((_p)->static_status)._field = STATUS_SET                       \
        )



#define SET_STATIC_STATUS(_p, _field, _status)                              \
            (((_p)->static_status)._field = _status)



#define SET_CONFIG_STATUS(_p, _field, _status)                              \
            (((_p)->config_status)._field = _status)



#define SET_CONFIG_STATUS_IN_ERROR(_p, _field)                              \
            (((_p)->config_status)._field |= STATUS_IN_ERROR)




#define UPDATE_STATIC_MASK(_p, _field, _mask)                               \
        ((GET_STATIC_STATUS(_p, _field) == STATUS_UNKNOWN) ?                \
             SET_STATIC_VALUE(                                              \
                 _p,                                                        \
                 _field,                                                    \
                 _mask) :                                                   \
             SET_STATIC_VALUE(                                              \
                 _p,                                                        \
                 _field,                                                    \
                 GET_STATIC_VALUE(_p, _field) | (_mask)))



#define UPCALL_FN_FROM_UDIDS(_p) (RES_FNS_FROM_UDIDS(_p)->upcall_fns)



#define UPCALL_FROM_UDIDS(_p) (RES_UDIDS_FROM_UDIDS(_p)->upcall)



#define ADAPTER_INFO_FROM_UDIDS(_p)                                         \
        (RES_UDIDS_FROM_UDIDS(_p)->aparams)



#define ADAPTER_RES_INFO_FROM_UDIDS(_p)                                     \
        (RES_UDIDS_FROM_UDIDS(_p)->adapter_res_info)



#define ADAPTER_PERSISTENT_RES_INFO_FROM_UDIDS(_p)                          \
        (RES_UDIDS_FROM_UDIDS(_p)->adapter_persistent_res_info)



#define ADAPTER_INIT_INFO_FROM_UDIDS(_p)                                    \
        (INIT_UDIDS_FROM_UDIDS(_p)->adapter_init_info)



#define GENERAL_RES_INFO_FROM_UDIDS(_p)                                      \
        (RES_UDIDS_FROM_UDIDS(_p)->res_data)



#define UDI_STATE(_p) (STATS_FROM_UDIDS(_p).udi_state)





#define INB(_p, _index, _offset)                                            \
        SSI_IO_READB(                                                       \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), io_handle[_index]),     \
            (_offset))



#define INW(_p, _index, _offset)                                            \
        SSI_IO_READW(                                                       \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), io_handle[_index]),     \
            (_offset))



#define IND(_p, _index, _offset)                                            \
        SSI_IO_READD(                                                       \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), io_handle[_index]),     \
            (_offset))



#define OUTB(_p, _index, _offset, _value)                                   \
        SSI_IO_WRITEB(                                                      \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), io_handle[_index]),     \
            (_offset),                                                      \
            (_value))


#define OUTW(_p, _index, _offset, _value)                                   \
        SSI_IO_WRITEW(                                                      \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), io_handle[_index]),     \
            (_offset),                                                      \
            (_value))


#define OUTD(_p, _index, _offset, _value)                                   \
        SSI_IO_WRITED(                                                      \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), io_handle[_index]),     \
            (_offset),                                                      \
            (_value))


#define PROBE_INB(_p, _offset)                                              \
        PSSI_IO_READB(                                                      \
            (_p),                                                           \
            (_p)->io_handle,                                                \
            (_offset))



#define PROBE_INW(_p, _offset)                                              \
        PSSI_IO_READW(                                                      \
            (_p),                                                           \
            (_p)->io_handle,                                                \
            (_offset))


#define PROBE_OUTB(_p, _offset, _value)                                     \
        PSSI_IO_WRITEB(                                                     \
            (_p),                                                           \
            (_p)->io_handle,                                                \
            (_offset),                                                      \
            (_value))



#define PROBE_OUTW(_p, _offset, _value)                                     \
        PSSI_IO_WRITEW(                                                     \
            (_p),                                                           \
            (_p)->io_handle,                                                \
            (_offset),                                                      \
            (_value))



#define PROBE_SET_REG_BIT(_p, _offset, _value)                              \
        PROBE_OUTB(                                                         \
            (_p),                                                           \
            (_offset),                                                      \
            ((BYTE_T)(PROBE_INB((_p), (_offset)) |                          \
             (BYTE_T)(_value))))



#define PROBE_CLEAR_REG_BIT(_p, _offset, _value)                            \
        PROBE_OUTB(                                                         \
            (_p),                                                           \
            (_offset),                                                      \
            ((BYTE_T)(PROBE_INB((_p), (_offset)) &                          \
             (BYTE_T)(~(_value)))))




#define PROBE_READB(_p, _offset)                                            \
        PSSI_SHARED_READB(                                                  \
            (_p),                                                           \
            (_p)->shared_handle,                                            \
            (_offset))




#define IO_TO_FRAG(                                                         \
                _xfer_method,                                               \
                _dds_ptr,                                                   \
                _frag_handle,                                               \
                _frag_offset,                                               \
                _io_handle,                                                 \
                _io_offset,                                                 \
                _byte_count)                                                \
                                                                            \
        (((_xfer_method) == PIO_32BIT) ?                                    \
                                                                            \
        (SSI_IO_TO_FRAG_32BIT(                                              \
                (_dds_ptr),                                                 \
                (_frag_handle),                                             \
                (_frag_offset),                                             \
                (_io_handle),                                               \
                (_io_offset),                                               \
                (_byte_count))) :                                           \
                                                                            \
        (SSI_IO_TO_FRAG_16BIT(                                              \
                (_dds_ptr),                                                 \
                (_frag_handle),                                             \
                (_frag_offset),                                             \
                (_io_handle),                                               \
                (_io_offset),                                               \
                (_byte_count))))



#define FRAG_TO_IO(                                                         \
                _xfer_method,                                               \
                _dds_ptr,                                                   \
                _io_handle,                                                 \
                _io_offset,                                                 \
                _frag_handle,                                               \
                _frag_offset,                                               \
                _byte_count)                                                \
                                                                            \
        (((_xfer_method) == PIO_32BIT) ?                                    \
                                                                            \
        (SSI_FRAG_TO_IO_32BIT(                                              \
                (_dds_ptr),                                                 \
                (_io_handle),                                               \
                (_io_offset),                                               \
                (_frag_handle),                                             \
                (_frag_offset),                                             \
                (_byte_count))) :                                           \
                                                                            \
        (SSI_FRAG_TO_IO_16BIT(                                              \
                (_dds_ptr),                                                 \
                (_io_handle),                                               \
                (_io_offset),                                               \
                (_frag_handle),                                             \
                (_frag_offset),                                             \
                (_byte_count))))


#define SET_REG_BIT(_p, _index, _offset, _mask)                             \
        OUTB(                                                               \
            (_p),                                                           \
            (_index),                                                       \
            (_offset),                                                      \
            ((BYTE_T)(INB((_p), (_index), (_offset)) | (BYTE_T)(_mask))))



#define CLEAR_REG_BIT(_p, _index, _offset, _mask)                           \
        OUTB(                                                               \
            (_p),                                                           \
            (_index),                                                       \
            (_offset),                                                      \
            ((BYTE_T)(INB((_p), (_index), (_offset)) & (BYTE_T)(~(_mask)))))



#define SET_WORD_REG_BIT(_p, _index, _offset, _mask)                        \
        OUTW(                                                               \
            (_p),                                                           \
            (_index),                                                       \
            (_offset),                                                      \
            ((WORD_T)(INW((_p), (_index), (_offset)) | (WORD_T)(_mask))))



#define CLEAR_WORD_REG_BIT(_p, _index, _offset, _mask)                      \
        OUTW(                                                               \
            (_p),                                                           \
            (_index),                                                       \
            (_offset),                                                      \
            ((WORD_T)(INW((_p), (_index), (_offset)) & (WORD_T)(~(_mask)))))





#define READB(_p, _index, _offset)                                          \
        SSI_SHARED_READB(                                                   \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), shared_handle[_index]), \
            (_offset))


#define INIT_READB(_p, _index, _offset)                                     \
        SSI_INIT_SHARED_READB(                                              \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p),                         \
               init_shared_handle[_index]),                                 \
               (_offset))




#define READW(_p, _index, _offset)                                          \
        SSI_SHARED_READW(                                                   \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), shared_handle[_index]), \
            (_offset))


#define INIT_READW(_p, _index, _offset)                                     \
        SSI_SHARED_READW(                                                   \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p),                         \
               init_shared_handle[_index]),                                 \
               (_offset))



#define READD(_p, _index, _offset)                                          \
        SSI_SHARED_READD(                                                   \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), shared_handle[_index]), \
            (_offset))


#define INIT_READD(_p, _index, _offset)                                     \
        SSI_SHARED_READD(                                                   \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p),                         \
               init_shared_handle[_index]),                                 \
               (_offset))




#define WRITEB(_p, _index, _offset, _value)                                 \
        SSI_SHARED_WRITEB(                                                  \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), shared_handle[_index]), \
            (_offset),                                                      \
            (_value))



#define WRITEW(_p, _index, _offset, _value)                                 \
        SSI_SHARED_WRITEW(                                                  \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), shared_handle[_index]), \
            (_offset),                                                      \
            (_value))



#define WRITED(_p, _index,_offset, _value)                                  \
        SSI_SHARED_WRITED(                                                  \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), shared_handle[_index]), \
            (_offset),                                                      \
            (_value))



#define READ_SHARED_TO_FRAG(_p, _shared_index, _shared_offset,              \
                            _frag_handle, _frag_offset, _length)            \
        SSI_SHARED_TO_FRAG(                                                 \
            (_p),                                                           \
            (_frag_handle),                                                 \
            (_frag_offset),                                                 \
            GET_CONFIG_VALUE(                                               \
                CONFIG_FROM_UDIDS(_p),                                      \
                shared_handle[(_shared_index)]),                            \
            (_shared_offset),                                               \
            (_length))



#define WRITE_FRAG_TO_SHARED(_p, _shared_index, _shared_offset,             \
                             _frag_handle, _frag_offset, _length)           \
        SSI_FRAG_TO_SHARED(                                                 \
            (_p),                                                           \
            GET_CONFIG_VALUE(                                               \
                CONFIG_FROM_UDIDS(_p),                                      \
                shared_handle[(_shared_index)]),                            \
            (_shared_offset),                                               \
            (_frag_handle),                                                 \
            (_frag_offset),                                                 \
            (_length))





#define PCI_NUMBER(_bus, _dev, _func)                                       \
        (WORD_T)((((WORD_T)(_bus)  & 0x00FF) << 8) |                        \
                 (((WORD_T)(_dev)  & 0x001F) << 3) |                        \
                 (((WORD_T)(_func) & 0x0007)))



#define PCI_BUS_NUMBER(_number)                                             \
        (((_number) >> 8) & 0x00FF)



#define PCI_DEVICE_NUMBER(_number) (((_number) >> 3) & 0x001F)



#define PCI_FUNCTION_NUMBER(_number) (((_number)) & 0x0007)



#define PCI_READB(_p, _offset)                                              \
        SSI_PCI_READB(                                                      \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), pci_handle),            \
            (_offset))



#define PCI_READW(_p, _offset)                                              \
        SSI_PCI_READW(                                                      \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), pci_handle),            \
            (_offset))



#define PCI_READD(_p, _offset)                                              \
        SSI_PCI_READD(                                                      \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), pci_handle),            \
            (_offset))



#define PCI_WRITEB(_p, _offset, _value)                                     \
        SSI_PCI_WRITEB(                                                     \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), pci_handle),            \
            _offset,                                                        \
            (_value))



#define PCI_WRITEW(_p, _offset, _value)                                     \
        SSI_PCI_WRITEW(                                                     \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), pci_handle),            \
            _offset,                                                        \
            (_value))



#define PCI_WRITED(_p, _offset, _value)                                     \
        SSI_PCI_WRITED(                                                     \
            (_p),                                                           \
            GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), pci_handle),            \
            _offset,                                                        \
            (_value))





#define SET_CONFIG_ON_MASK(_p, _cparams, _field, _mask, _err_str)           \
        if(GET_CONFIG_STATUS(_cparams, _field) == STATUS_SET &&             \
           GET_STATIC_STATUS(STATIC_FROM_UDIDS(_p), _mask) == STATUS_SET)   \
        {                                                                   \
                                                                         \
                                                                            \
            if(GET_CONFIG_STATUS(                                           \
                   CONFIG_FROM_UDIDS(_p),                                   \
                   _field) == STATUS_SET)                                   \
            {                                                               \
                if(GET_CONFIG_VALUE(_cparams, _field) !=                    \
                   GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), _field))         \
                {                                                           \
                    SET_CONFIG_STATUS_IN_ERROR(_cparams, _field);           \
                    POKE(                                                   \
                        _p,                                                 \
                        PO_CHAN_CONFIG,                                     \
                        PO_LEV_ERROR,                                       \
                        PO_RED,                                             \
                        _err_str);                                          \
                    RETURN(_p, BAD_CONFIG_PARAMETER);                       \
                }                                                           \
            }                                                               \
            else                                                            \
            {                                                               \
                                                                         \
                                                                            \
                if(GET_STATIC_VALUE(STATIC_FROM_UDIDS(_p), _mask) &         \
                   MASK(GET_CONFIG_VALUE(_cparams, _field)))                \
                {                                                           \
                    SET_CONFIG_VALUE(                                       \
                        CONFIG_FROM_UDIDS(_p),                              \
                        _field,                                             \
                        GET_CONFIG_VALUE(_cparams, _field));                \
                }                                                           \
                else                                                        \
                {                                                           \
                    SET_CONFIG_STATUS_IN_ERROR(_cparams, _field);           \
                    POKE(                                                   \
                        _p,                                                 \
                        PO_CHAN_CONFIG,                                     \
                        PO_LEV_ERROR,                                       \
                        PO_RED,                                             \
                        _err_str);                                          \
                    RETURN(_p, BAD_CONFIG_PARAMETER);                       \
                }                                                           \
            }                                                               \
        }





#define SET_CONFIG_ON_RANGE(_p, _cparams, _field, _min, _max, _err_str)     \
        if(GET_CONFIG_STATUS(_cparams, _field) == STATUS_SET &&             \
           GET_STATIC_STATUS(STATIC_FROM_UDIDS(_p), _min) == STATUS_SET &&  \
           GET_STATIC_STATUS(STATIC_FROM_UDIDS(_p), _max) == STATUS_SET)    \
        {                                                                   \
                                                                         \
                                                                            \
            if(GET_CONFIG_STATUS(                                           \
                   CONFIG_FROM_UDIDS(_p),                                   \
                   _field) == STATUS_SET)                                   \
            {                                                               \
                if(GET_CONFIG_VALUE(_cparams, _field) !=                    \
                   GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), _field))         \
                {                                                           \
                    SET_CONFIG_STATUS_IN_ERROR(_cparams, _field);           \
                    POKE(                                                   \
                        _p,                                                 \
                        PO_CHAN_CONFIG,                                     \
                        PO_LEV_ERROR,                                       \
                        PO_RED,                                             \
                        _err_str);                                          \
                    RETURN(_p, BAD_CONFIG_PARAMETER);                       \
                }                                                           \
            }                                                               \
            else                                                            \
            {                                                               \
                                                                         \
                                                                            \
                if(GET_STATIC_VALUE(STATIC_FROM_UDIDS(_p), _min) <=         \
                       GET_CONFIG_VALUE(_cparams, _field) &&                \
                   GET_STATIC_VALUE(STATIC_FROM_UDIDS(_p), _max) >=         \
                       GET_CONFIG_VALUE(_cparams, _field))                  \
                {                                                           \
                    SET_CONFIG_VALUE(                                       \
                        CONFIG_FROM_UDIDS(_p),                              \
                        _field,                                             \
                        GET_CONFIG_VALUE(_cparams, _field));                \
                }                                                           \
                else                                                        \
                {                                                           \
                    SET_CONFIG_STATUS_IN_ERROR(_cparams, _field);           \
                    POKE(                                                   \
                        _p,                                                 \
                        PO_CHAN_CONFIG,                                     \
                        PO_LEV_ERROR,                                       \
                        PO_RED,                                             \
                        _err_str);                                          \
                    RETURN(_p, BAD_CONFIG_PARAMETER);                       \
                }                                                           \
            }                                                               \
        }




#define RAM_LOC_MASK(_p, _ram_loc)                                          \
        (SSI_DWORD_SHIFT_L(                                                 \
             (_p),                                                          \
             1,                                                             \
             (UINT_T)(SSI_DWORD_SHIFT_R((_p), (_ram_loc - 0xb0000uL), 13))))

#define SET_CONFIG_ON_RAM_MASK(_p, _cparams, _field, _mask, _err_str)       \
        if(GET_CONFIG_STATUS(_cparams, _field) == STATUS_SET &&             \
           GET_STATIC_STATUS(STATIC_FROM_UDIDS(_p), _mask) == STATUS_SET)   \
        {                                                                   \
                                                                         \
                                                                            \
            if(GET_CONFIG_STATUS(                                           \
                   CONFIG_FROM_UDIDS(_p),                                   \
                   _field) == STATUS_SET)                                   \
            {                                                               \
                if(GET_CONFIG_VALUE(_cparams, _field) !=                    \
                   GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), _field))         \
                {                                                           \
                    SET_CONFIG_STATUS_IN_ERROR(_cparams, _field);           \
                    POKE(                                                   \
                        _p,                                                 \
                        PO_CHAN_CONFIG,                                     \
                        PO_LEV_ERROR,                                       \
                        PO_RED,                                             \
                        _err_str);                                          \
                    RETURN(_p, BAD_CONFIG_PARAMETER);                       \
                }                                                           \
            }                                                               \
            else                                                            \
            {                                                               \
                                                                         \
                                                                            \
                if(GET_STATIC_VALUE(STATIC_FROM_UDIDS(_p), _mask) &         \
                   RAM_LOC_MASK(_p, GET_CONFIG_VALUE(_cparams, _field)))    \
                {                                                           \
                    SET_CONFIG_VALUE(                                       \
                        CONFIG_FROM_UDIDS(_p),                              \
                        _field,                                             \
                        GET_CONFIG_VALUE(_cparams, _field));                \
                }                                                           \
                else                                                        \
                {                                                           \
                    SET_CONFIG_STATUS_IN_ERROR(_cparams, _field);           \
                    POKE(                                                   \
                        _p,                                                 \
                        PO_CHAN_CONFIG,                                     \
                        PO_LEV_ERROR,                                       \
                        PO_RED,                                             \
                        _err_str);                                          \
                    RETURN(_p, BAD_CONFIG_PARAMETER);                       \
                }                                                           \
            }                                                               \
        }




#define SET_CONFIG_ON_VALUE(_p, _cparams, _field, _trigger, _err_str)       \
        if(GET_CONFIG_STATUS(_cparams, _field) == STATUS_SET &&             \
           GET_STATIC_STATUS(STATIC_FROM_UDIDS(_p), _trigger) == STATUS_SET)\
        {                                                                   \
                                                                         \
                                                                            \
            if(GET_CONFIG_STATUS(                                           \
                   CONFIG_FROM_UDIDS(_p),                                   \
                   _field) == STATUS_SET)                                   \
            {                                                               \
                if(GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), _field) !=       \
                   GET_CONFIG_VALUE(_cparams, _field))                      \
                {                                                           \
                    SET_CONFIG_STATUS_IN_ERROR(_cparams, _field);           \
                    POKE(                                                   \
                        _p,                                                 \
                        PO_CHAN_CONFIG,                                     \
                        PO_LEV_ERROR,                                       \
                        PO_RED,                                             \
                        _err_str);                                          \
                    RETURN(_p, BAD_CONFIG_PARAMETER);                       \
                }                                                           \
            }                                                               \
            else                                                            \
            {                                                               \
                                                                         \
                                                                            \
                SET_CONFIG_VALUE(                                           \
                    CONFIG_FROM_UDIDS(_p),                                  \
                    _field,                                                 \
                    GET_CONFIG_VALUE(_cparams, _field));                    \
            }                                                               \
        }




#define SET_CONFIG_FOR_DRIVER(_p, _cparams, _field, _err_str)               \
        if(GET_CONFIG_STATUS(_cparams, _field) == STATUS_SET)               \
        {                                                                   \
                                                                         \
                                                                            \
            if(GET_CONFIG_STATUS(                                           \
                   CONFIG_FROM_UDIDS(_p),                                   \
                   _field) == STATUS_SET)                                   \
            {                                                               \
                if(GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(_p), _field) !=       \
                   GET_CONFIG_VALUE(_cparams, _field))                      \
                {                                                           \
                    SET_CONFIG_STATUS_IN_ERROR(_cparams, _field);           \
                    POKE(                                                   \
                        _p,                                                 \
                        PO_CHAN_CONFIG,                                     \
                        PO_LEV_ERROR,                                       \
                        PO_RED,                                             \
                        _err_str);                                          \
                    RETURN(_p, BAD_CONFIG_PARAMETER);                       \
                }                                                           \
            }                                                               \
            else                                                            \
            {                                                               \
                                                                         \
                                                                            \
                SET_CONFIG_VALUE(                                           \
                    CONFIG_FROM_UDIDS(_p),                                  \
                    _field,                                                 \
                    GET_CONFIG_VALUE(_cparams, _field));                    \
            }                                                               \
        }




#ifdef UDT_MAINTAIN_COUNTERS

# define ADD_TO_COUNTER(_p, _counter, _n)                                   \
            STATS_FROM_UDIDS(_p).counters._counter += (_n)

#else

# define ADD_TO_COUNTER(_p, _counter, _n)

#endif



#ifdef UDT_CPU_IS_BIG_ENDIAN

#  define MAKE_LOHI_WORD(_b1, _b2) \
   ((WORD_T) (((WORD_T) (_b1) << 8) | ((WORD_T) (_b1))))

#else

#  define MAKE_LOHI_WORD(_b1, _b2) \
   ((WORD_T) (((WORD_T) (_b1)) | ((WORD_T) (_b2) << 8)))

#endif



#define SET_CONFIG_VALUE(_p, _field, _value)                                \
        while(                                                              \
            ((_p)->config_value)._field  = (_value),                        \
            ((_p)->config_status)._field = STATUS_SET,                      \
            0)



#define GET_STATIC_VALUE(_p, _field)                                        \
        (((_p)->static_value)._field)



#define GET_STATIC_STATUS(_p, _field)                                       \
        (((_p)->static_status)._field)



#define GET_CONFIG_VALUE(_p, _field)                                        \
        (((_p)->config_value)._field)



#define GET_CONFIG_STATUS(_p, _field)                                       \
        (((_p)->config_status)._field)



#define IS_CONFIG_IN_ERROR(_p, _field)                                      \
        (((_p)->config_status)._field & STATUS_IN_ERROR)



#define MASK(_value)                                                        \
        ( ( ((_value) > 15) ?                                               \
                    (0x0000) :                                              \
                    (0x0001 << (_value))))



#define DDS_FROM_UPIDS(_p) ((_p)->dds_ptr)



#define UPI_FROM_UPIDS(_p) ((_p)->upi)



#define INIT_UDIDS_FROM_UDIDS(_p) ((_p)->init)



#define RES_UDIDS_FROM_UDIDS(_p) ((UDI_RES_DATA_T FAR_DATA *)&((_p)->res))



#define INIT_FNS_FROM_UDIDS(_p) ((UDI_INIT_FUNCTION_PTRS_T FAR_INIT_DATA *)&(INIT_UDIDS_FROM_UDIDS(_p)->init_fns))



#define RES_FNS_FROM_UDIDS(_p) ((UDI_RES_FUNCTION_PTRS_T FAR_DATA *)&(RES_UDIDS_FROM_UDIDS(_p)->res_fns))



#define DDS_FROM_UDIDS(_p) (RES_UDIDS_FROM_UDIDS(_p)->dds_ptr)



#define UDI_INIT_FROM_UDIDS(_p) (INIT_FNS_FROM_UDIDS(_p)->udi_init)



#define UDI_RES_FROM_UDIDS(_p) (RES_FNS_FROM_UDIDS(_p)->udi_res)



#define UDTI_FROM_UDIDS(_p) (RES_FNS_FROM_UDIDS(_p)->udti)



#define COMMON_RES_FROM_UDIDS(_p) (RES_FNS_FROM_UDIDS(_p)->common_res)



#define ADAPTER_INIT_FROM_UDIDS(_p) (INIT_FNS_FROM_UDIDS(_p)->adapter_init)



#define ADAPTER_RES_FROM_UDIDS(_p) (RES_FNS_FROM_UDIDS(_p)->adapter_res)



#define STATIC_FROM_UDIDS(_p) ((STATIC_PARAMETERS_T FAR_INIT_DATA *)&(INIT_UDIDS_FROM_UDIDS(_p)->sparams))



#define CONFIG_FROM_UDIDS(_p) ((CONFIG_PARAMETERS_T FAR_DATA *)&(RES_UDIDS_FROM_UDIDS(_p)->cparams))



#define UDTI_INFO_FROM_UDIDS(_p) (RES_UDIDS_FROM_UDIDS(_p)->udti_info)



#define STATS_FROM_UDIDS(_p) (RES_UDIDS_FROM_UDIDS(_p)->stats)



#define VERSION_FROM_STATS(_p) ((_p)->version)



#define BYTE_SWAP(word) ( (WORD_T)( ( (word) << 8) | ( (word) >> 8) ) )



#define MIN_VALUE(_x, _y) ((_x) < (_y) ? (_x) : (_y))
#define MAX_VALUE(_x, _y) ((_x) > (_y) ? (_x) : (_y))





#define MAC_ADDRESSES_EQUAL(_a, _b)                                         \
         ((*((DWORD_T *) &(_a).byte[0]) == *((DWORD_T *) &(_b).byte[0])) && \
          (*((DWORD_T *) &(_a).byte[2]) == *((DWORD_T *) &(_b).byte[2])))






#define UDT_OFFSET(type , field) ((UINT_T)(&((type *)0)->field))




#define UDT_MEMSET(_ptr, _value, _len)          \
{                                               \
    UINT_T   length_left = (_len);              \
    P_BYTE_T memory_pointer = (P_BYTE_T)_ptr;   \
                                                \
    while (length_left--)                       \
    {                                           \
        *(memory_pointer++) = (_value);         \
    }                                           \
}



