/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/*****************************************************************************
*
* ******  ****  *****      *****
*  **  **  **  **   **    **   **
*  **  **  **  **   **    **
*  *****   **  **   **    **
*  **      **  **   **    **
*  **      **  **   **    **   **
* ****    ****  *****  **  *****
*
******************************************************************************
*
* PIO helper functions for Smart 16/4 adapters.
*
******************************************************************************
*
* Copyright (C) 1996-98 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
******************************************************************************
*/



#define UDI_MODULE

#include "udt_driver.h"

#ifdef SMART_UDI

#ifndef UDT_ONLY_GET_CARD_INFO



#ifdef UDT_USE_RX_LOOKAHEAD

STATIC VOID_T UDT_INDIRECT
pio_to_lookahead(
    INOUT P_UDI_DATA_T udids_ptr,
          WORD_T       slot,
          WORD_T       offset,
          IO_HANDLE_T  io_handle,
          UINT_T       io_offset,
          WORD_T       length);

#endif

STATIC VOID_T UDT_INDIRECT
pio_to_frame(
    INOUT P_UDI_DATA_T udids_ptr,
          WORD_T       slot,
          WORD_T       offset,
          IO_HANDLE_T  io_handle,
          UINT_T       io_offset,
          WORD_T       length);

#if defined(COMPAQ_ISA_UDI) || \
    defined(OLICOM_ISA_UDI) || \
    defined(OLICOM_EISA_UDI)

STATIC VOID_T UDT_INDIRECT
pio_to_frame_eight_bit(
    INOUT P_UDI_DATA_T udids_ptr,
          WORD_T       slot,
          WORD_T       offset,
          IO_HANDLE_T  io_handle,
          UINT_T       io_offset,
          WORD_T       length);

#endif

STATIC VOID_T UDT_INDIRECT
pio_from_frame(
    INOUT P_UDI_DATA_T udids_ptr,
          WORD_T       slot,
          WORD_T       offset,
          IO_HANDLE_T  io_handle,
          UINT_T       io_offset,
          WORD_T       length);

#if defined(COMPAQ_ISA_UDI) || \
    defined(OLICOM_ISA_UDI) || \
    defined(OLICOM_EISA_UDI)

STATIC VOID_T UDT_INDIRECT
pio_from_frame_eight_bit(
    INOUT P_UDI_DATA_T udids_ptr,
          WORD_T       slot,
          WORD_T       offset,
          IO_HANDLE_T  io_handle,
          UINT_T       io_offset,
          WORD_T       length);

#endif

DECLARE_MODULE_START_FUNCTION(pio_start)
DECLARE_MODULE_END_FUNCTION(pio_end)



RETCODE_T UDT_INTER_MODULE
pio_register(
    IN P_UDI_DATA_T udids_ptr)
{
    POKE(
        udids_ptr,
        PO_CHAN_CONFIG,
        PO_LEV_USER,PO_MAGENTA,
        "REGISTERING PIO");

    

    SSI_MODULE_REGISTERED(
        udids_ptr,
        pio_register,
        pio_start,
        pio_end,
        MOD_SCOPE_RUNTIME);

    

#ifdef UDT_USE_RX_LOOKAHEAD

    SMART_RES_FROM_UDIDS(udids_ptr).smart_pio_to_lookahead =
        pio_to_lookahead;

#endif

#   if defined(COMPAQ_ISA_UDI) || \
       defined(OLICOM_ISA_UDI) || \
       defined(OLICOM_EISA_UDI)

    if(SMART_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).
           eight_bit_psdma)
    {
        SMART_RES_FROM_UDIDS(udids_ptr).smart_pio_to_frame     =
            pio_to_frame_eight_bit;

        SMART_RES_FROM_UDIDS(udids_ptr).smart_pio_from_frame   =
            pio_from_frame_eight_bit;
    }
    else

#   endif

    {
        SMART_RES_FROM_UDIDS(udids_ptr).smart_pio_to_frame     =
            pio_to_frame;

        SMART_RES_FROM_UDIDS(udids_ptr).smart_pio_from_frame   =
            pio_from_frame;
    }

    

    return SUCCESS;
}

BUILD_MODULE_START_FUNCTION(pio_start)




#ifdef UDT_USE_RX_LOOKAHEAD

STATIC VOID_T UDT_INDIRECT
pio_to_lookahead(
    INOUT P_UDI_DATA_T udids_ptr,
          WORD_T       slot,
          WORD_T       offset,
          IO_HANDLE_T  io_handle,
          UINT_T       io_offset,
          WORD_T       length)
{
    P_FRAME_T          frame;
    UINT_T             copy_length;
    UINT_T             lookahead_offset;
    UINT_T             frag_index;
    UINT_T             frag_length;
    UINT_T             frag_offset;
    INT_T              rx_window_offset;
    WORD_T             rx_window_start;
    WORD_T             rx_window_stop;
    INT_T              rx_window_length;
    FRAG_HANDLE_T      pio_dump_handle   = GET_CONFIG_VALUE(
                                               CONFIG_FROM_UDIDS(udids_ptr),
                                               frag_handle[1]);
    XFER_METHOD_T      xfer_method       = GET_CONFIG_VALUE(
                                               CONFIG_FROM_UDIDS(udids_ptr),
                                               xfer_method);

    

    

    if(STATS_FROM_UDIDS(udids_ptr).lookahead_size < 2)
    {
        RX_INFO(udids_ptr, slot).rx_phase = RX_ABORTED;
    }

    

    else if(RX_INFO(udids_ptr, slot).rx_phase != RX_LOOKAHEAD ||
            offset > 0x0000)
    {
        RX_INFO(udids_ptr, slot).rx_phase = RX_ABORTED;
    }

    

    if(RX_INFO(udids_ptr, slot).rx_phase == RX_ABORTED)
    {
        

        if (IO_TO_FRAG(
                        xfer_method,
                        udids_ptr,
                        pio_dump_handle,
                        0,
                        io_handle,
                        io_offset,
                        length) > 0)
        {
            

            SSI_IO_READB(udids_ptr, io_handle, io_offset);
        }

        

        return;
    }

    

    

    frame = RX_INFO(udids_ptr, slot).frame;

    

    frame->lookahead_frag_length = length;

    POKEW(
        udids_ptr,
        PO_CHAN_ISR,
        PO_LEV_USER,PO_BLUE,
        "PIO: ",
        length);

    if (IO_TO_FRAG(
                xfer_method,
                udids_ptr,
                frame->lookahead_frag,
                0,
                io_handle,
                io_offset,
                length) > 0)
    {
        

        SSI_FRAG_WRITEB(
            udids_ptr,
            frame->lookahead_frag,
            length - 1,
            SSI_IO_READB(udids_ptr, io_handle, io_offset));
    }


    

    if((SSI_FRAG_READB(udids_ptr, frame->lookahead_frag, 1) & 0xC0) == 0x00)
    {
        

        POKE(
            udids_ptr,
            PO_CHAN_ISR,
            PO_LEV_USER,PO_MAGENTA,
            "MAC");

         if (!(SMART_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).
                    receive_mac_frames))
         {
            

             RX_INFO(udids_ptr, slot).rx_phase = RX_ABORTED;

             return;
         }
    }


    

    frame->rx_status = FRAME_INCOMPLETE;

    POKE(
        udids_ptr,
        PO_CHAN_RX,
        PO_LEV_USER,PO_BROWN,
        "PRE_RX...");

    if (UPCALL_PRE_RX(
            udids_ptr,
            frame,
            &rx_window_offset,
            &rx_window_length) == SUCCESS)
    {
        RX_INFO(udids_ptr, slot).rx_phase = RX_CONFIRMED;

        POKE(
            udids_ptr,
            PO_CHAN_RX,
            PO_LEV_USER,PO_BROWN,
            "done");

    }
    else
    {
        RX_INFO(udids_ptr, slot).rx_phase = RX_ABORTED;

        POKE(
            udids_ptr,
            PO_CHAN_RX,
            PO_LEV_USER,PO_BROWN,
            "rejected");

        return;
    }


    

    

    RX_INFO(udids_ptr, slot).rx_window_start = rx_window_offset;
    rx_window_start                          = rx_window_offset;

    

    RX_INFO(udids_ptr, slot).rx_window_stop =
        RX_INFO(udids_ptr, slot).rx_window_start +
        ((rx_window_length == REMAINING_FRAME) ?
             (STATS_FROM_UDIDS(udids_ptr).open_info).max_frame_size :
             rx_window_length);

    rx_window_stop = RX_INFO(udids_ptr, slot).rx_window_stop;


    

    if(rx_window_start < length)
    {
        if(rx_window_stop < length)
        {
            copy_length = rx_window_stop - rx_window_start;
        }
        else
        {
            copy_length = length - rx_window_start;
        }

        

        RX_INFO(udids_ptr, slot).frame->data_length = copy_length;

        

        RX_INFO(udids_ptr, slot).cumulative_frag_length = 0;
        RX_INFO(udids_ptr, slot).last_frag_index        = 0;

        

        POKEW(
            udids_ptr,
            PO_CHAN_ISR,
            PO_LEV_USER,PO_GREEN,
            "COPY: ",
            copy_length);

        lookahead_offset  = rx_window_start;

        frag_index  = 0;
        frag_offset = 0;
        frag_length = SSI_FRAG_LENGTH(
                          udids_ptr,
                          frame->frag_array_ptr[frag_index]);

        while(copy_length > 0)
        {
            

            if(copy_length <= frag_length)
            {
                SSI_FRAG_TO_FRAG(
                    udids_ptr,
                    frame->frag_array_ptr[frag_index],
                    frag_offset,
                    frame->lookahead_frag,
                    lookahead_offset,
                    copy_length);

                copy_length = 0;
            }
            else
            {
                if(frag_length > 0)
                {
                    SSI_FRAG_TO_FRAG(
                        udids_ptr,
                        frame->frag_array_ptr[frag_index],
                        frag_offset,
                        frame->lookahead_frag,
                        lookahead_offset,
                        frag_length);

                    copy_length -= frag_length;

                    

                    lookahead_offset += frag_length;

                    

                    RX_INFO(udids_ptr, slot).cumulative_frag_length +=
                        frag_length;

                    frag_index++;

                    RX_INFO(udids_ptr, slot).last_frag_index = frag_index;

                    if(frag_index >= frame->frag_array_length)
                    {
                        POKEW(
                            udids_ptr,
                            PO_CHAN_ISR,
                            PO_LEV_USER,PO_RED,
                            "FRAG ARRAY FULL",
                            copy_length);

                        break;
                    }

                    frag_length = SSI_FRAG_LENGTH(
                                      udids_ptr,
                                      frame->frag_array_ptr[frag_index]);

                    frag_offset = 0;
                }
                else
                {
                    

                    frag_index++;

                    RX_INFO(udids_ptr, slot).last_frag_index = frag_index;

                    if(frag_index >= frame->frag_array_length)
                    {
                        POKEW(
                            udids_ptr,
                            PO_CHAN_ISR,
                            PO_LEV_USER,PO_RED,
                            "FRAG ARRAY FULL",
                            copy_length);

                        break;
                    }

                    frag_length = SSI_FRAG_LENGTH(
                                      udids_ptr,
                                      frame->frag_array_ptr[frag_index]);

                    frag_offset = 0;
                }
            }
        }
    }

    

    return;
}


#endif



#ifdef UDT_USE_RX_LOOKAHEAD

STATIC VOID_T UDT_INDIRECT
pio_to_frame(
    INOUT P_UDI_DATA_T udids_ptr,
          WORD_T       slot,
          WORD_T       offset,
          IO_HANDLE_T  io_handle,
          UINT_T       io_offset,
          WORD_T       length)
{
    P_FRAME_T          frame;
    UINT_T             frag_index;
    UINT_T             frag_length;
    UINT_T             frag_offset;
    UINT_T             rx_window_start;
    UINT_T             rx_window_stop;
    BOOLEAN_T          is_buffered_byte  = FALSE;
    BYTE_T             buffered_byte     = 0x00;
    UINT_T             xfer_length;
    FRAG_HANDLE_T      pio_dump_handle   = GET_CONFIG_VALUE(
                                               CONFIG_FROM_UDIDS(udids_ptr),
                                               frag_handle[1]);
    XFER_METHOD_T      xfer_method       = GET_CONFIG_VALUE(
                                               CONFIG_FROM_UDIDS(udids_ptr),
                                               xfer_method);

    

    if(length == 0x0000)
    {
        return;
    }

    

    if(RX_INFO(udids_ptr, slot).rx_phase == RX_ABORTED)
    {
        POKEW(
            udids_ptr,
            PO_CHAN_ISR,
            PO_LEV_USER,PO_RED,
            "RX_ABORTED: ",
            length);

        

        if (IO_TO_FRAG(
                       xfer_method,
                   udids_ptr,
                       pio_dump_handle,
                       0,
                       io_handle,
                       io_offset,
                       length) > 0)
        {
            

            SSI_IO_READB(udids_ptr, io_handle, io_offset);
        }

        

        return;
    }


    

    frame = RX_INFO(udids_ptr, slot).frame;

    

    rx_window_start = RX_INFO(udids_ptr, slot).rx_window_start;
    rx_window_stop  = RX_INFO(udids_ptr, slot).rx_window_stop;


    

    if(offset < rx_window_start)
    {
        if(offset + length <= rx_window_start)
        {
            

            POKEW(
                udids_ptr,
                PO_CHAN_ISR,
                PO_LEV_USER,PO_CYAN,
                "DISCARD: ",
                length);

            if (IO_TO_FRAG(
                           xfer_method,
                           udids_ptr,
                           pio_dump_handle,
                           0,
                           io_handle,
                           io_offset,
                           length) > 0)
            {
                

                SSI_IO_READB(udids_ptr, io_handle, io_offset);
            }

            

            return;
        }
        else
        {
            

            POKEW(
                udids_ptr,
                PO_CHAN_ISR,
                PO_LEV_USER,PO_CYAN,
                "DISCARD: ",
                rx_window_start - offset);

            if (IO_TO_FRAG(
                           xfer_method,
                           udids_ptr,
                           pio_dump_handle,
                           0,
                           io_handle,
                           io_offset,
                           rx_window_start - offset) > 0);
            {
                

                SSI_IO_TO_FRAG_16BIT(
                    udids_ptr,
                    pio_dump_handle,
                    0,
                    io_handle,
                    io_offset,
                    sizeof(WORD_T));

                

                POKE(
                    udids_ptr,
                    PO_CHAN_ISR,
                    PO_LEV_USER,PO_BROWN,
                    "B");

                is_buffered_byte = TRUE;
                buffered_byte    = SSI_FRAG_READB(
                                       udids_ptr,
                                       pio_dump_handle,
                                       1);
            }
        }

        

        length -= rx_window_start - offset;
        offset  = rx_window_start;
    }


    

    if(rx_window_start <= offset && offset < rx_window_stop)
    {
        

        frag_index = RX_INFO(udids_ptr, slot).last_frag_index;

        if(offset - rx_window_start <
           RX_INFO(udids_ptr, slot).cumulative_frag_length)
        {
            

            do
            {
                frag_index--;

                RX_INFO(udids_ptr, slot).cumulative_frag_length -=
                    SSI_FRAG_LENGTH(
                        udids_ptr,
                        frame->frag_array_ptr[frag_index]);

            } while(offset - rx_window_start <
                    RX_INFO(udids_ptr, slot).cumulative_frag_length);
        }
        else if(offset - rx_window_start >=
                RX_INFO(udids_ptr, slot).cumulative_frag_length +
                SSI_FRAG_LENGTH(
                    udids_ptr,
                    frame->frag_array_ptr[frag_index]))
        {
            

            do
            {
                RX_INFO(udids_ptr, slot).cumulative_frag_length +=
                    SSI_FRAG_LENGTH(
                        udids_ptr,
                        frame->frag_array_ptr[frag_index]);

                frag_index++;

                if(frag_index >= frame->frag_array_length)
                {
                    

                    POKE(
                        udids_ptr,
                        PO_CHAN_ISR,
                        PO_LEV_USER,PO_RED,
                        "cannot find start fragment");

                    if(IO_TO_FRAG(
                           xfer_method,
                           udids_ptr,
                           pio_dump_handle,
                           0,
                           io_handle,
                           io_offset,
                           length) > 0)
                    {
                        

                        SSI_IO_READB(udids_ptr, io_handle, io_offset);
                    }

                    

                    return;
                }

            } while(offset - rx_window_start >=
                    RX_INFO(udids_ptr, slot).cumulative_frag_length +
                    SSI_FRAG_LENGTH(
                        udids_ptr,
                        frame->frag_array_ptr[frag_index]));
        }

        

        if(offset + length < rx_window_stop)
        {
            

            xfer_length = length;
        }
        else
        {
            

            xfer_length = rx_window_stop - offset;
        }

        

        frag_offset =
            offset -
            rx_window_start -
            RX_INFO(udids_ptr, slot).cumulative_frag_length;

        frag_length =
            SSI_FRAG_LENGTH(
                udids_ptr,
                frame->frag_array_ptr[frag_index]);

        

        if(is_buffered_byte)
        {
            POKE(
                udids_ptr,
                PO_CHAN_ISR,
                PO_LEV_USER,
                PO_BROWN,
                "B");

            SSI_FRAG_WRITEB(
                udids_ptr,
                frame->frag_array_ptr[frag_index],
                frag_offset,
                buffered_byte);

            frag_offset++;

            

            RX_INFO(udids_ptr, slot).frame->data_length++;

            

            xfer_length--;
            length--;
        }

        

        POKEW(
            udids_ptr,
            PO_CHAN_ISR,
            PO_LEV_USER,PO_GREEN,
            "",
            xfer_length);

        while(xfer_length > 0)
        {
            if(frag_offset + xfer_length <= frag_length)
            {
                

                POKEW(
                    udids_ptr,
                    PO_CHAN_ISR,
                    PO_LEV_USER,PO_RED,
                    " ",
                    frag_length);

                POKEW(
                    udids_ptr,
                    PO_CHAN_ISR,
                    PO_LEV_USER,PO_RED,
                    ",",
                    frag_offset);

                POKEW(
                    udids_ptr,
                    PO_CHAN_ISR,
                    PO_LEV_USER,PO_RED,
                    " DONE: ",
                    xfer_length);

                

                RX_INFO(udids_ptr, slot).frame->data_length += xfer_length;

                if (IO_TO_FRAG(
                       xfer_method,
                       udids_ptr,
                       frame->frag_array_ptr[frag_index],
                       frag_offset,
                       io_handle,
                       io_offset,
                       xfer_length) > 0)
                {
                    

                    frag_offset += xfer_length - 1;

                    

                    length      -= xfer_length;
                    xfer_length  = 0;

                    

                    if(length > 0)
                    {
                        SSI_IO_TO_FRAG_16BIT(
                            udids_ptr,
                            pio_dump_handle,
                            0,
                            io_handle,
                            io_offset,
                            sizeof(WORD_T));

                        length--;

                        SSI_FRAG_WRITEB(
                            udids_ptr,
                            frame->frag_array_ptr[frag_index],
                            frag_offset,
                            SSI_FRAG_READB(
                                udids_ptr,
                                pio_dump_handle,
                                0));
                    }
                    else
                    {
                        SSI_FRAG_WRITEB(
                            udids_ptr,
                            frame->frag_array_ptr[frag_index],
                            frag_offset,
                            SSI_IO_READB(udids_ptr, io_handle, io_offset));

                        

                        return;
                    }
                }
                else
                {
                    

                    length      -= xfer_length;
                    xfer_length  = 0;
                }
            }
            else
            {
                

                POKEW(
                    udids_ptr,
                    PO_CHAN_ISR,
                    PO_LEV_USER,PO_WHITE,
                    " ",
                    frag_length);

                POKEW(
                    udids_ptr,
                    PO_CHAN_ISR,
                    PO_LEV_USER,PO_WHITE,
                    ",",
                    frag_offset);

                

                RX_INFO(udids_ptr, slot).frame->data_length +=
                    frag_length - frag_offset;

                if (IO_TO_FRAG(
                       xfer_method,
                       udids_ptr,
                       frame->frag_array_ptr[frag_index],
                       frag_offset,
                       io_handle,
                       io_offset,
                       frag_length - frag_offset) > 0)
                {
                    

                    xfer_length -= frag_length - frag_offset;
                    length      -= frag_length - frag_offset;

                    

                    SSI_IO_TO_FRAG_16BIT(
                        udids_ptr,
                        pio_dump_handle,
                        0,
                        io_handle,
                        io_offset,
                        sizeof(WORD_T));

                    frag_offset = frag_length - 1;

                    SSI_FRAG_WRITEB(
                        udids_ptr,
                        frame->frag_array_ptr[frag_index],
                        frag_offset,
                        SSI_FRAG_READB(
                            udids_ptr,
                            pio_dump_handle,
                            0));

                    

                    RX_INFO(udids_ptr, slot).cumulative_frag_length +=
                        frag_length;

                    frag_index++;

                    RX_INFO(udids_ptr, slot).last_frag_index = frag_index;

                    if(frag_index >= frame->frag_array_length)
                    {
                        

                        POKEW(
                            udids_ptr,
                            PO_CHAN_ISR,
                            PO_LEV_USER,PO_BROWN,
                            "FRAG ARRAY FULL",
                            length);

                        if(SSI_IO_TO_FRAG_16BIT(
                               udids_ptr,
                               pio_dump_handle,
                               0,
                               io_handle,
                               io_offset,
                               length) > 0)
                        {
                            

                            SSI_IO_READB(udids_ptr, io_handle, io_offset);
                        }

                        

                        return;
                    }

                    frag_length = SSI_FRAG_LENGTH(
                                      udids_ptr,
                                      frame->frag_array_ptr[frag_index]);

                    frag_offset = 0;

                    

                    SSI_FRAG_WRITEB(
                        udids_ptr,
                        frame->frag_array_ptr[frag_index],
                        frag_offset,
                        SSI_FRAG_READB(
                            udids_ptr,
                            pio_dump_handle,
                            1));

                    RX_INFO(udids_ptr, slot).frame->data_length++;

                    frag_offset++;

                    

                    xfer_length--;
                    length--;
                }
                else
                {
                    

                    xfer_length -= frag_length - frag_offset;
                    length      -= frag_length - frag_offset;

                    

                    RX_INFO(udids_ptr, slot).cumulative_frag_length +=
                        frag_length;

                    frag_index++;

                    RX_INFO(udids_ptr, slot).last_frag_index = frag_index;

                    if(frag_index >= frame->frag_array_length)
                    {
                        

                        POKEW(
                            udids_ptr,
                            PO_CHAN_ISR,
                            PO_LEV_USER,PO_BROWN,
                            "FRAG ARRAY FULL",
                            length);

                        if (IO_TO_FRAG(
                               xfer_method,
                               udids_ptr,
                               pio_dump_handle,
                               0,
                               io_handle,
                               io_offset,
                               length) > 0)
                        {
                            

                            SSI_IO_READB(udids_ptr, io_handle, io_offset);
                        }

                        

                        return;
                    }

                    frag_length = SSI_FRAG_LENGTH(
                                      udids_ptr,
                                      frame->frag_array_ptr[frag_index]);

                    frag_offset = 0;
                }
            }
        }
    }


    

    if(length > 0)
    {
        

        POKEW(
            udids_ptr,
            PO_CHAN_ISR,
            PO_LEV_USER,PO_CYAN,
            "DISCARD: ",
            length);

        if(SSI_IO_TO_FRAG_16BIT(
               udids_ptr,
               pio_dump_handle,
               0,
               io_handle,
               io_offset,
               length) > 0)
        {
            

            SSI_IO_READB(udids_ptr, io_handle, io_offset);
        }
    }


    

    return;
}


#else



STATIC VOID_T UDT_INDIRECT
pio_to_frame(
    INOUT P_UDI_DATA_T udids_ptr,
          WORD_T       slot,
          WORD_T       offset,
          IO_HANDLE_T  io_handle,
          UINT_T       io_offset,
          WORD_T       length)
{
    P_FRAME_T          frame;

    

    frame = RX_INFO(udids_ptr, slot).frame;

    

    if(IO_TO_FRAG(
          GET_CONFIG_VALUE(CONFIG_FROM_UDIDS(udids_ptr), xfer_method),
          udids_ptr,
          frame->frag_array_ptr[0],
          offset,
          io_handle,
          io_offset,
          length) > 0)
    {
        

        SSI_FRAG_WRITEB(
               udids_ptr,
               frame->frag_array_ptr[0],
               offset + length - 1,
               SSI_IO_READB(udids_ptr, io_handle, io_offset));
    }
}



#if defined(COMPAQ_ISA_UDI) || \
    defined(OLICOM_ISA_UDI) || \
    defined(OLICOM_EISA_UDI)

STATIC VOID_T UDT_INDIRECT
pio_to_frame_eight_bit(
    INOUT P_UDI_DATA_T udids_ptr,
          WORD_T       slot,
          WORD_T       offset,
          IO_HANDLE_T  io_handle,
          UINT_T       io_offset,
          WORD_T       length)
{
    P_FRAME_T          frame;

    

    frame = RX_INFO(udids_ptr, slot).frame;

    

    SSI_IO_TO_FRAG_8BIT(
          udids_ptr,
          frame->frag_array_ptr[0],
          offset,
          io_handle,
          io_offset,
          length);
}

#endif

#endif



STATIC VOID_T UDT_INDIRECT
pio_from_frame(
    INOUT P_UDI_DATA_T udids_ptr,
          WORD_T       slot,
          WORD_T       offset,
          IO_HANDLE_T  io_handle,
          UINT_T       io_offset,
          WORD_T       length)
{
    UINT_T             frag_index;
    FRAG_HANDLE_T      frag_handle;
    UINT_T             frag_length;
    P_FRAME_T          frame;
    BYTE_T             extra_byte;
    UINT_T             xfer_length;
    BOOLEAN_T          is_extra_byte = FALSE;
    XFER_METHOD_T      xfer_method   = GET_CONFIG_VALUE(
                                               CONFIG_FROM_UDIDS(udids_ptr),
                                               xfer_method);
    

    frame = TX_INFO(udids_ptr, slot).frame;

    

    frag_index = TX_INFO(udids_ptr, slot).last_frag_index;

    

    offset -= TX_INFO(udids_ptr, slot).cumulative_frag_length;


    

    while (length > 0)
    {
        

        frag_handle = frame->frag_array_ptr[frag_index];
        frag_length = SSI_FRAG_LENGTH(udids_ptr, frag_handle);

        

        if (frag_length - offset <= length)
        {
            

            xfer_length = frag_length - offset;
            frag_index++;
            TX_INFO(udids_ptr, slot).cumulative_frag_length += frag_length;
        }
        else
        {
            

            xfer_length = length;
        }

        POKEW_ISR(PO_GREEN, "[Tx:", xfer_length);
        POKED_ISR(PO_CYAN, "<-",
            SSI_FRAG_PHYS_ADDRESS(udids_ptr,frag_handle));
        POKE_ISR(PO_GREEN, "]");

        

        length -= xfer_length;

        

        if (xfer_length > 0)
        {
            

            if (is_extra_byte)
            {
                WORD_T temp = MAKE_LOHI_WORD(
                                    extra_byte,
                                    SSI_FRAG_READB(
                                            udids_ptr,
                                            frag_handle,
                                            offset));

                SSI_IO_WRITEW(
                        udids_ptr,
                        io_handle,
                        io_offset,
                        temp);

                is_extra_byte = FALSE;
                offset++;
                xfer_length--;
            }

            

            POKEB_ISR(PO_GREEN, "b",xfer_method);
            POKEW_ISR(PO_MAGENTA, "IO=",io_handle);
            POKEW_ISR(PO_MAGENTA, ",",io_offset);

            if(FRAG_TO_IO(
                        xfer_method,
                        udids_ptr,
                        io_handle,
                        io_offset,
                        frag_handle,
                        offset,
                        xfer_length) > 0)
            {
                

                extra_byte = SSI_FRAG_READB(
                                        udids_ptr,
                                        frag_handle,
                                        offset + xfer_length - 1);
                is_extra_byte = TRUE;
            }

        }

        

        offset = 0;
    }

    

    if (is_extra_byte)
    {
        SSI_IO_WRITEB(
                    udids_ptr,
                    io_handle,
                    io_offset,
                    extra_byte);
    }

    TX_INFO(udids_ptr, slot).last_frag_index = frag_index;
}



#if defined(COMPAQ_ISA_UDI) || \
    defined(OLICOM_ISA_UDI) || \
    defined(OLICOM_EISA_UDI)

STATIC VOID_T UDT_INDIRECT
pio_from_frame_eight_bit(
    INOUT P_UDI_DATA_T udids_ptr,
          WORD_T       slot,
          WORD_T       offset,
          IO_HANDLE_T  io_handle,
          UINT_T       io_offset,
          WORD_T       length)
{
    UINT_T             frag_index;
    FRAG_HANDLE_T      frag_handle;
    UINT_T             frag_length;
    P_FRAME_T          frame;
    UINT_T             xfer_length;

    

    frame = TX_INFO(udids_ptr, slot).frame;

    

    frag_index = TX_INFO(udids_ptr, slot).last_frag_index;

    

    offset -= TX_INFO(udids_ptr, slot).cumulative_frag_length;


    

    while (length > 0)
    {
        

        frag_handle = frame->frag_array_ptr[frag_index];
        frag_length = SSI_FRAG_LENGTH(udids_ptr, frag_handle);

        

        if (frag_length - offset <= length)
        {
            

            xfer_length = frag_length - offset;
            frag_index++;
            TX_INFO(udids_ptr, slot).cumulative_frag_length += frag_length;
        }
        else
        {
            

            xfer_length = length;
        }

        

        length -= xfer_length;

        

        if (xfer_length > 0)
        {

            

            SSI_FRAG_TO_IO_8BIT(
                        udids_ptr,
                        io_handle,
                        io_offset,
                        frag_handle,
                        offset,
                        xfer_length);
        }

        

        offset = 0;
    }

    TX_INFO(udids_ptr, slot).last_frag_index = frag_index;
}

#endif



BUILD_MODULE_END_FUNCTION(pio_end)



#endif 

#endif




