/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/*****************************************************************************
*
* ******  ****  *****  ******** ******  ****  ********     *****
*  **  **  **  **   ** *  **  * **     **   * *  **  *    **   **
*  **  **  **  **   **    **    **     **        **       **
*  *****   **  **   **    **    ******  ****     **       **
*  **      **  **   **    **    **         **    **       **
*  **      **  **   **    **    **     *   **    **       **   **
* ****    ****  *****    ****   ******  ****    ****   **  *****
*
******************************************************************************
*
* Functions fot doing test PIO transfers on Smart cards
*
******************************************************************************
*
* Copyright (C) 1996-98 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
******************************************************************************
*/



#define UDI_MODULE

#include "udt_driver.h"

#ifdef SMART_UDI

#ifndef UDT_ONLY_GET_CARD_INFO

STATIC VOID_T UDT_INDIRECT
do_pio_test_transfer(
    INOUT P_UDI_DATA_T udids_ptr,
    IN WORD_T magic,
    IN WORD_T offset,
    IN BOOLEAN_T direction,
    IN IO_HANDLE_T  io_handle,
    IN UINT_T       io_offset);

DECLARE_MODULE_START_FUNCTION(piotest_start)
DECLARE_MODULE_END_FUNCTION(piotest_end)




RETCODE_T UDT_INTER_MODULE
piotest_register(
    IN P_UDI_DATA_T udids_ptr)
{
    POKE(
        udids_ptr,
        PO_CHAN_CONFIG,
        PO_LEV_USER,
        PO_BLUE,
        "REGISTERING PIO TEST XFER");

    

    SSI_MODULE_REGISTERED(
        udids_ptr,
        piotest_register,
        piotest_start,
        piotest_end,
        MOD_SCOPE_INITIALISATION);

    

    SMART_INIT_FROM_UDIDS(udids_ptr).smart_do_pio_test_transfer  =
        do_pio_test_transfer;

    

    return SUCCESS;
}

BUILD_MODULE_START_FUNCTION(piotest_start)



STATIC VOID_T UDT_INDIRECT
do_pio_test_transfer(
    INOUT P_UDI_DATA_T udids_ptr,
    IN WORD_T          magic,
    IN WORD_T          offset,
    IN BOOLEAN_T       direction,
    IN IO_HANDLE_T     io_handle,
    IN UINT_T          io_offset)

{
#   ifdef UDT_POKEOUTS_ON
    UINT_T i;
#   endif

    FRAG_HANDLE_T  frag_handle = GET_CONFIG_VALUE(
                                     CONFIG_FROM_UDIDS(udids_ptr),
                                     frag_handle[0]);

    if(direction)
    {
        

        if(magic == SCB_XFER)
        {
            POKE(
                udids_ptr,
                PO_CHAN_ISR,
                PO_LEV_USER,
                PO_CYAN,
                "recv SCB");

            

#           if defined(COMPAQ_ISA_UDI)  || \
               defined(OLICOM_EISA_UDI) || \
               defined(OLICOM_ISA_UDI)

            if(SMART_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).
                   eight_bit_psdma)
            {
                SSI_IO_TO_FRAG_8BIT(
                    udids_ptr,
                    frag_handle,
                    offset + SCB_OFFSET,
                    io_handle,
                    io_offset,
                    SIZEOF_SCB_PATTERN - offset);
            }
            else

#           endif

            {


                SSI_IO_TO_FRAG_16BIT(
                    udids_ptr,
                    frag_handle,
                    offset + SCB_OFFSET,
                    io_handle,
                    io_offset,
                    SIZEOF_SCB_PATTERN - offset);
            }

#           ifdef UDT_POKEOUTS_ON

            for (i=offset; i<SIZEOF_SCB_PATTERN; i++)
            {
                TPOKEB_ISR(
                    TT_INFO,
                    ",",
                    SSI_FRAG_READB(udids_ptr, frag_handle, i+SCB_OFFSET));
            }

#           endif

        }
        else if(magic == SSB_XFER)
        {
            POKE(
                udids_ptr,
                PO_CHAN_ISR,
                PO_LEV_USER,
                PO_CYAN,
                "Recv SSB");

            

#           if defined(COMPAQ_ISA_UDI)  || \
               defined(OLICOM_EISA_UDI) || \
               defined(OLICOM_ISA_UDI)

            if(SMART_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).
                   eight_bit_psdma)
            {
                SSI_IO_TO_FRAG_8BIT(
                    udids_ptr,
                    frag_handle,
                    offset + SSB_OFFSET,
                    io_handle,
                    io_offset,
                    SIZEOF_SSB_PATTERN - offset);
            }
            else

#           endif

            {
                SSI_IO_TO_FRAG_16BIT(
                    udids_ptr,
                    frag_handle,
                    offset + SSB_OFFSET,
                    io_handle,
                    io_offset,
                    SIZEOF_SSB_PATTERN - offset);
            }
        }
    }
    else
    {
        

        if(magic == SCB_XFER)
        {
            POKE(
                udids_ptr,
                PO_CHAN_ISR,
                PO_LEV_USER,
                PO_BLUE,
                "Send SCB");

            

#           if defined(COMPAQ_ISA_UDI)  || \
               defined(OLICOM_EISA_UDI) || \
               defined(OLICOM_ISA_UDI)

            if(SMART_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).
                   eight_bit_psdma)
            {
                SSI_FRAG_TO_IO_8BIT(
                    udids_ptr,
                    io_handle,
                    io_offset,
                    frag_handle,
                    offset + SCB_OFFSET,
                    SIZEOF_SCB_PATTERN - offset);
            }
            else

#           endif

            {
                SSI_FRAG_TO_IO_16BIT(
                    udids_ptr,
                    io_handle,
                    io_offset,
                    frag_handle,
                    offset + SCB_OFFSET,
                    SIZEOF_SCB_PATTERN - offset);
            }

        }
        else if(magic == SSB_XFER)
        {
            POKE(
                udids_ptr,
                PO_CHAN_ISR,
                PO_LEV_USER,
                PO_BLUE,
                "Send SSB");

            

#           if defined(COMPAQ_ISA_UDI)  || \
               defined(OLICOM_EISA_UDI) || \
               defined(OLICOM_ISA_UDI)

            if(SMART_PERSISTENT_RES_INFO_FROM_UDIDS(udids_ptr).
                   eight_bit_psdma)
            {
                SSI_FRAG_TO_IO_8BIT(
                    udids_ptr,
                    io_handle,
                    io_offset,
                    frag_handle,
                    offset + SSB_OFFSET,
                    SIZEOF_SSB_PATTERN - offset);
            }
            else

#           endif

            {
                SSI_FRAG_TO_IO_16BIT(
                    udids_ptr,
                    io_handle,
                    io_offset,
                    frag_handle,
                    offset + SSB_OFFSET,
                    SIZEOF_SSB_PATTERN - offset);
            }

        }
    }
    return;
}



BUILD_MODULE_END_FUNCTION(piotest_end)



#endif 

#endif



