/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/*****************************************************************************
*
*    ******    ***   ***  ** ******    **  **
*     **  **  ** **   **  ** **        **  **
*     **  ** **   **  ** **  **        **  **
*     *****  **   **  ****   ****      ******
*     **     **   **  ** **  **        **  **
*     **      ** **   **  ** **     ** **  **
*    ****      ***   ***  ** ****** ** **  **
*
*****************************************************************************
*
* Declaration of the pokeout interface provided by the toolkit.
*
* Used to provide diagnostic information on the UPI, UDI and driver during
* development. Provides intellagable string and value data to one or more
* devices.
*
* NOTE
* ----
*
* Define UDT_POKEOUTS_ON for a build including POKEOUTS
*
* Define DO_POKEOUTS in every module where pokeouts are required.
* Not defining this macro supresses pokeouts for that module.
*
*****************************************************************************
*
* Copyright (C) 1996-1998 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
******************************************************************************
*/









#define POKE_UPI(_c, _s) \
        POKE(upids_ptr, PO_CHAN_UPI, PO_LEV_USER, _c, _s)
#define POKEB_UPI(_c, _s, _v) \
        POKEB(upids_ptr, PO_CHAN_UPI, PO_LEV_USER, _c, _s, _v)
#define POKEW_UPI(_c, _s, _v) \
        POKEW(upids_ptr, PO_CHAN_UPI, PO_LEV_USER, _c, _s, _v)
#define POKED_UPI(_c, _s, _v) \
        POKED(upids_ptr, PO_CHAN_UPI, PO_LEV_USER, _c, _s, _v)
#define POKEI_UPI(_c, _s, _v) \
        POKEI(upids_ptr, PO_CHAN_UPI, PO_LEV_USER, _c, _s, _v)

#define TPOKEB_UPI(_tt, _s, _v) \
        POKE_UPI(TONE_A(_tt), _s); \
        POKEB_UPI(TONE_B(_tt), "", _v)
#define TPOKEW_UPI(_tt, _s, _v) \
        POKE_UPI(TONE_A(_tt), _s); \
        POKEW_UPI(TONE_B(_tt), "", _v)
#define TPOKED_UPI(_tt, _s, _v) \
        POKE_UPI(TONE_A(_tt), _s); \
        POKED_UPI(TONE_B(_tt), "", _v)
#define TPOKEI_UPI(_tt, _s, _v) \
        POKE_UPI(TONE_A(_tt), _s); \
        POKEI_UPI(TONE_B(_tt), "", _v)



#define POKE_CFG(_c, _s) \
        POKE(udids_ptr, PO_CHAN_CONFIG, PO_LEV_USER, _c, _s)
#define POKEB_CFG(_c, _s, _v) \
        POKEB(udids_ptr, PO_CHAN_CONFIG, PO_LEV_USER, _c, _s, _v)
#define POKEW_CFG(_c, _s, _v) \
        POKEW(udids_ptr, PO_CHAN_CONFIG, PO_LEV_USER, _c, _s, _v)
#define POKED_CFG(_c, _s, _v) \
        POKED(udids_ptr, PO_CHAN_CONFIG, PO_LEV_USER, _c, _s, _v)
#define POKEI_CFG(_c, _s, _v) \
        POKEI(udids_ptr, PO_CHAN_CONFIG, PO_LEV_USER, _c, _s, _v)

#define TPOKEB_CFG(_tt, _s, _v) \
        POKE_CFG(TONE_A(_tt), _s); \
        POKEB_CFG(TONE_B(_tt), "", _v)
#define TPOKEW_CFG(_tt, _s, _v) \
        POKE_CFG(TONE_A(_tt), _s); \
        POKEW_CFG(TONE_B(_tt), "", _v)
#define TPOKED_CFG(_tt, _s, _v) \
        POKE_CFG(TONE_A(_tt), _s); \
        POKED_CFG(TONE_B(_tt), "", _v)
#define TPOKEI_CFG(_tt, _s, _v) \
        POKE_CFG(TONE_A(_tt), _s); \
        POKEI_CFG(TONE_B(_tt), "", _v)



#define POKE_ISR(_c, _s) \
        POKE(udids_ptr, PO_CHAN_ISR, PO_LEV_USER, _c, _s)
#define POKEB_ISR(_c, _s, _v) \
        POKEB(udids_ptr, PO_CHAN_ISR, PO_LEV_USER, _c, _s, _v)
#define POKEW_ISR(_c, _s, _v) \
        POKEW(udids_ptr, PO_CHAN_ISR, PO_LEV_USER, _c, _s, _v)
#define POKED_ISR(_c, _s, _v) \
        POKED(udids_ptr, PO_CHAN_ISR, PO_LEV_USER, _c, _s, _v)
#define POKEI_ISR(_c, _s, _v) \
        POKEI(udids_ptr, PO_CHAN_ISR, PO_LEV_USER, _c, _s, _v)

#define TPOKEB_ISR(_tt, _s, _v) \
        POKE_ISR(TONE_A(_tt), _s); \
        POKEB_ISR(TONE_B(_tt), "", _v)
#define TPOKEW_ISR(_tt, _s, _v) \
        POKE_ISR(TONE_A(_tt), _s); \
        POKEW_ISR(TONE_B(_tt), "", _v)
#define TPOKED_ISR(_tt, _s, _v) \
        POKE_ISR(TONE_A(_tt), _s); \
        POKED_ISR(TONE_B(_tt), "", _v)
#define TPOKEI_ISR(_tt, _s, _v) \
        POKE_ISR(TONE_A(_tt), _s); \
        POKEI_ISR(TONE_B(_tt), "", _v)




#define POKE_CTRL(_c, _s) \
        POKE(udids_ptr, PO_CHAN_CONTROL, PO_LEV_USER, _c, _s)
#define POKEB_CTRL(_c, _s, _v) \
        POKEB(udids_ptr, PO_CHAN_CONTROL, PO_LEV_USER, _c, _s, _v)
#define POKEW_CTRL(_c, _s, _v) \
        POKEW(udids_ptr, PO_CHAN_CONTROL, PO_LEV_USER, _c, _s, _v)
#define POKED_CTRL(_c, _s, _v) \
        POKED(udids_ptr, PO_CHAN_CONTROL, PO_LEV_USER, _c, _s, _v)
#define POKEI_CTRL(_c, _s, _v) \
        POKEI(udids_ptr, PO_CHAN_CONTROL, PO_LEV_USER, _c, _s, _v)

#define TPOKEB_CTRL(_tt, _s, _v) \
        POKE_CTRL(TONE_A(_tt), _s); \
        POKEB_CTRL(TONE_B(_tt), "", _v)
#define TPOKEW_CTRL(_tt, _s, _v) \
        POKE_CTRL(TONE_A(_tt), _s); \
        POKEW_CTRL(TONE_B(_tt), "", _v)
#define TPOKED_CTRL(_tt, _s, _v) \
        POKE_CTRL(TONE_A(_tt), _s); \
        POKED_CTRL(TONE_B(_tt), "", _v)
#define TPOKEI_CTRL(_tt, _s, _v) \
        POKE_CTRL(TONE_A(_tt), _s); \
        POKEI_CTRL(TONE_B(_tt), "", _v)




#define POKE_TX(_c, _s) \
        POKE(udids_ptr, PO_CHAN_TX, PO_LEV_USER, _c, _s)
#define POKEB_TX(_c, _s, _v) \
        POKEB(udids_ptr, PO_CHAN_TX, PO_LEV_USER, _c, _s, _v)
#define POKEW_TX(_c, _s, _v) \
        POKEW(udids_ptr, PO_CHAN_TX, PO_LEV_USER, _c, _s, _v)
#define POKED_TX(_c, _s, _v) \
        POKED(udids_ptr, PO_CHAN_TX, PO_LEV_USER, _c, _s, _v)
#define POKEI_TX(_c, _s, _v) \
        POKEI(udids_ptr, PO_CHAN_TX, PO_LEV_USER, _c, _s, _v)

#define TPOKEB_TX(_tt, _s, _v) \
        POKE_TX(TONE_A(_tt), _s); \
        POKEB_TX(TONE_B(_tt), "", _v)
#define TPOKEW_TX(_tt, _s, _v) \
        POKE_TX(TONE_A(_tt), _s); \
        POKEW_TX(TONE_B(_tt), "", _v)
#define TPOKED_TX(_tt, _s, _v) \
        POKE_TX(TONE_A(_tt), _s); \
        POKED_TX(TONE_B(_tt), "", _v)
#define TPOKEI_TX(_tt, _s, _v) \
        POKE_TX(TONE_A(_tt), _s); \
        POKEI_TX(TONE_B(_tt), "", _v)




#define POKE_RX(_c, _s) \
        POKE(udids_ptr, PO_CHAN_RX, PO_LEV_USER, _c, _s)
#define POKEB_RX(_c, _s, _v) \
        POKEB(udids_ptr, PO_CHAN_RX, PO_LEV_USER, _c, _s, _v)
#define POKEW_RX(_c, _s, _v) \
        POKEW(udids_ptr, PO_CHAN_RX, PO_LEV_USER, _c, _s, _v)
#define POKED_RX(_c, _s, _v) \
        POKED(udids_ptr, PO_CHAN_RX, PO_LEV_USER, _c, _s, _v)
#define POKEI_RX(_c, _s, _v) \
        POKEI(udids_ptr, PO_CHAN_RX, PO_LEV_USER, _c, _s, _v)

#define TPOKEB_RX(_tt, _s, _v) \
        POKE_RX(TONE_A(_tt), _s); \
        POKEB_RX(TONE_B(_tt), "", _v)
#define TPOKEW_RX(_tt, _s, _v) \
        POKE_RX(TONE_A(_tt), _s); \
        POKEW_RX(TONE_B(_tt), "", _v)
#define TPOKED_RX(_tt, _s, _v) \
        POKE_RX(TONE_A(_tt), _s); \
        POKED_RX(TONE_B(_tt), "", _v)
#define TPOKEI_RX(_tt, _s, _v) \
        POKE_RX(TONE_A(_tt), _s); \
        POKEI_RX(TONE_B(_tt), "", _v)






#define QPOKE(_c, _s) \
        POKE(NULL, PO_CHAN_DRIVER, PO_LEV_USER, _c, _s)
#define QPOKEB(_c, _s, _v) \
        POKEB(NULL, PO_CHAN_DRIVER, PO_LEV_USER, _c, _s, _v)
#define QPOKEW(_c, _s, _v) \
        POKEW(NULL, PO_CHAN_DRIVER, PO_LEV_USER, _c, _s, _v)
#define QPOKED(_c, _s, _v) \
        POKED(NULL, PO_CHAN_DRIVER, PO_LEV_USER, _c, _s, _v)
#define QPOKEI(_c, _s, _v) \
        POKEI(NULL, PO_CHAN_DRIVER, PO_LEV_USER, _c, _s, _v)
#define QPOKES(_c, _s, _v) \
        POKES(NULL, PO_CHAN_DRIVER, PO_LEV_USER, _c, _s, _v)

#define TQPOKEB(_tt, _s, _v) \
        QPOKE(TONE_A(_tt), _s); \
        QPOKEB(TONE_B(_tt), "", _v)
#define TQPOKEW(_tt, _s, _v) \
        QPOKE(TONE_A(_tt), _s); \
        QPOKEW(TONE_B(_tt), "", _v)
#define TQPOKED(_tt, _s, _v) \
        QPOKE(TONE_A(_tt), _s); \
        QPOKED(TONE_B(_tt), "", _v)
#define TQPOKEI(_tt, _s, _v) \
        QPOKE(TONE_A(_tt), _s); \
        QPOKEI(TONE_B(_tt), "", _v)
#define TQPOKES(_tt, _s, _v) \
        QPOKE(TONE_A(_tt), _s); \
        QPOKES(TONE_B(_tt), "", _v)




#define COLOUR_FN           PO_BRIGHT_GREEN
#define COLOUR_SUBFN        PO_GREEN
#define COLOUR_INFO         PO_BRIGHT_YELLOW
#define COLOUR_ACTION       PO_MAGENTA
#define COLOUR_EVENT        PO_MAGENTA
#define COLOUR_ERROR        PO_BRIGHT_FLASHING_RED
#define COLOUR_UNLIKELY     PO_BRIGHT_FLASHING_CYAN
#define COLOUR_INSANE       PO_BRIGHT_FLASHING_WHITE
#define COLOUR_INT_TYPE     PO_BRIGHT_RED
#define COLOUR_CMD_DONE     PO_MAGENTA
#define COLOUR_PROV_RX      PO_CYAN
#define COLOUR_CTRL_FN      PO_BRIGHT_YELLOW
#define COLOUR_TX           PO_MAGENTA

#define COLOUR_MISC         PO_YELLOW

#define TWO_TONE(_ca, _cb)  (_ca*256+_cb)
#define TONE_A(_tt)         ((_tt>>8)&255)
#define TONE_B(_tt)         (_tt&255)

#define TT_FN               TWO_TONE(PO_BRIGHT_GREEN, PO_BRIGHT_YELLOW)
#define TT_INFO             TWO_TONE(PO_BRIGHT_BLUE, PO_BRIGHT_YELLOW)
#define TT_USER             TWO_TONE(PO_BRIGHT_BLUE, PO_BRIGHT_RED)
#define TT_VALUE            TWO_TONE(PO_BRIGHT_BLUE, PO_BRIGHT_CYAN)
#define TT_TX               TWO_TONE(PO_BLUE, PO_CYAN)
#define TT_RX_MAC           TWO_TONE(PO_MAGENTA, PO_BRIGHT_CYAN)
#define TT_STATE            TWO_TONE(PO_BLUE, PO_RED)
#define TT_DULL             TWO_TONE(PO_BLUE, PO_MAGENTA)
#define TT_DULL2            TWO_TONE(PO_YELLOW, PO_GREEN)
#define TT_DULL3            TWO_TONE(PO_RED, PO_CYAN)
#define TT_BRIGHT           TWO_TONE(PO_BRIGHT_RED, PO_BRIGHT_YELLOW)
#define TT_BRIGHT2          TWO_TONE(PO_BRIGHT_MAGENTA, PO_BRIGHT_GREEN)
#define TT_BRIGHT3          TWO_TONE(PO_BRIGHT_GREEN, PO_BRIGHT_WHITE)
#define TT_BRIGHT_FLASHING  TWO_TONE(PO_BRIGHT_FLASHING_RED, \
                                     PO_BRIGHT_FLASHING_YELLOW)

#define TT_BLUE_CYAN        TWO_TONE(PO_BLUE, PO_CYAN)




#ifdef UDT_POKEOUTS_ON

# if defined(DO_POKEOUTS)

#  ifdef UPI_MODULE

#   define UDT_POKE(_context, _a, _b, _c, _d, _e, _f)                       \
           PSSI_POKE(DDS_FROM_UPIDS(_context), _a, _b, _c, _d, _e, _f)

#  else
#   ifdef UDI_MODULE

#    define UDT_POKE(_context, _a, _b, _c, _d, _e, _f)                      \
            SSI_POKE(DDS_FROM_UDIDS(_context), _a, _b, _c, _d, _e, _f)

#   else

#     define UDT_POKE(_context, _a, _b, _c, _d, _e, _f)                     \
             D_POKE(_context, _a, _b, _c, _d, _e, _f)

#   endif 
#  endif 

# define PFORCE_TYPE(                                                        \
    _context,                                                                \
    _channel,                                                                \
    _level,                                                                  \
    _colour,                                                                 \
    _prompt,                                                                 \
    _type,                                                                   \
    _data)                                                                   \
                                                                             \
      UDT_POKE(                                                              \
            (_context),                                                      \
            (_channel),                                                      \
            (_level),                                                        \
            (_colour),                                                       \
            ((STRING_T)(_prompt)),                                           \
            (_type),                                                         \
            (DWORD_T)(_data) );




# define POKE(_context, _channel, _level, _colour, _prompt)                  \
         PFORCE_TYPE(_context, _channel, _level, _colour, _prompt, PO_TYPE_N,\
         (DWORD_T) 0)

# define POKEC(_context, _channel, _level, _colour, _prompt, _data)          \
         PFORCE_TYPE(_context, _channel, _level, _colour, _prompt, PO_TYPE_C,\
         (DWORD_T) _data)

# define POKEB(_context, _channel, _level, _colour, _prompt, _data)          \
         PFORCE_TYPE(_context, _channel, _level, _colour, _prompt, PO_TYPE_B,\
         (DWORD_T) _data)

# define POKEW(_context, _channel, _level, _colour, _prompt, _data)          \
         PFORCE_TYPE(_context, _channel, _level, _colour, _prompt, PO_TYPE_W,\
         (DWORD_T) _data)

# define POKED(_context, _channel, _level, _colour, _prompt, _data)          \
         PFORCE_TYPE(_context, _channel, _level, _colour, _prompt, PO_TYPE_D,\
         (DWORD_T) _data)

# define POKES(_context, _channel, _level, _colour, _prompt, _data)          \
         PFORCE_TYPE(_context, _channel, _level, _colour, _prompt, PO_TYPE_S,\
         (DWORD_T) ( (STRING_T) _data) )

# define POKEP(_context, _channel, _level, _colour, _prompt, _data)          \
         PFORCE_TYPE(_context, _channel, _level, _colour, _prompt, PO_TYPE_P,\
         (DWORD_T) _data)

# define POKEI(_context, _channel, _level, _colour, _prompt, _data)          \
         PFORCE_TYPE(_context, _channel, _level, _colour, _prompt, PO_TYPE_I,\
         (DWORD_T) _data)

# define POKEL(_context, _channel, _level, _colour, _prompt, _data)          \
         PFORCE_TYPE(_context, _channel, _level, _colour, _prompt, PO_TYPE_L,\
         (DWORD_T) _data)
# else

# define POKE(_context, _channel, _level, _colour, _prompt)
# define POKEC(_context, _channel, _level, _colour, _prompt, _data)
# define POKEB(_context, _channel, _level, _colour, _prompt, _data)
# define POKEW(_context, _channel, _level, _colour, _prompt, _data)
# define POKED(_context, _channel, _level, _colour, _prompt, _data)
# define POKES(_context, _channel, _level, _colour, _prompt, _data)
# define POKEP(_context, _channel, _level, _colour, _prompt, _data)
# define POKEI(_context, _channel, _level, _colour, _prompt, _data)
# define POKEL(_context, _channel, _level, _colour, _prompt, _data)

# endif     

#else

# define POKE(_context, _channel, _level, _colour, _prompt)
# define POKEC(_context, _channel, _level, _colour, _prompt, _data)
# define POKEB(_context, _channel, _level, _colour, _prompt, _data)
# define POKEW(_context, _channel, _level, _colour, _prompt, _data)
# define POKED(_context, _channel, _level, _colour, _prompt, _data)
# define POKES(_context, _channel, _level, _colour, _prompt, _data)
# define POKEP(_context, _channel, _level, _colour, _prompt, _data)
# define POKEI(_context, _channel, _level, _colour, _prompt, _data)
# define POKEL(_context, _channel, _level, _colour, _prompt, _data)

#endif 





# define PO_FLASHING    0x80
# define PO_BRIGHT	0x08



# define PO_BLACK       0x00
# define PO_BLUE        0x01
# define PO_GREEN       0x02
# define PO_CYAN        0x03
# define PO_RED         0x04
# define PO_MAGENTA     0x05
# define PO_BROWN       0x06
# define PO_WHITE       0x07

# define PO_BRIGHT_BLACK   (PO_BLACK+PO_BRIGHT)
# define PO_BRIGHT_BLUE    (PO_BLUE+PO_BRIGHT)
# define PO_BRIGHT_GREEN   (PO_GREEN+PO_BRIGHT)
# define PO_BRIGHT_CYAN    (PO_CYAN+PO_BRIGHT)
# define PO_BRIGHT_RED     (PO_RED+PO_BRIGHT)
# define PO_BRIGHT_MAGENTA (PO_MAGENTA+PO_BRIGHT)
# define PO_BRIGHT_BROWN   (PO_BROWN+PO_BRIGHT)
# define PO_BRIGHT_WHITE   (PO_WHITE+PO_BRIGHT)

# define PO_FLASHING_BLACK   (PO_BLACK+PO_FLASHING)
# define PO_FLASHING_BLUE    (PO_BLUE+PO_FLASHING)
# define PO_FLASHING_GREEN   (PO_GREEN+PO_FLASHING)
# define PO_FLASHING_CYAN    (PO_CYAN+PO_FLASHING)
# define PO_FLASHING_RED     (PO_RED+PO_FLASHING)
# define PO_FLASHING_MAGENTA (PO_MAGENTA+PO_FLASHING)
# define PO_FLASHING_BROWN   (PO_BROWN+PO_FLASHING)
# define PO_FLASHING_WHITE   (PO_WHITE+PO_FLASHING)

# define PO_BRIGHT_FLASHING_BLACK   (PO_BRIGHT_BLACK+PO_FLASHING)
# define PO_BRIGHT_FLASHING_BLUE    (PO_BRIGHT_BLUE+PO_FLASHING)
# define PO_BRIGHT_FLASHING_GREEN   (PO_BRIGHT_GREEN+PO_FLASHING)
# define PO_BRIGHT_FLASHING_CYAN    (PO_BRIGHT_CYAN+PO_FLASHING)
# define PO_BRIGHT_FLASHING_RED     (PO_BRIGHT_RED+PO_FLASHING)
# define PO_BRIGHT_FLASHING_MAGENTA (PO_BRIGHT_MAGENTA+PO_FLASHING)
# define PO_BRIGHT_FLASHING_BROWN   (PO_BRIGHT_BROWN+PO_FLASHING)
# define PO_BRIGHT_FLASHING_WHITE   (PO_BRIGHT_WHITE+PO_FLASHING)



# define PO_BG_BLACK    0x00
# define PO_BG_BLUE     0x10
# define PO_BG_GREEN    0x20
# define PO_BG_CYAN     0x30
# define PO_BG_RED      0x40
# define PO_BG_MAGENTA  0x50
# define PO_BG_BROWN    0x60
# define PO_BG_WHITE    0x70

# define POKE_FOREGROUND_COLOUR_MASK        0x07
# define POKE_FOREGROUND_COLOUR_BIT_SHIFT   0
# define POKE_BACKGROUND_COLOUR_MASK        0x70
# define POKE_BACKGROUND_COLOUR_BIT_SHIFT   4



# define PO_YELLOW                  PO_BROWN
# define PO_BRIGHT_YELLOW           PO_BRIGHT_BROWN
# define PO_FLAHING_YELLOW          PO_FLASHING_BROWN
# define PO_BRIGHT_FLASHING_YELLOW  PO_BRIGHT_FLASHING_BROWN
# define PO_BG_YELLOW               PO_BG_BROWN




# define PO_LEV_USER        0x00
# define PO_LEV_WARNING     0x10
# define PO_LEV_ERROR       0x20
# define PO_LEV_SEVERE      0x30

# define PO_LEV_ALL         0x00
# define PO_LEV_OFF         0x40



# define PO_TYPE_N            0x00 
# define PO_TYPE_C            0x01 
# define PO_TYPE_B            0x02 
# define PO_TYPE_W            0x03 
# define PO_TYPE_D            0x04 
# define PO_TYPE_S            0x05 
# define PO_TYPE_P            0x06 
# define PO_TYPE_I            0x07 
# define PO_TYPE_L            0x08 
# define PO_TYPE_DRIVER       0x09



enum
{
  PO_CHAN_GENERAL          =0, 
  PO_CHAN_UPI,                 
  PO_CHAN_UDI_REG,             
  PO_CHAN_CONFIG,              
  PO_CHAN_UDTI_REG,            
  PO_CHAN_CONTROL,             
  PO_CHAN_GET_ISR,             
  PO_CHAN_ISR,                 
  PO_CHAN_TX,                  
  PO_CHAN_TX_COMPLETE,         
  PO_CHAN_RX,                  
  PO_CHAN_DATA,                
  PO_CHAN_DRIVER               

   
};




#define POKE_CHAN_MESSAGES {  \
   "GENERAL     ",            \
   "UPI         ",            \
   "UDI_REG     ",            \
   "CONFIG      ",            \
   "UDTI_REG    ",            \
   "CONTROL     ",            \
   "GET_ISR     ",            \
   "ISR         ",            \
   "TX          ",            \
   "TX_COMPLETE ",            \
   "RX          ",            \
   "DATA        ",            \
   "DRIVER 1    ",            \
   "DRIVER 2    ",            \
   "DRIVER 3    ",            \
   "DRIVER 4    ",            \
   "DRIVER 5    "             \
};




VOID_T cdecl event_log(BYTE_T event, BYTE_T event_mask);

#ifdef DO_EVENT_LOG
# define EVENT_LOG(a,b) event_log(BYTE_T event, BYTE_T event_mask)
#else
# define EVENT_LOG(a,b)
#endif

#define  EVENT_INT      0x01

#define  EVENT_SEND     0x02
#define  EVENT_TX_PUT   0x04
#define  EVENT_TX_COMP  0x08

#define  EVENT_RX       0x10
#define  EVENT_RX_GET   0x20
#define  EVENT_RX_COMP  0x40



