/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/*****************************************************************************
*
*    ******  ******* ****** **   ** ******  **   **    **   **
*     **  **  **   * * ** * **   **  **  ** ***  **    **   **
*     **  **  ** *     **   **   **  **  ** **** **    **   **
*     *****   ****     **   **   **  *****  ** ****    *******
*     **  **  ** *     **   **   **  **  ** **  ***    **   **
*     **  **  **   *   **   **   **  **  ** **   **    **   **
*    ***  ** *******  ****   *****  ***  ** **   ** ** **   **
*
******************************************************************************
*
* Declaration of the return code checking interface provided by the toolkit.
*
* Defines the following macro:
*
*     RETURN()
*
* This can be used in place of 'return' when under normal successful
* operation, the value returned should be SUCCESS (zero). It checks that
* this is the case, and if not, if UDT_RETURN_CHECKING_ON is defined, invokes
* SSI_ERROR/PSSI_ERROR/D_ERROR as appropriate. If UDT_RETURN_CHECKING_ON is
* not defined, then RETURN() reduces to return, as one might expect.
*
* Hence diagnostic information can be provided for debugging purposes.
*
* The driver itself can make use of this macro.
*
******************************************************************************
*
* Copyright (C) 1996-1998 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
******************************************************************************
*/









#if defined(UDT_RETURN_CHECKING_ON)

# ifdef UPI_MODULE
#  define ERROR(_context, _a, _b, _c)       PSSI_ERROR(_context, _a, _b, _c)
# else
#  ifdef UDI_MODULE
#   define ERROR(_context, _a, _b, _c)      SSI_ERROR(_context, _a, _b, _c)
#  else
#   ifdef D_ERROR
#    define ERROR(_context, _a, _b, _c)     D_ERROR(_context, _a, _b, _c)
#   else
#    define ERROR(_context, _a, _b, _c)
#  endif 
#  endif 
# endif  



#define CHECK_RETURN(_context, _rc)                                         \
            if( _rc != 0) { ERROR(_context, _rc, __FILE__, __LINE__); }


#define RETURN(_context, _rc)                                               \
            CHECK_RETURN(_context, _rc); return (_rc)

#else



# define RETURN(_context, _rc) return (_rc)

#endif 



