/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
*  ****   ****  ****    **  **
* **  ** **  **  **     **  **
* ***    ***     **     **  **
*  ***    ***    **     ******
*    ***    ***  **     **  **
* **  ** **  **  **  ** **  **
*  ****   ****  **** ** **  **
*
******************************************************************************
*
* This file contains:
*
*     - Specification of the macros to be provided by the driver to provide
*       SSI functionality. These all start 'D_SSI_'.
*
*     - The derived macros for use in the UDT. These all start 'SSI_'.
*
******************************************************************************
*
* Copyright (C) 1996-1998 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/










































































































































#ifndef UDT_NO_SSI_PROTECT

typedef RETCODE_T
(UDT_LOCAL_PROTECTED *TARGET_T)(
    INOUT P_UDI_DATA_T   udids_ptr,
    INOUT PCLIENT_VOID_T arg1,
    INOUT PCLIENT_VOID_T arg2);

#endif















    

    

#       define SSI_IO_READB(_p, _a, _b)                                     \
               D_SSI_IO_READB(                                              \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_IO_READW(_p, _a, _b)                                     \
               D_SSI_IO_READW(                                              \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_IO_READD(_p, _a, _b)                                     \
               D_SSI_IO_READD(                                              \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_IO_WRITEB(_p, _a, _b, _c)                                \
               D_SSI_IO_WRITEB(                                             \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))

    

#       define SSI_IO_WRITEW(_p, _a, _b, _c)                                \
               D_SSI_IO_WRITEW(                                             \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))

    

#       define SSI_IO_WRITED(_p, _a, _b, _c)                                \
               D_SSI_IO_WRITED(                                             \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))


    


    

#       define SSI_INIT_SHARED_READB(_p, _a, _b)                            \
               D_SSI_INIT_SHARED_READB(                                     \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_INIT_SHARED_READW(_p, _a, _b)                            \
               D_SSI_INIT_SHARED_READW(                                     \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_INIT_SHARED_READD(_p, _a, _b)                            \
               D_SSI_INIT_SHARED_READD(                                     \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_SHARED_READB(_p, _a, _b)                                 \
               D_SSI_SHARED_READB(                                          \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_SHARED_READW(_p, _a, _b)                                 \
               D_SSI_SHARED_READW(                                          \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_SHARED_READD(_p, _a, _b)                                 \
               D_SSI_SHARED_READD(                                          \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_SHARED_WRITEB(_p, _a, _b, _c)                            \
               D_SSI_SHARED_WRITEB(                                         \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))

    

#       define SSI_SHARED_WRITEW(_p, _a, _b, _c)                            \
               D_SSI_SHARED_WRITEW(                                         \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))

    

#       define SSI_SHARED_WRITED(_p, _a, _b, _c)                            \
               D_SSI_SHARED_WRITED(                                         \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))


    

    

#       define SSI_FRAG_READB(_p, _a, _b)                                   \
               D_SSI_FRAG_READB(                                            \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_FRAG_READW(_p, _a, _b)                                   \
               D_SSI_FRAG_READW(                                            \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_FRAG_READD(_p, _a, _b)                                   \
               D_SSI_FRAG_READD(                                            \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_FRAG_WRITEB(_p, _a, _b, _c)                              \
               D_SSI_FRAG_WRITEB(                                           \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))

    

#       define SSI_FRAG_WRITEW(_p, _a, _b, _c)                              \
               D_SSI_FRAG_WRITEW(                                           \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))

    

#       define SSI_FRAG_WRITED(_p, _a, _b, _c)                              \
               D_SSI_FRAG_WRITED(                                           \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))

#       ifdef UDT_DISTINGUISH_MISALIGNED_DWORD_FRAG_ACCESS

#       define SSI_FRAG_WRITED_MISALIGNED(_p, _a, _b, _c)                   \
               D_SSI_FRAG_WRITED_MISALIGNED(                                \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))

#       else

#       define SSI_FRAG_WRITED_MISALIGNED(_p, _a, _b, _c)                   \
               D_SSI_FRAG_WRITED(                                           \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))

#       endif

    

#       define SSI_FRAG_PHYS_ADDRESS(_p, _a)                                \
               D_SSI_FRAG_PHYS_ADDRESS(                                     \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a))

    

#       define SSI_FRAG_LENGTH(_p, _a)                                      \
               D_SSI_FRAG_LENGTH(                                           \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a))


    

    

#       define SSI_PCI_READB(_p, _a, _b)                                    \
               D_SSI_PCI_READB(                                             \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_PCI_READW(_p, _a, _b)                                    \
               D_SSI_PCI_READW(                                             \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_PCI_READD(_p, _a, _b)                                    \
               D_SSI_PCI_READD(                                             \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b))

    

#       define SSI_PCI_WRITEB(_p, _a, _b, _c)                               \
               D_SSI_PCI_WRITEB(                                            \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))

    

#       define SSI_PCI_WRITEW(_p, _a, _b, _c)                               \
               D_SSI_PCI_WRITEW(                                            \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))

    

#       define SSI_PCI_WRITED(_p, _a, _b, _c)                               \
               D_SSI_PCI_WRITED(                                            \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_a),                                                   \
                    (_b),                                                   \
                    (_c))


    

#       define SSI_READ_TUPLE(_p, _t, _b, _s)                               \
               D_SSI_READ_TUPLE(                                            \
                    DDS_FROM_UDIDS(_p),                                     \
                    (_t),                                                   \
                    (_b),                                                   \
                    (_s))

    

#   if defined(COMPAQ_ISA_UDI) ||                                           \
       defined(OLICOM_ISA_UDI) ||                                           \
       defined(OLICOM_EISA_UDI)

    

#       define SSI_IO_TO_FRAG_8BIT(_p, _a, _b, _c, _d, _e)                  \
               D_SSI_IO_TO_FRAG_8BIT(                                       \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b),                                                  \
                     (_c),                                                  \
                     (_d),                                                  \
                     (_e))

    

#       define SSI_FRAG_TO_IO_8BIT(_p, _a, _b, _c, _d, _e)                  \
               D_SSI_FRAG_TO_IO_8BIT(                                       \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b),                                                  \
                     (_c),                                                  \
                     (_d),                                                  \
                     (_e))
#   endif

    

#       define SSI_IO_TO_FRAG_16BIT(_p, _a, _b, _c, _d, _e)                 \
               D_SSI_IO_TO_FRAG_16BIT(                                      \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b),                                                  \
                     (_c),                                                  \
                     (_d),                                                  \
                     (_e))

    

#       define SSI_FRAG_TO_IO_16BIT(_p, _a, _b, _c, _d, _e)                 \
               D_SSI_FRAG_TO_IO_16BIT(                                      \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b),                                                  \
                     (_c),                                                  \
                     (_d),                                                  \
                     (_e))

    

#       define SSI_IO_TO_FRAG_32BIT(_p, _a, _b, _c, _d, _e)                 \
               D_SSI_IO_TO_FRAG_32BIT(                                      \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b),                                                  \
                     (_c),                                                  \
                     (_d),                                                  \
                     (_e))

    

#       define SSI_FRAG_TO_IO_32BIT(_p, _a, _b, _c, _d, _e)                 \
               D_SSI_FRAG_TO_IO_32BIT(                                      \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b),                                                  \
                     (_c),                                                  \
                     (_d),                                                  \
                     (_e))

    

#       define SSI_FRAG_TO_MMIO(_p, _a, _b, _c, _d, _e)                     \
               D_SSI_FRAG_TO_MMIO(                                          \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b),                                                  \
                     (_c),                                                  \
                     (_d),                                                  \
                     (_e))

    

#       define SSI_MMIO_TO_FRAG(_p, _a, _b, _c, _d, _e)                     \
               D_SSI_MMIO_TO_FRAG(                                          \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b),                                                  \
                     (_c),                                                  \
                     (_d),                                                  \
                     (_e))

    

#       define SSI_FRAG_TO_SHARED(_p, _a, _b, _c, _d, _e)                   \
               D_SSI_FRAG_TO_SHARED(                                        \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b),                                                  \
                     (_c),                                                  \
                     (_d),                                                  \
                     (_e))

    

#       define SSI_SHARED_TO_FRAG(_p, _a, _b, _c, _d, _e)                   \
               D_SSI_SHARED_TO_FRAG(                                        \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b),                                                  \
                     (_c),                                                  \
                     (_d),                                                  \
                     (_e))

    

#       define SSI_FRAG_TO_FRAG(_p, _a, _b, _c, _d, _e)                     \
               D_SSI_FRAG_TO_FRAG(                                          \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b),                                                  \
                     (_c),                                                  \
                     (_d),                                                  \
                     (_e))


    

    

#       define SSI_WAIT_AT_LEAST_MSEC(_p, _a)                               \
               D_SSI_WAIT_AT_LEAST_MSEC(                                    \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a))

    

#       define SSI_WAIT_AT_LEAST_USEC(_p, _a)                               \
               D_SSI_WAIT_AT_LEAST_USEC(                                    \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a))


    

    

#       define SSI_DWORD_SHIFT_L(_p, _a, _b)                                \
               D_SSI_DWORD_SHIFT_L(                                         \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b))

    

#       define SSI_DWORD_SHIFT_R(_p, _a, _b)                                \
               D_SSI_DWORD_SHIFT_R(                                         \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b))


    

    

#       define SSI_CODE_OPEN(_p, _a, _b)                                    \
               D_SSI_CODE_OPEN(                                             \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b))

    

#       define SSI_CODE_READW(_p, _a)                                       \
               D_SSI_CODE_READW(                                            \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a))

    

#       define SSI_CODE_CLOSE(_p, _a)                                       \
               D_SSI_CODE_CLOSE(                                            \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a))


    

    

#       define SSI_ENABLE_DMA_CHANNEL(_p, _a)                               \
               D_SSI_ENABLE_DMA_CHANNEL(                                    \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a))

    

#       define SSI_DISABLE_DMA_CHANNEL(_p, _a)                              \
               D_SSI_DISABLE_DMA_CHANNEL(                                   \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a))

    

#       define SSI_COMPLETE_DMA_XFER(_p, _a)                                \
               D_SSI_COMPLETE_DMA_XFER(                                     \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a))


    

    

#    ifndef UDT_NO_SSI_PROTECT

#       define SSI_PROTECT(_p, _a, _b, _c)                                  \
               D_SSI_PROTECT(                                               \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_p),                                                  \
                     (_b),                                                  \
                     (_c))

#    else

#       define SSI_PROTECT(_p, _a, _b, _c)                                  \
               (_a)(_p,_b,_c)

#    endif


    

    

#   ifdef UDT_MODULE_REGISTRATION

#       define DECLARE_MODULE_START_FUNCTION(_fn_name)                      \
               VOID_T _fn_name(VOID_T);

#       define DECLARE_MODULE_END_FUNCTION(_fn_name)                        \
               VOID_T _fn_name(VOID_T);

#       define BUILD_MODULE_START_FUNCTION(_fn_name)                        \
               VOID_T _fn_name(VOID_T)                                      \
               {                                                            \
               }

#       define BUILD_MODULE_END_FUNCTION(_fn_name)                          \
               VOID_T _fn_name(VOID_T)                                      \
               {                                                            \
               }

#       define SSI_MODULE_REGISTERED(_p, _a, _b, _c, _d)                    \
               D_SSI_MODULE_REGISTERED(                                     \
                     DDS_FROM_UDIDS(_p),                                    \
                     (_a),                                                  \
                     (_b),                                                  \
                     (_c),                                                  \
                     (_d))

#   else

#       define DECLARE_MODULE_START_FUNCTION(_fn_name)
#       define DECLARE_MODULE_END_FUNCTION(_fn_name)
#       define BUILD_MODULE_START_FUNCTION(_fn_name)
#       define BUILD_MODULE_END_FUNCTION(_fn_name)
#       define SSI_MODULE_REGISTERED(_p, _a, _b, _c, _d)

#   endif

    

    

#   ifdef UDT_POKEOUTS_ON

#       define SSI_POKE(_p, _a, _b, _c, _d, _e, _f)                         \
               D_SSI_POKE(_p, _a, _b, _c, _d, _e, _f)

#   endif


    

#   ifdef UDT_ERROR_REPORTING_ON

#       define SSI_ERROR( _p, _a, _b, _c)                                   \
               D_SSI_ERROR( _p, _a, _b, _c)

#   endif




