/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
* ****** **  ** ******  *******  ****     **  **
* * ** * **  **  **  **  **   * **  **    **  **
*   **   **  **  **  **  ** *   ***       **  **
*   **    ****   *****   ****    ***      ******
*   **     **    **      ** *      ***    **  **
*   **     **    **      **   * **  ** ** **  **
*  ****   ****  ****    *******  ****  ** **  **
*
*****************************************************************************
*
* Declaration of miscellaneous types required by the toolkit.
*
*****************************************************************************
*
* Copyright (C) 1996-1999 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/





typedef CHAR_T          FAR_DATA    * P_CHAR_T,
                        FAR_CLIENT  * PCLIENT_CHAR_T;

typedef UCHAR_T         FAR_DATA    * P_UCHAR_T,
                        FAR_CLIENT  * PCLIENT_UCHAR_T;

typedef BYTE_T          FAR_DATA    * P_BYTE_T,
                        FAR_CLIENT  * PCLIENT_BYTE_T;

typedef WORD_T          FAR_DATA    * P_WORD_T,
                        FAR_CLIENT  * PCLIENT_WORD_T;

typedef LONG_T          FAR_DATA    * P_LONG_T,
                        FAR_CLIENT  * PCLIENT_LONG_T;

typedef ULONG_T         FAR_DATA    * P_ULONG_T,
                        FAR_CLIENT  * PCLIENT_ULONG_T;

typedef DWORD_T         FAR_DATA    * P_DWORD_T,
                        FAR_CLIENT  * PCLIENT_DWORD_T;

typedef INT_T           FAR_DATA    * P_INT_T,
                        FAR_CLIENT  * PCLIENT_INT_T;

typedef UINT_T          FAR_DATA    * P_UINT_T,
                        FAR_CLIENT  * PCLIENT_UINT_T;


typedef IO_HANDLE_T     FAR_DATA    * P_IO_HANDLE_T,
                        FAR_CLIENT  * PCLIENT_IO_HANDLE_T;

typedef SHARED_HANDLE_T FAR_DATA    * P_SHARED_HANDLE_T,
                        FAR_CLIENT  * PCLIENT_SHARED_HANDLE_T;

typedef FRAG_HANDLE_T   FAR_DATA    * P_FRAG_HANDLE_T,
                        FAR_FRAME_DATA * P_FRAME_DESCRIPTOR_FRAG_HANDLE_T;

typedef PCI_HANDLE_T    FAR_DATA    * P_PCI_HANDLE_T,
                        FAR_CLIENT  * PCLIENT_PCI_HANDLE_T;


typedef CODE_HANDLE_T   FAR_CLIENT  * PCLIENT_CODE_HANDLE_T;

typedef VOID_T          FAR_DATA    * P_VOID_T,
                        FAR_CLIENT  * PCLIENT_VOID_T;

typedef P_VOID_T        FAR_CLIENT  * PCLIENT_P_VOID_T;




typedef struct _UDI_DATA_T FAR_DATA * P_UDI_DATA_T;

typedef struct _UDI_INIT_DATA_T FAR_INIT_DATA  *P_UDI_INIT_DATA_T;




typedef WORD_T          ERROR_CODE_T;

typedef ERROR_CODE_T    FAR_DATA  *P_ERROR_CODE_T;




typedef VOID_T (UDT_INTER_MODULE *P_MODULE_T)(VOID_T);



typedef UINT_T MOD_SCOPE_T;

#define MOD_SCOPE_INITIALISATION 1
#define MOD_SCOPE_RUNTIME 2




typedef DWORD_T IO_LOCATION_T, FAR_CLIENT * PCLIENT_IO_LOCATION_T;




#define SIZEOF_MAC_ADDRESS              6

#ifdef UDT_ALIGN_KNOSSOS_STRUCTURES

    #pragma align 1

#endif

typedef struct _MAC_ADDRESS_T
{
    BYTE_T byte[SIZEOF_MAC_ADDRESS];
} MAC_ADDRESS_T,
  FAR_DATA  *P_MAC_ADDRESS_T,
  FAR_CLIENT * PCLIENT_MAC_ADDRESS_T;

#ifdef UDT_ALIGN_KNOSSOS_STRUCTURES

    #pragma align 0

#endif

typedef BYTE_T GROUP_ADDRESS_T[4];
typedef BYTE_T FUNCTIONAL_ADDRESS_T[4];




typedef struct _EXCLUSION_T FAR_INIT_DATA  *P_EXCLUSION_T;

typedef struct _EXCLUSION_T
{
    

    P_EXCLUSION_T      next;

    

    IDENTIFIER_TYPE_T  identifier_type;

    

    IO_LOCATION_T      io_base;
    IO_LOCATION_T      io_range;

    

    UINT_T             slot_base;
    UINT_T             slot_range;

    

    WORD_T             pci_number_base;
    WORD_T             pci_number_range;


} EXCLUSION_T;




typedef struct _ADAPTER_ID_T
{
    

    ADAPTER_TYPE_T      adapter_type;

    

    ADAPTER_SUBTYPE_T   adapter_subtype;

    

    IO_LOCATION_T       io_base;

    

    UINT_T              pci_number;

    

    BYTE_T              field_used_to_identify_card;

#   define          USE_PCI_NUMBER 0
#   define          USE_IO_BASE    1


    

    ADAPTER_STATE_T     adapter_state;


} ADAPTER_ID_T,
  FAR_INIT_DATA  *P_ADAPTER_ID_T;




#ifdef UDT_TRANSMIT_PRIORITY_SUPPORT
#include "priority.h"
#endif



#ifdef UDI_ENABLED





#define MAX_IO_REGIONS     5
#define MAX_SHARED_REGIONS 2
#ifdef UDT_DEBUG
#define MAX_FRAG_REGIONS   4
#else
#define MAX_FRAG_REGIONS   6
#endif




typedef struct _STATIC_PARAMETERS_VALUE_T
{
    

    

    DWORD_T        shared_override_mask;

    PHYS_ADDRESS_T preferred_shared_override;

    

    WORD_T         irq_mask;
    BYTE_T         preferred_irq;

    

    WORD_T         dma_channel_mask;
    BYTE_T         preferred_dma_channel;

    

    WORD_T         xfer_method_mask;
    XFER_METHOD_T  preferred_xfer_method;

    

    WORD_T         ring_speed_mask;
    RING_SPEED_T   preferred_ring_speed;

    

    WORD_T         dtr_options_mask;

    

#   ifdef UDT_USE_WATCHDOG

    UINT_T         max_watchdog_period;
    UINT_T         preferred_watchdog_period;

#   endif


    

    

    IO_LOCATION_T  io_base[MAX_IO_REGIONS];
    UINT_T         io_range[MAX_IO_REGIONS];

    

    WORD_T         pci_number;

    

#   define SHARED_REQUIRED_BUT_UNKNOWN 0

    PHYS_ADDRESS_T shared_phys[MAX_SHARED_REGIONS];
    UINT_T         shared_maximum_offset[MAX_SHARED_REGIONS];

    

    FRAG_TYPE_T    frag_type[MAX_FRAG_REGIONS];
    UINT_T         frag_length[MAX_FRAG_REGIONS];
    UINT_T         frag_alignment[MAX_FRAG_REGIONS];

    

    UINT_T         min_tx_slots;
    UINT_T         max_tx_slots;

    UINT_T         max_tx_slots_buffered;

    

    UINT_T         min_rx_slots;
    UINT_T         max_rx_slots;

    

    FRAG_TYPE_T    xfer_frag_type_tx;
    FRAG_TYPE_T    xfer_frag_type_rx;


    

    

    WORD_T         adapter_interface;

    

    MAC_ADDRESS_T bia;

    

    UINT_T        group_addresses;

    

    BOOLEAN_T     supports_promiscuous;

    

    OPTIONAL_FLAG_T promiscuous_enabled;

    

    BOOLEAN_T     laa_present;

    MAC_ADDRESS_T laa;


    

    BOOLEAN_T     edge_triggered_interrupts;

    

    BOOLEAN_T     shareable_interrupts;

#   ifdef UDT_UDI_SLEEP_COMMAND

    

    BOOLEAN_T     supports_sleep_command;

    

    BOOLEAN_T     auxilliary_power_detected;

#   endif

    

#   ifdef UDT_SOURCE_ROUTE_MATCHING

    BOOLEAN_T     supports_source_route_matching;

#   endif

} STATIC_PARAMETERS_VALUE_T,
  FAR_INIT_DATA  *P_STATIC_PARAMETERS_VALUE_T,
  FAR_CLIENT     *PCLIENT_STATIC_PARAMETERS_VALUE_T;




typedef struct _STATIC_PARAMETERS_STATUS_T
{
    BYTE_T preferred_adapter_if;
    BYTE_T irq_mask;
    BYTE_T preferred_irq;
    BYTE_T dma_channel_mask;
    BYTE_T preferred_dma_channel;
    BYTE_T shared_override_mask;
    BYTE_T preferred_shared_override;
    BYTE_T xfer_method_mask;
    BYTE_T preferred_xfer_method;
    BYTE_T ring_speed_mask;
    BYTE_T preferred_ring_speed;
    BYTE_T dtr_options_mask;
#   ifdef UDT_USE_WATCHDOG
    BYTE_T max_watchdog_period;
    BYTE_T preferred_watchdog_period;
#   endif

    BYTE_T io_base[MAX_IO_REGIONS];
    BYTE_T io_range[MAX_IO_REGIONS];
    BYTE_T pci_number;
    BYTE_T shared_phys[MAX_SHARED_REGIONS];
    BYTE_T shared_maximum_offset[MAX_SHARED_REGIONS];
    BYTE_T frag_type[MAX_FRAG_REGIONS];
    BYTE_T frag_length[MAX_FRAG_REGIONS];
    BYTE_T frag_alignment[MAX_FRAG_REGIONS];
    BYTE_T min_tx_slots;
    BYTE_T max_tx_slots;
    BYTE_T max_tx_slots_buffered;
    BYTE_T min_rx_slots;
    BYTE_T max_rx_slots;
    BYTE_T xfer_frag_type_tx;
    BYTE_T xfer_frag_type_rx;

    BYTE_T adapter_interface;
    BYTE_T bia;
    BYTE_T group_addresses;
    BYTE_T supports_promiscuous;
    BYTE_T promiscuous_enabled;
    BYTE_T laa_present;
    BYTE_T laa;
    BYTE_T edge_triggered_interrupts;
    BYTE_T shareable_interrupts;
#   ifdef UDT_UDI_SLEEP_COMMAND
    BYTE_T supports_sleep_command;
    BYTE_T auxilliary_power_detected;
#   endif

} STATIC_PARAMETERS_STATUS_T,
  FAR_INIT_DATA  *P_STATIC_PARAMETERS_STATUS_T,
  FAR_CLIENT     *PCLIENT_STATIC_PARAMETERS_STATUS_T;




typedef struct _STATIC_PARAMETERS_T
{
    STATIC_PARAMETERS_VALUE_T  static_value;
    STATIC_PARAMETERS_STATUS_T static_status;

    

    BOOLEAN_T     static_complete;

} STATIC_PARAMETERS_T,
  FAR_INIT_DATA  *P_STATIC_PARAMETERS_T,
  FAR_CLIENT     *PCLIENT_STATIC_PARAMETERS_T;









typedef struct _CONFIG_PARAMETERS_VALUE_T
{
    

    

    BYTE_T         irq;

    

    BYTE_T         dma_channel;

    

    PHYS_ADDRESS_T shared_override;

    

    XFER_METHOD_T  xfer_method;

    

    RING_SPEED_T   ring_speed;

    

    DTR_OPTIONS_T  dtr_options;

    

#   ifdef UDT_USE_WATCHDOG

    UINT_T         watchdog_period;

#   endif


    

    

    IO_HANDLE_T     io_handle[MAX_IO_REGIONS];

    

    PCI_HANDLE_T    pci_handle;

    

    SHARED_HANDLE_T shared_handle[MAX_SHARED_REGIONS];

    

    INIT_SHARED_HANDLE_T init_shared_handle[MAX_SHARED_REGIONS];

    

    FRAG_HANDLE_T   frag_handle[MAX_FRAG_REGIONS];

    

    UINT_T          tx_slots;

    

    UINT_T          rx_slots;


    

    

#   ifdef UDT_LIMIT_RX_LOOPS

    UINT_T    max_rx_loops;

#   endif 

    

    UINT_T    requested_max_frame_size;


    

    BOOLEAN_T tx_completion_status_required;


    

#   ifdef UDT_UDI_SLEEP_COMMAND

    BOOLEAN_T sleep_mode_may_be_used;

#   endif


} CONFIG_PARAMETERS_VALUE_T,
  FAR_DATA      *P_CONFIG_PARAMETERS_VALUE_T,
  FAR_CLIENT    *PCLIENT_CONFIG_PARAMETERS_VALUE_T;




typedef struct _CONFIG_PARAMETERS_STATUS_T
{
    BYTE_T irq;
    BYTE_T dma_channel;
    BYTE_T shared_override;
    BYTE_T xfer_method;
    BYTE_T ring_speed;
    BYTE_T dtr_options;
#   ifdef UDT_USE_WATCHDOG
    BYTE_T watchdog_period;
#   endif

    BYTE_T io_handle[MAX_IO_REGIONS];
    BYTE_T pci_handle;
    BYTE_T shared_handle[MAX_SHARED_REGIONS];
    BYTE_T init_shared_handle[MAX_SHARED_REGIONS];
    BYTE_T frag_handle[MAX_FRAG_REGIONS];
    BYTE_T tx_slots;
    BYTE_T rx_slots;

#   ifdef UDT_LIMIT_RX_LOOPS
    BYTE_T max_rx_loops;
#   endif 
    BYTE_T requested_max_frame_size;
    BYTE_T tx_completion_status_required;
    BYTE_T sleep_mode_may_be_used;

} CONFIG_PARAMETERS_STATUS_T,
  FAR_DATA      *P_CONFIG_PARAMETERS_STATUS_T,
  FAR_CLIENT    *PCLIENT_CONFIG_PARAMETERS_STATUS_T;




typedef struct _CONFIG_PARAMETERS_T
{
    CONFIG_PARAMETERS_VALUE_T  config_value;
    CONFIG_PARAMETERS_STATUS_T config_status;

} CONFIG_PARAMETERS_T,
  FAR_DATA      *P_CONFIG_PARAMETERS_T,
  FAR_CLIENT    *PCLIENT_CONFIG_PARAMETERS_T;




typedef struct _UDTI_INFO_T
{
    

    UINT_T min_lookahead_frag_length;

    

    BOOLEAN_T  can_dma_above_16meg;

    

    

    UINT_T    max_tx_frags;

    

    UINT_T    min_first_tx_frag_length;
    UINT_T    max_first_tx_frag_length;

    

    UINT_T    min_tx_frag_length;
    UINT_T    max_tx_frag_length;


    

    

    UINT_T max_rx_frags;

    

    UINT_T min_first_rx_frag_length;
    UINT_T max_first_rx_frag_length;

    

    UINT_T min_rx_frag_length;
    UINT_T max_rx_frag_length;

    

    UINT_T rx_class;


} UDTI_INFO_T,
  FAR_INIT_DATA *P_UDTI_INFO_T,
  FAR_CLIENT    *PCLIENT_UDTI_INFO_T;




typedef struct _ADAPTER_PARAMETERS_T
{
    

    ADAPTER_TYPE_T    adapter_type;

    

    ADAPTER_SUBTYPE_T adapter_subtype;

    

    UINT_T            adapter_ram_size;

    

    UDT_BUS_TYPE_T    bus_type;

    

    ADAPTER_ID_T      adapter_id;


} ADAPTER_PARAMETERS_T,
  FAR_DATA  *P_ADAPTER_PARAMETERS_T;

#endif 


typedef struct _FRAME_T FAR_FRAME_DATA * P_FRAME_T;

typedef VOID_T
(UDT_INDIRECT *UPCALL_XFER_COMPLETE_T)(
    INOUT P_DRIVER_T dds_ptr,
    IN    P_FRAME_T  frame,
          UINT_T     handle);




typedef struct _FRAME_T
{
    

    P_FRAME_T              next;

    

    UINT_T                 frame_length;

    

    UINT_T                 data_length;

    

    FRAME_STATUS_T         rx_status;

    

    FRAG_HANDLE_T          lookahead_frag;

    

    UINT_T                 lookahead_frag_length;

    

    P_FRAME_DESCRIPTOR_FRAG_HANDLE_T  frag_array_ptr;

    

    UINT_T                 frag_array_length;

    

    UPCALL_XFER_COMPLETE_T xfer_complete;

    

    PCLIENT_VOID_T         driver_ptr;

    

    UINT_T                 current_frag;
    UINT_T                 current_offset;


} FRAME_T;




typedef struct _OPEN_INFO_T
{
    

    OPEN_ERROR_T error_code;

    

    OPEN_PHASE_T fault_phase;

    

    RING_SPEED_T  ring_speed;

    

    UINT_T        max_frame_size_avail;

    

    UINT_T        max_rcv_buf_size;

    

    UINT_T        max_frame_size;

    

    OPEN_MODE_T   mode;

} OPEN_INFO_T,
  FAR_DATA  *P_OPEN_INFO_T;






#ifdef DOS_ODI_TEMPORARY_FUDGE



typedef enum {

    UDT_COMMAND_OPEN = 1,
    UDT_COMMAND_CLOSE=14,
    UDT_COMMAND_UPDATE_ERROR_LOG=99,
    UDT_COMMAND_SET_PROMISCUOUS_MODE=120,
    UDT_COMMAND_SET_GROUP_ADDRESS=122,
    UDT_COMMAND_SET_FUNCTIONAL_ADDRESS=139,
    UDT_COMMAND_SET_PRODUCT_INSTANCE_ID=166,
    UDT_COMMAND_INITIALISE=174,                
    UDT_COMMAND_INTERRUPT_HOST=203,            
    UDT_COMMAND_TRANSMIT_DIR_FRAME=205,        
    UDT_COMMAND_SLEEP=243,
#ifdef OLICOM_HEBE_UDI
    UDT_RESTART_RX=111,
#endif
} ASYNC_COMMAND_TYPE_T;

#else

typedef enum {

    UDT_COMMAND_OPEN = 1,
    UDT_COMMAND_CLOSE,
    UDT_COMMAND_UPDATE_ERROR_LOG,
    UDT_COMMAND_SET_PROMISCUOUS_MODE,
#   ifdef UDT_SOURCE_ROUTE_MATCHING
    UDT_COMMAND_SET_SOURCE_ROUTE_MATCHING,
#   endif
    UDT_COMMAND_SET_GROUP_ADDRESS,
    UDT_COMMAND_SET_FUNCTIONAL_ADDRESS,
    UDT_COMMAND_SET_PRODUCT_INSTANCE_ID,
    UDT_COMMAND_INITIALISE,                
    UDT_COMMAND_INTERRUPT_HOST,            
    UDT_COMMAND_TRANSMIT_DIR_FRAME,        
    UDT_COMMAND_SLEEP,
#ifdef OLICOM_HEBE_UDI
    UDT_RESTART_RX,
#endif

} ASYNC_COMMAND_TYPE_T;

#endif



typedef union _ASYNC_COMMAND_PARAMETERS_ {

    OPEN_OPTION_T           open_mode;

    PROMISCUOUS_LEVEL_T     promiscuous_level;

#   ifdef UDT_SOURCE_ROUTE_MATCHING

    struct
    {
        BOOLEAN_T           enable_matching;
        UINT_T              source_ring_number;
        UINT_T              bridge_number;
        UINT_T              destination_ring_number;
        BOOLEAN_T           single_route_matching;
    } source_route_matching_info;

#   endif 

    struct
    {
        UINT_T              index;
        MAC_ADDRESS_T       group_address;
    } group_address_info;

    MAC_ADDRESS_T           functional_address;

    CHAR_T                  product_instance_id[18];

    struct
    {
        BOOLEAN_T           use_auxilliary_power_supply;
        BOOLEAN_T           use_pme;
        BOOLEAN_T           wake_up_if_magic_packet;
        BOOLEAN_T           wake_up_if_template_matches;
        UINT_T              template_data_length;
        PCLIENT_BYTE_T      template_data;
        BOOLEAN_T           wake_up_if_cable_present;
        BOOLEAN_T           wake_up_if_cable_absent;

    } sleep_info;

} ASYNC_COMMAND_PARAMETERS_T,
  FAR_CLIENT * PCLIENT_ASYNC_COMMAND_PARAMETERS_T;




typedef union _UDT_ARGUMENT_T_
{
    CLIENT_ARGUMENT_T   client_argument;
    P_UDI_DATA_T        udt_argument;
} UDT_ARGUMENT_T,
  FAR_CLIENT * PCLIENT_UDT_ARGUMENT_T;




typedef VOID_T
(UDT_INDIRECT *UPCALL_COMMAND_COMPLETE_T)(
    INOUT P_DRIVER_T             dds_ptr,
    IN    PCLIENT_UDT_ARGUMENT_T argument,
          RETCODE_T              response);

typedef struct _ASYNC_COMMAND_PACKET_T_ {

    ASYNC_COMMAND_TYPE_T        type;
    ASYNC_COMMAND_PARAMETERS_T  parameters;
    UPCALL_COMMAND_COMPLETE_T   completion;
    UDT_ARGUMENT_T              argument;    
                                             

} ASYNC_COMMAND_PACKET_T,
  FAR_DATA *   P_ASYNC_COMMAND_PACKET_T,
  FAR_CLIENT * PCLIENT_ASYNC_COMMAND_PACKET_T;




#define MAX_GROUP_ADDRESSES     1

typedef struct _ERROR_LOG_T
{
    

    

    ULONG_T line_errors;

    

    ULONG_T internal_errors;

    

    ULONG_T burst_errors;

    

    ULONG_T ari_fci_errors;

    

    ULONG_T abort_delimiters;

    

    ULONG_T lost_frame_errors;

    

    ULONG_T congestion_errors;

    

    ULONG_T frame_copied_errors;

    

    ULONG_T frequency_errors;

    

    ULONG_T token_errors;

    

    ULONG_T dma_bus_errors;

    

    ULONG_T dma_parity_errors;


} ERROR_LOG_T,
  FAR_DATA  *P_ERROR_LOG_T;

typedef struct _COUNTERS_T
{
    

    

    ULONG_T tx_bytes;

    

    ULONG_T tx_frames;

    

    ULONG_T tx_no_resources;

    

    ULONG_T rx_bytes;

    

    ULONG_T rx_frames;

    

    ULONG_T rx_aborts;

    

#   ifdef UDT_EXTENDED_COUNTERS

    ULONG_T rx_overruns;

#   endif

} COUNTERS_T,
  FAR_DATA  *P_COUNTERS_T;


typedef struct _STATS_T
{
    

    

    MAC_ADDRESS_T       node_address;

    

    MAC_ADDRESS_T       upstream_node_address;

    

    MAC_ADDRESS_T       group_address[MAX_GROUP_ADDRESSES];

    

    MAC_ADDRESS_T       functional_address;

    

    PROMISCUOUS_LEVEL_T promiscuous_level;

    

    CHAR_T              product_instance_id[18];


    

    OPEN_INFO_T open_info;


    

    

    WORD_T      ring_status;

    

    WORD_T      last_beacon_type;

    

    WORD_T      local_ring_number;

    

    UDI_STATE_T udi_state;


    

#ifdef UDT_TRANSMIT_PRIORITY_SUPPORT

    

    USER_PRIORITY_TABLE_T   priority_table;

    

    UINT_T                  priority_lookahead;

#endif

    

    BOOLEAN_T command_pending;


    

#   ifndef UDT_DRIVER_REQUIRED_COMMAND_QUEUE_ENTRIES
#       define UDT_DRIVER_REQUIRED_COMMAND_QUEUE_ENTRIES 1
#   endif

#   define MAX_COMMAND_QUEUE_ENTRIES \
               (4 + UDT_DRIVER_REQUIRED_COMMAND_QUEUE_ENTRIES)

    ASYNC_COMMAND_PACKET_T command_queue[MAX_COMMAND_QUEUE_ENTRIES];

    UINT_T command_queue_in_use;   
    UINT_T command_queue_free;     
    UINT_T command_queue_next;     


    

#   ifndef UDT_HOUSEKEEPING_NOT_CALLED

#   define UDT_REQUIRED_CLOSE_PERIOD 1000000
#   define UDT_REQUIRED_OPEN_PERIOD   250000

    BOOLEAN_T first_housekeeping_call_made;
    DWORD_T microseconds_while_closed;
    DWORD_T microseconds_while_open;

#   endif 

    

    UINT_T lookahead_size;


    

    BOOLEAN_T pme_occurred;


    

#ifdef UDT_MAINTAIN_COUNTERS

    COUNTERS_T  counters;

#endif

    ERROR_LOG_T error_log;


} STATS_T,
  FAR_DATA    *P_STATS_T,
  FAR_CLIENT  *PCLIENT_STATS_T;




#ifdef UDT_DECOMPRESS_BIN_FILES



typedef struct _SF_TREE_T
{
    BYTE_T   bit_length;
    BYTE_T   value;
    WORD_T   tree_code;
} SF_TREE_T,
  FAR_DATA    *P_SF_TREE_T,
  FAR_CLIENT  *PCLIENT_SF_TREE_T;

#define DECOMPRESS_TREE_ENTRIES     64
#define DECOMPRESS_BUFFER_SIZE      4096
#define DECOMPRESS_BUFFER_MASK      (DECOMPRESS_BUFFER_SIZE-1)

typedef struct _DECOMPRESS_WORKSPACE_T
{
    

    P_UDI_DATA_T udids_ptr;

    

    PCLIENT_CODE_HANDLE_T code_handle_ptr;

    

    SF_TREE_T len_tree [DECOMPRESS_TREE_ENTRIES];
    SF_TREE_T dist_tree [DECOMPRESS_TREE_ENTRIES];

    

    BYTE_T    buffer[DECOMPRESS_BUFFER_SIZE];
    UINT_T    least_recent_byte;

    

    WORD_T    pending_bits;
    UINT_T    pending_bit_count;

    

    UINT_T    copy_offset;
    UINT_T    copy_bytes_left;

} DECOMPRESS_WORKSPACE_T,
  FAR_DATA    *P_DECOMPRESS_WORKSPACE_T,
  FAR_CLIENT  *PCLIENT_DECOMPRESS_WORKSPACE_T;

#endif 




#ifdef UDT_TRANSMIT_PRIORITY_SUPPORT

#ifdef UDT_PACK_ON
#pragma UDT_PACK_ON
#else
#ifdef UDT_ALT_PACK
#pragma pack 1
#else
#pragma pack(1)
#endif
#endif



typedef struct _ROUTING_CONTROL_T
{
    WORD_T          length      : 5;
    WORD_T          reserved1   : 1;
    WORD_T          limited     : 1;
    WORD_T          broadcast   : 1;
    WORD_T          reserved2   : 4;
    WORD_T          maxFrame    : 3;
    WORD_T          direction   : 1;

} ROUTING_CONTROL_T;

#define LIMITED_BROADCAST_CONTROL { 2, 0, TRUE, TRUE, 0, 7, 0 }
#define GENERAL_BROADCAST_CONTROL { 2, 0, FALSE, TRUE, 0, 7, 0 }

#define LIMITED_BROADCAST_CONTROL_WORD 0x70C2
#define GENERAL_BROADCAST_CONTROL_WORD 0x7082



typedef union _ROUTING_INFO_T
{

    ROUTING_CONTROL_T control;
    struct
    {
        WORD_T      control;
        WORD_T      segment[14];

    }               word;

} ROUTING_INFO_T;



typedef union _ACCESS_CONTROL_T
{

    struct
    {
        BYTE_T      reservation : 3;
        BYTE_T      monitor     : 1;
        BYTE_T      token       : 1;
        BYTE_T      priority    : 3;

    } bit;

    BYTE_T          byte;

} ACCESS_CONTROL_T;



#define TRN_FRAME_TYPE_MAC      0x00
#define TRN_FRAME_TYPE_LLC      0x01
#define TRN_FRAME_TYPE_RES1     0x02
#define TRN_FRAME_TYPE_RES2     0x03

typedef union _FRAME_CONTROL_T
{

    struct {

        BYTE_T      control : 6;
        BYTE_T      type    : 2;

    } bit;

    BYTE_T          byte;

} FRAME_CONTROL_T;



typedef struct _TRN_HEADER_T
{
    ACCESS_CONTROL_T ac;
    FRAME_CONTROL_T  fc;
    MAC_ADDRESS_T    destination;
    MAC_ADDRESS_T    source;
    ROUTING_INFO_T   route;

} TRN_HEADER_T;



typedef struct _TRN_HEADER_SHORT_T
{
    BYTE_T           ac;
    BYTE_T           fc;
    MAC_ADDRESS_T    destination;
    MAC_ADDRESS_T    source;

} TRN_HEADER_SHORT_T;



typedef struct _DLC_HEADER_T 
{
    BYTE_T          dsap;
    BYTE_T          ssap;
    BYTE_T          control1;
    BYTE_T          control2;

} DLC_HEADER_T;



#define SNAP_DSAP_SSAP  0xAAAA
#define SNAP_CONTROL    0x03
#define SNAP_PROT_IP    0x0800
#define SNAP_PROT_ARP   0x0806
#define SNAP_PROT_IPX   0x8137

typedef struct _SNAP_HEADER_T
{
    BYTE_T          global[3];
    WORD_T          protocol;
} SNAP_HEADER_T;



#define IPX_DSAP_SSAP   0xE0E0
#define IPX_CONTROL     0x03
#define IPX_CHECKSUM    0xFFFF

typedef struct _IPX_HEADER_T
{
    WORD_T          checksum; 
    WORD_T          length;   
    BYTE_T          transport_control;
    BYTE_T          packet_type;
    
    DWORD_T         dest_network;
    MAC_ADDRESS_T   dest_node;
    WORD_T          dest_socket;
    
    DWORD_T         source_network;
    MAC_ADDRESS_T   source_node;
    WORD_T          source_socket;

} IPX_HEADER_T;



#define IP_PROT_UDP     17
#define IP_PROT_TCP     6

typedef struct _IP4_HEADER_T
{
    struct
    {
        BYTE_T      header_length : 4;
        BYTE_T      version       : 4;
    } length_and_version;

    BYTE_T          service_type;
    WORD_T          length;
    WORD_T          id;
    WORD_T          flags;
    BYTE_T          time_to_live;
    BYTE_T          protocol;
    WORD_T          checksum;
    DWORD_T         source;
    DWORD_T         destination;
    BYTE_T          options;
    BYTE_T          padding[3];

} IP4_HEADER_T;



typedef struct _UDP_HEADER_T
{
    WORD_T          source_port;
    WORD_T          dest_port;
    WORD_T          length;
    WORD_T          checksum;

} UDP_HEADER_T;



typedef struct _TCP_HEADER_T
{
    WORD_T          source_port;
    WORD_T          dest_port;
    DWORD_T         seq_number;
    DWORD_T         ack_number;
    WORD_T          flags;
    WORD_T          window;
    WORD_T          checksum;
    WORD_T          urgent_ptr;


} TCP_HEADER_T;



#define MAX_PRIORITY_LOOKAHEAD (sizeof(TRN_HEADER_T)  +  \
                                3                     +  \
                                sizeof(SNAP_HEADER_T) +  \
                                sizeof(IP4_HEADER_T)  +  \
                                4)



#define MIN_DSAP_SSAP   3
#define MIN_SNAP        3 + sizeof(SNAP_HEADER_T)
#define MIN_IP          3 + sizeof(SNAP_HEADER_T) + sizeof(IP4_HEADER_T)
#define MIN_UDP         3 + sizeof(SNAP_HEADER_T) + sizeof(IP4_HEADER_T) + sizeof(UDP_HEADER_T)
#define MIN_TCP         3 + sizeof(SNAP_HEADER_T) + sizeof(IP4_HEADER_T) + sizeof(UDP_HEADER_T)
#define MIN_IPX_SNAP    3 + sizeof(SNAP_HEADER_T) + sizeof(IPX_HEADER_T)
#define MIN_IPX         3 + sizeof(IPX_HEADER_T)


#ifdef UDT_PACK_OFF
#pragma UDT_PACK_OFF
#else
#ifdef UDT_ALT_PACK
#pragma pack 0
#else
#pragma pack()
#endif
#endif

#endif 



