/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
* **  ** *****   ****    **  **
* **  **  ** **   **     **  **
* **  **  **  **  **     **  **
* **  **  **  **  **     ******
* **  **  **  **  **     **  **
* **  **  ** **   **  ** **  **
* ****** *****   **** ** **  **
*
*****************************************************************************
*
* This file contains:
*
*     - Declaration of the following functions provided by the tookit for the
*       client to use across the UDI:
*
*         - UDI get paramters                  (indirect)
*         - UDI commit paramters
*         - UDI register UDTI                  (indirect)
*
*         - UDI kill promiscuous mode
*
*         - UDI open
*         - UDI close
*         - UDI update error log
*         - UDI set promiscuous mode
*         - UDI set source route matching
*         - UDI set group address
*         - UDI set functional address
*         - UDI set product instance id
*         - UDI request interrupt from adapter
*         - UDI sleep
*
*         - UDI kill                           (indirect)
*         - UDI abort transmits                (indirect)
*         - UDI housekeeping
*         - UDI set node address               (indirect)
*         - UDI read adapter interrupt status  (indirect)
*         - UDI process adapter interrupts     (indirect)
*         - UDI enable adapter interrupts      (indirect)
*         - UDI disable adapter interrupts     (indirect)
*         - UDI regenerate adapter interrupt   (indirect)
*
*         See also UDI_HC46_READ/WRITE_WORD and UDI_CAN_CONFIGURE in
*         COMMON.H.
*
*    - Macros for calling all of the above funcions. E.g. UDI_OPEN.
*
*    - UDI_INIT_T and UDI_RES_T, containing pointers for the indirectly
*      called functions listed above.
*
*    - Definition of UDI_DATA_T:
*
*          /- UDI_DATA_T ----------------------\
*          |                                   |
*          |  o--------------------------------+--\
*          |                                   |  |
*          |  /- UDI_RES_DATA_T -------------\ |  |
*          |  |                              | |  v
*          |  |  /-UDI_RES_FUNCTION_PTRS_T-\ | |  /- UDI_INIT_DATA_T --------\
*          |  |  |                         | | |  |                          |
*          |  |  | UPCALL_FN_T             | | |  | UDI_INIT_FUNCTION_PTRS_T |
*          |  |  |                         | | |  | |                      | |
*          |  |  | UDI_RES_T               | | |  | |  UDI_INIT_T          | |
*          |  |  |   Res UDI fn ptrs       | | |  | |    Init UDI fn ptrs  | |
*          |  |  |                         | | |  | |                      | |
*          |  |  | UDTI_T                  | | |  | |                      | |
*          |  |  |                         | | |  | |                      | |
*          |  |  | COMMON_RES_T            | | |  | |                      | |
*          |  |  |                         | | |  | |                      | |
*          |  |  | ADAPTER_RES_T           | | |  | |  ADAPTER_INIT_T      | |
*          |  |  |   Smart/blue/knossos    | | |  | |   Smart/blue/knossos | |
*          |  |  |                         | | |  | |                      | |
*          |  |  \-------------------------/ | |  | \----------------------/ |
*          |  |                              | |  |                          |
*          |  |  UPCALL_T                    | |  |                          |
*          |  |                              | |  |                          |
*          |  |  UDTI_INFO_T                 | |  |                          |
*          |  |                              | |  |                          |
*   /------+--+--o                           | |  |                          |
*   |      |  |                              | |  |                          |
*   |      |  |  CONFIG_PARAMETERS_T         | |  |  STATIC_PARAMTERS_T      |
*   |      |  |    See types.h               | |  |    See types.h           |
*   |      |  |                              | |  |                          |
*   |      |  |  ADAPTER_PARAMTERS_T         | |  |                          |
*   |      |  |    See types.h               | |  |                          |
*   v      |  |                              | |  |                          |
* Driver   |  |  STATS_T                     | |  |                          |
* data     |  |    See types.h               | |  |                          |
* space    |  |                              | |  |                          |
*          |  |  ADAPTER_RES_INFO_T          | |  |  ADAPTER_INIT_INFO_T     |
*          |  |    Smart/blue/knossos        | |  |    Smart/blue/knossos    |
*          |  |                              | |  |                          |
*          |  |  ADAPTER_PERSISTENT_RES_INFO_T |  |                          |
*          |  |    Smart/blue/knossos        | |  |                          |
*          |  |                              | |  |  DECOMPRESS_WORKSPACE_T  |
*          |  |  UDI_GENERAL_RES_T           | |  |                          |
*          |  |    AT24 & HC46 info          | |  \--------------------------/
*          |  |                              | |
*          |  \------------------------------/ |
*          |                                   |
*          \-----------------------------------/
*
*****************************************************************************
*
* Copyright (C) 1996-1999 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/








typedef RETCODE_T
(UDT_INDIRECT *UDI_GET_PARAMETERS_T)(
    INOUT P_UDI_DATA_T                       udids_ptr,
    OUT   PCLIENT_BOOLEAN_T                  completed);




RETCODE_T
UDT_PUBLIC common_commit_parameters(
    INOUT P_UDI_DATA_T                       udids_ptr,
          BOOLEAN_T                          ints_on,
          UPCALL_COMMAND_COMPLETE_T          completion,
    IN    PCLIENT_UDT_ARGUMENT_T             argument);



typedef RETCODE_T
(UDT_INDIRECT *ADAPTER_COMMIT_PARAMETERS_T)(
    INOUT P_UDI_DATA_T                       udids_ptr,
          BOOLEAN_T                          ints_on);




typedef RETCODE_T
(UDT_INDIRECT *UDI_REGISTER_UDTI_T)(
    INOUT P_UDI_DATA_T         udids_ptr,
          UPCALL_TX_COMPLETE_T tx_complete,
          UPCALL_PRE_RX_T      pre_rx,
          UPCALL_RX_T          rx,
    IN    P_FRAME_T            rx_list);



#ifdef UDT_KILL_PROMISCUOUS_MODE

RETCODE_T
UDT_PUBLIC common_kill_promiscuous_mode(
    INOUT P_UDI_DATA_T              udids_ptr);

#endif 






RETCODE_T
UDT_PUBLIC common_open(
    INOUT P_UDI_DATA_T                       udids_ptr,
    IN    OPEN_OPTION_T                      open_mode,
    IN    UPCALL_COMMAND_COMPLETE_T          completion,
    IN    PCLIENT_UDT_ARGUMENT_T             argument);




RETCODE_T
UDT_PUBLIC common_close(
    INOUT P_UDI_DATA_T                       udids_ptr,
    IN    UPCALL_COMMAND_COMPLETE_T          completion,
    IN    PCLIENT_UDT_ARGUMENT_T             argument);




RETCODE_T
UDT_PUBLIC common_update_error_log(
    INOUT P_UDI_DATA_T                       udids_ptr,
    IN    UPCALL_COMMAND_COMPLETE_T          completion,
    IN    PCLIENT_UDT_ARGUMENT_T             argument);




RETCODE_T
UDT_PUBLIC common_set_promiscuous_mode(
    INOUT P_UDI_DATA_T                       udids_ptr,
    IN    PROMISCUOUS_LEVEL_T                level,
    IN    UPCALL_COMMAND_COMPLETE_T          completion,
    IN    PCLIENT_UDT_ARGUMENT_T             argument);




#   ifdef UDT_SOURCE_ROUTE_MATCHING

RETCODE_T
UDT_PUBLIC common_set_source_route_matching(
    INOUT P_UDI_DATA_T                       udids_ptr,
    IN    BOOLEAN_T                          enable_matching,
    IN    UINT_T                             source_ring_number,
    IN    UINT_T                             bridge_number,
    IN    UINT_T                             destination_ring_number,
    IN    BOOLEAN_T                          single_route_matching,
    IN    UPCALL_COMMAND_COMPLETE_T          completion,
    IN    PCLIENT_UDT_ARGUMENT_T             argument);

#   endif 




RETCODE_T
UDT_PUBLIC common_set_group_address(
    INOUT P_UDI_DATA_T                       udids_ptr,
    IN    UINT_T                             index,
    IN    PCLIENT_MAC_ADDRESS_T              group_address,
    IN    UPCALL_COMMAND_COMPLETE_T          completion,
    IN    PCLIENT_UDT_ARGUMENT_T             argument);




RETCODE_T
UDT_PUBLIC common_set_functional_address(
    INOUT P_UDI_DATA_T                       udids_ptr,
    IN    PCLIENT_MAC_ADDRESS_T              functional_address,
    IN    UPCALL_COMMAND_COMPLETE_T          completion,
    IN    PCLIENT_UDT_ARGUMENT_T             argument);




RETCODE_T
UDT_PUBLIC common_set_product_instance_id(
    INOUT P_UDI_DATA_T                       udids_ptr,
    IN    STRING_T                           id,
    IN    UPCALL_COMMAND_COMPLETE_T          completion,
    IN    PCLIENT_UDT_ARGUMENT_T             argument);




RETCODE_T
UDT_PUBLIC common_request_interrupt_from_adapter(
    INOUT P_UDI_DATA_T                       udids_ptr);




#ifdef UDT_UDI_SLEEP_COMMAND

RETCODE_T
UDT_PUBLIC common_sleep(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    BOOLEAN_T                 use_auxilliary_power_supply,
    IN    BOOLEAN_T                 use_pme,
    IN    BOOLEAN_T                 wake_up_if_magic_packet,
    IN    BOOLEAN_T                 wake_up_if_template_matches,
    IN    UINT_T                    template_data_length,
    IN    PCLIENT_BYTE_T            template_data,
    IN    BOOLEAN_T                 wake_up_if_cable_present,
    IN    BOOLEAN_T                 wake_up_if_cable_absent,
    IN    UPCALL_COMMAND_COMPLETE_T completion,
    IN    PCLIENT_UDT_ARGUMENT_T    argument);

#endif 




#ifdef OLICOM_HEBE_UDI

RETCODE_T UDT_PUBLIC
common_startrx(
    INOUT P_UDI_DATA_T              udids_ptr);

#endif  





typedef RETCODE_T
(UDT_INDIRECT *UDI_KILL_T)(
    INOUT P_UDI_DATA_T udids_ptr);




typedef RETCODE_T
(UDT_INDIRECT *UDI_ABORT_TXS_T)(
    INOUT P_UDI_DATA_T udids_ptr);




#ifndef UDT_HOUSEKEEPING_NOT_CALLED

VOID_T
UDT_PUBLIC common_housekeeping(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    DWORD_T                   microseconds_since_last_call);



typedef VOID_T
(UDT_INDIRECT *UDI_HOUSEKEEPING_T)(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    DWORD_T                   microseconds_since_last_call);

#endif 



typedef RETCODE_T
(UDT_INDIRECT *UDI_SET_NODE_ADDRESS_T)(
    INOUT P_UDI_DATA_T         udids_ptr,
    IN    PCLIENT_MAC_ADDRESS_T node_address);




#define UDT_INTERRUPT_NOT_OURS             0
#define UDT_ADAPTER_SIGNALLED_INTERRUPT    1
#define UDT_INTERRUPT_PROCESSING_REQUIRED  3

typedef UINT_T
(UDT_INDIRECT *UDI_READ_ADAPTER_INTERRUPT_STATUS_T)(
    INOUT P_UDI_DATA_T       udids_ptr);




typedef VOID_T
(UDT_INDIRECT *UDI_PROCESS_ADAPTER_INTERRUPTS_T)(
    INOUT P_UDI_DATA_T udids_ptr);




typedef RETCODE_T
(UDT_INDIRECT *UDI_ENABLE_ADAPTER_INTERRUPTS_T)(
    INOUT P_UDI_DATA_T udids_ptr);




typedef RETCODE_T
(UDT_INDIRECT *UDI_DISABLE_ADAPTER_INTERRUPTS_T)(
    INOUT P_UDI_DATA_T udids_ptr);




#ifdef UDT_REGENERATE_INTERRUPTS

typedef RETCODE_T
(UDT_INDIRECT *UDI_REGENERATE_ADAPTER_INTERRUPT_T)(
    INOUT P_UDI_DATA_T udids_ptr);

#endif 



#ifdef UDT_TRANSMIT_PRIORITY_SUPPORT

VOID_T
UDT_PUBLIC common_calculate_priority_lookahead(
    IN P_UDI_DATA_T udids_ptr);

#endif 



#ifdef UDT_TRANSMIT_PRIORITY_SUPPORT

UINT_T
UDT_PUBLIC common_get_transmit_priority(
    IN P_UDI_DATA_T udids_ptr,
    IN P_BYTE_T     frame,
    IN UINT_T       frame_length);

#endif 





#   define UDI_COMMIT_PARAMETERS(_p, _a, _b, _c)                            \
           common_commit_parameters(                                        \
                                        (_p),                               \
                                        (_a),                               \
                                        (_b),                               \
                                        (_c))

typedef struct _UDI_INIT_T
{
    UDI_GET_PARAMETERS_T                udi_get_parameters;

#   define UDI_GET_PARAMETERS(_p, _a)                                       \
           (UDI_INIT_FROM_UDIDS(_p).udi_get_parameters(                     \
                                        (_p),                               \
                                        (_a)))

    

    ADAPTER_COMMIT_PARAMETERS_T         udi_commit_parameters;


    UDI_REGISTER_UDTI_T                 udi_register_udti;

#   define UDI_REGISTER_UDTI(_p, _a, _b, _c, _d)                            \
           (UDI_INIT_FROM_UDIDS(_p).udi_register_udti(                      \
                                        (_p),                               \
                                        (_a),                               \
                                        (_b),                               \
                                        (_c),                               \
                                        (_d)))
} UDI_INIT_T;

#ifdef UDT_KILL_PROMISCUOUS_MODE

#   define UDI_KILL_PROMISCUOUS_MODE(_p)                                    \
           common_kill_promiscuous_mode(_p)

#endif 




#   define UDI_OPEN(_p, _a, _b, _c)                                         \
           common_open(                                                     \
                                       (_p),                                \
                                       (_a),                                \
                                       (_b),                                \
                                       (_c))

#   define UDI_CLOSE(_p, _a, _b)                                            \
           common_close(                                                    \
                                       (_p),                                \
                                       (_a),                                \
                                       (_b))

#   define UDI_UPDATE_ERROR_LOG(_p, _a, _b)                                 \
           common_update_error_log(                                         \
                                       (_p),                                \
                                       (_a),                                \
                                       (_b))

#   define UDI_SET_PROMISCUOUS_MODE(_p, _a, _b, _c)                         \
           common_set_promiscuous_mode(                                     \
                                       (_p),                                \
                                       (_a),                                \
                                       (_b),                                \
                                       (_c))

#   ifdef UDT_SOURCE_ROUTE_MATCHING

#   define UDI_SET_SOURCE_ROUTE_MATCHING(_p, _a, _b, _c, _d, _e, _f, _g)    \
           common_set_source_route_matching(                                \
                                       (_p),                                \
                                       (_a),                                \
                                       (_b),                                \
                                       (_c),                                \
                                       (_d),                                \
                                       (_e),                                \
                                       (_f),                                \
                                       (_g))

#   endif 

#   define UDI_SET_GROUP_ADDRESS(_p, _a, _b, _c, _d)                        \
           common_set_group_address(                                        \
                                       (_p),                                \
                                       (_a),                                \
                                       (_b),                                \
                                       (_c),                                \
                                       (_d))

#   define UDI_SET_FUNCTIONAL_ADDRESS(_p, _a, _b, _c)                       \
           common_set_functional_address(                                   \
                                       (_p),                                \
                                       (_a),                                \
                                       (_b),                                \
                                       (_c))

#   define UDI_SET_PRODUCT_INSTANCE_ID(_p, _a, _b, _c)                      \
           common_set_product_instance_id(                                  \
                                       (_p),                                \
                                       (_a),                                \
                                       (_b),                                \
                                       (_c))

#   define UDI_REQUEST_INTERRUPT_FROM_ADAPTER(_p)                           \
           common_request_interrupt_from_adapter(_p)

#   define UDI_SLEEP(_p, _a, _b, _c, _d, _e, _f, _g, _h, _i, _j)            \
           common_sleep(                                                    \
                                       (_p),                                \
                                       (_a),                                \
                                       (_b),                                \
                                       (_c),                                \
                                       (_d),                                \
                                       (_e),                                \
                                       (_f),                                \
                                       (_g),                                \
                                       (_h),                                \
                                       (_i),                                \
                                       (_j))

#   ifdef OLICOM_HEBE_UDI

#   define UDI_STARTRX(_p)                                                  \
           common_startrx(                                                  \
                                       (_p))
#   endif 

#   ifndef UDT_HOUSEKEEPING_NOT_CALLED

#   define UDI_HOUSEKEEPING(_p, _a)                                         \
           common_housekeeping(                                             \
                                       (_p),                                \
                                       (_a))

#   endif 

#   ifdef UDT_TRANSMIT_PRIORITY_SUPPORT

#   define UDI_CALCULATE_PRIORITY_LOOKAHEAD(_p)                             \
           common_calculate_priority_lookahead(_p)

#   define UDI_GET_TRANSMIT_PRIORITY(_p, _a, _b)                            \
           common_get_transmit_priority(                                    \
                                       (_p),                                \
                                       (_a),                                \
                                       (_b))

#   endif 



typedef struct _UDI_RES_T
{
    UDI_KILL_T                          udi_kill;

#   define UDI_KILL(_p)                                                     \
           (UDI_RES_FROM_UDIDS(_p).udi_kill(                                \
                                       (_p)))

    UDI_ABORT_TXS_T                     udi_abort_txs;

#   define UDI_ABORT_TXS(_p)                                                \
           (UDI_RES_FROM_UDIDS(_p).udi_abort_txs(                           \
                                       (_p)))
    

#   ifndef UDT_HOUSEKEEPING_NOT_CALLED
    UDI_HOUSEKEEPING_T                  udi_housekeeping;
#   endif 

    UDI_SET_NODE_ADDRESS_T              udi_set_node_address;

#   define UDI_SET_NODE_ADDRESS(_p, _a)                                     \
           (UDI_RES_FROM_UDIDS(_p).udi_set_node_address(                    \
                                       (_p),                                \
                                       (_a)))

    UDI_READ_ADAPTER_INTERRUPT_STATUS_T udi_read_adapter_interrupt_status;

#   define UDI_READ_ADAPTER_INTERRUPT_STATUS(_p)                            \
           (UDI_RES_FROM_UDIDS(_p).udi_read_adapter_interrupt_status(       \
                                       (_p)))

    UDI_PROCESS_ADAPTER_INTERRUPTS_T    udi_process_adapter_interrupts;

#   define UDI_PROCESS_ADAPTER_INTERRUPTS(_p)                               \
           (UDI_RES_FROM_UDIDS(_p).udi_process_adapter_interrupts(          \
                                       (_p)))

    UDI_ENABLE_ADAPTER_INTERRUPTS_T     udi_enable_adapter_interrupts;

#   define UDI_ENABLE_ADAPTER_INTERRUPTS(_p)                                \
           (UDI_RES_FROM_UDIDS(_p).udi_enable_adapter_interrupts(           \
                                       (_p)))

    UDI_DISABLE_ADAPTER_INTERRUPTS_T    udi_disable_adapter_interrupts;

#   define UDI_DISABLE_ADAPTER_INTERRUPTS(_p)                               \
           (UDI_RES_FROM_UDIDS(_p).udi_disable_adapter_interrupts(          \
                                       (_p)))

#ifdef UDT_REGENERATE_INTERRUPTS

    UDI_REGENERATE_ADAPTER_INTERRUPT_T  udi_regenerate_adapter_interrupt;

#   define UDI_REGENERATE_ADAPTER_INTERRUPT(_p)                             \
           (UDI_RES_FROM_UDIDS(_p).udi_regenerate_adapter_interrupt == NULL \
                ? UNSUPPORTED_FUNCTION :                                    \
                (UDI_RES_FROM_UDIDS(_p).udi_regenerate_adapter_interrupt(   \
                                       (_p))))

#endif 

} UDI_RES_T,
  FAR_DATA  *P_UDI_RES_T;






typedef union _ADAPTER_INIT_T
{
#ifdef D_SMART_INIT_T

    

    SMART_INIT_T     smart;

#else
    UINT_T           smart;
#endif
#ifdef D_BLUE_INIT_T

    

    BLUE_INIT_T      blue;

#else
    UINT_T           blue;
#endif
#ifdef D_KNOSSOS_INIT_T

    

    KNOSSOS_INIT_T   knossos;
#else
    UINT_T           knossos;
#endif
#ifdef D_HEBE_INIT_T

    

    HEBE_INIT_T      hebe;
#else
    UINT_T           hebe;
#endif

} ADAPTER_INIT_T,
  FAR_INIT_DATA  *P_ADAPTER_INIT_T;




typedef union _ADAPTER_RES_T
{
#ifdef D_SMART_RES_T

    

    SMART_RES_T       smart;

#else
    UINT_T            smart;
#endif
#ifdef D_BLUE_RES_T

    

    BLUE_RES_T        blue;

#else
    UINT_T            blue;
#endif
#ifdef D_KNOSSOS_RES_T

    

    KNOSSOS_RES_T     knossos;

#else
    UINT_T            knossos;
#endif
#ifdef D_HEBE_RES_T

    

    HEBE_RES_T        hebe;

#else
    UINT_T            hebe;
#endif

} ADAPTER_RES_T,
  FAR_DATA  *P_ADAPTER_RES_T;




typedef union _ADAPTER_INIT_INFO_T
{
#ifdef D_SMART_INIT_INFO_T

    

    SMART_INIT_INFO_T   smart;

#else
    UINT_T              smart;
#endif
#ifdef D_BLUE_INIT_INFO_T

    

    BLUE_INIT_INFO_T    blue;

#else
    UINT_T              blue;
#endif
#ifdef D_KNOSSOS_INIT_INFO_T

    

    KNOSSOS_INIT_INFO_T knossos;

#else
    UINT_T              knossos;
#endif

} ADAPTER_INIT_INFO_T,
  FAR_INIT_DATA  *P_ADAPTER_INIT_INFO_T;




typedef union _ADAPTER_RES_INFO_T
{
#ifdef D_SMART_RES_INFO_T

    

    SMART_RES_INFO_T    smart;

#else
    UINT_T              smart;
#endif
#ifdef D_BLUE_RES_INFO_T

    

    BLUE_RES_INFO_T     blue;

#else
    UINT_T              blue;
#endif
#ifdef D_KNOSSOS_RES_INFO_T

    

    KNOSSOS_RES_INFO_T  knossos;

#else
    UINT_T              knossos;
#endif
#ifdef D_HEBE_RES_INFO_T

    

    HEBE_RES_INFO_T     hebe;

#else
    UINT_T              hebe;
#endif

} ADAPTER_RES_INFO_T,
  FAR_DATA  *P_ADAPTER_RES_INFO_T;



typedef union _ADAPTER_PERSISTENT_RES_INFO_T
{
#ifdef D_SMART_RES_INFO_T

    

    SMART_PERSISTENT_RES_INFO_T         smart;

#else
    UINT_T                              smart;
#endif
#ifdef D_BLUE_RES_INFO_T

    

    BLUE_PERSISTENT_RES_INFO_T          blue;

#else
    UINT_T                              blue;
#endif
#ifdef D_KNOSSOS_RES_INFO_T

    

    KNOSSOS_PERSISTENT_RES_INFO_T       knossos;

#else
    UINT_T                              knossos;
#endif
#ifdef D_HEBE_RES_INFO_T

    

    HEBE_PERSISTENT_RES_INFO_T          hebe;

#else
    UINT_T                              hebe;
#endif


} ADAPTER_PERSISTENT_RES_INFO_T,
  FAR_DATA  *P_ADAPTER_PERSISTENT_RES_INFO_T;




typedef struct _UDI_GENERAL_RES_T
{
    

    WORD_T              at24_eeprom_IO_offset;

    WORD_T              hc46_eeprom_IO_offset;
    WORD_T              hc46_eeprom_DO_IO_offset;

    

    BYTE_T              hc46_DO_mask;
    BYTE_T              hc46_DO_posn;
    BYTE_T              hc46_DI_mask;
    BYTE_T              hc46_SK_mask;
    BYTE_T              hc46_CS_mask;
    BYTE_T              hc46_bits_to_remember;
    BYTE_T              hc46_bits_to_clear;
    BYTE_T              hc46_bits_to_set;
    BYTE_T              hc46_remembered_bits;
    BYTE_T              packing_byte; 

} UDI_GENERAL_RES_T,
  FAR_DATA  *P_UDI_GENERAL_RES_T;




typedef struct
{
    

    UDI_INIT_T                         udi_init;

    

    ADAPTER_INIT_T                     adapter_init;

} UDI_INIT_FUNCTION_PTRS_T;




typedef struct _UDI_INIT_DATA_T
{
    

    UDI_INIT_FUNCTION_PTRS_T           init_fns;

    

    STATIC_PARAMETERS_T                sparams;

    

    ADAPTER_INIT_INFO_T                adapter_init_info;

#   ifdef UDT_DECOMPRESS_BIN_FILES

    

    DECOMPRESS_WORKSPACE_T             decompression_workspace;

#   endif


} UDI_INIT_DATA_T;




typedef struct
{
    

    UPCALL_FN_T                        upcall_fns;

    

    UDI_RES_T                          udi_res;

    

    UDTI_T                             udti;

    

    COMMON_RES_T                       common_res;

    

    ADAPTER_RES_T                      adapter_res;

} UDI_RES_FUNCTION_PTRS_T;




typedef struct _UDI_RES_DATA_T
{
    

    UDI_RES_FUNCTION_PTRS_T            res_fns;

    

    UPCALL_T                           upcall;

    

    UDTI_INFO_T                        udti_info;

    

    P_DRIVER_T                         dds_ptr;

    

    CONFIG_PARAMETERS_T                cparams;

    

    ADAPTER_PARAMETERS_T               aparams;

    

    STATS_T                            stats;

    

    ADAPTER_RES_INFO_T                 adapter_res_info;

    

    ADAPTER_PERSISTENT_RES_INFO_T      adapter_persistent_res_info;

    

    UDI_GENERAL_RES_T                  res_data;


} UDI_RES_DATA_T,
  FAR_DATA  *P_UDI_RES_DATA_T;



typedef struct _UDI_DATA_T
{
    

    P_UDI_INIT_DATA_T init;

    

    UDI_RES_DATA_T    res;

} UDI_DATA_T;




