/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
*    **  ** *****   **   ** ****      ****
*    **  **  ** **  *** ***  **      **  **
*    **  **  **  ** *******  **     **
*    **  **  **  ** *******  **     **
*    **  **  **  ** ** * **  **     **
*    **  **  ** **  **   **  **  **  **  **
*    ****** *****   **   ** **** **   ****
*
*****************************************************************************
*
* Module to provide registration of the UDI and UPI.
*
* Performs full initialisation of the UPI and UDI data spaces, setting
* all function tables and initialising data structures.
*
*****************************************************************************
*
* Copyright (C) 1996-1998 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/



#include "udt_driver.h"




#ifdef UPI_ENABLED

extern RETCODE_T UDT_INTER_MODULE
upi_register(
    IN P_UPI_DATA_T upids_ptr);



RETCODE_T UDT_PUBLIC
udmi_register_upi(
    IN P_DRIVER_T     dds_ptr,
    IN P_UPI_DATA_T   upids_ptr)
{
    PCLIENT_BYTE_T    ptr         = (PCLIENT_BYTE_T)upids_ptr;
    UINT_T            count;

    

    for(count = 0; count < sizeof(UPI_DATA_T); count++)
    {
        *(ptr++) = (BYTE_T)0;
    }

    

    DDS_FROM_UPIDS(upids_ptr) = dds_ptr;

    

    return upi_register(upids_ptr);

}
#endif




#ifdef UDI_ENABLED

extern RETCODE_T UDT_INTER_MODULE
udi_com_register(
    IN P_UDI_DATA_T        udids_ptr);

extern RETCODE_T UDT_INTER_MODULE
util_register(
    IN P_UDI_DATA_T         udids_ptr);



#if defined(STRAIGHTBLUEISA_UDI) || \
    defined(STRAIGHTBLUEMC_UDI)  || \
    defined(BLUEPLUS_UDI)

extern RETCODE_T UDT_INTER_MODULE
blue_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#ifdef ATULA_UDI

extern RETCODE_T UDT_INTER_MODULE
atulai_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#ifdef ISACPNP_UDI

extern RETCODE_T UDT_INTER_MODULE
isacpnpi_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#ifdef EISA_UDI

extern RETCODE_T UDT_INTER_MODULE
eisai_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#ifdef PCMCIA_UDI

extern RETCODE_T UDT_INTER_MODULE
pcmciai_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#ifdef PCI1B_UDI

extern RETCODE_T UDT_INTER_MODULE
pci1bi_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#if defined(PCIBM1_UDI) || \
    defined(COMPAQ_PCI_UDI)

extern RETCODE_T UDT_INTER_MODULE
pcibm1i_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#if defined(PCIBM2_UDI) || \
    defined(CARDBUS_UDI)

extern RETCODE_T UDT_INTER_MODULE
pcibm2i_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#ifdef SMART16_UDI

extern RETCODE_T UDT_INTER_MODULE
smart16i_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#ifdef COMPAQ_ISA_UDI

extern RETCODE_T UDT_INTER_MODULE
cpqisai_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#if defined(MC16_UDI) || \
    defined(MC32_UDI)

extern RETCODE_T UDT_INTER_MODULE
smartmci_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#if defined(KNOSSOS_UDI)

extern RETCODE_T UDT_INTER_MODULE
knossosi_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#if defined(OLICOM_PCI_UDI)

extern RETCODE_T UDT_INTER_MODULE
opcitmsi_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#ifdef OLICOM_HEBE_UDI

extern RETCODE_T UDT_INTER_MODULE
hebei_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#if defined(OLICOM_ISAPNP_UDI)

extern RETCODE_T UDT_INTER_MODULE
oisapnpi_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#if defined(OLICOM_ISA_UDI)

extern RETCODE_T UDT_INTER_MODULE
oisatmsi_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#if defined(OLICOM_PCMCIA_UDI)

extern RETCODE_T UDT_INTER_MODULE
opcmciai_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif

#if defined(OLICOM_EISA_UDI)

extern RETCODE_T UDT_INTER_MODULE
oeisai_register(
    IN P_UDI_DATA_T         udids_ptr,
    IN P_ADAPTER_ID_T       id);

#endif



RETCODE_T UDT_PUBLIC
udmi_register_udi(
    IN P_ADAPTER_ID_T      id,
    IN P_DRIVER_T          dds_ptr,
    IN P_UDI_DATA_T        udids_ptr,
    IN P_UDI_INIT_DATA_T   init_udids_ptr,
       UPCALL_EVENT_T      event_handler,
    IN P_VOID_T            argument)
{
    RETCODE_T              rc;
    UINT_T                 count;
    P_BYTE_T               ptr;
    PCLIENT_BYTE_T         i_ptr;


    

    ptr = (P_BYTE_T)udids_ptr;

    for(count = 0; count < sizeof(UDI_DATA_T); count++)
    {
        *(ptr++) = (BYTE_T)0;
    }

    i_ptr = (PCLIENT_BYTE_T) init_udids_ptr;

    for(count = 0; count < sizeof(UDI_INIT_DATA_T); count++)
    {
        *(i_ptr++) = (BYTE_T)0;
    }

    

    DDS_FROM_UDIDS(udids_ptr) = dds_ptr;

    

    INIT_UDIDS_FROM_UDIDS(udids_ptr) = init_udids_ptr;

    

    UPCALL_EVENT_FUNC(udids_ptr) = event_handler;
    UPCALL_EVENT_ARG(udids_ptr)  = argument;


    

    ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_id = *id;


    

    util_register(udids_ptr);

    

    UDI_RES_FROM_UDIDS(udids_ptr).udi_read_adapter_interrupt_status =
        common_null_read_interrupt_status;

    

#ifdef UDT_REGENERATE_INTERRUPTS

    UDI_RES_FROM_UDIDS(udids_ptr).udi_regenerate_adapter_interrupt =
        common_null_regenerate_adapter_interrupt;

#endif 

    

#   ifndef UDT_HOUSEKEEPING_NOT_CALLED

    STATS_FROM_UDIDS(udids_ptr).microseconds_while_closed =
        UDT_REQUIRED_CLOSE_PERIOD;

#   endif 

    

    rc = CARD_NOT_SUPPORTED;

    switch(id->adapter_type)
    {
#ifdef STRAIGHTBLUEISA_UDI
        case ADAPTER_TYPE_STRAIGHTBLUEISA:
            rc = blue_register(udids_ptr, id);
        break;
#endif

#ifdef STRAIGHTBLUEMC_UDI
        case ADAPTER_TYPE_STRAIGHTBLUEMC:
            rc = blue_register(udids_ptr, id);
        break;
#endif

#ifdef BLUEPLUS_UDI
        case ADAPTER_TYPE_BLUEPLUS:
            rc = blue_register(udids_ptr, id);
        break;
#endif

#ifdef ATULA_UDI
        case ADAPTER_TYPE_ATULA:
            rc = atulai_register(udids_ptr, id);
        break;
#endif

#ifdef ISACPNP_UDI
        case ADAPTER_TYPE_ISACPNP:
            rc = isacpnpi_register(udids_ptr, id);
        break;
#endif

#ifdef EISA_UDI
        case ADAPTER_TYPE_EISA:
            rc = eisai_register(udids_ptr, id);
        break;
#endif

#ifdef PCMCIA_UDI
        case ADAPTER_TYPE_PCMCIA:
            rc = pcmciai_register(udids_ptr, id);
        break;
#endif

#ifdef PCI1B_UDI
        case ADAPTER_TYPE_PCI1B:
            rc = pci1bi_register(udids_ptr, id);
        break;
#endif

#ifdef PCIBM1_UDI
        case ADAPTER_TYPE_PCIBM1:
            rc = pcibm1i_register(udids_ptr, id);
        break;
#endif

#ifdef PCIBM2_UDI
        case ADAPTER_TYPE_PCIBM2:
            rc = pcibm2i_register(udids_ptr, id);
        break;
#endif

#ifdef CARDBUS_UDI
        case ADAPTER_TYPE_CARDBUS:
            rc = pcibm2i_register(udids_ptr, id);
        break;
#endif

#ifdef SMART16_UDI
        case ADAPTER_TYPE_SMART16:
            rc = smart16i_register(udids_ptr, id);
        break;
#endif

#ifdef COMPAQ_ISA_UDI
        case ADAPTER_TYPE_COMPAQ_ISA:
            rc = cpqisai_register(udids_ptr, id);
        break;
#endif

#ifdef COMPAQ_PCI_UDI
        case ADAPTER_TYPE_COMPAQ_PCI:
            rc = pcibm1i_register(udids_ptr, id);
        break;
#endif

#ifdef MC16_UDI
        case ADAPTER_TYPE_MC16:
            rc = smartmci_register(udids_ptr, id);
        break;
#endif

#ifdef MC32_UDI
        case ADAPTER_TYPE_MC32:
            rc = smartmci_register(udids_ptr, id);
        break;
#endif

#if defined(KNOSSOS_UDI)
        case ADAPTER_TYPE_KNOSSOS:
        case ADAPTER_TYPE_KNOSSOS_CARDBUS:
            rc = knossosi_register(udids_ptr, id);
        break;
#endif

#ifdef OLICOM_PCI_UDI
        case ADAPTER_TYPE_OLICOM_PCI:
            rc = opcitmsi_register(udids_ptr, id);
        break;
#endif

#ifdef OLICOM_HEBE_UDI
        case ADAPTER_TYPE_BULLSEYE_OLICOM_PCI:
        case ADAPTER_TYPE_HAWKEYE_OLICOM_PCI:
        case ADAPTER_TYPE_OLICOM_CARDBUS:
            rc = hebei_register(udids_ptr, id);
        break;
#endif

#ifdef OLICOM_ISAPNP_UDI
        case ADAPTER_TYPE_OLICOM_ISAPNP:
            rc = oisapnpi_register(udids_ptr, id);
        break;
#endif

#ifdef OLICOM_ISA_UDI
        case ADAPTER_TYPE_OLICOM_ISA:
            rc = oisatmsi_register(udids_ptr, id);
        break;
#endif

#ifdef OLICOM_PCMCIA_UDI
        case ADAPTER_TYPE_OLICOM_PCMCIA:
            rc = opcmciai_register(udids_ptr, id);
        break;
#endif

#ifdef OLICOM_EISA_UDI
        case ADAPTER_TYPE_OLICOM_EISA_3133:
        case ADAPTER_TYPE_OLICOM_EISA_3135:
            rc = oeisai_register(udids_ptr, id);
        break;
#endif

        default:
            rc = BAD_ADAPTER_ID;
        break;
    }

    return rc;
}
#endif




