/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
*  **  ** ******  ****      ****
*  **  **  **  **  **      **  **
*  **  **  **  **  **     **
*  **  **  *****   **     **
*  **  **  **      **     **
*  **  **  **      **  **  **  **
*  ****** ****    **** **   ****
*
*****************************************************************************
*
* Definition of functions to be provided by the tookit for the driver to use
* across the UPI.
*
*****************************************************************************
*
* Copyright (C) 1996-1999 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/


#define UPI_MODULE

#include "udt_driver.h"



#ifdef UPI_ENABLED


#define PROBABLY_ATULA       1
#define UNLIKELY_TO_BE_ATULA 2
#define IS_NOT_ATULA         3

#ifdef OLDCARDS_UPI

VOID_T UDT_INDIRECT
upi_find_old_adapters(
    IN  P_UPI_DATA_T          upids_ptr,
        UDT_BUS_TYPE_T        bus_type);

#endif

STATIC VOID_T UDT_INDIRECT
upi_find_adapters(
    IN  P_UPI_DATA_T          upids_ptr,
        UDT_BUS_TYPE_T        bus_type,
    IN  BOOLEAN_T             only_scan_one_pci_bus,
    IN  BYTE_T                pci_bus_number,
    IN  P_EXCLUSION_T         exclusion_list,
    OUT P_ADAPTER_ID_T        id_array,
        UINT_T                id_array_length,
    OUT PCLIENT_UINT_T        found);



#if defined(EISA_UPI)

STATIC VOID_T
upi_find_eisa(
    IN  P_UPI_DATA_T          upids_ptr);

#endif

#ifdef OLICOM_EISA_UPI

STATIC VOID_T
upi_find_olicom_eisa(
    IN  P_UPI_DATA_T          upids_ptr);

STATIC BOOLEAN_T 
oeisa_3135_check(
    P_UPI_DATA_T              upids_ptr,
    IO_LOCATION_T             cfg_base);

STATIC BOOLEAN_T
oeisa_tms_check(
    P_UPI_DATA_T              upids_ptr,
    IO_LOCATION_T             tms_base);

#endif

#ifdef OLICOM_ISAPNP_UPI

STATIC VOID_T
upi_find_olicom_isapnp(
    IN  P_UPI_DATA_T          upids_ptr);

#endif

#ifdef OLICOM_ISA_UPI

STATIC VOID_T
upi_find_olicom_isa(
    IN  P_UPI_DATA_T          upids_ptr);

#endif

#if defined(OLICOM_ISAPNP_UPI) || \
    defined(OLICOM_EISA_UPI)   || \
    defined(OLICOM_ISA_UPI)

STATIC BOOLEAN_T
upi_check_olicom_id(
    IN  P_UPI_DATA_T          upids_ptr,
    IN  UINT_T                offset,
    WORD_T                    id);

#endif

#if defined(ATULA_UPI)

STATIC VOID_T
upi_find_atula(
    IN  P_UPI_DATA_T          upids_ptr);

STATIC BOOLEAN_T
atula_bia_valid(
    BYTE_T                    id,
    BYTE_T                    type,
    BYTE_T                    rev,
    PCLIENT_ADAPTER_SUBTYPE_T subtype);

STATIC UINT_T
check_misc_atula_bits(
    IN  P_UPI_DATA_T          upids_ptr);

#endif

#if defined(SMART16_UPI)

STATIC VOID_T
upi_find_smart16(
    IN  P_UPI_DATA_T          upids_ptr);

#endif

#if defined(MC16_UPI) ||                                                     \
    defined(MC32_UPI)

STATIC VOID_T
upi_find_smart_mc(
    IN  P_UPI_DATA_T          upids_ptr);

STATIC ADAPTER_TYPE_T
smartmc_slot_to_io_base(
    IN  P_UPI_DATA_T          upids_ptr,
    IN  UINT_T                slot_num,
   OUT  PCLIENT_IO_LOCATION_T io_ptr);

#endif

#if defined(ISACPNP_UPI)

STATIC VOID_T
upi_find_isacpnp(
    IN  P_UPI_DATA_T          upids_ptr);

#endif

#if defined(ATULA_UPI) ||                                                   \
    defined(ISACPNP_UPI)

STATIC BOOLEAN_T
upi_check_for_pnp(
    IN P_UPI_DATA_T           upids_ptr,
       UINT_T                 offset);

#endif

#ifdef SMART16_UPI

STATIC BOOLEAN_T
upi_smart_read_bia_from_card(
    IN P_UPI_DATA_T           upids_ptr,
    IN UINT_T                 sif_addr,
    IN UINT_T                 sif_data,
    PCLIENT_MAC_ADDRESS_T     bia);

#endif


#ifdef SMART_UPI

STATIC BOOLEAN_T
upi_do_status_block_enquiry(
    IN P_UPI_DATA_T           upids_ptr,
    IN UINT_T                 sif_addr,
    IN UINT_T                 sif_data);

STATIC WORD_T
upi_read_dio(
    IN P_UPI_DATA_T           upids_ptr,
    IN UINT_T                 sif_addr,
    IN UINT_T                 sif_data,
   OUT WORD_T                 dio_addr);

#endif



#ifdef COMPAQ_ISA_UPI
STATIC VOID_T
upi_find_compaq_isa(
    IN  P_UPI_DATA_T          upids_ptr);
#endif



#if defined(STRAIGHTBLUEMC_UPI)
STATIC VOID_T
upi_find_ibm_mc(
    IN  P_UPI_DATA_T          upids_ptr);

STATIC VOID_T
bluemc_slot_to_io_base(
    IN  P_UPI_DATA_T          upids_ptr,
        UINT_T                slot,
    OUT PCLIENT_IO_LOCATION_T io_ptr);
#endif

#if defined(STRAIGHTBLUEISA_UPI)
STATIC VOID_T
upi_find_ibm_isa(
    IN  P_UPI_DATA_T          upids_ptr);
#endif

#if defined(BLUEPLUS_UPI)
STATIC VOID_T
upi_find_blueplus(
    IN  P_UPI_DATA_T          upids_ptr);
#endif

#if defined(STRAIGHTBLUEISA_UPI) ||                                         \
    defined(STRAIGHTBLUEMC_UPI) ||                                          \
    defined(BLUEPLUS_UPI)

STATIC BOOLEAN_T
upi_check_aia(
    IN P_UPI_DATA_T           upids_ptr);

STATIC BOOLEAN_T
upi_mmio_checksum(
    IN P_UPI_DATA_T           upids_ptr,
       WORD_T                 start_offset,
       WORD_T                 end_offset);

STATIC VOID_T
upi_read_mmio_string(
    IN  P_UPI_DATA_T          upids_ptr,
        WORD_T                offset,
        WORD_T                length,
    OUT PCLIENT_BYTE_T        buffer);

STATIC INT_T
upi_memcmp(
    IN PCLIENT_BYTE_T         string1,
    IN PCLIENT_BYTE_T         string2,
       UINT_T                 length);

STATIC DWORD_T
upi_check_for_blue(
    IN  P_UPI_DATA_T          upids_ptr,
    IN  IO_LOCATION_T         io_base);

#endif



#if defined(PCI1B_UPI)           ||  \
    defined(PCIBM1_UPI)          ||  \
    defined(PCIBM2_UPI)          ||  \
    defined(KNOSSOS_UPI)         ||  \
    defined(COMPAQ_PCI_UPI)      ||  \
    defined(IBMPCI_UPI)          ||  \
    defined(OLICOM_PCI_UPI)      ||  \
    defined(OLICOM_HEBE_UPI)

#   ifdef UDT_USE_BIOS_TO_FIND_PCI_CARDS

STATIC VOID_T
upi_find_pci(
    IN  P_UPI_DATA_T          upids_ptr);

#   else

STATIC VOID_T
upi_find_pci(
    IN  P_UPI_DATA_T          upids_ptr,
    IN  BOOLEAN_T             only_scan_one_pci_bus,
    IN  BYTE_T                pci_bus_number);

#   endif

#endif



#if defined(EISA_UPI)            ||                                         \
    defined(MC16_UPI)            ||                                         \
    defined(MC32_UPI)            ||                                         \
    defined(STRAIGHTBLUEMC_UPI)  ||                                         \
    defined(OLICOM_EISA_UPI)

STATIC BOOLEAN_T
upi_slot_excluded(
    IN P_UPI_DATA_T upids_ptr,
       UINT_T       slot);
#endif

#if defined(EISA_UPI)            ||                                         \
    defined(ATULA_UPI)           ||                                         \
    defined(ISACPNP_UPI)         ||                                         \
    defined(MC16_UPI)            ||                                         \
    defined(MC32_UPI)            ||                                         \
    defined(STRAIGHTBLUEISA_UPI) ||                                         \
    defined(STRAIGHTBLUEMC_UPI)  ||                                         \
    defined(BLUEPLUS_UPI)        ||                                         \
    defined(COMPAQ_ISA_UPI)      ||                                         \
    defined(OLICOM_EISA_UPI)     ||                                         \
    defined(OLICOM_ISAPNP_UPI)   ||                                         \
    defined(OLICOM_ISA_UPI)

BOOLEAN_T
upi_io_region_excluded(
    IN P_UPI_DATA_T           upids_ptr,
       IO_LOCATION_T          io_base,
       IO_LOCATION_T          io_range);

#endif

#if defined(PCI1B_UPI)           ||  \
    defined(PCIBM1_UPI)          ||  \
    defined(PCIBM2_UPI)          ||  \
    defined(KNOSSOS_UPI)         ||  \
    defined(COMPAQ_PCI_UPI)      ||  \
    defined(IBMPCI_UPI)          ||  \
    defined(OLICOM_PCI_UPI)      ||  \
    defined(OLICOM_HEBE_UPI)

STATIC BOOLEAN_T
upi_pci_number_excluded(
    IN P_UPI_DATA_T    upids_ptr,
       WORD_T          pci_number);
#endif

#ifdef OLDCARDS_UPI

STATIC BOOLEAN_T
upi_find_detailed_ibm_isa(
    IN P_UPI_DATA_T upids_ptr,
       DWORD_T      node_addr_first_four);

#endif

VOID_T
upi_found_adapter(
    IN P_UPI_DATA_T           upids_ptr,
       ADAPTER_TYPE_T         adapter_type,
       ADAPTER_SUBTYPE_T      adapter_subtype,
       IO_LOCATION_T          io_base,
       WORD_T                 pci_number,
       ADAPTER_STATE_T        adapter_state);

VOID_T
upi_exclude_io_range(
    IN P_UPI_DATA_T           upids_ptr,
       IO_LOCATION_T          io_base,
       IO_LOCATION_T          io_range);

UINT_T
upi_report_adapters(
    IN  P_UPI_DATA_T          upids_ptr,
    OUT P_ADAPTER_ID_T        id_array,
        UINT_T                length);


RETCODE_T UDT_INTER_MODULE
upi_register(
    IN P_UPI_DATA_T upids_ptr)
{

    UPI_FROM_UPIDS(upids_ptr).upi_find_adapters = upi_find_adapters;

    return SUCCESS;
}


STATIC VOID_T UDT_INDIRECT
upi_find_adapters(
    IN  P_UPI_DATA_T        upids_ptr,
        UDT_BUS_TYPE_T      bus_type,
    IN  BOOLEAN_T           only_scan_one_pci_bus,
    IN  BYTE_T              pci_bus_number,
    IN  P_EXCLUSION_T       exclusion_list,
    OUT P_ADAPTER_ID_T      id_array,
        UINT_T              id_array_length,
    OUT PCLIENT_UINT_T      found)
{
    POKE_UPI(COLOUR_FN, "upi_find_adapters");


    *found = 0;


    upids_ptr->found                 = 0;
    upids_ptr->extra_exclusion_count = 0;


    upids_ptr->exclusion_list = exclusion_list;


    if (bus_type & UDT_BUS_TYPE_EISA)
    {

#       if defined(EISA_UPI)

        POKE_UPI(PO_MAGENTA, "EISA");


        upi_find_eisa(upids_ptr);
            
#       endif

#       if defined(OLICOM_EISA_UPI)

        POKE_UPI(PO_MAGENTA, "OLICOM EISA");

        upi_find_olicom_eisa(upids_ptr);
            
#       endif


    }

    if (bus_type & UDT_BUS_TYPE_ISA)
    {

#       if defined(STRAIGHTBLUEISA_UPI) || \
           defined(BLUEPLUS_UPI)        || \
           defined(ISACPNP_UPI)         || \
           defined(ATULA_UPI)

        POKE_UPI(PO_MAGENTA, "ISA");

#       endif

#       if defined(STRAIGHTBLUEISA_UPI)

        upi_find_ibm_isa(upids_ptr);
            
#       endif

#       if defined(BLUEPLUS_UPI)

        upi_find_blueplus(upids_ptr);

#       endif

#       if defined(ISACPNP_UPI)

        upi_find_isacpnp(upids_ptr);

#       endif

#       if defined OLICOM_ISAPNP_UPI

        upi_find_olicom_isapnp(upids_ptr);

#       endif


#       if defined(ATULA_UPI)

        upi_find_atula(upids_ptr);
       
#       endif


#       if defined(SMART16_UPI)

        upi_find_smart16(upids_ptr);

#       endif


#       if defined(COMPAQ_ISA_UPI)

        upi_find_compaq_isa(upids_ptr);

#       endif


#       if defined OLICOM_ISA_UPI

        upi_find_olicom_isa(upids_ptr);

#       endif

    }


    if (bus_type & UDT_BUS_TYPE_MC)
    {
        POKE_UPI(PO_MAGENTA, "MC");


#       if defined(MC16_UPI) || \
           defined(MC32_UPI)

        upi_find_smart_mc(upids_ptr);

#       endif


#       if defined(STRAIGHTBLUEMC_UPI)

        upi_find_ibm_mc(upids_ptr);

#       endif

    }


    if (bus_type & UDT_BUS_TYPE_PCI)
    {

#if     defined(PCI1B_UPI)           ||  \
        defined(PCIBM1_UPI)          ||  \
        defined(PCIBM2_UPI)          ||  \
        defined(KNOSSOS_UPI)         ||  \
        defined(COMPAQ_PCI_UPI)      ||  \
        defined(IBMPCI_UPI)          ||  \
        defined(OLICOM_PCI_UPI)      ||  \
        defined(OLICOM_HEBE_UPI)

        POKE_UPI(PO_MAGENTA, "PCI");

#       ifdef UDT_USE_BIOS_TO_FIND_PCI_CARDS

        upi_find_pci(
            upids_ptr);

#       else

        upi_find_pci(
            upids_ptr,
            only_scan_one_pci_bus,
            pci_bus_number);

#       endif

#       endif

    }

#   ifdef OLDCARDS_UPI

    upi_find_old_adapters(
        upids_ptr,
        bus_type);

#   endif


    *found = upi_report_adapters(upids_ptr, id_array, id_array_length); 
}


#ifdef SMART16_UPI

STATIC BOOLEAN_T
upi_smart_read_bia_from_card(
    IN P_UPI_DATA_T        upids_ptr,
    IN UINT_T              sif_addr,
    IN UINT_T              sif_data,
    PCLIENT_MAC_ADDRESS_T  bia)
{
    UINT_T i;
    WORD_T bia_addr;
    WORD_T bia_word;


    bia_addr = upi_read_dio(upids_ptr, sif_addr, sif_data, DIO_BIA_POINTER);


    for (i=0; i<6; i+=2)
    {
        bia_word = upi_read_dio(
                       upids_ptr,
                       sif_addr,
                       sif_data,
                       bia_addr+i);

        bia->byte[i] = (BYTE_T) (bia_word >> 8);
        bia->byte[i+1] = (BYTE_T) bia_word;
    }


    return (bia->byte[0] == 0x00 &&
            bia->byte[1] == 0x00 &&
            bia->byte[2] == 0xF6);
}

#endif 



#ifdef SMART_UPI


STATIC BOOLEAN_T
upi_do_status_block_enquiry(
    IN P_UPI_DATA_T  upids_ptr,
    IN UINT_T        sif_addr,
    IN UINT_T        sif_data)
{
    WORD_T stb_addr;
    WORD_T stb_sig;

    stb_addr = upi_read_dio(upids_ptr, sif_addr, sif_data, DIO_STB);

    stb_addr += UDT_OFFSET(FASTMAC_STATUS_BLOCK_T, stb_enq_vec[0]);


    stb_addr += 2;

    if (upi_read_dio(
            upids_ptr,
            sif_addr,
            sif_data,
            stb_addr) != 0x0009) return FALSE;


    stb_addr += 2;

    stb_sig = upi_read_dio(
                  upids_ptr,
                  sif_addr,
                  sif_data,
                  stb_addr);

    if ((stb_sig != 0x4824) && (stb_sig != 0x4624)) return FALSE;

    stb_addr += 2;

    if (upi_read_dio(
            upids_ptr,
            sif_addr,
            sif_data,
            stb_addr) != 0x3233) return FALSE;

    return TRUE;
}

STATIC WORD_T
upi_read_dio(
    IN  P_UPI_DATA_T  upids_ptr,
    IN  UINT_T        sif_addr,
    IN  UINT_T        sif_data,
    OUT WORD_T        dio_addr)
{
    WORD_T     saved_sifadr;
    WORD_T     dio_data;


    saved_sifadr = PROBE_INW(upids_ptr, sif_addr);


    PROBE_OUTW(upids_ptr, sif_addr, dio_addr);


    dio_data = PROBE_INW(upids_ptr, sif_data);


    PROBE_OUTW(upids_ptr, sif_addr, saved_sifadr);

    return dio_data;
}

#endif 



#if defined(OLICOM_EISA_UPI)

STATIC VOID_T
upi_find_olicom_eisa(
    IN  P_UPI_DATA_T        upids_ptr)
{
    WORD_T                  value;
    IO_LOCATION_T           io_base, tms_base, cfg_base;
    UINT_T                  slot_number;
    ADAPTER_TYPE_T          type;
    ADAPTER_SUBTYPE_T       subtype;
    ADAPTER_STATE_T         adap_state = ADAPTER_STATE_UNKNOWN;
    int                     ix;
    IO_LOCATION_T           eisa_cfg_base[] = OLICOM_EISA_IO_BASE_LIST;
    IO_LOCATION_T           eisa_tms_base[] = OLICOM_EISA_TMS_BASE_LIST;


    for(slot_number = 1; slot_number <= MAX_EISA_SLOT_NO ; slot_number++)
    {

        io_base = slot_number * 0x1000;


        if(upi_slot_excluded(upids_ptr, slot_number))
        {

            continue;
        }

        if(upi_io_region_excluded(
               upids_ptr,
               io_base,
               EISA_PRIMARY_IO_RANGE))
        {

            continue;
        }

        if(!(PSSI_REGISTER_IO(
                 upids_ptr,
                 io_base + EISA_SECONDARY_IO_BASE,
                 EISA_SECONDARY_IO_RANGE,
                 &upids_ptr->io_handle)))
        {
            continue;
        }


        TPOKEW_UPI(TT_BLUE_CYAN, "Slot:", slot_number);
        TPOKEW_UPI(TT_BLUE_CYAN, "ID:", PROBE_INW(upids_ptr, EISA_ID_REG0));

        subtype = 0;

        if(PROBE_INW(upids_ptr, EISA_ID_REG0) == EISA_ID_REG0_OLICOM_ID)
        {
            value = PROBE_INW(upids_ptr, EISA_ID_REG1);
            TPOKEW_UPI(TT_BLUE_CYAN, ",", value);

            if (value == EISA_ID_REG1_OLICOM_31331)
            {
                type    = ADAPTER_TYPE_OLICOM_EISA_3133;
                subtype = ADAPTER_SUBTYPE_OLICOM_EISA_3133;
            }
            else if (value == EISA_ID_REG1_OLICOM_31332)
            {
                type    = ADAPTER_TYPE_OLICOM_EISA_3133;
                subtype = ADAPTER_SUBTYPE_OLICOM_EISA_3133;
            }
            else if (value == EISA_ID_REG1_OLICOM_3135)
            {
                type    = ADAPTER_TYPE_OLICOM_EISA_3135;
                subtype = ADAPTER_SUBTYPE_OLICOM_EISA_3135;
            }
        }


        ix = (PROBE_INB(upids_ptr, OLICOM_EISA_3133_CFG2) >> 4) & 3;


        PSSI_UNREGISTER_IO(
            upids_ptr,
            io_base + EISA_SECONDARY_IO_BASE,
            upids_ptr->io_handle);

        if (subtype == 0)
        {

            continue;
        }


        TPOKEW_UPI(TT_BLUE_CYAN, "Found:", subtype);

        if (subtype == ADAPTER_SUBTYPE_OLICOM_EISA_3135)
        {
#if 0
            BYTE_T cfg3;
            
            if(!(PSSI_REGISTER_IO(
                     upids_ptr,
                     io_base + OLICOM_EISA_3135_SECONDARY_IO_BASE,
                     OLICOM_EISA_3135_SECONDARY_IO_RANGE,
                     &upids_ptr->io_handle)))
            {
                continue;
            }

            cfg3 = PROBE_INB(upids_ptr, OLICOM_EISA_3135_CFG3);
            TPOKEB_UPI(TT_BLUE_CYAN, "cfg3=",cfg3);
            ix = (cfg3 & 6) >> 1;
            
            if (cfg3 & 0x80)
            {
                ix += 4;
            }

            PSSI_UNREGISTER_IO(
                upids_ptr,
                io_base + OLICOM_EISA_3135_SECONDARY_IO_BASE,
                upids_ptr->io_handle);
#else

            for (ix = 0; ix < 8; ix++)
            {

                if ((eisa_tms_base[ix] == 0) || (eisa_cfg_base[ix] == 0))
                {
                    continue;
                }

                if (oeisa_tms_check(upids_ptr, eisa_tms_base[ix]) &&
                    oeisa_3135_check(upids_ptr, eisa_cfg_base[ix]))
                {

                    break;
                }
            }

            if (ix > 7) continue;
#endif
        }


        tms_base = eisa_tms_base[ix];
        cfg_base = eisa_cfg_base[ix];

        eisa_tms_base[ix] = 0;
        eisa_cfg_base[ix] = 0;

        if(upi_io_region_excluded(
               upids_ptr,
               tms_base,
               OLICOM_EISA_TMS_IO_RANGE))
        {

            continue;
        }

        if(upi_io_region_excluded(
               upids_ptr,
               cfg_base,
               OLICOM_EISA_CONFIGURATION_IO_RANGE))
        {

            continue;
        }

        if((PSSI_REGISTER_IO(
             upids_ptr,
             tms_base,
             OLICOM_EISA_TMS_IO_RANGE,
             &upids_ptr->io_handle)))
        {
            if (upi_do_status_block_enquiry(
                    upids_ptr,
                    OLICOM_EISA_SIFADR,
                    OLICOM_EISA_SIFDAT))
            {
                adap_state = ADAPTER_STATE_RUNNING;
            }
 
            PSSI_UNREGISTER_IO(
                upids_ptr,
                io_base,
                upids_ptr->io_handle);
        }


        upi_found_adapter(
            upids_ptr,
            type,
            subtype,
            cfg_base,
            0,
            adap_state);
    }
}


STATIC BOOLEAN_T
oeisa_tms_check(
    P_UPI_DATA_T  upids_ptr,
    IO_LOCATION_T tms_base)
{
    BOOLEAN_T result;
    WORD_T    adr;
    WORD_T    address;
    WORD_T    i;
    WORD_T    wdata;
    BYTE_T    data;
    BYTE_T    idata;

    if (upi_io_region_excluded(upids_ptr, tms_base, OLICOM_EISA_TMS_IO_RANGE))
    {
        return FALSE;
    }

    if (!(PSSI_REGISTER_IO(
            upids_ptr,
            tms_base,
            OLICOM_EISA_TMS_IO_RANGE,
            &upids_ptr->io_handle)))
    {
        return FALSE;
    }

    address = PROBE_INW(upids_ptr, OLICOM_EISA_SIFADR);

    if (!(address & 1))
    {
        result = TRUE;

        data  = PROBE_INB(upids_ptr, OLICOM_EISA_SIFDAT);
        wdata = PROBE_INW(upids_ptr, OLICOM_EISA_SIFDATINC);

        for (i = address + 2; i < address + 10; i += 2)
        {
            adr = PROBE_INW(upids_ptr, OLICOM_EISA_SIFADR);
            if (i != adr)
            {
                result = FALSE;
                break;
            }

            adr = PROBE_INW(upids_ptr, OLICOM_EISA_SIFADL);
            if (i != adr)
            {
                result = FALSE;
                break;
            }

            data = PROBE_INB(upids_ptr, OLICOM_EISA_SIFDAT);
            PSSI_WAIT_AT_LEAST_MSEC(upids_ptr, 10);
            idata = PROBE_INB(upids_ptr, OLICOM_EISA_SIFDATINC);
            if (data != idata)
            {
                result = FALSE;
                break;
            }

            idata = PROBE_INB(upids_ptr, OLICOM_EISA_SIFDATINC+1);
        }
    }
    else
    {
        result = FALSE;
    }

    PSSI_UNREGISTER_IO(
        upids_ptr,
        tms_base,
        &upids_ptr->io_handle);

    return result;
}

STATIC BOOLEAN_T 
oeisa_3135_check(
    P_UPI_DATA_T        upids_ptr,
    IO_LOCATION_T       cfg_base)
{
    BYTE_T    old;
    BYTE_T    old1;
    BYTE_T    new;
    BYTE_T    mask;
    BOOLEAN_T MCorEISA;
    INT_T     i;
    BOOLEAN_T result = FALSE;

    if (upi_io_region_excluded(
            upids_ptr,
            cfg_base,
            OLICOM_EISA_CONFIGURATION_IO_RANGE))
    {
        return FALSE;
    }

    if (!(PSSI_REGISTER_IO(
            upids_ptr,
            cfg_base,
            OLICOM_EISA_CONFIGURATION_IO_RANGE,
            &upids_ptr->io_handle)))
    {
        return FALSE;
    }

    new  = PROBE_INB(upids_ptr, 2);
    old  = new;
    mask = 0x3F;
    new &= mask;
    old1 = new;
    PROBE_OUTB(upids_ptr, 2, new);

    MCorEISA = FALSE;
    while (mask)
    {
        PROBE_OUTB(upids_ptr, 2, (BYTE_T) (new ^ mask));
        PSSI_WAIT_AT_LEAST_MSEC(upids_ptr, 10);
        new = (BYTE_T) (PROBE_INB(upids_ptr, 2) ^ mask);

        if (new != old1)
        {
            MCorEISA = TRUE;
            break;
        }
        mask--;
    }

    PROBE_OUTB(upids_ptr, 2, old);

    if (!MCorEISA)
    {
        old = PROBE_INB(upids_ptr, 3);
        for (i = 0; i < 10; i++)
        {
            if (PROBE_INB(upids_ptr, 3) != old)
            {
                break;
            }
        }

        if (i == 10)
        {
            if (! (new & 6))
            {

                result = TRUE;
            }
        }
    }

    PSSI_UNREGISTER_IO(
        upids_ptr,
        cfg_base,
        &upids_ptr->io_handle);

    return result;
}

#endif 



#if defined(EISA_UPI)

STATIC VOID_T
upi_find_eisa(
    IN  P_UPI_DATA_T        upids_ptr)
{
    WORD_T                  value;
    IO_LOCATION_T           io_base;
    UINT_T                  slot_number;
    ADAPTER_SUBTYPE_T       subtype;


    for(slot_number = 1; slot_number <= MAX_EISA_SLOT_NO ; slot_number++)
    {

        io_base = slot_number * 0x1000;


        if(upi_slot_excluded(upids_ptr, slot_number))
        {

            continue;
        }

        if(upi_io_region_excluded(
               upids_ptr,
               io_base,
               EISA_PRIMARY_IO_RANGE))
        {

            continue;
        }


        if(!(PSSI_REGISTER_IO(
                 upids_ptr,
                 io_base + EISA_SECONDARY_IO_BASE,
                 EISA_SECONDARY_IO_RANGE,
                 &upids_ptr->io_handle)))
        {
            continue;
        }


        if(PROBE_INW(upids_ptr, EISA_ID_REG0) == EISA_ID_REG0_MDG_CODE)
        {
            value = PROBE_INW(upids_ptr, EISA_ID_REG1);
            subtype = 0;


            PSSI_UNREGISTER_IO(
                upids_ptr,
                io_base + EISA_SECONDARY_IO_BASE,
                upids_ptr->io_handle);

            if      (value == EISA_ID_REG1_MK1_MDG_CODE)
                subtype = ADAPTER_SUBTYPE_EISA_MK1;
            else if (value == EISA_ID_REG1_MK2_MDG_CODE)
                subtype = ADAPTER_SUBTYPE_EISA_MK2;
            else if (value == EISA_ID_REG1_BRIDGE_MDG_CODE)
                subtype = ADAPTER_SUBTYPE_EISA_BRIDGE;
            else if (value == EISA_ID_REG1_MK3_MDG_CODE)
                subtype = ADAPTER_SUBTYPE_EISA_MK3;

            if (subtype)
            {
                ADAPTER_STATE_T  adap_state = ADAPTER_STATE_UNKNOWN;

                if(PSSI_REGISTER_IO(
                       upids_ptr,
                       io_base,
                       EISA_PRIMARY_IO_RANGE,
                       &upids_ptr->io_handle))
                {
                    if (upi_do_status_block_enquiry(
                           upids_ptr,
                           EISA_SIFADR,
                           EISA_SIFDAT))
                    {
                        adap_state = ADAPTER_STATE_RUNNING;
                    }

                    PSSI_UNREGISTER_IO(
                        upids_ptr,
                        io_base,
                        upids_ptr->io_handle);
                }


                upi_found_adapter(
                    upids_ptr,
                    ADAPTER_TYPE_EISA,
                    subtype,
                    io_base,
                    0,
                    adap_state);
            }

#if defined(OLDCARDS_UPI)

            else
            {

#define EISA_ID_REG1_SMT1001_MDG_CODE (0x1010)
#define EISA_ID_REG1_SMT1002_MDG_CODE (0x2010)

                if (value == EISA_ID_REG1_SMT1001_MDG_CODE ||
                    value == EISA_ID_REG1_SMT1002_MDG_CODE)
                {
                    upi_found_adapter(
                        upids_ptr,
                        ADAPTER_TYPE_OLD_CARDS,
                        ADAPTER_SUBTYPE_SMART100,
                        io_base,
                        0,
                        ADAPTER_STATE_UNKNOWN);             
               }
            }
#endif

        }
        else
        {

            PSSI_UNREGISTER_IO(
                upids_ptr,
                io_base + EISA_SECONDARY_IO_BASE,
                upids_ptr->io_handle);
        }
    }
}

#endif



#if defined(STRAIGHTBLUEISA_UPI)

STATIC VOID_T
upi_find_ibm_isa(
    IN  P_UPI_DATA_T        upids_ptr)
{
    IO_LOCATION_T           io_base[]   = STRAIGHT_BLUE_IO_BASE_LIST;
    UINT_T                  count;
    WORD_T                  node_addr_3rd_and_4th;
    DWORD_T                 node_addr_first_four;
    ADAPTER_SUBTYPE_T       subtype = ADAPTER_SUBTYPE_INVALID;


    for(count = 0; count < sizeof(io_base) / sizeof(IO_LOCATION_T); count++)
    {

        node_addr_first_four = upi_check_for_blue(
                                      upids_ptr,
                                      io_base[count]);

        if (node_addr_first_four == 0)
           continue; 
       
        node_addr_3rd_and_4th = (WORD_T)(node_addr_first_four & 0xFFFF);


        if ((node_addr_3rd_and_4th & 0xFF00) == 0xF600)
        {
           
           if (node_addr_3rd_and_4th>=0xF692 && node_addr_3rd_and_4th<=0xF697)
           {
               subtype = ADAPTER_SUBTYPE_STRAIGHTBLUE;
           }
        }

        else
        {
#ifdef OLDCARDS_UPI
            subtype = upi_find_detailed_ibm_isa(upids_ptr,node_addr_first_four);
#else
            subtype = ADAPTER_SUBTYPE_IBM;
#endif
        }

        if (subtype != ADAPTER_SUBTYPE_INVALID)
        {

             upi_found_adapter(
                upids_ptr,
                ADAPTER_TYPE_STRAIGHTBLUEISA,
                subtype,
                io_base[count],
                0,
                ADAPTER_STATE_UNKNOWN);


             upi_exclude_io_range(
                 upids_ptr,
                 io_base[count],
                 IBM_PRIMARY_IO_RANGE);
        }
    } 
}

#endif



#if defined(BLUEPLUS_UPI)

STATIC VOID_T
upi_find_blueplus(
    IN  P_UPI_DATA_T        upids_ptr)
{
    IO_LOCATION_T           io_base[]   = IBM_IO_BASE_LIST;
    UINT_T                  count;
    WORD_T                  node_addr_3rd_and_4th;
    ADAPTER_STATE_T         adap_state = ADAPTER_STATE_UNKNOWN;
    BYTE_T                  superset_control;
    ADAPTER_SUBTYPE_T       subtype;


    for(count = 0; count < sizeof(io_base) / sizeof(IO_LOCATION_T); count++)
    {
        node_addr_3rd_and_4th = (WORD_T)(upi_check_for_blue(
                                           upids_ptr,
                                           io_base[count]) & 0xFFFF);


        if (
            ((node_addr_3rd_and_4th&0xFF00) == 0xF600)
            &&
            !(node_addr_3rd_and_4th>=0xF690 && node_addr_3rd_and_4th<=0xF697)
           )
        {

            POKE_UPI(PO_MAGENTA, "BluePlus");

            subtype = ADAPTER_SUBTYPE_BLUE_PNP;

            if ( node_addr_3rd_and_4th == 0xF65A ||
                 (node_addr_3rd_and_4th >= 0xF698 &&
                  node_addr_3rd_and_4th <= 0xF69B ) )
            {
                subtype = ADAPTER_SUBTYPE_BLUE_PLUS;
            }


            if(!(PSSI_REGISTER_IO(
                 upids_ptr,
                 io_base[count]+FAST_PIO_BASE,   
                 FAST_PIO_RANGE,                 
                 &upids_ptr->io_handle)))
            {
                continue;
            }

            superset_control = PROBE_INB(upids_ptr, FAST_PIO_OPTIONS); 

            if (superset_control!=0xFF &&
                (superset_control & FAST_PIO_OPTION_SIF_IRQ_ENABLE) != 0)
            {
                adap_state = ADAPTER_STATE_RUNNING;
            }
            else
            {

                adap_state = ADAPTER_STATE_UNKNOWN;
            }

            upi_found_adapter(
                upids_ptr,
                ADAPTER_TYPE_BLUEPLUS,
                subtype,
                io_base[count],
                0,
                adap_state);


            upi_exclude_io_range(
                upids_ptr,
                io_base[count],
                IBM_PRIMARY_IO_RANGE);


            PSSI_UNREGISTER_IO(
                upids_ptr,
                io_base[count],
                upids_ptr->io_handle); 
        }
    }
}

#endif



#if defined(STRAIGHTBLUEISA_UPI) || \
    defined(BLUEPLUS_UPI)

STATIC DWORD_T
upi_check_for_blue(
    IN  P_UPI_DATA_T        upids_ptr,
    IN  IO_LOCATION_T       io_base)
{
    BYTE_T                  r_0a20;
    BYTE_T                  r_0a21;
    BYTE_T                  r_0a22;
    PHYS_ADDRESS_T          mmio_base;
    DWORD_T                 result;


    if(upi_io_region_excluded(
           upids_ptr,
           io_base,
           IBM_PRIMARY_IO_RANGE)) 
    {

        return 0;
    }


    if(!(PSSI_REGISTER_IO(
             upids_ptr,
             io_base,
             IBM_PRIMARY_IO_RANGE, 
             &upids_ptr->io_handle)))
    {
        return 0;
    }


    result = 0;


    r_0a20 = PROBE_INB(upids_ptr, IBM_PIO_SWITCH_READ_1);
    r_0a21 = PROBE_INB(upids_ptr, IBM_PIO_MADGE_IDENT);
    r_0a22 = PROBE_INB(upids_ptr, IBM_PIO_SWITCH_READ_2);


    mmio_base =
        (PHYS_ADDRESS_T)
        (PSSI_DWORD_SHIFT_L(upids_ptr, (DWORD_T)(r_0a20 & 0xFC), 11) |
         PSSI_DWORD_SHIFT_L(upids_ptr, (DWORD_T)(r_0a22 & 0x01), 19));


    PSSI_UNREGISTER_IO(
        upids_ptr,
        io_base,
        upids_ptr->io_handle);


    if(!(PSSI_REGISTER_IO(
             upids_ptr,
             io_base+FAST_PIO_BASE, 
             FAST_PIO_RANGE,       
             &upids_ptr->io_handle)))
    {
        return 0;
    }



    if(mmio_base >= 0xA0000uL && mmio_base < 0xF0000uL)
    {

        TPOKED_UPI(TT_BLUE_CYAN, "Check blue:", mmio_base);


        if((PSSI_REGISTER_SHARED(
                 upids_ptr,
                 mmio_base,
                 IBM_MMIO_SIZE-1,
                 &upids_ptr->shared_handle)))
        {

            if (r_0a21==0x00)
            {
                PROBE_OUTB(
                    upids_ptr,
                    FAST_PIO_OPTIONS,
                    FAST_PIO_OPTION_RESET(FAST_PIO_OPTION_SIF_PAGING));
            }



            if(upi_check_aia(upids_ptr) == TRUE)
            {

                 upi_read_mmio_string(
                     upids_ptr,
                     0x1F00,
                     4,
                     (PCLIENT_BYTE_T)&result);
                 
#ifndef UDT_CPU_IS_BIG_ENDIAN
                 result = 
                   PSSI_DWORD_SHIFT_R(upids_ptr, result & 0xFF000000, 24) |
                   PSSI_DWORD_SHIFT_R(upids_ptr, result & 0x00FF0000, 8 ) |
                   PSSI_DWORD_SHIFT_L(upids_ptr, result & 0x0000FF00, 8 ) |
                   PSSI_DWORD_SHIFT_L(upids_ptr, result & 0x000000FF, 24);
#endif

#ifdef OLDCARDS_UPI
                 {

                     BYTE_T B = PROBE_READB(upids_ptr, 0x1FB8);
                     if ((B & 0x0F) == 0x0D)
                     {
                         upids_ptr->bAutoISA = TRUE;
                     }
                     else
                     {
                         upids_ptr->bAutoISA = FALSE;
                     }
                 }
#endif
                   

                 TPOKED_UPI(TT_BRIGHT, "Yes!BIA=", result);
            }


            PSSI_UNREGISTER_SHARED(
                upids_ptr,
                mmio_base,
                upids_ptr->shared_handle);
        }
    }


    PSSI_UNREGISTER_IO(
        upids_ptr,
        io_base,
        upids_ptr->io_handle);

    return result;
}

#endif



#if defined(ISACPNP_UPI)

STATIC VOID_T
upi_find_isacpnp(
    IN  P_UPI_DATA_T        upids_ptr)
{
    IO_LOCATION_T           io_base[]   = ISACPNP_IO_BASE_LIST;
    UINT_T                  count;


    for(count = 0; count < sizeof(io_base) / sizeof(IO_LOCATION_T); count++)
    {

        if(upi_io_region_excluded(
               upids_ptr,
               io_base[count],
               ISACPNP_PRIMARY_IO_RANGE))
        {

            continue;
        }

        if(!(PSSI_REGISTER_IO(
                 upids_ptr,
                 io_base[count],
                 ISACPNP_PRIMARY_IO_RANGE,
                 &upids_ptr->io_handle)))
        {
            continue;
        }


        if(upi_check_for_pnp(upids_ptr, ISACPNP_ID_REG) == TRUE)
        {
            ADAPTER_STATE_T  adap_state = ADAPTER_STATE_UNKNOWN;

            if (upi_do_status_block_enquiry(
                upids_ptr,
                ISACPNP_SIFADR,
                ISACPNP_SIFDAT))
            {
                adap_state = ADAPTER_STATE_RUNNING;
            }


            upi_found_adapter(
                upids_ptr,
                ADAPTER_TYPE_ISACPNP,
                ADAPTER_SUBTYPE_ISACPNP,
                io_base[count],
                0,
                adap_state);


            upi_exclude_io_range(
                upids_ptr,
                io_base[count],
                ISACPNP_PRIMARY_IO_RANGE);
        }


        PSSI_UNREGISTER_IO(
            upids_ptr,
            io_base[count],
            upids_ptr->io_handle);
    }
}

#endif


#if defined(OLICOM_ISAPNP_UPI)

STATIC VOID_T
upi_find_olicom_isapnp(
    IN  P_UPI_DATA_T        upids_ptr)
{
    IO_LOCATION_T           io_base;

    for (io_base = 0x0A00; io_base < 0x0C00; io_base += 0x0020)
    {

        if(upi_io_region_excluded(
               upids_ptr,
               io_base,
               OLICOM_ISAPNP_PRIMARY_IO_RANGE))
        {

            continue;
        }


        if(!(PSSI_REGISTER_IO(
                 upids_ptr,
                 io_base,
                 OLICOM_ISAPNP_PRIMARY_IO_RANGE,
                 &upids_ptr->io_handle)))
        {
            continue;
        }


        if (upi_check_olicom_id(
                upids_ptr,
                OLICOM_PNP_CONTROL,
                OLICOM_ISAPNP_ID) == TRUE)
        {
            ADAPTER_STATE_T adap_state = ADAPTER_STATE_UNKNOWN;

            if (upi_do_status_block_enquiry(
                    upids_ptr,
                    OLICOM_PNP_SIFADR,
                    OLICOM_PNP_SIFDAT))
            {
                adap_state = ADAPTER_STATE_RUNNING;
            }

            upi_found_adapter(
                upids_ptr,
                ADAPTER_TYPE_OLICOM_ISAPNP,
                ADAPTER_SUBTYPE_OLICOM_ISA_3118,
                io_base,
                0,
                adap_state);


            upi_exclude_io_range(
                upids_ptr,
                io_base,
                OLICOM_ISAPNP_PRIMARY_IO_RANGE);
        }


        PSSI_UNREGISTER_IO(
            upids_ptr,
            io_base,
            upids_ptr->io_handle);
    }
}

#endif


#if defined(OLICOM_ISA_UPI)

STATIC VOID_T
upi_find_olicom_isa(
    IN  P_UPI_DATA_T        upids_ptr)
{
    IO_LOCATION_T           primary_io_base[] = OISA_PRIMARY_IO_BASE_LIST;
    IO_LOCATION_T           secondary_io_base[] = OISA_SECONDARY_IO_BASE_LIST;
    int                     count;
    BOOLEAN_T               found;

    for(count = 0;
        count < sizeof(primary_io_base) / sizeof(IO_LOCATION_T);
        count++)
    {

        if (upi_io_region_excluded(
                upids_ptr,
                primary_io_base[count],
                OLICOM_ISA_CONFIGURATION_IO_RANGE) ||

            upi_io_region_excluded(
                upids_ptr,
                secondary_io_base[count],
                OLICOM_ISA_TMS_IO_RANGE))
        {

            continue;
        }


        if(!(PSSI_REGISTER_IO(
                 upids_ptr,
                 primary_io_base[count],
                 OLICOM_ISA_CONFIGURATION_IO_RANGE,
                 &upids_ptr->io_handle)))
        {
            continue;
        }


        found = upi_check_olicom_id(
                    upids_ptr,
                    OLICOM_ISA_CONFPTR,
                    OLICOM_ISA_ID);


        PSSI_UNREGISTER_IO(
            upids_ptr,
            primary_io_base[count],
            upids_ptr->io_handle);

        if (found)
        {
            ADAPTER_STATE_T adap_state = ADAPTER_STATE_UNKNOWN;


            if(!(PSSI_REGISTER_IO(
                     upids_ptr,
                     secondary_io_base[count],
                     OLICOM_ISA_TMS_IO_RANGE,
                     &upids_ptr->io_handle)))
            {
                continue;
            }

            if (upi_do_status_block_enquiry(
                    upids_ptr,
                    OLICOM_ISA_SIFADR,
                    OLICOM_ISA_SIFDAT))
            {
                adap_state = ADAPTER_STATE_RUNNING;
            }

            upi_found_adapter(
                upids_ptr,
                ADAPTER_TYPE_OLICOM_ISA,
                ADAPTER_SUBTYPE_OLICOM_ISA_3117,
                primary_io_base[count],
                0,
                adap_state);


            upi_exclude_io_range(
                upids_ptr,
                primary_io_base[count],
                OLICOM_ISA_CONFIGURATION_IO_RANGE);

            upi_exclude_io_range(
                upids_ptr,
                secondary_io_base[count],
                OLICOM_ISA_TMS_IO_RANGE);

            PSSI_UNREGISTER_IO(
                upids_ptr,
                secondary_io_base[count],
                upids_ptr->io_handle);
        }
    }
}

#endif

#if defined(OLICOM_ISAPNP_UPI) ||                                          \
    defined(OLICOM_EISA_UPI) ||                                            \
    defined(OLICOM_ISA_UPI)

STATIC BOOLEAN_T
upi_check_olicom_id(
    IN  P_UPI_DATA_T    upids_ptr,
    IN  UINT_T          offset,
    WORD_T              id)
{
    WORD_T found_id = 0;
    INT_T  i;

    for (i = 0; i < 4; i++)
    {
        found_id <<= 4;
        found_id |= (WORD_T)(PROBE_INB(upids_ptr, offset) >> 4);
    }

    for (i = 0; i < 4; i++)
    {
        if (id == found_id)
        {
            return TRUE;
        }

        found_id = (found_id << 12) | (found_id >> 4);
    }

    return FALSE;
}

#endif


#if defined(ATULA_UPI)


STATIC VOID_T
upi_find_atula(
    IN  P_UPI_DATA_T        upids_ptr)
{
    IO_LOCATION_T           io_base[]   = ATULA_IO_BASE_LIST;
    UINT_T                  count;
    BYTE_T                  r0;
    BYTE_T                  new_r0;
    BYTE_T                  r1;
    BYTE_T                  r3;
    BYTE_T                  r7;
    BOOLEAN_T               bia_mapped_in;
    BOOLEAN_T               found_atula;
    BOOLEAN_T               found_random_bit;
    BOOLEAN_T               test_using_writes;
    BOOLEAN_T               not_atula;
    UINT_T                  misc_result;
    ADAPTER_SUBTYPE_T       subtype = ADAPTER_SUBTYPE_ATP;
    BYTE_T                  id,type,rev;

    for(count = 0; count < sizeof(io_base) / sizeof(IO_LOCATION_T); count++)
    {

        if(upi_io_region_excluded(
               upids_ptr,
               io_base[count],
               ATULA_PRIMARY_IO_RANGE))
        {

            continue;
        }


        if(!(PSSI_REGISTER_IO(
                 upids_ptr,
                 io_base[count],
                 ATULA_PRIMARY_IO_RANGE,
                 &upids_ptr->io_handle)))
        {
            continue;
        }


        if(upi_check_for_pnp(upids_ptr, ATPNP_ID_REG))
        {
            ADAPTER_STATE_T  adap_state = ADAPTER_STATE_UNKNOWN;

            if (upi_do_status_block_enquiry(
                upids_ptr,
                ATULA_SIFADR,
                ATULA_SIFDAT))
            {
                adap_state = ADAPTER_STATE_RUNNING;
            }


            upi_found_adapter(
                upids_ptr,
                ADAPTER_TYPE_ATULA,
                ADAPTER_SUBTYPE_ATPNP,
                io_base[count],
                0,
                adap_state);


            upi_exclude_io_range(
                upids_ptr,
                io_base[count],
                ATULA_PRIMARY_IO_RANGE);


            PSSI_UNREGISTER_IO(
                upids_ptr,
                io_base[count],
                upids_ptr->io_handle);

            continue;
        }


        if (
               io_base[count]==0x0A20 ||
               io_base[count]==0x1A20 ||
               io_base[count]==0x2A20 ||
               io_base[count]==0x3A20
           )
        {


            found_atula=FALSE;  
            not_atula=FALSE;    


            bia_mapped_in=FALSE;

            r7=PROBE_INB(upids_ptr, ATULA_CTRL_REG7);

            TPOKEB_UPI(TT_DULL, "r7=", r7);

            if ( (r7&ATULA_CTRL_REG7_PAGE) == 0 )
            {
                if ( (r7&ATULA_CTRL_REG7_SIFSEL) == 0)
                {
                    bia_mapped_in=TRUE;
                }
                else
                {
                    r1=PROBE_INB(upids_ptr, ATULA_CTRL_REG1);

                    TPOKEB_UPI(TT_DULL, "r1=", r1);

                    if ( (r1&ATULA_CTRL_REG1_NSRESET) == 0)
                    {
                        bia_mapped_in=TRUE;
                    }
                }
            }

            if (bia_mapped_in)
            {
                id=PROBE_INB(upids_ptr, ATULA_BIAPROM_ID);
                type=PROBE_INB(upids_ptr, ATULA_BIAPROM_ADAPTER);
                rev=PROBE_INB(upids_ptr, ATULA_BIAPROM_REVISION);


                if (atula_bia_valid(id, type, rev, &subtype))
                {
                    found_atula=TRUE;

                    POKE_UPI(PO_WHITE, "BiaOK");
                }
                else
                {
                    not_atula=TRUE;

                    POKE_UPI(PO_WHITE, "BiaBad");
                }
            }


            found_random_bit=FALSE;

            if (!not_atula && !found_atula)
            {
                UINT_T                  zero_count=0;
                UINT_T                  one_count=0;
                BYTE_T                  last_r3;
                UINT_T                  i;

                r3=PROBE_INB(upids_ptr, ATULA_STATUS_REG);

                i=0;

                while (not_atula==FALSE && found_random_bit==FALSE)
                {
                    last_r3=r3;
                    r3=PROBE_INB(upids_ptr, ATULA_STATUS_REG);


                    if ((r3&0x89)!=0x89)
                    {
                        not_atula=TRUE;
                    }


                    if ( (last_r3&0xE9) != (r3&0xE9) )
                    {
                        not_atula=TRUE;
                    }


                    if (r3 & ATULA_STATUS_REG_RNDBIT)
                    {
                        one_count++;

                    }
                    else
                    {
                        zero_count++;

                    }


                    if (i>50 && (zero_count>0 && one_count>0) )
                    {
                        found_random_bit=TRUE;
                    }


                    if (i>500)
                    {
                        break;
                    }

                    i++;
                }
            }


            test_using_writes=FALSE;

            if (!not_atula && !found_atula)
            {
                misc_result = check_misc_atula_bits(upids_ptr);

                if (found_random_bit)
                {

                    if (misc_result==IS_NOT_ATULA)
                    {
                        not_atula=TRUE;
                    }

                    if (misc_result==PROBABLY_ATULA)
                    {
                        found_atula=TRUE;
                    }
                    else
                    {
                        test_using_writes=TRUE;
                    }
                }
                else
                {
                    if (misc_result==PROBABLY_ATULA)
                    {
                        test_using_writes=TRUE;
                    }
                }
            }


            if (!not_atula && !found_atula)
            {
                if (test_using_writes)
                {

                    r0=PROBE_INB(upids_ptr, ATULA_IBM_REG);
                    r0^=0xFF;
                    PROBE_OUTB(upids_ptr, ATULA_IBM_REG, r0);


                    r7=PROBE_INB(upids_ptr, ATULA_CTRL_REG7);

                    new_r0=PROBE_INB(upids_ptr, ATULA_IBM_REG);

                    PROBE_OUTB(upids_ptr, ATULA_IBM_REG, (BYTE_T)(r0^0xFF));

                    if (new_r0==r0)
                    {


                        PROBE_OUTB(
                            upids_ptr,
                            ATULA_CTRL_REG7,
                            (BYTE_T)(r7&
                              ~(ATULA_CTRL_REG7_PAGE|ATULA_CTRL_REG7_SIFSEL))
                            );

                        id=PROBE_INB(upids_ptr, ATULA_BIAPROM_ID);
                        type=PROBE_INB(upids_ptr, ATULA_BIAPROM_ADAPTER);
                        rev=PROBE_INB(upids_ptr, ATULA_BIAPROM_REVISION);


                        PROBE_OUTB(upids_ptr, ATULA_IBM_REG, r7);


                        if (atula_bia_valid(id, type, rev, &subtype))
                        {
                            found_atula=TRUE;
                        }
                    }
                }
            }


            if (found_atula)
            {
                ADAPTER_STATE_T  adap_state = ADAPTER_STATE_UNKNOWN;

                if (upi_do_status_block_enquiry(
                       upids_ptr,
                       ATULA_SIFADR,
                       ATULA_SIFDAT))
                {
                    adap_state = ADAPTER_STATE_RUNNING;
                }


                upi_found_adapter(
                    upids_ptr,
                    ADAPTER_TYPE_ATULA,
                    subtype,                
                    io_base[count],
                    0,
                    adap_state);


                upi_exclude_io_range(
                    upids_ptr,
                    io_base[count],
                    ATULA_PRIMARY_IO_RANGE);
            }
        }


        PSSI_UNREGISTER_IO(
            upids_ptr,
            io_base[count],
            upids_ptr->io_handle);

    } 
}


STATIC BOOLEAN_T
atula_bia_valid(
    BYTE_T                    id,
    BYTE_T                    type,
    BYTE_T                    rev,
    PCLIENT_ADAPTER_SUBTYPE_T subtype)
{
    BOOLEAN_T rc;

    rc = FALSE;

    if (id=='M')
    {
        switch(type)
        {
            case ATULA_BIAPROM_ADAPTER_AT:  
                switch(rev)
                {
#                   ifdef UDT_SUPPORT_OLD_AT_CARDS

                    case AT_BIAPROM_REVISION_AT0:      
                    case AT_BIAPROM_REVISION_AT1:     
                    case AT_BIAPROM_REVISION_AT2:    
                        *subtype = ADAPTER_SUBTYPE_AT;
                        rc = TRUE;
                        break;

                    case AT_BIAPROM_REVISION_FIBER:    
                        *subtype = ADAPTER_SUBTYPE_FIBER;
                        rc = TRUE;
                        break;

                    case AT_BIAPROM_REVISION_BRIDGE:  
                        *subtype = ADAPTER_SUBTYPE_BRIDGE;
                        rc = TRUE;
                        break;

                    case AT_BIAPROM_REVISION_ISAC:   
                        *subtype = ADAPTER_SUBTYPE_ISAC;
                        rc = TRUE;
                        break;

#                   endif 

                    case AT_BIAPROM_REVISION_ATP0:     
                        *subtype = ADAPTER_SUBTYPE_ATP;
                        rc = TRUE;
                        break;
                }
                break;

#if defined(OLDCARDS_UPI)
#define    ATULA_BIAPROM_ADAPTER_PC_RINGNODE   (0x0B)
#define    ATULA_BIAPROM_ADAPTER_MAXY          (0x0C)

            case ATULA_BIAPROM_ADAPTER_PC_RINGNODE:
                if (rev == 0)
                {
                   *subtype = ADAPTER_SUBTYPE_PC;
                   rc = TRUE;
                }
                break;
            case ATULA_BIAPROM_ADAPTER_MAXY:
                if (rev == 0)
                {
                   *subtype = ADAPTER_SUBTYPE_MAXY;
                   rc = TRUE;
                }
                break;

#endif 


            case ATULA_BIAPROM_ADAPTER_ATP: 
                switch(rev)
                {
                    case ATP_BIAPROM_REVISION_ISACP:    
                        *subtype = ADAPTER_SUBTYPE_ISACP;
                        rc = TRUE;
                        break;


                    case ATP_BIAPROM_REVISION_FIBERP:   
                    case ATP_BIAPROM_REVISION_ATP:   
                        *subtype = ADAPTER_SUBTYPE_ATP;
                        rc = TRUE;
                        break;
                }
                break;
        }
    }

    return rc;
}


STATIC UINT_T
check_misc_atula_bits(
    IN  P_UPI_DATA_T upids_ptr)

{
    UINT_T failures;
    BYTE_T r0;
    BYTE_T r1;
    BYTE_T r2;
    BYTE_T r3;
    BYTE_T r6;
    BYTE_T r7;


    r2=PROBE_INB(upids_ptr, ATULA_CTRL_REG2);
    r3=PROBE_INB(upids_ptr, ATULA_STATUS_REG_RNDBIT);


    if ( (r2&ATULA_CTRL_REG2_ADDSEL) != 0 )
    {
        if ( (r3&0x89) != 0x89)
        {
            return IS_NOT_ATULA;
        }
    }


    failures=0;

    r0=PROBE_INB(upids_ptr, ATULA_IBM_REG);
    r1=PROBE_INB(upids_ptr, ATULA_CTRL_REG1);
    r6=PROBE_INB(upids_ptr, ATULA_CTRL_REG6);
    r7=PROBE_INB(upids_ptr, ATULA_CTRL_REG7);

    if (r0!=0) failures++;

    if (r1&ATULA_CTRL_REG1_SXREGSEL) failures++;
    if (r1&ATULA_CTRL_REG1_TMDIV) failures++;

    if (r2&ATULA_CTRL_REG2_SHLDA) failures++;
    if (r2&ATULA_CTRL_REG2_SHLDA2) failures++;
    if (r2&ATULA_CTRL_REG2_ADDSEL) failures++;

    if (r6&ATULA_CTRL_REG6_UDRQ) failures++;

    if (r7&ATULA_CTRL_REG7_UINT) failures++;


    TPOKEB_UPI(TT_DULL, "Failed:", failures);

    if (failures<=1)
        return PROBABLY_ATULA;

    if (failures<=4)
        return UNLIKELY_TO_BE_ATULA;

    return IS_NOT_ATULA;
}


#endif 



#if defined(SMART16_UPI)

STATIC VOID_T
upi_find_smart16(
    IN  P_UPI_DATA_T        upids_ptr)
{
    IO_LOCATION_T      io_base = (IO_LOCATION_T)0x4a20;
    BYTE_T             two_bits, bia_byte_2;
    UINT_T             i, j, offset;
    DWORD_T            node_address = 0;
    MAC_ADDRESS_T      bia;
    BOOLEAN_T          found_card = FALSE;
    BOOLEAN_T          adapter_check;
    ADAPTER_STATE_T    adap_state = ADAPTER_STATE_UNKNOWN;


    if(!(PSSI_REGISTER_IO(
            upids_ptr,
            io_base,
            SMART16_IO_RANGE,
            &upids_ptr->io_handle)))
    {
        return;
    }


    adapter_check =
        (PROBE_INW(upids_ptr, SMART16_SIFINT) & SIFINT_ADAPTER_CHECK) != 0;

    if ((!adapter_check)
        &&
        upi_smart_read_bia_from_card(
            upids_ptr,
            SMART16_SIFADR,
            SMART16_SIFDAT,
            &bia))
    {

        POKEB_UPI(PO_MAGENTA, "Smart16,SwRun,Bia=0000F6", bia.byte[3]);

        if (bia.byte[3]>=0x31 && bia.byte[3]<=0x35 && bia.byte[3]!=0x33)
        {
             found_card = TRUE;
             adap_state = ADAPTER_STATE_RUNNING;
        }
    }
    else
    {

        PROBE_OUTB(upids_ptr, SMART16_CTRL_REG1, 0);

        for (i=0; i<4; i++)
        {
            PROBE_OUTB(upids_ptr, SMART16_CTRL_REG2, (BYTE_T)i);

            offset = 0;

            for (j=0; j<4; j++)
            {
                two_bits = (BYTE_T)(PROBE_INB(upids_ptr, offset) & 3);
                node_address = PSSI_DWORD_SHIFT_L(upids_ptr, node_address, 2);
                node_address |= two_bits;
                offset += 8;
            }
        }

        POKED_UPI(PO_MAGENTA, "Smart16,SwRun,Bia=0000", node_address);

        bia_byte_2 = (BYTE_T)
            (PSSI_DWORD_SHIFT_R(upids_ptr, node_address, (8*3)) & 0x0ff);

        if (bia_byte_2 == (BYTE_T)0xF6)
        {
              found_card = TRUE;
              adap_state = ADAPTER_STATE_RESET;
        }
    }


    if (found_card)
    {
        upi_found_adapter(
            upids_ptr,
            ADAPTER_TYPE_SMART16,
            ADAPTER_SUBTYPE_SMART16,
            io_base,
            0,
            adap_state);


        upi_exclude_io_range(
            upids_ptr,
            io_base,
            SMART16_IO_RANGE);
    }


    PSSI_UNREGISTER_IO(
        upids_ptr,
        io_base,
        upids_ptr->io_handle);
}

#endif 



#if defined(COMPAQ_ISA_UPI)

STATIC VOID_T
upi_find_compaq_isa(
    IN  P_UPI_DATA_T        upids_ptr)
{
    IO_LOCATION_T      io_base[]   = COMPAQ_ISA_IO_BASE_LIST;
    UINT_T             count;
    UINT_T             i;
    BOOLEAN_T          found_eagle;
    WORD_T             old_sifadr;
    BYTE_T             index_5;
    BOOLEAN_T          switch_based_card;
    MAC_ADDRESS_T      bia;
    UINT_T             index;
    WORD_T             old_sifadrx;
    BYTE_T             in;

    for(count = 0; count < sizeof(io_base) / sizeof(IO_LOCATION_T); count++)
    {

        if(upi_io_region_excluded(
               upids_ptr,
               io_base[count],
               COMPAQ_ISA_IO_RANGE))
        {

            continue;
        }


        if(!(PSSI_REGISTER_IO(
                 upids_ptr,
                 io_base[count],
                 ATULA_PRIMARY_IO_RANGE,
                 &upids_ptr->io_handle)))
        {
            continue;
        }

        found_eagle = FALSE;

        for (i=0; i<10; i++)
        {
            old_sifadr = PROBE_INW(upids_ptr, COMPAQ_ISA_SIFADR);

            if (old_sifadr==0xFFFF)
            {
                break;
            }

            PROBE_INW(upids_ptr, COMPAQ_ISA_SIFDATINC);

            if (PROBE_INW(upids_ptr, COMPAQ_ISA_SIFADR) == (old_sifadr+2))
            {
                found_eagle = TRUE;
                break;
            }
        }

        if (found_eagle)
        {
            TPOKEW_UPI(TT_INFO, "PossibleCompaqIsa:", io_base[count]);


            PROBE_OUTB(
                upids_ptr,
                COMPAQ_ISA_INDEX_REG,
                COMPAQ_ISA_ID_1_INDEX);

            TPOKEB_UPI(
                TT_VALUE,
                "R0:",
                PROBE_INB(upids_ptr, COMPAQ_ISA_INDEX_REG));

            if (PROBE_INB(upids_ptr, COMPAQ_ISA_INDEX_REG) == 0x40)
            {
                PROBE_OUTB(
                    upids_ptr,
                    COMPAQ_ISA_INDEX_REG,
                    COMPAQ_ISA_ID_2_INDEX);

                TPOKEB_UPI(
                    TT_VALUE,
                    "R1:",
                    PROBE_INB(upids_ptr, COMPAQ_ISA_INDEX_REG));

                if (PROBE_INB(upids_ptr, COMPAQ_ISA_INDEX_REG) == 0x45)
                {
                    PROBE_OUTB(upids_ptr, COMPAQ_ISA_INDEX_REG, 5);

                    index_5 = PROBE_INB(upids_ptr, COMPAQ_ISA_INDEX_REG);

                    switch_based_card = (index_5==0x45);

                    TPOKEB_UPI(TT_INFO, "Index5=", index_5);


                    PROBE_OUTW(upids_ptr, COMPAQ_ISA_SIFACL, 0x0000);

                    PSSI_WAIT_AT_LEAST_MSEC(upids_ptr, 14);


                    old_sifadrx = PROBE_INW(upids_ptr, COMPAQ_ISA_SIFADX);

                    PROBE_OUTW(upids_ptr, COMPAQ_ISA_SIFADX, 0);

                    PROBE_OUTW(upids_ptr, COMPAQ_ISA_SIFADR, 0);

                    for(index = 0; index < SIZEOF_MAC_ADDRESS; index++)
                    {
                        in = PROBE_INB(upids_ptr, COMPAQ_ISA_SIFDATINC+1);

                        TPOKEB_UPI(TT_INFO, ",", in);

                        bia.byte[index] = in;
                    }


                    PROBE_OUTW(upids_ptr, COMPAQ_ISA_SIFADX, old_sifadrx);

                    TPOKEB_UPI(TT_INFO, "Bia:",    bia.byte[0]);
                    POKEB_UPI(TONE_B(TT_INFO), "", bia.byte[1]);
                    POKEB_UPI(TONE_B(TT_INFO), "", bia.byte[2]);
                    POKEB_UPI(TONE_B(TT_INFO), "", bia.byte[3]);
                    POKEB_UPI(TONE_B(TT_INFO), "", bia.byte[4]);
                    POKEB_UPI(TONE_B(TT_INFO), "", bia.byte[5]);


                    if (bia.byte[0] == 0x00
                        &&
                        bia.byte[1] == 0x01
                        &&
                        (bia.byte[2] == 0xC8 || bia.byte[2] == 0xFA)
                       )
                    {

                        upi_found_adapter(
                            upids_ptr,
                            ADAPTER_TYPE_COMPAQ_ISA,
                            switch_based_card ?
                                ADAPTER_SUBTYPE_COMPAQ_TC_ISA
                                :
                                (
                                    bia.byte[2]==0xC8 ?
                                        ADAPTER_SUBTYPE_COMPAQ_TC_PNP
                                        :
                                        ADAPTER_SUBTYPE_COMPAQ_PNP
                                ),
                            io_base[count],
                            0,
                            ADAPTER_STATE_RESET);


                        upi_exclude_io_range(
                            upids_ptr,
                            io_base[count],
                            COMPAQ_ISA_IO_RANGE);
                    }
                }
            }
        }



        PSSI_UNREGISTER_IO(
            upids_ptr,
            io_base[count],
            upids_ptr->io_handle);

    } 
}

#endif 



#if defined(MC16_UPI) || \
    defined(MC32_UPI)


STATIC VOID_T
upi_find_smart_mc(
    IN  P_UPI_DATA_T        upids_ptr)
{
    UINT_T                  slot_num;
    ADAPTER_TYPE_T          adap_type;
    IO_LOCATION_T           io_base;

    if (!(PSSI_DETECT_MCA(upids_ptr)))
    {
        return;
    }

    for(slot_num = 1; slot_num <= 8; slot_num++)
    {

        if(upi_slot_excluded(upids_ptr, slot_num))
        {

            continue;
        }

        adap_type = smartmc_slot_to_io_base(upids_ptr, slot_num, &io_base);


        if(upi_io_region_excluded(
               upids_ptr,
               io_base,
               SMARTMC_PRIMARY_IO_RANGE))
        {

            continue;
        }

#ifdef MC16_UPI
        if (adap_type == ADAPTER_TYPE_MC16)
        {
            ADAPTER_STATE_T  adap_state = ADAPTER_STATE_UNKNOWN;

            if (upi_do_status_block_enquiry(
                upids_ptr,
                SMARTMC_SIFADR,
                SMARTMC_SIFDAT))
            {
                adap_state = ADAPTER_STATE_RUNNING;
            }

            upi_found_adapter(
                upids_ptr,
                ADAPTER_TYPE_MC16,
                ADAPTER_SUBTYPE_MC16,
                io_base,
                0,
                adap_state);


            upi_exclude_io_range(
                upids_ptr,
                io_base,
                SMARTMC_PRIMARY_IO_RANGE);
        }
#endif
#ifdef MC32_UPI
        if (adap_type == ADAPTER_TYPE_MC32)
        {
            ADAPTER_STATE_T  adap_state = ADAPTER_STATE_UNKNOWN;

            if (upi_do_status_block_enquiry(
                upids_ptr,
                SMARTMC_SIFADR,
                SMARTMC_SIFDAT))
            {
                adap_state = ADAPTER_STATE_RUNNING;
            }

            upi_found_adapter(
                upids_ptr,
                ADAPTER_TYPE_MC32,
                ADAPTER_SUBTYPE_MC32,
                io_base,
                0,
                adap_state);


            upi_exclude_io_range(
                upids_ptr,
                io_base,
                SMARTMC_PRIMARY_IO_RANGE);
        }
#endif
    }
}


STATIC ADAPTER_TYPE_T
smartmc_slot_to_io_base(
    IN  P_UPI_DATA_T          upids_ptr,
    IN  UINT_T                slot_num,
    OUT PCLIENT_IO_LOCATION_T io_ptr)
{
    ADAPTER_TYPE_T  adap_type = ADAPTER_TYPE_INVALID;
    BYTE_T          mc_id1, mc_id2;
    BYTE_T          mc_pos0, mc_pos2, mc_pos3;
    WORD_T          io_base;


    if(!(PSSI_REGISTER_IO(
             upids_ptr,
             MC_POS_IO_BASE1,
             MC_POS_IO_RANGE1,
             &upids_ptr->io_handle)))
    {
        return adap_type;
    }

    PROBE_OUTB(
        upids_ptr,
        MC_SETUP_SLOT_REG,
        (BYTE_T)(MC_POS_AES_REG_CSENABLE + slot_num - 1));

    PSSI_UNREGISTER_IO(
        upids_ptr,
        MC_POS_IO_BASE1,
        upids_ptr->io_handle);


    if(!(PSSI_REGISTER_IO(
             upids_ptr,
             MC_POS_IO_BASE2,
             MC_POS_IO_RANGE2,
             &upids_ptr->io_handle)))
    {
        return adap_type;
    }

    mc_id1 = PROBE_INB(upids_ptr, MC_SETUP_ADAP_ID1);

    mc_id2 = PROBE_INB(upids_ptr, MC_SETUP_ADAP_ID2);

#ifdef MC16_UPI
    if ((mc_id1 == MC_16_ID1) && (mc_id2 == MC_16_ID2))
    {
        adap_type = ADAPTER_TYPE_MC16;
    }
#endif
#ifdef MC32_UPI
    if ((mc_id1 == MC_32_ID1) && (mc_id2 == MC_32_ID2))
    {
        adap_type = ADAPTER_TYPE_MC32;
    }
#endif

    if (adap_type != ADAPTER_TYPE_INVALID)
    {

        mc_pos0 = (BYTE_T)(PROBE_INB(upids_ptr, MC_SETUP_POS_0) & IOSEL_POS0);
        mc_pos2 = (BYTE_T)(PROBE_INB(upids_ptr, MC_SETUP_POS_2) & IOSEL_POS2);
        mc_pos3 = (BYTE_T)(PROBE_INB(upids_ptr, MC_SETUP_POS_3) & IOSEL_POS3);


        io_base =  0x0020;
        io_base += mc_pos0 << 7;
        io_base += mc_pos3 << 8;
        io_base += mc_pos2 << 8;

        *io_ptr = (IO_LOCATION_T)io_base;
    }

    PSSI_UNREGISTER_IO(
        upids_ptr,
        MC_POS_IO_BASE2,
        upids_ptr->io_handle);


    if(!(PSSI_REGISTER_IO(
             upids_ptr,
             MC_POS_IO_BASE1,
             MC_POS_IO_RANGE1,
             &upids_ptr->io_handle)))
    {
        return adap_type;
    }

    PROBE_OUTB(
        upids_ptr,
        MC_SETUP_SLOT_REG,
        0);

    PSSI_UNREGISTER_IO(
        upids_ptr,
        MC_POS_IO_BASE1,
        upids_ptr->io_handle);

    return adap_type;
}


#endif 



#if defined(STRAIGHTBLUEMC_UPI)

STATIC VOID_T
upi_find_ibm_mc(
    IN  P_UPI_DATA_T        upids_ptr)
{
    UINT_T                  slot_num;
    IO_LOCATION_T           io_base;
    BYTE_T                  setup1;
    BYTE_T                  setup2;
    PHYS_ADDRESS_T          mmio_base;
    BYTE_T                  madge_id;

    if (!(PSSI_DETECT_MCA(upids_ptr)))
    {
        return SUCCESS;
    }

    for(slot_num = 1; slot_num <= 8; slot_num++)
    {

        if(upi_slot_excluded(upids_ptr, slot_num))
        {

            continue;
        }


        bluemc_slot_to_io_base(upids_ptr, slot_num, &io_base);


        if(upi_io_region_excluded(
               upids_ptr,
               io_base,
               IBM_PRIMARY_IO_RANGE))
        {

            continue;
        }

        if(!(PSSI_REGISTER_IO(
                 upids_ptr,
                 io_base,
                 FAST_PIO_BASE + FAST_PIO_RANGE,
                 &upids_ptr->io_handle)))
        {
            continue;
        }


        setup1 = PROBE_INB(upids_ptr, IBM_PIO_SWITCH_READ_1);
        setup2 = PROBE_INB(upids_ptr, IBM_PIO_SWITCH_READ_2);


        mmio_base =
            (PHYS_ADDRESS_T)
            (PSSI_DWORD_SHIFT_L(upids_ptr, (DWORD_T)(setup1 & 0xFC), 11) |
             PSSI_DWORD_SHIFT_L(upids_ptr, (DWORD_T)(setup2 & 0x01), 19));


        if(mmio_base >= 0xA0000 && mmio_base < 0xF0000)
        {

            madge_id = PROBE_INB(upids_ptr, IBM_PIO_MADGE_IDENT);


            if(madge_id == 'M' || madge_id == 0)
            {

                PROBE_OUTB(
                    upids_ptr,
                    FAST_PIO_OPTIONS + 8,
                    FAST_PIO_OPTION_RESET(FAST_PIO_OPTION_SIF_PAGING));
            }


            if(!(PSSI_REGISTER_SHARED(
                     upids_ptr,
                     mmio_base,
                     IBM_MMIO_SIZE-1,
                     &upids_ptr->shared_handle)))
            {

                if(upi_check_aia(upids_ptr))
                {

                    upi_found_adapter(
                        upids_ptr,
                        ADAPTER_TYPE_STRAIGHTBLUEMC,
                        ADAPTER_SUBTYPE_BLUE_MC,
                        io_base,
                        0,
                        ADAPTER_STATE_UNKNOWN);
                }


                PSSI_UNREGISTER_SHARED(
                    upids_ptr,
                    mmio_base,
                    upids_ptr->shared_handle);
            }
        }


        PSSI_UNREGISTER_IO(
            upids_ptr,
            io_base,
            upids_ptr->io_handle);
    }

    return SUCCESS;
}

STATIC VOID_T
bluemc_slot_to_io_base(
    IN  P_UPI_DATA_T          upids_ptr,
        UINT_T                slot,
    OUT PCLIENT_IO_LOCATION_T io_ptr)
{
    IO_LOCATION_T            io_base[]       = MC_IO_BASE_LIST;
    UINT_T                   io_select;
    BYTE_T                   pos_reg1_value;
    BYTE_T                   pos_reg3_value;
    BYTE_T                   pos_reg4_value;


    if(!(PSSI_REGISTER_IO(
             upids_ptr,
             MC_POS_IO_BASE,
             MC_POS_IO_RANGE,
             &upids_ptr->io_handle)))
    {
        *io_ptr = (IO_LOCATION_T)0x0000;

        return;
    }


    PROBE_OUTB(
        upids_ptr,
        MC_SETUP_SLOT_REG,
        (BYTE_T)(MC_SETUP_SLOT_REG + slot - 1));


    pos_reg1_value = PROBE_INB(upids_ptr, MC_SETUP_POS_0);
    pos_reg3_value = PROBE_INB(upids_ptr, MC_SETUP_POS_2);
    pos_reg4_value = PROBE_INB(upids_ptr, MC_SETUP_POS_3);


    PROBE_OUTB(
        upids_ptr,
        MC_SETUP_SLOT_REG,
        0);


    PSSI_UNREGISTER_IO(
        upids_ptr,
        MC_POS_IO_BASE,
        upids_ptr->io_handle);


    io_select = (pos_reg1_value >> 5) & 0x01 |
                (pos_reg3_value >> 4) & 0x02 |
                (pos_reg4_value     ) & 0x04;

    *io_ptr = io_base[io_select];

    return;
}


#endif



#if defined(PCI1B_UPI)           ||                                         \
    defined(PCIBM1_UPI)          ||                                         \
    defined(PCIBM2_UPI)          ||                                         \
    defined(KNOSSOS_UPI)         ||                                         \
    defined(COMPAQ_PCI_UPI)      ||                                         \
    defined(OLICOM_PCI_UPI)      ||                                         \
    defined(OLICOM_HEBE_UPI)     ||                                         \
    defined(IBMPCI_UPI)

#ifdef UDT_USE_BIOS_TO_FIND_PCI_CARDS


#if defined(COMPAQ_PCI3_UPI)     || \
    defined(COMPAQ_PCI_UPI)      || \
    defined(OLICOM_PCI_UPI)      || \
    defined(OLICOM_HEBE_UPI)     || \
    defined(IBMPCI_UPI)

#    define UPI_DISTINGUISH_VENDOR

#endif

#ifdef UDT_PACK_ON
#pragma UDT_PACK_ON
#else
#ifdef UDT_ALT_PACK
#pragma pack 1
#else
#pragma pack(1)
#endif
#endif

typedef struct
{
#   ifdef UPI_DISTINGUISH_VENDOR
    WORD_T vendor_id;
#   endif

    WORD_T device_id;

    BYTE_T revision_id;

#   ifdef UPI_DISTINGUISH_VENDOR
    WORD_T subsystem_vendor_id; 
#   endif

    WORD_T subsystem_device_id; 

    WORD_T io_range;            
                                

    BYTE_T sifbase;             
                                
    BYTE_T card_type;
    BYTE_T card_subtype;

} PCI_CARD_T;

#ifdef UDT_PACK_OFF
#pragma UDT_PACK_OFF
#else
#ifdef UDT_ALT_PACK
#pragma pack 0
#else
#pragma pack()
#endif
#endif

#ifdef UPI_DISTINGUISH_VENDOR
#    define PCI_CARD_ENTRY(_a, _b, _c, _d, _e, _f, _g, _h, _i) \
                {_a, _b, _c, _d, _e, _f, _g, _h, _i}
#else
#    define PCI_CARD_ENTRY(_a, _b, _c, _d, _e, _f, _g, _h, _i) \
                {    _b, _c,     _e, _f, _g, _h, _i}
#endif


STATIC VOID_T
upi_find_pci(
    IN  P_UPI_DATA_T        upids_ptr)
{
    PCI_CARD_T pci_cards[] =
        {

#           ifdef PCI1B_UPI

            PCI_CARD_ENTRY(
                PCI_MADGE_VENDOR_ID,
                PCI1B_DEVICE_ID,
                0xFF,
                0xFFFF,
                0xFFFF,
                PCI1B_PRIMARY_IO_RANGE,
                PCI1B_SIFDAT,
                ADAPTER_TYPE_PCI1B,
                ADAPTER_SUBTYPE_PCI1B),

#           endif

#           ifdef PCIBM1_UPI

            PCI_CARD_ENTRY(
                PCI_MADGE_VENDOR_ID,
                PCIBM1_DEVICE_ID,
                0xFF,
                0xFFFF,
                0xFFFF,
                PCIBM1_PRIMARY_IO_RANGE,
                PCIBM1_SIFDAT,
                ADAPTER_TYPE_PCIBM1,
                ADAPTER_SUBTYPE_PCIBM1),

#           endif

#           ifdef PCIBM2_UPI

            PCI_CARD_ENTRY(
                PCI_MADGE_VENDOR_ID,
                PCIBM2_DEVICE_ID,
                0xFF,
                0xFFFF,
                0xFFFF,
                PCIBM2_PRIMARY_IO_RANGE,
                PCIBM2_SIFDAT,
                ADAPTER_TYPE_PCIBM2,
                ADAPTER_SUBTYPE_PCIBM2),

#           endif


#           ifdef PRESTO_UPI

            PCI_CARD_ENTRY(
                PCI_MADGE_VENDOR_ID,
                PRESTO_DEVICE_ID,
                0xFF,
                0xFFFF,
                PRESTO_SUBSYSTEM_ID,
                KNOSSOS_IO_SPACE_SIZE,
                0,
                ADAPTER_TYPE_KNOSSOS,
                ADAPTER_SUBTYPE_PRESTO),

#           endif

#           ifdef PCI3_UPI

            PCI_CARD_ENTRY(
                PCI_MADGE_VENDOR_ID,
                K2_DEVICE_ID,
                0xFF,
                0xFFFF,
                PCI3_SUBSYSTEM_ID,
                KNOSSOS_IO_SPACE_SIZE,
                0,
                ADAPTER_TYPE_KNOSSOS,
                ADAPTER_SUBTYPE_PCI3),

#           endif

#           ifdef PRESTO2_UPI

            PCI_CARD_ENTRY(
                PCI_MADGE_VENDOR_ID,
                K2_DEVICE_ID,
                PRESTO2_PCI_REVISION,
                0xFFFF,
                PRESTO_SUBSYSTEM_ID,
                KNOSSOS_IO_SPACE_SIZE,
                0,
                ADAPTER_TYPE_KNOSSOS,
                ADAPTER_SUBTYPE_PRESTO2),

#           endif

#           ifdef PRESTO2000_UPI

            PCI_CARD_ENTRY(
                PCI_MADGE_VENDOR_ID,
                K2_DEVICE_ID,
                PRESTO2000_PCI_REVISION,
                0xFFFF,
                PRESTO_SUBSYSTEM_ID,
                KNOSSOS_IO_SPACE_SIZE,
                0,
                ADAPTER_TYPE_KNOSSOS,
                ADAPTER_SUBTYPE_PRESTO2000),

#           endif

#           ifdef PCI4_UPI

            PCI_CARD_ENTRY(
                PCI_MADGE_VENDOR_ID,
                PCI4_DEVICE_ID,
                0xFF,
                0xFFFF,
                0xFFFF,
                KNOSSOS_IO_SPACE_SIZE,
                0,
                ADAPTER_TYPE_KNOSSOS,
                ADAPTER_SUBTYPE_PCI4),

            PCI_CARD_ENTRY(
                PCI_MADGE_VENDOR_ID,
                PCI4_MK2_DEVICE_ID,
                0xFF,
                0xFFFF,
                0xFFFF,
                KNOSSOS_IO_SPACE_SIZE,
                0,
                ADAPTER_TYPE_KNOSSOS,
                ADAPTER_SUBTYPE_PCI4_MK2),

#           endif

#           ifdef OLICOM_3140V2_UPI

            PCI_CARD_ENTRY(
                PCI_MADGE_VENDOR_ID,
                OLICOM_3140V2_DEVICE_ID,
                0xFF,
                0xFFFF,
                0xFFFF,
                KNOSSOS_IO_SPACE_SIZE,
                0,
                ADAPTER_TYPE_KNOSSOS,
                ADAPTER_SUBTYPE_OLICOM_PCI_3140_V2),

#           endif


#           ifdef COMPAQ_PCI3_UPI

            PCI_CARD_ENTRY(
                PCI_MADGE_VENDOR_ID,
                K2_DEVICE_ID,
                0xFF,
                PCI_COMPAQ_VENDOR_ID,
                COMPAQ_PCI3_SUBSYSTEM_ID,
                KNOSSOS_IO_SPACE_SIZE,
                0,
                ADAPTER_TYPE_KNOSSOS,
                ADAPTER_SUBTYPE_COMPAQ_PCI3),

#           endif


#           ifdef COMPAQ_PCI_UPI

            PCI_CARD_ENTRY(
                PCI_THOMAS_CONRAD_VENDOR_ID,
                COMPAQ_PCI_DEVICE_ID,
                0xFF,
                0xFFFF,
                0xFFFF,
                PCIBM1_PRIMARY_IO_RANGE,
                PCIBM1_SIFDAT,
                ADAPTER_TYPE_COMPAQ_PCI,
                ADAPTER_SUBTYPE_COMPAQ_TC_PCI),

            PCI_CARD_ENTRY(
                PCI_COMPAQ_VENDOR_ID,
                COMPAQ_PCI_DEVICE_ID,
                0xFF,
                0xFFFF,
                0xFFFF,
                PCIBM1_PRIMARY_IO_RANGE,
                PCIBM1_SIFDAT,
                ADAPTER_TYPE_COMPAQ_PCI,
                ADAPTER_SUBTYPE_COMPAQ_PCI),

#           endif

#           ifdef OLICOM_PCI_UPI


            PCI_CARD_ENTRY(
                PCI_OLICOM_VENDOR_ID,
                OLICOM_PCI_3136_DEVICE_ID,
                OLICOM_PCI_3136_1_PCI_REVISION,
                0xFFFF,
                0xFFFF,
                OLICOM_PCI_PRIMARY_IO_RANGE,
                OLICOM_PCI_SIFDAT,
                ADAPTER_TYPE_OLICOM_PCI,
                ADAPTER_SUBTYPE_OLICOM_PCI_3136),

            PCI_CARD_ENTRY(
                PCI_OLICOM_VENDOR_ID,
                OLICOM_PCI_3136_DEVICE_ID,
                OLICOM_PCI_3136_2_PCI_REVISION,
                0xFFFF,
                0xFFFF,
                OLICOM_PCI_PRIMARY_IO_RANGE,
                OLICOM_PCI_SIFDAT,
                ADAPTER_TYPE_OLICOM_PCI,
                ADAPTER_SUBTYPE_OLICOM_PCI_3136),


            PCI_CARD_ENTRY(
                PCI_OLICOM_VENDOR_ID,
                OLICOM_PCI_3137_DEVICE_ID,
                OLICOM_PCI_3137_PCI_REVISION,
                0xFFFF,
                0xFFFF,
                OLICOM_PCI_PRIMARY_IO_RANGE,
                OLICOM_PCI_SIFDAT,
                ADAPTER_TYPE_OLICOM_PCI,
                ADAPTER_SUBTYPE_OLICOM_PCI_3137),

#           endif

#           ifdef OLICOM_3139_UPI

            PCI_CARD_ENTRY(
                PCI_OLICOM_VENDOR_ID,
                OLICOM_PCI_3139_DEVICE_ID,
                OLICOM_PCI_3139_PCI_REVISION,
                0xFFFF,
                0xFFFF,
                HEBE_IO_SPACE_RANGE,
                0,
                ADAPTER_TYPE_HAWKEYE_OLICOM_PCI,
                ADAPTER_SUBTYPE_OLICOM_PCI_3139),
#           endif

#           ifdef OLICOM_314X_UPI

            PCI_CARD_ENTRY(
                PCI_OLICOM_VENDOR_ID,
                OLICOM_PCI_3140_DEVICE_ID,
                OLICOM_PCI_3140_PCI_REVISION,
                0xFFFF,
                0xFFFF,
                HEBE_IO_SPACE_RANGE,
                0,
                ADAPTER_TYPE_HAWKEYE_OLICOM_PCI,
                ADAPTER_SUBTYPE_OLICOM_PCI_3140),

            PCI_CARD_ENTRY(
                PCI_OLICOM_VENDOR_ID,
                OLICOM_PCI_3141_DEVICE_ID,
                0xFF,
                0xFFFF,
                0xFFFF,
                HEBE_IO_SPACE_RANGE,
                0,
                ADAPTER_TYPE_HAWKEYE_OLICOM_PCI,
                ADAPTER_SUBTYPE_OLICOM_PCI_3141),

#           endif

#           ifdef OLICOM_3540_UPI

            PCI_CARD_ENTRY(
                PCI_OLICOM_VENDOR_ID,
                OLICOM_PCI_3540_DEVICE_ID,
                0xFF,
                0xFFFF,
                0xFFFF,
                HEBE_IO_SPACE_RANGE,
                0,
                ADAPTER_TYPE_BULLSEYE_OLICOM_PCI,
                ADAPTER_SUBTYPE_OLICOM_PCI_3540),

#           endif


#ifdef IBMPCI_UPI

#define PCI_IBM_LANSTREAMER_PRIMARY_IO_RANGE       (256)

            PCI_CARD_ENTRY(
                PCI_IBM_VENDOR_ID,
                IBM_LANSTREAMER_DEVICE_ID,
                0xFF,
                0xFFFF,
                0xFFFF,
                PCI_IBM_LANSTREAMER_PRIMARY_IO_RANGE,
                0,
                ADAPTER_TYPE_IBM_PCI,
                ADAPTER_SUBTYPE_IBMPCI_LANSTREAMER),
#endif

            PCI_CARD_ENTRY(0, 0, 0, 0, 0, 0, 0, ADAPTER_TYPE_INVALID, 0)
        };

    PCI_CARD_T              card;
    WORD_T                  pci_number;
    PCI_HANDLE_T            pci_handle;
    RETCODE_T               rc;
    IO_LOCATION_T           io_base;
    ADAPTER_STATE_T         adap_state;
    UINT_T                  i;
    UINT_T                  index;
    BYTE_T                  pci_revision_id;
    WORD_T                  subsystem_device_id;
#   ifdef UPI_DISTINGUISH_VENDOR
    WORD_T                  subsystem_vendor_id;
#   endif


    for (i=0; pci_cards[i].card_type != ADAPTER_TYPE_INVALID; i++)
    {
        card = pci_cards[i];

        TPOKEW_UPI(TT_DULL, "DevId=", card.device_id);


        for (index=0;

#            ifdef UPI_DISTINGUISH_VENDOR

             PSSI_FIND_PCI_DEVICE(
                 upids_ptr,
                 card.vendor_id,
                 card.device_id,
                 index,
                 &pci_number) == SUCCESS;

#            else

             PSSI_FIND_PCI_DEVICE(
                 upids_ptr,
                 PCI_MADGE_VENDOR_ID,
                 card.device_id,
                 index,
                 &pci_number) == SUCCESS;

#            endif

             index++)
        {

            TPOKEB_UPI(TT_BRIGHT, "PciNum:", pci_number);

            if(upi_pci_number_excluded(upids_ptr, pci_number))
            {
                continue;
            }


            if(PCI_FUNCTION_NUMBER(pci_number)!=0)
            {
                continue;
            }


            rc=PSSI_REGISTER_PCI(
                   upids_ptr,
                   pci_number,
                   &pci_handle);

            if (rc!=SUCCESS)
            {
                return;
            }


            pci_revision_id = (BYTE_T) PSSI_PCI_READW(
                                           upids_ptr,
                                           pci_handle,
                                           PCI_REVISION_ID_INDEX);

            TPOKEB_UPI(TT_BRIGHT2, ",Rev:", pci_revision_id);

#           ifdef UPI_DISTINGUISH_VENDOR

            subsystem_vendor_id = PSSI_PCI_READW(
                                      upids_ptr,
                                      pci_handle,
                                      PCI_SUBSYSTEM_VENDOR_ID_INDEX);

            TPOKEW_UPI(TT_BRIGHT2, ",Ssv:", subsystem_vendor_id);

#           endif 

            subsystem_device_id = PSSI_PCI_READW(
                                      upids_ptr,
                                      pci_handle,
                                      PCI_SUBSYSTEM_DEVICE_ID_INDEX);

            TPOKEW_UPI(TT_BRIGHT2, ",Ssd:", subsystem_device_id);

            io_base = (IO_LOCATION_T)
                (PSSI_PCI_READD(
                     upids_ptr,
                     pci_handle,
                     PCI_IO_BASE_INDEX) & PCI_IO_BASE_MASK);

            TPOKEW_UPI(TT_BRIGHT2, ",IO:", io_base);


            PSSI_PCI_WRITEW(
                upids_ptr,
                pci_handle,
                PCI_COMMAND_INDEX,
                (
                    PSSI_PCI_READW(
                         upids_ptr,
                         pci_handle,
                         PCI_COMMAND_INDEX)
                    & 0x0010
                ) | 0x0007);

            PSSI_UNREGISTER_PCI(
                upids_ptr,
                pci_number,
                pci_handle);

#           ifdef UPI_DISTINGUISH_VENDOR

            if (card.subsystem_vendor_id != 0xFFFF
                &&
                card.subsystem_vendor_id != subsystem_vendor_id)
            {
                POKE_UPI(PO_BRIGHT_RED, "WrongSsv");
                continue;
            }

#           endif 


            if ((card.subsystem_device_id != 0xFFFF
                 &&
                 card.subsystem_device_id != subsystem_device_id)

#               ifdef PCIBM2_UPI

                ||
                (card.card_subtype == ADAPTER_SUBTYPE_PCIBM2
                    &&
                    subsystem_device_id == CARDBUS_SUBSYSTEM_ID)

#               endif

                )
            {
                POKE_UPI(PO_BRIGHT_RED, "WrongSsd");
                continue;
            }


            if (card.revision_id != 0xFF
                &&
                card.revision_id != pci_revision_id)
            {
                POKE_UPI(PO_BRIGHT_RED, "WrongRev");
                continue;
            }


            if (!PSSI_REGISTER_IO(
                     upids_ptr,
                     io_base,
                     card.io_range,
                     &upids_ptr->io_handle))
            {
                continue;
            }


            adap_state = ADAPTER_STATE_UNKNOWN;

            switch (card.card_type)
            {

#               ifdef KNOSSOS_UPI

                case ADAPTER_TYPE_KNOSSOS :


                    POKE_UPI(PO_WHITE, "Krun?");

                    if(
                       (PROBE_INW(
                          upids_ptr,
                          KNOSSOS_ADAPTER_CTRL_W)
                               & ADAPTER_CTRL_WORD_PROC_RESET)  &&
                       ((PROBE_INW(
                          upids_ptr,
                          PRESTO_WATCHDOG_TIMER_W)
                               & PRESTO_WATCHDOG_TIMER_W_MSK) < 30) )
                    {
                        POKE_UPI(PO_BRIGHT_WHITE, "Yes!");
                        adap_state = ADAPTER_STATE_RUNNING;
                    }

                    break;

#               endif 


#               ifdef OLICOM_HEBE_UPI

                case ADAPTER_TYPE_HAWKEYE_OLICOM_PCI  :
                case ADAPTER_TYPE_BULLSEYE_OLICOM_PCI :


                    break;

#               endif 


#               ifdef IBMPCI_UPI

                case ADAPTER_TYPE_IBM_PCI :


                    break;

#               endif 


                default :

#               if defined(PCI1B_UPI)   || \
                   defined(PCIBM1_UPI)  || \
                   defined(PCIBM2_UPI)


                    POKE_UPI(PO_WHITE, "Srun?");

#                   ifdef PCIBM2_UPI

                    if (!(card.card_subtype == ADAPTER_SUBTYPE_PCIBM2)
                        ||
                        (
                            (PROBE_INB(
                                 upids_ptr,
                                 PCIBM2_RESET_REG)
                                 &
                                     (PCIBM2_RESET_REG_CHIP_NRES |
                                      PCIBM2_RESET_REG_SIF_NRES |
                                      PCIBM2_RESET_REG_FIFO_NRES)
                            )
                            ==
                            (PCIBM2_RESET_REG_CHIP_NRES |
                             PCIBM2_RESET_REG_SIF_NRES |
                             PCIBM2_RESET_REG_FIFO_NRES)
                        )
                       )

#                   endif 

                    {
                        if (upi_do_status_block_enquiry(
                                    upids_ptr,
                                    card.sifbase
#                                   ifdef PCI1B_UPI
                                       + (card.card_type==ADAPTER_TYPE_PCI1B)?
                                             8:4,
#                                   else
                                       + 4,
#                                   endif
                                    (WORD_T)(card.sifbase)))
                        {
                            POKE_UPI(PO_BRIGHT_WHITE, "Yes!");
                            adap_state = ADAPTER_STATE_RUNNING;
                        }
                    }

#                   endif 

                    break;
            }

            PSSI_UNREGISTER_IO(
                upids_ptr,
                io_base,
                upids_ptr->io_handle);



            upi_found_adapter(
                upids_ptr,
                card.card_type,
                card.card_subtype,
                io_base,
                pci_number,
                adap_state);


            upi_exclude_io_range(
                upids_ptr,
                io_base,
                card.io_range);

        }
    }
}

#endif 


#ifndef UDT_USE_BIOS_TO_FIND_PCI_CARDS

#define MAX_BUS_STACK_ENTRIES 120

STATIC VOID_T
upi_find_pci(
    IN  P_UPI_DATA_T        upids_ptr,
    IN  BOOLEAN_T           only_scan_one_pci_bus,
    IN  BYTE_T              pci_bus_number)
{
    BYTE_T                  bus_stack[MAX_BUS_STACK_ENTRIES];
    WORD_T                  bus_stack_entries;
    WORD_T                  pci_number;
    WORD_T                  vendor_id;
    WORD_T                  device_id;
    BYTE_T                  pci_revision_id;
#   ifdef KNOSSOS_UPI
    WORD_T                  subsystem_vendor_id;
#   endif
    ADAPTER_TYPE_T          type;
    ADAPTER_SUBTYPE_T       subtype;
    WORD_T                  subsystem_device_id;
    BYTE_T                  bus_number=0; 
    PCI_HANDLE_T            pci_handle;
    RETCODE_T               rc;
    IO_LOCATION_T           io_base;
    UINT_T                  io_range;
    ADAPTER_STATE_T         adap_state;
    WORD_T                  secondary_and_primary;
    BYTE_T                  primary;
    BYTE_T                  secondary;
    BYTE_T                  subordinate;
    BOOLEAN_T               incremental_search=FALSE; 
                                                      
    BYTE_T                  max_bus_number=0;         
                                                      

    bus_stack[0] = (BYTE_T)
                       ((only_scan_one_pci_bus) ? pci_bus_number : (BYTE_T)0);

    bus_stack_entries = 1;

    while (incremental_search?
               (bus_number++,bus_number<=max_bus_number)
               :
               (bus_stack_entries > 0))
    {

        if (!incremental_search)
        {
            bus_stack_entries--;

            bus_number = bus_stack[bus_stack_entries];
        }

        TPOKEB_UPI(TT_DULL, "PciBus=", bus_number);


        for(pci_number =  PCI_NUMBER(bus_number, 0, 0);
            pci_number <= PCI_NUMBER(bus_number, 31, 0x07);
            pci_number += 1)
        {

            if(upi_pci_number_excluded(upids_ptr, pci_number))
            {

                continue;
            }


            rc=PSSI_REGISTER_PCI(
                   upids_ptr,
                   pci_number,
                   &pci_handle);

            if (rc==NO_PCI_BUSES)
            {
               return;
            }

            if (rc!=SUCCESS)
            {

                continue;
            }


            if(PCI_FUNCTION_NUMBER(pci_number)==0)
            {

                adap_state = ADAPTER_STATE_UNKNOWN;
                type       = ADAPTER_TYPE_INVALID;
                subtype    = ADAPTER_SUBTYPE_INVALID;


                vendor_id = PSSI_PCI_READW(
                                upids_ptr,
                                pci_handle,
                                PCI_VENDOR_ID_INDEX);


                device_id = PSSI_PCI_READW(
                                upids_ptr,
                                pci_handle,
                                PCI_DEVICE_ID_INDEX);


                pci_revision_id = (BYTE_T) PSSI_PCI_READW(
                                               upids_ptr,
                                               pci_handle,
                                               PCI_REVISION_ID_INDEX);

#               ifdef KNOSSOS_UPI

                subsystem_vendor_id = PSSI_PCI_READW(
                                          upids_ptr,
                                          pci_handle,
                                          PCI_SUBSYSTEM_VENDOR_ID_INDEX);

#               endif 

                subsystem_device_id = PSSI_PCI_READW(
                                          upids_ptr,
                                          pci_handle,
                                          PCI_SUBSYSTEM_DEVICE_ID_INDEX);


#if defined(PCI1B_UPI)   ||                                                 \
    defined(PCIBM1_UPI)  ||                                                 \
    defined(PCIBM2_UPI)  ||                                                 \
    defined(KNOSSOS_UPI)

                if(vendor_id == PCI_MADGE_VENDOR_ID)
                {

                    io_base = (IO_LOCATION_T)
                        (PSSI_PCI_READD(
                             upids_ptr,
                             pci_handle,
                             PCI_IO_BASE_INDEX) & PCI_IO_BASE_MASK);

#ifdef PCI1B_UPI
                    if(device_id == PCI1B_DEVICE_ID
                       &&
                       PSSI_REGISTER_IO(
                           upids_ptr,
                           io_base,
                           PCI1B_PRIMARY_IO_RANGE,
                           &upids_ptr->io_handle)
                      )
                    {
                        if (upi_do_status_block_enquiry(
                            upids_ptr,
                            PCI1B_SIFADR,
                            PCI1B_SIFDAT))
                        {
                            adap_state = ADAPTER_STATE_RUNNING;
                        }

                        PSSI_UNREGISTER_IO(
                            upids_ptr,
                            io_base,
                            upids_ptr->io_handle);


                        type     = ADAPTER_TYPE_PCI1B;
                        subtype  = ADAPTER_SUBTYPE_PCI1B;
                        io_range = PCI1B_PRIMARY_IO_RANGE;
                    }
#endif
#ifdef PCIBM1_UPI
                    if(device_id == PCIBM1_DEVICE_ID
                       &&
                       PSSI_REGISTER_IO(
                           upids_ptr,
                           io_base,
                           PCIBM1_PRIMARY_IO_RANGE,
                           &upids_ptr->io_handle)
                      )
                    {
                        if (upi_do_status_block_enquiry(
                            upids_ptr,
                            PCIBM1_SIFADR,
                            PCIBM1_SIFDAT))
                        {
                            adap_state = ADAPTER_STATE_RUNNING;
                        }

                        PSSI_UNREGISTER_IO(
                            upids_ptr,
                            io_base,
                            upids_ptr->io_handle);


                        type     = ADAPTER_TYPE_PCIBM1;
                        subtype  = ADAPTER_SUBTYPE_PCIBM1;
                        io_range = PCIBM1_PRIMARY_IO_RANGE;
                    }
#endif
#ifdef PCIBM2_UPI
                    if(device_id == PCIBM2_DEVICE_ID)
                    {
                        BYTE_T reset_reg_val;


                        if(subsystem_device_id!=CARDBUS_SUBSYSTEM_ID
                           &&
                           PSSI_REGISTER_IO(
                               upids_ptr,
                               io_base,
                               PCIBM2_PRIMARY_IO_RANGE,
                               &upids_ptr->io_handle)
                          )
                        {

                            reset_reg_val = (BYTE_T)(PROBE_INB(
                                                      upids_ptr,
                                                      PCIBM2_RESET_REG) &
                                                (PCIBM2_RESET_REG_CHIP_NRES |
                                                 PCIBM2_RESET_REG_SIF_NRES |
                                                 PCIBM2_RESET_REG_FIFO_NRES));

                            if (
                                (reset_reg_val ==
                                     (PCIBM2_RESET_REG_CHIP_NRES |
                                      PCIBM2_RESET_REG_SIF_NRES |
                                      PCIBM2_RESET_REG_FIFO_NRES))
                                && (upi_do_status_block_enquiry(
                                        upids_ptr,
                                        PCIBM2_SIFADR,
                                        PCIBM2_SIFDAT))
                               )
                            {
                                adap_state = ADAPTER_STATE_RUNNING;
                            }

                            PSSI_UNREGISTER_IO(
                                upids_ptr,
                                io_base,
                                upids_ptr->io_handle);


                            type     = ADAPTER_TYPE_PCIBM2;
                            subtype  = ADAPTER_SUBTYPE_PCIBM2;
                            io_range = PCIBM2_PRIMARY_IO_RANGE;
                        }
                    }
#endif
#ifdef KNOSSOS_UPI
                    if (subtype == ADAPTER_SUBTYPE_INVALID)
                    {

#                       if defined(PRESTO_UPI)  ||                          \
                           defined(PCI3_UPI)    ||                          \
                           defined(PRESTO2_UPI) ||                          \
                           defined(PCI4_UPI)    ||                          \
                           defined(OLICOM_3140V2_UPI)

                        if(subsystem_vendor_id == PCI_MADGE_VENDOR_ID)
                        {
#                           ifdef PRESTO_UPI

                            if (device_id == PRESTO_DEVICE_ID
                                &&
                                subsystem_device_id == PRESTO_SUBSYSTEM_ID)
                            {
                                subtype = ADAPTER_SUBTYPE_PRESTO;
                            }

#                           endif

#                           ifdef PCI3_UPI

                            if (device_id == K2_DEVICE_ID
                                &&
                                subsystem_device_id == PCI3_SUBSYSTEM_ID)
                            {
                                subtype = ADAPTER_SUBTYPE_PCI3;
                            }

#                           endif

#                           ifdef PRESTO2_UPI

                            if (device_id == K2_DEVICE_ID
                                &&
                                subsystem_device_id == PRESTO_SUBSYSTEM_ID
                                &&
                                pci_revision_id == PRESTO2_PCI_REVISION)
                            {
                                subtype = ADAPTER_SUBTYPE_PRESTO2;
                            }

#                           endif

#                           ifdef PRESTO2000_UPI

                            if (device_id == K2_DEVICE_ID
                                &&
                                subsystem_device_id == PRESTO_SUBSYSTEM_ID
                                &&
                                pci_revision_id == PRESTO2000_PCI_REVISION)
                            {
                                subtype = ADAPTER_SUBTYPE_PRESTO2000;
                            }

#                           endif

#                           ifdef PCI4_UPI

                            if (device_id == PCI4_DEVICE_ID)
                            {
                                subtype = ADAPTER_SUBTYPE_PCI4;
                            }

                            if (device_id == PCI4_MK2_DEVICE_ID)
                            {
                                subtype = ADAPTER_SUBTYPE_PCI4_MK2;
                            }

#                           endif

#                           ifdef OLICOM_3140V2_UPI

                            if (device_id == OLICOM_3140V2_DEVICE_ID)
                            {
                                subtype = ADAPTER_SUBTYPE_OLICOM_PCI_3140_V2;
                            }

#                           endif
                        }

#                       endif


#                       ifdef COMPAQ_PCI3_UPI

                        if(subsystem_vendor_id == PCI_COMPAQ_VENDOR_ID
                           &&
                           device_id == K2_DEVICE_ID
                           &&
                           subsystem_device_id == COMPAQ_PCI3_SUBSYSTEM_ID)
                        {
                            subtype = ADAPTER_SUBTYPE_COMPAQ_PCI3;
                        }

#                       endif

                        if (subtype != ADAPTER_SUBTYPE_INVALID
                            &&
                            PSSI_REGISTER_IO(
                                upids_ptr,
                                io_base,
                                KNOSSOS_IO_SPACE_SIZE,
                                &upids_ptr->io_handle)
                            )
                        {

                            if(
                               (PROBE_INW(
                                    upids_ptr,
                                    KNOSSOS_ADAPTER_CTRL_W)
                               & ADAPTER_CTRL_WORD_PROC_RESET)  &&
                               ((PROBE_INW(
                                    upids_ptr,
                                    PRESTO_WATCHDOG_TIMER_W)
                               & PRESTO_WATCHDOG_TIMER_W_MSK) < 30) )
                            {
                                adap_state = ADAPTER_STATE_RUNNING;
                            }

                            PSSI_UNREGISTER_IO(
                                upids_ptr,
                                io_base,
                                upids_ptr->io_handle);


                            type     = ADAPTER_TYPE_KNOSSOS;
                            io_range = KNOSSOS_IO_SPACE_SIZE;
                        }
                    }
#endif
                }
#endif


#ifdef COMPAQ_PCI_UPI

                if((vendor_id == PCI_COMPAQ_VENDOR_ID ||
                    vendor_id == PCI_THOMAS_CONRAD_VENDOR_ID)
                   &&
                   device_id == COMPAQ_PCI_DEVICE_ID)
                {

                    io_base = (IO_LOCATION_T)
                        (PSSI_PCI_READD(
                             upids_ptr,
                             pci_handle,
                             PCI_IO_BASE_INDEX) & PCI_IO_BASE_MASK);


                    if (PSSI_REGISTER_IO(
                            upids_ptr,
                            io_base,
                            PCIBM1_PRIMARY_IO_RANGE,
                            &upids_ptr->io_handle))
                    {
                        if (upi_do_status_block_enquiry(
                            upids_ptr,
                            PCIBM1_SIFADR,
                            PCIBM1_SIFDAT))
                        {
                            adap_state = ADAPTER_STATE_RUNNING;
                        }

                        PSSI_UNREGISTER_IO(
                            upids_ptr,
                            io_base,
                            upids_ptr->io_handle);


                        type     = ADAPTER_TYPE_COMPAQ_PCI;
                        subtype  =
                            (vendor_id == PCI_THOMAS_CONRAD_VENDOR_ID) ?
                                ADAPTER_SUBTYPE_COMPAQ_TC_PCI :
                                ADAPTER_SUBTYPE_COMPAQ_PCI;
                        io_range = PCIBM1_PRIMARY_IO_RANGE;
                    }
                }
#endif

#if defined(OLICOM_PCI_UPI) || defined(OLICOM_HEBE_UPI)


                if (vendor_id == PCI_OLICOM_VENDOR_ID)
                {

                    io_base = (IO_LOCATION_T)
                        (PSSI_PCI_READD(
                             upids_ptr,
                             pci_handle,
                             PCI_IO_BASE_INDEX) & PCI_IO_BASE_MASK);

#ifdef OLICOM_PCI_UPI
 

                    if (device_id == OLICOM_PCI_3137_DEVICE_ID)
                    {
                        if (PSSI_REGISTER_IO(
                                upids_ptr,
                                io_base,
                                OLICOM_PCI_PRIMARY_IO_RANGE,
                                &upids_ptr->io_handle))
                        {

                            if (upi_do_status_block_enquiry(
                                    upids_ptr,
                                    OLICOM_PCI_SIFADR,
                                    OLICOM_PCI_SIFDAT))
                            {
                                adap_state = ADAPTER_STATE_RUNNING;
                            }

                            PSSI_UNREGISTER_IO(
                                upids_ptr,
                                io_base,
                                upids_ptr->io_handle);


                            io_range = OLICOM_PCI_PRIMARY_IO_RANGE;
                            type     = ADAPTER_TYPE_OLICOM_PCI;

                            if ((pci_revision_id ==
                                    OLICOM_PCI_3136_1_PCI_REVISION) ||
                                (pci_revision_id ==
                                    OLICOM_PCI_3136_2_PCI_REVISION))
                            {
                                subtype = ADAPTER_SUBTYPE_OLICOM_PCI_3136;
                            }
                            else if (pci_revision_id == 
                                        OLICOM_PCI_3137_PCI_REVISION)
                            {
                                subtype = ADAPTER_SUBTYPE_OLICOM_PCI_3137;
                            }
                        }
                    }

#endif 

#ifdef OLICOM_HEBE_UPI


                    if ((device_id == OLICOM_PCI_3139_DEVICE_ID) ||
                        (device_id == OLICOM_PCI_3141_DEVICE_ID) ||
                        (device_id == OLICOM_PCI_3540_DEVICE_ID))
                    {
                        if (PSSI_REGISTER_IO(
                                upids_ptr,
                                io_base,
                                HEBE_IO_SPACE_RANGE,
                                &upids_ptr->io_handle))
                        {

                            PSSI_UNREGISTER_IO(
                                upids_ptr,
                                io_base,
                                upids_ptr->io_handle);

                                
                            io_range = HEBE_IO_SPACE_RANGE;

                            if (device_id == OLICOM_PCI_3139_DEVICE_ID)
                            {

                                type = ADAPTER_TYPE_HAWKEYE_OLICOM_PCI;
#ifdef OLICOM_3139_UPI
                                if (pci_revision_id ==
                                        OLICOM_PCI_3139_PCI_REVISION)
                                {
                                    subtype = ADAPTER_SUBTYPE_OLICOM_PCI_3139;
                                }
#endif 

#ifdef OLICOM_314X_UPI
                                if (pci_revision_id ==
                                        OLICOM_PCI_3140_PCI_REVISION)
                                {
                                    subtype = ADAPTER_SUBTYPE_OLICOM_PCI_3140;
                                }
#endif 

                            }

#ifdef OLICOM_314X_UPI
                            if (device_id == OLICOM_PCI_3141_DEVICE_ID)
                            {
                                type    = ADAPTER_TYPE_HAWKEYE_OLICOM_PCI;
                                subtype = ADAPTER_SUBTYPE_OLICOM_PCI_3141;
                            }

#endif 

#ifdef OLICOM_3540_UPI

                            if (device_id == OLICOM_PCI_3540_DEVICE_ID)
                            {
                                type    = ADAPTER_TYPE_BULLSEYE_OLICOM_PCI;
                                subtype = ADAPTER_SUBTYPE_OLICOM_PCI_3540;
                            }

#endif 

                        }
                    }

#endif 

                }

#endif 


#ifdef IBMPCI_UPI

#define PCI_IBM_LANSTREAMER_PRIMARY_IO_RANGE       (256)

                if(vendor_id == PCI_IBM_VENDOR_ID  &&
                   device_id == IBM_LANSTREAMER_DEVICE_ID)
                {

                    io_base = (IO_LOCATION_T)
                        (PSSI_PCI_READD(
                             upids_ptr,
                             pci_handle,
                             PCI_IO_BASE_INDEX) & PCI_IO_BASE_MASK);


                    type     = ADAPTER_TYPE_IBM_PCI;
                    subtype  = ADAPTER_SUBTYPE_IBMPCI_LANSTREAMER;
                    io_range = PCI_IBM_LANSTREAMER_PRIMARY_IO_RANGE;
                }
#endif


                if ((type    != ADAPTER_TYPE_INVALID) &&
                    (subtype != ADAPTER_SUBTYPE_INVALID))
                {

                    upi_found_adapter(
                        upids_ptr,
                        type,
                        subtype,
                        io_base,
                        pci_number,
                        adap_state);

                    upi_exclude_io_range(
                        upids_ptr,
                        io_base,
                        io_range);
                }

            } 


            if(!only_scan_one_pci_bus)
            {
                WORD_T base_and_sub_class;

                base_and_sub_class = PSSI_PCI_READW(
                                         upids_ptr,
                                         pci_handle,
                                         0x0A);

                if (base_and_sub_class==0x0604 ||
                    base_and_sub_class==0x0607)
                {
                    secondary_and_primary = PSSI_PCI_READW(
                                                upids_ptr,
                                                pci_handle,
                                                0x18);

                    primary=(BYTE_T)secondary_and_primary;
                    secondary=(BYTE_T)(secondary_and_primary>>8);
                    subordinate=(BYTE_T) PSSI_PCI_READW(
                                             upids_ptr,
                                             pci_handle,
                                             0x1A);

                    if (primary==bus_number &&
                        secondary>primary &&
                        subordinate>=secondary)
                    {
                        if (incremental_search)
                        {
                            if (max_bus_number < secondary)
                            {
                                max_bus_number = secondary;
                            }
                        }
                        else
                        {
                            UINT_T stack_loc;
                            BOOLEAN_T found_bus_on_stack=FALSE;


                            for (
                                stack_loc=0;
                                stack_loc<bus_stack_entries;
                                stack_loc++)
                            {
                                if (bus_stack[stack_loc]==secondary)
                                    found_bus_on_stack=TRUE;
                            }

                            if (!found_bus_on_stack)
                            {
                                bus_stack[bus_stack_entries]=secondary;
                                bus_stack_entries++;
                            }
                        }
                    }
                }


                if (base_and_sub_class==0x0600 && bus_number==0
                    && pci_number>=1)
                {

                    incremental_search = TRUE;

                    if (max_bus_number < 6) max_bus_number=6;

                    secondary = (BYTE_T) PSSI_PCI_READW(
                                             upids_ptr,
                                             pci_handle,
                                             0x4A);

                    if (max_bus_number < secondary)
                    {
                        max_bus_number = secondary;
                    }

                    secondary = (BYTE_T) PSSI_PCI_READW(
                                             upids_ptr,
                                             pci_handle,
                                             0x98);

                    if (max_bus_number < secondary)
                    {
                        max_bus_number = secondary;
                    }
                }
            }


            PSSI_UNREGISTER_PCI(
                upids_ptr,
                pci_number,
                pci_handle);

        }

    } 
}
#endif 

#endif 



#if defined(STRAIGHTBLUEISA_UPI) || \
    defined(STRAIGHTBLUEMC_UPI)  || \
    defined(BLUEPLUS_UPI)

STATIC BOOLEAN_T
upi_check_aia(
    IN P_UPI_DATA_T upids_ptr)
{
    MAC_ADDRESS_T   bia;
    MAC_ADDRESS_T   not_bia;
    BYTE_T          signature[12]         = {0};
    BYTE_T          isa_bus_signature[12] = {0};
    BYTE_T          mc_bus_signature[12]  = {0};
    UINT_T          count;



    isa_bus_signature[0] = 'P';
    isa_bus_signature[1] = 'I';
    isa_bus_signature[2] = 'C';
    isa_bus_signature[3] = 'O';
    isa_bus_signature[4] = '6';
    isa_bus_signature[5] = '1';
    isa_bus_signature[6] = '1';
    isa_bus_signature[7] = '0';
    isa_bus_signature[8] = '9';
    isa_bus_signature[9] = '9';
    isa_bus_signature[10] = '0';
    isa_bus_signature[11] = ' ';

    mc_bus_signature[0]  = 'M';
    mc_bus_signature[1]  = 'A';
    mc_bus_signature[2]  = 'R';
    mc_bus_signature[3]  = 'S';
    mc_bus_signature[4]  = '6';
    mc_bus_signature[5]  = '3';
    mc_bus_signature[6]  = 'X';
    mc_bus_signature[7]  = '4';
    mc_bus_signature[8]  = '5';
    mc_bus_signature[9]  = '1';
    mc_bus_signature[10] = '8';
    mc_bus_signature[11] = ' ';


    upi_read_mmio_string(upids_ptr, 0x1F00, 6, (PCLIENT_BYTE_T)bia.byte);
    upi_read_mmio_string(upids_ptr, 0x1F18, 6, (PCLIENT_BYTE_T)not_bia.byte);


    for(count = 0; count < 6; count++)
    {
        if((bia.byte[count] ^ not_bia.byte[count]) != 0xFF)
        {
            return FALSE;
        }
    }



    upi_read_mmio_string(upids_ptr, 0x1F30, 12, signature);

    if((upi_memcmp(signature, isa_bus_signature, 12) == 0) ||
       (upi_memcmp(signature, mc_bus_signature,  12) == 0))
    {

        if(upi_mmio_checksum(upids_ptr, 0x1F00, 0x1F60))
        {

            return upi_mmio_checksum(upids_ptr, 0x1F00, 0x1FF0);
        }
    }

    return FALSE;
}


STATIC BOOLEAN_T
upi_mmio_checksum(
    IN P_UPI_DATA_T upids_ptr,
       WORD_T       start_offset,
       WORD_T       end_offset)
{
    WORD_T          offset        = start_offset;
    BYTE_T          checksum      = 0;
    BYTE_T          byte_value;


    do
    {
        byte_value = PROBE_READB(upids_ptr, offset);

        offset   += 2;
        checksum = (BYTE_T) (checksum + (byte_value & 0x0F) );

    } while(offset <= end_offset);

    return ((checksum & 0x0F) == 0);
}


STATIC VOID_T
upi_read_mmio_string(
    IN  P_UPI_DATA_T   upids_ptr,
        WORD_T         offset,
        WORD_T         length,
    OUT PCLIENT_BYTE_T buffer)
{
    UINT_T            count;
    BYTE_T            hi;
    BYTE_T            lo;


    for(count = 0; count < length; count++)
    {
        hi = PROBE_READB(upids_ptr, offset);
        offset += 2;

        lo = PROBE_READB(upids_ptr, offset);
        offset += 2;

        buffer[count] = (BYTE_T)((lo & 0x0F) | ((hi & 0x0F) << 4));

        TPOKEB_UPI(TT_BRIGHT2, "-", buffer[count]);
    }
}


STATIC INT_T
upi_memcmp(
    IN  PCLIENT_BYTE_T string1,
    IN  PCLIENT_BYTE_T string2,
        UINT_T         length)
{
    UINT_T             count;

    for(count = 0; count < length; count++)
    {
        if( *string1 < *string2)
        {
            return -1;
        }
        else if(*string1++ > *string2++)
        {
            return 1;
        }
    }

    return 0;
}


#endif



#if defined(EISA_UPI)            ||                                         \
    defined(MC16_UPI)            ||                                         \
    defined(MC32_UPI)            ||                                         \
    defined(STRAIGHTBLUEMC_UPI)  ||                                         \
    defined(OLICOM_EISA_UPI)

STATIC BOOLEAN_T
upi_slot_excluded(
    IN P_UPI_DATA_T upids_ptr,
       UINT_T       slot)
{
    P_EXCLUSION_T list;

    for(list = upids_ptr->exclusion_list; list != NULL; list = list->next)
    {

        if(list->identifier_type == SLOT_RANGE)
        {
            if(slot >= list->slot_base &&
               slot <  (list->slot_base + list->slot_range))
            {

                return TRUE;
            }
        }
    }


    return FALSE;
}
#endif


#if defined(EISA_UPI)            ||                                         \
    defined(ATULA_UPI)           ||                                         \
    defined(ISACPNP_UPI)         ||                                         \
    defined(MC16_UPI)            ||                                         \
    defined(MC32_UPI)            ||                                         \
    defined(STRAIGHTBLUEISA_UPI) ||                                         \
    defined(STRAIGHTBLUEMC_UPI)  ||                                         \
    defined(BLUEPLUS_UPI)        ||                                         \
    defined(COMPAQ_ISA_UPI)      ||                                         \
    defined(OLICOM_EISA_UPI)     ||                                         \
    defined(OLICOM_ISAPNP_UPI)   ||                                         \
    defined(OLICOM_ISA_UPI)

BOOLEAN_T
upi_io_region_excluded(
    IN P_UPI_DATA_T    upids_ptr,
       IO_LOCATION_T   io_base,
       IO_LOCATION_T   io_range)
{
    P_EXCLUSION_T list;

    for(list = upids_ptr->exclusion_list; list != NULL; list = list->next)
    {

        if(list->identifier_type == IO_REGION)
        {
            if(io_base >= list->io_base &&
               io_base <  (list->io_base+ list->io_range))
            {

                return TRUE;
            }

            if(list->io_base >= io_base &&
               list->io_base <  (io_base + io_range))
            {

                return TRUE;
            }
        }
    }


    return FALSE;
}

#endif



#if defined(PCI1B_UPI)           ||  \
    defined(PCIBM1_UPI)          ||  \
    defined(PCIBM2_UPI)          ||  \
    defined(KNOSSOS_UPI)         ||  \
    defined(COMPAQ_PCI_UPI)      ||  \
    defined(IBMPCI_UPI)          ||  \
    defined(OLICOM_PCI_UPI)      ||  \
    defined(OLICOM_HEBE_UPI)

STATIC BOOLEAN_T
upi_pci_number_excluded(
    IN P_UPI_DATA_T    upids_ptr,
       WORD_T          pci_number)
{
    P_EXCLUSION_T list;

    for(list = upids_ptr->exclusion_list; list != NULL; list = list->next)
    {

        if(list->identifier_type == PCI_NUMBER_RANGE)
        {
            if(pci_number >= list->pci_number_base &&
               pci_number <  (list->pci_number_base +
                              list->pci_number_range))
            {

                return TRUE;
            }
        }
    }


    return FALSE;
}
#endif

#ifdef OLDCARDS_UPI
STATIC ADAPTER_SUBTYPE_T
upi_find_detailed_ibm_isa(
    IN P_UPI_DATA_T upids_ptr,
       DWORD_T      node_addr_first_four)
{
   DWORD_T             node_addr_first_three;
   ADAPTER_SUBTYPE_T   subtype;

   node_addr_first_three = (node_addr_first_four & 0xFFFFFF00) >> 8;     
   
   if (    node_addr_first_three == 0x0004AC ||
           node_addr_first_three == 0x002035 ||
           node_addr_first_three == 0x08005a ||
           node_addr_first_three == 0x10005a   )
   {
       if (upids_ptr->bAutoISA)
           subtype = ADAPTER_SUBTYPE_IBMAUTOISA;
       else
           subtype = ADAPTER_SUBTYPE_IBM;
       
   } 
   else 
   {
       if (    node_addr_first_three == 0x0020AF ||
               node_addr_first_three == 0x0040B4 ||
               node_addr_first_three == 0x00608C ||
               node_addr_first_three == 0x00A024   )
       {
           subtype = ADAPTER_SUBTYPE_THREECOM;
       }
       else
       {
           subtype = ADAPTER_SUBTYPE_INVALID;
       }
   }
   return subtype;
}
#endif


#if defined(ATULA_UPI) ||                                                   \
    defined(ISACPNP_UPI)

STATIC BOOLEAN_T
upi_check_for_pnp(
    IN P_UPI_DATA_T upids_ptr,
       UINT_T       offset)
{
    UINT_T          count;


    for(count = 0; count < 4; count++)
    {
        if(PROBE_INB(upids_ptr, offset) == (BYTE_T)'m')
        {
            if(PROBE_INB(upids_ptr, offset) == (BYTE_T)'d')
            {
                return TRUE;
            }
        }
    }


    return FALSE;
}

#endif



VOID_T
upi_found_adapter(
    IN P_UPI_DATA_T      upids_ptr,
       ADAPTER_TYPE_T    adapter_type,
       ADAPTER_SUBTYPE_T adapter_subtype,
       IO_LOCATION_T     io_base,
       WORD_T            pci_number,
       ADAPTER_STATE_T   adapter_state)
{
    TPOKEW_UPI(TT_BRIGHT, "FoundAdapter:", adapter_type);
    TPOKEW_UPI(TT_BRIGHT, ",Subtype:", adapter_subtype);
    TPOKEW_UPI(TT_BRIGHT, ",IoBase:", io_base);
    TPOKEW_UPI(TT_BRIGHT, ",PciNum:", pci_number);

    if (upids_ptr->found==MAX_PROBE_ADAPTERS)
    {
        POKE_UPI(COLOUR_ERROR, "TooManyFound");

        return;
    }


    (upids_ptr->id_array[upids_ptr->found]).adapter_type     = adapter_type;
    (upids_ptr->id_array[upids_ptr->found]).adapter_subtype  = adapter_subtype;
    (upids_ptr->id_array[upids_ptr->found]).io_base          = io_base;
    (upids_ptr->id_array[upids_ptr->found]).pci_number       = pci_number;
    (upids_ptr->id_array[upids_ptr->found]).adapter_state    = adapter_state;


    upids_ptr->found++;

    return;
}



VOID_T
upi_exclude_io_range(
    IN P_UPI_DATA_T    upids_ptr,
       IO_LOCATION_T   io_base,
       IO_LOCATION_T   io_range)
{
    P_EXCLUSION_T new;

    POKEW_UPI(PO_RED, "Excluding:", io_base);
    POKEW_UPI(PO_RED, "->", io_base+io_range-1);


    new = &(upids_ptr->extra_exclusion[upids_ptr->extra_exclusion_count]);


    new->identifier_type  = IO_REGION;
    new->io_base          = io_base;
    new->io_range         = io_range;
    new->slot_base        = 0;
    new->slot_range       = 0;
    new->pci_number_base  = 0;
    new->pci_number_range = 0;


    new->next                 = upids_ptr->exclusion_list;
    upids_ptr->exclusion_list = new;


    upids_ptr->extra_exclusion_count++;

    return;
}


UINT_T
upi_report_adapters(
    IN  P_UPI_DATA_T        upids_ptr,
    OUT P_ADAPTER_ID_T      id_array,
        UINT_T              length)
{
    UINT_T                  count;
    UINT_T                  initial_length;
    P_ADAPTER_ID_T          current_id;


    initial_length = length;


    for(count = 0;
        count < upids_ptr->found && length > 0;
        count++)
    {
        current_id = &(upids_ptr->id_array[count]);

        id_array->adapter_type     = current_id->adapter_type;
        id_array->adapter_subtype  = current_id->adapter_subtype;
        id_array->io_base          = current_id->io_base;
        id_array->pci_number       = current_id->pci_number;
        id_array->adapter_state    = current_id->adapter_state;


        id_array++;
        length--;
    }


    return initial_length - length;
}



#endif 

