/********************************************************************
*	THE USE BY YOU OF THIS SOFTWARE IS GOVERNED IN ALL
*	RESPECTS BY THE MADGE NETWORKS LTD OPEN SOURCE LICENSE.		
*	WE ADVISE YOU TO READ THE TERMS OF THE OPEN SOURCE LICENSE
*	WHICH CAN BE FOUND WITHIN THE LICENSE.TXT FILE WHICH IS PART OF
*	THE SOFTWARE OR BY VISITING THE URL
*	http://www.madge.com/Connect/Downloads/Software/.		
*	MADGE NETWORKS LTD RESERVES THE RIGHT TO SEEK REDRESS FOR
*	ANY VIOLATION OF THE LICENSE'S TERMS					
*********************************************************************/

/****************************************************************************
*
* **   ** ****** **** ****        *****
* **   ** * ** *  **   **        **   **
* **   **   **    **   **        **
* **   **   **    **   **        **
* **   **   **    **   **        **
* **   **   **    **   **   *    **   **
*  *****   ****  **** ******* **  *****
*
*****************************************************************************
*
* Utility functions common to all UDIs.
*
*****************************************************************************
*
* Copyright (C) 1996-1999 Madge Networks Ltd.
*
* COMPANY CONFIDENTIAL
*
*****************************************************************************
*/



#define UDI_MODULE

#include "udt_driver.h"

#ifdef UDI_ENABLED





STATIC BOOLEAN_T UDT_INDIRECT
default_check_adapter_is_present(
    INOUT P_UDI_DATA_T                       udids_ptr);



STATIC RETCODE_T
common_queue_command(
    INOUT P_UDI_DATA_T                       udids_ptr,
    IN    ASYNC_COMMAND_TYPE_T               command,
    IN    PCLIENT_ASYNC_COMMAND_PARAMETERS_T parameters,
    IN    UPCALL_COMMAND_COMPLETE_T          completion,
    IN    PCLIENT_UDT_ARGUMENT_T             argument);

STATIC RETCODE_T UDT_LOCAL_PROTECTED
common_fill_command_queue_slot(
    INOUT P_UDI_DATA_T                       udids_ptr,
    IN    PCLIENT_VOID_T                     queue_element,
    IN    PCLIENT_VOID_T                     arg2);

STATIC RETCODE_T UDT_LOCAL_PROTECTED
common_decide_if_can_dequeue(
    INOUT P_UDI_DATA_T                       udids_ptr,
    INOUT PCLIENT_VOID_T                     arg1,
    INOUT PCLIENT_VOID_T                     arg2);



RETCODE_T UDT_INTER_MODULE
util_register(
    IN P_UDI_DATA_T udids_ptr)
{
    

#   ifndef UDT_ONLY_GET_CARD_INFO

    COMMON_RES_FROM_UDIDS(udids_ptr).common_check_adapter_is_present =
        default_check_adapter_is_present;

#   endif

    return SUCCESS;
}

#ifndef UDT_ONLY_GET_CARD_INFO


RETCODE_T UDT_PUBLIC
common_open(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    OPEN_OPTION_T             open_mode,
    IN    UPCALL_COMMAND_COMPLETE_T completion,
    IN    PCLIENT_UDT_ARGUMENT_T    argument)
{
    ASYNC_COMMAND_PARAMETERS_T params;

    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "OpenReq");

    

    params.open_mode = open_mode;

    

    return common_queue_command(
               udids_ptr,
               UDT_COMMAND_OPEN,
               &params,
               completion,
               argument);
}


RETCODE_T UDT_PUBLIC
common_close(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    UPCALL_COMMAND_COMPLETE_T completion,
    IN    PCLIENT_UDT_ARGUMENT_T    argument)
{
    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "CloseReq");

    

    

    return common_queue_command(
               udids_ptr,
               UDT_COMMAND_CLOSE,
               NULL,
               completion,
               argument);
}


RETCODE_T UDT_PUBLIC
common_update_error_log(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    UPCALL_COMMAND_COMPLETE_T completion,
    IN    PCLIENT_UDT_ARGUMENT_T    argument)
{
    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "UpdErrLogReq");

    

    

    return common_queue_command(
               udids_ptr,
               UDT_COMMAND_UPDATE_ERROR_LOG,
               NULL,
               completion,
               argument);
}


RETCODE_T UDT_PUBLIC
common_set_promiscuous_mode(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    PROMISCUOUS_LEVEL_T       level,
    IN    UPCALL_COMMAND_COMPLETE_T completion,
    IN    PCLIENT_UDT_ARGUMENT_T    argument)
{
    ASYNC_COMMAND_PARAMETERS_T params;

    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "PromiscModeReq");

    

    params.promiscuous_level = level;

    

    return common_queue_command(
               udids_ptr,
               UDT_COMMAND_SET_PROMISCUOUS_MODE,
               &params,
               completion,
               argument);
}



#ifdef OLICOM_HEBE_UDI

RETCODE_T UDT_PUBLIC
common_startrx(
    INOUT P_UDI_DATA_T              udids_ptr)
{
    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "RestartRX");

    

    return common_queue_command(
               udids_ptr,
               UDT_RESTART_RX,
               NULL,                        
               NULL,
               NULL);
}

#endif  



#ifdef UDT_SOURCE_ROUTE_MATCHING

RETCODE_T UDT_PUBLIC
common_set_source_route_matching(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    BOOLEAN_T                 enable_matching,
    IN    UINT_T                    source_ring_number,
    IN    UINT_T                    bridge_number,
    IN    UINT_T                    destination_ring_number,
    IN    BOOLEAN_T                 single_route_matching,
    IN    UPCALL_COMMAND_COMPLETE_T completion,
    IN    PCLIENT_UDT_ARGUMENT_T    argument)
{
    ASYNC_COMMAND_PARAMETERS_T params;

    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "SrcRouteMatchReq");

    

    params.source_route_matching_info.enable_matching = enable_matching;
    params.source_route_matching_info.source_ring_number = source_ring_number;
    params.source_route_matching_info.bridge_number = bridge_number;
    params.source_route_matching_info.destination_ring_number =
                                          destination_ring_number;
    params.source_route_matching_info.single_route_matching =
                                          single_route_matching;

    

    return common_queue_command(
               udids_ptr,
               UDT_COMMAND_SET_SOURCE_ROUTE_MATCHING,
               &params,
               completion,
               argument);
}

#endif 



RETCODE_T UDT_PUBLIC
common_set_group_address(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    UINT_T                    index,
    IN    PCLIENT_MAC_ADDRESS_T     group_address,
    IN    UPCALL_COMMAND_COMPLETE_T completion,
    IN    PCLIENT_UDT_ARGUMENT_T    argument)
{
    ASYNC_COMMAND_PARAMETERS_T params;

    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "GrpAddrReq");

    

    params.group_address_info.index = index;
    params.group_address_info.group_address = * group_address;

    

    return common_queue_command(
               udids_ptr,
               UDT_COMMAND_SET_GROUP_ADDRESS,
               &params,
               completion,
               argument);
}


RETCODE_T UDT_PUBLIC
common_set_functional_address(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    PCLIENT_MAC_ADDRESS_T     functional_address,
    IN    UPCALL_COMMAND_COMPLETE_T completion,
    IN    PCLIENT_UDT_ARGUMENT_T    argument)
{
    ASYNC_COMMAND_PARAMETERS_T params;

    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "FnAddrReq");

    

    params.functional_address = * functional_address;

    

    return common_queue_command(
               udids_ptr,
               UDT_COMMAND_SET_FUNCTIONAL_ADDRESS,
               &params,
               completion,
               argument);
}



RETCODE_T UDT_PUBLIC
common_set_product_instance_id(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    STRING_T                  id,
    IN    UPCALL_COMMAND_COMPLETE_T completion,
    IN    PCLIENT_UDT_ARGUMENT_T    argument)
{
    UINT_T                     count;
    ASYNC_COMMAND_PARAMETERS_T params;

    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "ProdIdReq");

    

    for(count = 0; count < 18; count++)
    {
        params.product_instance_id[count] = id[count];
    }

    

    return common_queue_command(
               udids_ptr,
               UDT_COMMAND_SET_PRODUCT_INSTANCE_ID,
               &params,
               completion,
               argument);
}




RETCODE_T UDT_PUBLIC
common_request_interrupt_from_adapter(
    INOUT P_UDI_DATA_T              udids_ptr)
{
    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "IntHostReq");

    

    return common_queue_command(
               udids_ptr,
               UDT_COMMAND_INTERRUPT_HOST,
               NULL,                        
               NULL,
               NULL);
}




#if defined(STRAIGHTBLUEISA_UDI) ||                                         \
    defined(STRAIGHTBLUEMC_UDI)  ||                                         \
    defined(BLUEPLUS_UDI)

RETCODE_T UDT_PUBLIC
common_transmit_dir_frame(
    INOUT P_UDI_DATA_T              udids_ptr)
{
    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "IntHostReq");

    

    return common_queue_command(
               udids_ptr,
               UDT_COMMAND_TRANSMIT_DIR_FRAME,
               NULL,                        
               NULL,
               NULL);
}

#endif




#ifdef UDT_UDI_SLEEP_COMMAND

RETCODE_T UDT_PUBLIC
common_sleep(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    BOOLEAN_T                 use_auxilliary_power_supply,
    IN    BOOLEAN_T                 use_pme,
    IN    BOOLEAN_T                 wake_up_if_magic_packet,
    IN    BOOLEAN_T                 wake_up_if_template_matches,
    IN    UINT_T                    template_data_length,
    IN    PCLIENT_BYTE_T            template_data,
    IN    BOOLEAN_T                 wake_up_if_cable_present,
    IN    BOOLEAN_T                 wake_up_if_cable_absent,
    IN    UPCALL_COMMAND_COMPLETE_T completion,
    IN    PCLIENT_UDT_ARGUMENT_T    argument)
{
    ASYNC_COMMAND_PARAMETERS_T params;

    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "SleepReq");

    

    params.sleep_info.use_auxilliary_power_supply =
                                                 use_auxilliary_power_supply;

    params.sleep_info.use_pme                     = use_pme;

    params.sleep_info.wake_up_if_magic_packet     = wake_up_if_magic_packet;

    params.sleep_info.wake_up_if_template_matches =
                                                 wake_up_if_template_matches;

    params.sleep_info.template_data_length        = template_data_length;

    params.sleep_info.template_data               = template_data;

    params.sleep_info.wake_up_if_cable_present    = wake_up_if_cable_present;

    params.sleep_info.wake_up_if_cable_absent     = wake_up_if_cable_absent;


    

    return common_queue_command(
               udids_ptr,
               UDT_COMMAND_SLEEP,
               &params,
               completion,
               argument);
}

#endif 



STATIC RETCODE_T
common_queue_command(
    INOUT P_UDI_DATA_T                       udids_ptr,
    IN    ASYNC_COMMAND_TYPE_T               command,
    IN    PCLIENT_ASYNC_COMMAND_PARAMETERS_T parameters,
    IN    UPCALL_COMMAND_COMPLETE_T          completion,
    IN    PCLIENT_UDT_ARGUMENT_T             argument)
{
    RETCODE_T                       rc;
    ASYNC_COMMAND_PACKET_T          queue_element;

    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_MAGENTA,
        "Queue");

    

    queue_element.type = command;

    if (parameters != NULL)
    {
        queue_element.parameters = * parameters;
    }

    queue_element.completion = completion;

    if (argument != NULL)
    {
        queue_element.argument = * argument;
    }


    

    rc = SSI_PROTECT(
             udids_ptr,
             common_fill_command_queue_slot,
             (PCLIENT_VOID_T) (& queue_element),
             NULL);

    if (rc == SUCCESS)
    {
        

        common_dequeue_command_if_possible(udids_ptr);
    }

    return rc;
}



STATIC RETCODE_T UDT_LOCAL_PROTECTED
common_fill_command_queue_slot(
    INOUT P_UDI_DATA_T    udids_ptr,
    IN    PCLIENT_VOID_T  queue_element,
    IN    PCLIENT_VOID_T  arg2)
{
    if (STATS_FROM_UDIDS(udids_ptr).command_queue_in_use <
            MAX_COMMAND_QUEUE_ENTRIES)
    {
        STATS_FROM_UDIDS(udids_ptr).command_queue_in_use++;

        

        STATS_FROM_UDIDS(udids_ptr).command_queue[
            STATS_FROM_UDIDS(udids_ptr).command_queue_free] =
                * ((PCLIENT_ASYNC_COMMAND_PACKET_T) queue_element);

        if (++(STATS_FROM_UDIDS(udids_ptr).command_queue_free) >=
                MAX_COMMAND_QUEUE_ENTRIES)
        {
             STATS_FROM_UDIDS(udids_ptr).command_queue_free = 0;
        }

        return SUCCESS;
    }
    return COMMAND_PENDING;
}


VOID_T UDT_INTER_MODULE
common_command_complete(
    INOUT P_UDI_DATA_T                      udids_ptr,
    OUT   PCLIENT_UPCALL_COMMAND_COMPLETE_T completion_ptr,
    OUT   PCLIENT_UDT_ARGUMENT_T            argument_ptr)
{
    P_ASYNC_COMMAND_PACKET_T        queue_element_ptr;

    

    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_MAGENTA,
        "Remove");

    

    queue_element_ptr =
        & (STATS_FROM_UDIDS(udids_ptr).command_queue[
               STATS_FROM_UDIDS(udids_ptr).command_queue_next]);

    

    * completion_ptr = queue_element_ptr -> completion;

    * argument_ptr = queue_element_ptr -> argument;


    if (++(STATS_FROM_UDIDS(udids_ptr).command_queue_next) >=
            MAX_COMMAND_QUEUE_ENTRIES)
    {
        STATS_FROM_UDIDS(udids_ptr).command_queue_next = 0;
    }

    STATS_FROM_UDIDS(udids_ptr).command_queue_in_use--;

    STATS_FROM_UDIDS(udids_ptr).command_pending = FALSE;
}



VOID_T UDT_INTER_MODULE
common_dequeue_command_if_possible(
    INOUT P_UDI_DATA_T      udids_ptr)
{
    RETCODE_T                       rc;
    P_ASYNC_COMMAND_PACKET_T        queue_element_ptr;
    UPCALL_COMMAND_COMPLETE_T       completion;
    UDT_ARGUMENT_T                  argument;
    ASYNC_COMMAND_TYPE_T            command;

    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_MAGENTA,
        "Dq");

    while(TRUE)
    {
        

        rc = SSI_PROTECT(
                 udids_ptr,
                 common_decide_if_can_dequeue,
                 NULL,
                 NULL);

        if (rc != SUCCESS)
        {
            return;
        }

        

        queue_element_ptr =
            & (STATS_FROM_UDIDS(udids_ptr).command_queue[
                   STATS_FROM_UDIDS(udids_ptr).command_queue_next]);

        command = queue_element_ptr->type;

        

        rc = COMMON_DISPATCH_COMMAND(udids_ptr, queue_element_ptr);


        

#       ifndef UDT_HOUSEKEEPING_NOT_CALLED

        if (command==UDT_COMMAND_OPEN)
        {
            STATS_FROM_UDIDS(udids_ptr).microseconds_while_closed = 0;
            STATS_FROM_UDIDS(udids_ptr).microseconds_while_open = 0;
            STATS_FROM_UDIDS(udids_ptr).first_housekeeping_call_made = FALSE;
        }

#       endif 


        

        if (rc == SUCCESS)
        {
            return;
        }

        if (rc == COMMAND_COMPLETED)
        {
            rc = SUCCESS;
        }

        common_command_complete(udids_ptr, &completion, &argument);

        if (completion != NULL)
        {
            completion(DDS_FROM_UDIDS(udids_ptr), &argument, rc);
        }

    }
}



STATIC RETCODE_T UDT_LOCAL_PROTECTED
common_decide_if_can_dequeue(
    INOUT P_UDI_DATA_T     udids_ptr,
    INOUT PCLIENT_VOID_T   arg1,
    INOUT PCLIENT_VOID_T   arg2)
{
    if (STATS_FROM_UDIDS(udids_ptr).command_pending ||
        STATS_FROM_UDIDS(udids_ptr).command_queue_in_use==0

#       ifndef UDT_HOUSEKEEPING_NOT_CALLED

        ||
        (
            STATS_FROM_UDIDS(udids_ptr).command_queue[
                STATS_FROM_UDIDS(udids_ptr).command_queue_next].type ==
                    UDT_COMMAND_OPEN
            &&
            STATS_FROM_UDIDS(udids_ptr).microseconds_while_closed <
                UDT_REQUIRED_CLOSE_PERIOD
            &&
            UDI_STATE(udids_ptr) <= READY
        )

        ||
        (
            STATS_FROM_UDIDS(udids_ptr).command_queue[
                STATS_FROM_UDIDS(udids_ptr).command_queue_next].type ==
                    UDT_COMMAND_CLOSE
            &&
            STATS_FROM_UDIDS(udids_ptr).microseconds_while_open <
                UDT_REQUIRED_OPEN_PERIOD
            &&
            UDI_STATE(udids_ptr) == OPEN
        )

#       endif 

       )
    {
        return FAILURE;
    }
    else
    {
        STATS_FROM_UDIDS(udids_ptr).command_pending = TRUE;
        return SUCCESS;
    }
}




STATIC BOOLEAN_T UDT_INDIRECT
default_check_adapter_is_present(
    INOUT P_UDI_DATA_T udids_ptr)
{
    return TRUE;
}



#ifdef UDT_ADAPTER_CONFIGURATION

BOOLEAN_T UDT_PUBLIC
common_can_configure(
    IN P_UDI_DATA_T udids_ptr)
{
    UINT_T index;
    BYTE_T status;

    

    if (ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_type ==
            ADAPTER_TYPE_INVALID
        ||
        ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype ==
            ADAPTER_SUBTYPE_INVALID)
    {
        return FALSE;
    }

    

    status = GET_CONFIG_STATUS(
                 CONFIG_FROM_UDIDS(udids_ptr),
                 io_handle[0]);

    if (status != STATUS_SET)
    {
        return FALSE;
    }


    if (ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_type ==
                ADAPTER_TYPE_BLUEPLUS)
    {
        for(index = IO_INDEX_FAST; index <= IO_INDEX_FDT_ADDR; index++)
        {
            status = GET_CONFIG_STATUS(
                         CONFIG_FROM_UDIDS(udids_ptr),
                         io_handle[index]);

            if (status != STATUS_SET)
            {
                return FALSE;
            }
        }
    }

    

    return TRUE;
}

#endif 




RETCODE_T UDT_PUBLIC
common_commit_parameters(
    INOUT P_UDI_DATA_T                       udids_ptr,
          BOOLEAN_T                          ints_on,
          UPCALL_COMMAND_COMPLETE_T          completion,
    IN    PCLIENT_UDT_ARGUMENT_T             argument_ptr)
{
    

    if(UDI_STATE(udids_ptr) != REGISTERED)
    {
        

        RETURN(udids_ptr, WRONG_STATE);
    }


    

    UPCALL_COMMAND_COMPLETE_FUNC(udids_ptr) = completion;
    UPCALL_COMMAND_COMPLETE_ARG(udids_ptr)  = * argument_ptr;


    

    UDI_STATE(udids_ptr) = COMMIT_PENDING;


    

    UDT_MEMSET(
         &ADAPTER_RES_INFO_FROM_UDIDS(udids_ptr),
         0,
         sizeof(ADAPTER_RES_INFO_T));


    

    UDT_MEMSET(
         &STATS_FROM_UDIDS(udids_ptr).command_queue,
         0,
         sizeof(STATS_FROM_UDIDS(udids_ptr).command_queue));


    

    return UDI_INIT_FROM_UDIDS(udids_ptr).udi_commit_parameters(
               udids_ptr,
               ints_on);
}




#ifdef UDT_KILL_PROMISCUOUS_MODE

RETCODE_T UDT_PUBLIC
common_kill_promiscuous_mode(
    INOUT P_UDI_DATA_T              udids_ptr)
{
    WORD_T hf1;

    POKE(
        udids_ptr,
        PO_CHAN_CONTROL,
        PO_LEV_USER,
        PO_BLUE,
        "KillPromiscuous");

    if (ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype ==
            ADAPTER_SUBTYPE_PCI3
        ||
        ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype ==
            ADAPTER_SUBTYPE_PRESTO2000
        ||
        ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype ==
            ADAPTER_SUBTYPE_CARDBUS2
        ||
        ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype ==
            ADAPTER_SUBTYPE_PCI4
        ||
        ADAPTER_INFO_FROM_UDIDS(udids_ptr).adapter_subtype ==
            ADAPTER_SUBTYPE_PCI4_MK2)
    {
        

        hf1 = UDI_HC46_READ_WORD(
                  udids_ptr,
                  SEEPROM_OFF_HF1);

        UDI_HC46_WRITE_WORD(
             udids_ptr,
             SEEPROM_OFF_HF1,
             (WORD_T)(hf1 & (~0x0004)));

        UDI_HC46_WRITE_WORD(
            udids_ptr,
            SEEPROM_OFF_PBIA_LOW,
            0);

        UDI_HC46_WRITE_WORD(
            udids_ptr,
            SEEPROM_OFF_PBIA_HIGH,
            0);

        

        SET_STATIC_VALUE(
            STATIC_FROM_UDIDS(udids_ptr),
            promiscuous_enabled,
            FLAG_FALSE);

        return SUCCESS;
    }

    return CANNOT_DISABLE_PROMISC;
}

#endif 

#endif 


UINT_T UDT_INDIRECT
common_null_read_interrupt_status(
    INOUT P_UDI_DATA_T       udids_ptr)
{
    

    return UDT_INTERRUPT_NOT_OURS;
}


#ifdef UDT_REGENERATE_INTERRUPTS

RETCODE_T UDT_INDIRECT
common_null_regenerate_adapter_interrupt(
    INOUT P_UDI_DATA_T udids_ptr)
{

    return SUCCESS;

}    

#endif 



#ifndef UDT_ONLY_GET_CARD_INFO



#ifndef UDT_HOUSEKEEPING_NOT_CALLED

VOID_T UDT_PUBLIC
common_housekeeping(
    INOUT P_UDI_DATA_T              udids_ptr,
    IN    DWORD_T                   microseconds_since_last_call)
{
    

    if(UDI_STATE(udids_ptr) <= READY)
    {
        if (STATS_FROM_UDIDS(udids_ptr).first_housekeeping_call_made &&
                STATS_FROM_UDIDS(udids_ptr).microseconds_while_closed <
                    UDT_REQUIRED_CLOSE_PERIOD)
        {
            STATS_FROM_UDIDS(udids_ptr).microseconds_while_closed +=
                microseconds_since_last_call;

            

            common_dequeue_command_if_possible(udids_ptr);
        }
    }

    

    if(UDI_STATE(udids_ptr) == OPEN)
    {
        if (STATS_FROM_UDIDS(udids_ptr).first_housekeeping_call_made &&
                STATS_FROM_UDIDS(udids_ptr).microseconds_while_open <
                    UDT_REQUIRED_OPEN_PERIOD)
        {
            STATS_FROM_UDIDS(udids_ptr).microseconds_while_open +=
                microseconds_since_last_call;

            

            common_dequeue_command_if_possible(udids_ptr);
        }
    }

    

    UDI_RES_FROM_UDIDS(udids_ptr).udi_housekeeping(
         udids_ptr,
         microseconds_since_last_call);

    STATS_FROM_UDIDS(udids_ptr).first_housekeeping_call_made = TRUE;
}

#   endif 




#ifdef UDT_TRANSMIT_PRIORITY_SUPPORT

VOID_T UDT_PUBLIC
common_calculate_priority_lookahead(
    IN P_UDI_DATA_T udids_ptr)
{
    DWORD_T decode_flags =
        STATS_FROM_UDIDS(udids_ptr).priority_table.master.decode_flags;

    

    STATS_FROM_UDIDS(udids_ptr).priority_lookahead = 0;

    

    if (decode_flags & DECODE_IP)
    {
        STATS_FROM_UDIDS(udids_ptr).priority_lookahead =
            MAX_VALUE(
                STATS_FROM_UDIDS(udids_ptr).priority_lookahead,
                sizeof(TRN_HEADER_T)      +
                    3                     +
                    sizeof(SNAP_HEADER_T) +
                    sizeof(IP4_HEADER_T)  +
                    4);
    }

    if (decode_flags & DECODE_IPX)
    {
        STATS_FROM_UDIDS(udids_ptr).priority_lookahead =
            MAX_VALUE(
                STATS_FROM_UDIDS(udids_ptr).priority_lookahead,
                sizeof(TRN_HEADER_T)      +
                    3                     +
                    sizeof(SNAP_HEADER_T) +
                    sizeof(IPX_HEADER_T));
    }

    if (decode_flags & DECODE_SNAP)
    {
        STATS_FROM_UDIDS(udids_ptr).priority_lookahead =
            MAX_VALUE(
                STATS_FROM_UDIDS(udids_ptr).priority_lookahead,
                sizeof(TRN_HEADER_T)      +
                    3                     +
                    sizeof(SNAP_HEADER_T));
    }

    if (decode_flags & DECODE_DSAP_SSAP)
    {
        STATS_FROM_UDIDS(udids_ptr).priority_lookahead =
            MAX_VALUE(
                STATS_FROM_UDIDS(udids_ptr).priority_lookahead,
                sizeof(TRN_HEADER_T) + 2);
    }

    if (decode_flags & DECODE_TRN_DADDR)
    {
        STATS_FROM_UDIDS(udids_ptr).priority_lookahead =
            MAX_VALUE(
                STATS_FROM_UDIDS(udids_ptr).priority_lookahead,
                8);
    }

    POKEW_TX(
        PO_GREEN,
        "PRI:New lookahead=",
        STATS_FROM_UDIDS(udids_ptr).priority_lookahead);
}

#endif 



#ifdef UDT_TRANSMIT_PRIORITY_SUPPORT

UINT_T UDT_PUBLIC
common_get_transmit_priority(
    IN P_UDI_DATA_T udids_ptr,
    IN P_BYTE_T     frame,
    IN UINT_T       frame_length)
{
    MASTER_PRIORITY_TABLE_T * priority_table =
        &STATS_FROM_UDIDS(udids_ptr).priority_table.master;

    DWORD_T            decode_flags = priority_table->decode_flags;
    SUBTABLE_ENTRY_T * entry;
    BYTE_T *           ptr = frame;
    BYTE_T *           ptr2;
    UINT_T             i;
    UINT_T             priority;
    UINT_T             data_length;
    BOOLEAN_T          isSnap;

    

    

    if (decode_flags & DECODE_TRN_DADDR)
    {
        

        for (i = 0, entry = priority_table->s.s.trn_daddr_subtable;
             i < priority_table->s.s.trn_daddr_entries;
             i++)
        {
            if (MAC_ADDRESSES_EQUAL(
                    entry[i].r.mac_addr,
                    ((TRN_HEADER_T *) ptr)->destination))
            {
                POKEB_TX(PO_CYAN, "P", entry[i].priority);
                POKEB_TX(PO_CYAN, ":TRN_ADDR=", entry[i].r.mac_addr.byte[0]);
                POKEB_TX(PO_CYAN, "", entry[i].r.mac_addr.byte[1]);
                POKEB_TX(PO_CYAN, "", entry[i].r.mac_addr.byte[2]);
                POKEB_TX(PO_CYAN, "", entry[i].r.mac_addr.byte[3]);
                POKEB_TX(PO_CYAN, "", entry[i].r.mac_addr.byte[4]);
                POKEB_TX(PO_CYAN, "", entry[i].r.mac_addr.byte[5]);

                return entry[i].priority;
            }
        }
    }

    if (((TRN_HEADER_T *) ptr)->source.byte[0] & 0x80)
    {
        ptr += ((TRN_HEADER_T *) ptr)->route.control.length;
    }

    ptr += sizeof(TRN_HEADER_SHORT_T);
    
    

    data_length = frame_length - (ptr - frame);

    if (data_length < MIN_DSAP_SSAP)
    {
        return 0;
    }

    

    if (decode_flags & DECODE_DSAP_SSAP)
    {
        
        
        for (i = 0, entry = priority_table->s.s.dsap_ssap_subtable;
             i < priority_table->s.s.dsap_ssap_entries;
             i++)
        {
            if (entry[i].r.saps == *((WORD_T *) ptr))
            {
                POKEB_TX(PO_CYAN, "P", entry[i].priority);
                POKEW_TX(PO_CYAN, ":DSAP_SSAP=", entry[i].r.saps);

                return entry[i].priority;
            }
        }
    }

    

    if (isSnap = (*((WORD_T *) ptr) == SNAP_DSAP_SSAP) &&
                    (*((BYTE_T *) (ptr + 2)) == SNAP_CONTROL))
    {
        ptr += 3;
    }

    ptr2 = ptr;

    if (isSnap && (decode_flags & (DECODE_IP | DECODE_SNAP)))
    {
        

        if ((decode_flags & DECODE_SNAP) && (data_length >= MIN_SNAP))
        {
            
            
            for (i = 0, entry = priority_table->s.s.snap_subtable;
                 i < priority_table->s.s.snap_entries;
                 i++)
            {
                if (entry[i].r.snap.protocol ==
                        ((SNAP_HEADER_T *) ptr)->protocol &&
                    entry[i].r.snap.global[0] ==
                        ((SNAP_HEADER_T *) ptr)->global[0] &&
                    entry[i].r.snap.global[1] ==
                        ((SNAP_HEADER_T *) ptr)->global[1] &&
                    entry[i].r.snap.global[2] ==
                        ((SNAP_HEADER_T *) ptr)->global[2])
                {
                    POKEB_TX(PO_CYAN, "P", entry[i].priority);
                    POKEB_TX(PO_CYAN, ":SNAP=", entry[i].r.snap.global[0]);
                    POKEB_TX(PO_CYAN, ":SNAP=", entry[i].r.snap.global[1]);
                    POKEB_TX(PO_CYAN, ":SNAP=", entry[i].r.snap.global[2]);
                    POKEW_TX(PO_CYAN, ",", entry[i].r.snap.protocol);

                    return entry[i].priority;
                }
            }
        }

        

        if ((((SNAP_HEADER_T *) ptr)->protocol == BYTE_SWAP(SNAP_PROT_IP))
            &&
            (((*(DWORD_T *) ptr) & 0x00FFFFFF) == 0)
            &&
            (data_length >= MIN_IP)
            &&
            (((IP4_HEADER_T *) (ptr + sizeof(SNAP_HEADER_T)))->
                length_and_version.version == 4))
        {
            
            
            ptr += sizeof(SNAP_HEADER_T);
            
            

            if (decode_flags & DECODE_IP_SERVICE)
            {
                
                
                if ((((IP4_HEADER_T *) ptr)->service_type & 0x0F) != 0)
                {
                    

                    priority = ((IP4_HEADER_T *) ptr)->service_type & 0x07;

                    

                    if (((IP4_HEADER_T *) ptr)->service_type & 0x08)
                    {
                        priority = (priority > 5) ? priority : 5;
                    }

                    POKEB_TX(
                        PO_CYAN,
                        "P",
                        (priority < 7) ? priority : 6);

                    POKE_TX(PO_CYAN, ":IP_SERVICE");

                    return (priority < 7) ? priority : 6;
                }
            }

            

            if (decode_flags & DECODE_IP_DADDR)
            {
                
                
                for (i = 0, entry = priority_table->s.s.ip_daddr_subtable;
                     i < priority_table->s.s.ip_daddr_entries;
                     i++)
                {
                    if (entry[i].r.ip_addr ==
                           ((IP4_HEADER_T *) ptr)->destination)
                    {
                        POKEB_TX(PO_CYAN, "P", entry[i].priority);
                        POKED_TX(PO_CYAN, ":IP_DADDR=", entry[i].r.ip_addr);

                        return entry[i].priority;
                    }
                }
            }

            

            if ((decode_flags & DECODE_UDP_PORT)
                &&
                (((IP4_HEADER_T *) ptr)->protocol == IP_PROT_UDP)
                &&
                (data_length >= MIN_UDP))
            {
                ptr += ((IP4_HEADER_T *) ptr)->
                                length_and_version.header_length
                           * sizeof(DWORD_T);

                
                
                for (i = 0, entry = priority_table->s.s.udp_port_subtable;
                     i < priority_table->s.s.udp_port_entries;
                     i++)
                {
                    if ((BYTE_SWAP(((UDP_HEADER_T *) ptr)->dest_port) >=
                            entry[i].r.range.first &&
                         BYTE_SWAP(((UDP_HEADER_T *) ptr)->dest_port) <=
                            entry[i].r.range.last)
                                    ||
                        (BYTE_SWAP(((UDP_HEADER_T *) ptr)->source_port) >=
                            entry[i].r.range.first &&
                         BYTE_SWAP(((UDP_HEADER_T *) ptr)->source_port) <=
                            entry[i].r.range.last))
                    {
                        POKEB_TX(PO_CYAN, "P", entry[i].priority);
                        POKEW_TX(
                            PO_CYAN,
                            ":UDP_PORT=",
                            BYTE_SWAP(((UDP_HEADER_T *) ptr)->dest_port));

                        return entry[i].priority;
                    }
                }
            }

            

            else if ((decode_flags & DECODE_TCP_PORT) 
                     &&
                     (((IP4_HEADER_T *) ptr)->protocol == IP_PROT_TCP)
                     &&
                     (data_length >= MIN_TCP))
            {
                ptr += ((IP4_HEADER_T *) ptr)->
                               length_and_version.header_length
                           * sizeof(DWORD_T);

                
                
                for (i = 0, entry = priority_table->s.s.tcp_port_subtable;
                     i < priority_table->s.s.tcp_port_entries;
                     i++)
                {
                    if ((BYTE_SWAP(((TCP_HEADER_T *) ptr)->dest_port) >=
                            entry[i].r.range.first &&
                         BYTE_SWAP(((TCP_HEADER_T *) ptr)->dest_port) <=
                            entry[i].r.range.last)
                                     ||
                        (BYTE_SWAP(((TCP_HEADER_T *) ptr)->source_port) >=
                            entry[i].r.range.first &&
                         BYTE_SWAP(((TCP_HEADER_T *) ptr)->source_port) <=
                            entry[i].r.range.last))
                    {
                        POKEB_TX(PO_CYAN, "P", entry[i].priority);
                        POKEW_TX(
                            PO_CYAN,
                            ":TCP_PORT=",
                            BYTE_SWAP(((TCP_HEADER_T *) ptr)->dest_port));

                        return entry[i].priority;
                    }
                }
            }
        }
    }

    

    if (decode_flags & DECODE_IPX)
    {
        

        if (isSnap)
        {
            if ((((SNAP_HEADER_T *) ptr2)->protocol ==
                     BYTE_SWAP(SNAP_PROT_IPX))
                &&
                (((*(DWORD_T *) ptr2) & 0x00FFFFFF) == 0)
                &&
                (data_length >= MIN_IPX_SNAP))
            {
                ptr2 += sizeof(SNAP_HEADER_T);
            }
            else
            {
                

                return 0;
            }
        }
        else
        {
            if ((*((WORD_T *) ptr2)       == IPX_DSAP_SSAP)
                &&
                (*((BYTE_T *) (ptr2 + 2)) == IPX_CONTROL)
                &&
                (data_length >= MIN_IPX))
            {
                ptr2 += 3;
            }
            else
            {
                

                return 0;
            }
        }

        

        if ((((IPX_HEADER_T *) ptr2)->checksum == IPX_CHECKSUM)
            &&
            (((IPX_HEADER_T *) ptr2)->length   ==
                BYTE_SWAP(frame_length - (ptr2 - frame))))
        {
            

            

            if (decode_flags & DECODE_IPX_DADDR)
            {
                
                
                for (i = 0, entry = priority_table->s.s.ipx_daddr_subtable;
                     i < priority_table->s.s.ipx_daddr_entries;
                     i++)
                {
                    if ((entry[i].r.ipx_addr.net ==
                            ((IPX_HEADER_T *) ptr2)->dest_network) &&
                        MAC_ADDRESSES_EQUAL(
                            entry[i].r.ipx_addr.mac_addr,
                            ((IPX_HEADER_T *) ptr2)->dest_node))
                    {
                        POKEB_TX(PO_CYAN, "P", entry[i].priority);
                        POKED_TX(
                            PO_CYAN,
                            ":IPX_DADDR=",
                            entry[i].r.ipx_addr.net);

                        POKED_TX(PO_CYAN,",",
                            entry[i].r.ipx_addr.mac_addr.byte[0]);
                        POKED_TX(PO_CYAN,"",
                            entry[i].r.ipx_addr.mac_addr.byte[1]);
                        POKED_TX(PO_CYAN,"",
                            entry[i].r.ipx_addr.mac_addr.byte[2]);
                        POKED_TX(PO_CYAN,"",
                            entry[i].r.ipx_addr.mac_addr.byte[3]);
                        POKED_TX(PO_CYAN,"",
                            entry[i].r.ipx_addr.mac_addr.byte[4]);
                        POKED_TX(PO_CYAN,"",
                            entry[i].r.ipx_addr.mac_addr.byte[5]);

                        return entry[i].priority;
                    }
                }
            }

            

            if (decode_flags & DECODE_IPX_PORT)
            {
                
                
                for (i = 0, entry = priority_table->s.s.ipx_port_subtable;
                     i < priority_table->s.s.ipx_port_entries;
                     i++)
                {
                    if ((BYTE_SWAP(((IPX_HEADER_T *) ptr2)->dest_socket) >=
                            entry[i].r.range.first &&
                         BYTE_SWAP(((IPX_HEADER_T *) ptr2)->dest_socket) <=
                            entry[i].r.range.last)
                                     ||
                        (BYTE_SWAP(((IPX_HEADER_T *) ptr2)->source_socket) >=
                            entry[i].r.range.first &&
                         BYTE_SWAP(((IPX_HEADER_T *) ptr2)->source_socket) <=
                            entry[i].r.range.last))
                    {
                        POKEB_TX(PO_CYAN, "P", entry[i].priority);
                        POKE_TX(PO_CYAN,":IPX_PORT");

                        return entry[i].priority;
                    }
                }
            }
        }
    }

    

    return 0;
}    

#endif 



#endif 

#endif



