 /*
    tw98.h - definitions for the generic i2c-driver for the
     
     - tw98 Analog to Digital Video Decoder
    
    Copyright (C) 2000 H. S. Magnuski <hankm@mtinet.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __INCLUDED_TW98__
#define __INCLUDED_TW98__

/* fixme: this has to be defined in "i2c.h" !!!! */
/* Updated to work with 2.4.1 kernel release */
#define I2C_DRIVERID_TW98	0xF6

/* returns a short form of the status of the TW98 */
#define	TW98_GET_STATUS		_IOR('d', 1, int)
#define	TW98_STATUS_BAD		0	/* receiving inacceptable input */
#define	TW98_STATUS_GOOD	1	/* receiving acceptable input */

/* returns the whole status-byte of the tw98
   - do what you want with it ;-)*/
#define	TW98_GET_STATUS_BYTE	_IOR('d', 2, u8)

/* set the video norm */
#define	TW98_SET_NORM		_IOW('d', 3, int)
#define TW98_VIDEO_MODE_PAL	0
#define TW98_VIDEO_MODE_NTSC	1
#define TW98_VIDEO_MODE_SECAM	2

#define	TW98_SET_MODE		_IOW('d', 4, int)
#define	TW98_SET_SVIDEO		_IOW('d', 5, int)
#define	TW98_SET_OPFORM		_IOW('d', 6, int)

/* All unused bytes are reserverd. */

#define TW98_ID			0x00
#define TW98_CSTATUS		0x01
#define TW98_INFORM		0x02
#define TW98_OPFORM		0x03
#define TW98_HSLEN		0x04
#define TW98_POLARITY		0x05
#define TW98_ACNTL		0x06
#define TW98_CROP_HI		0x07
#define TW98_VDELAY_LO		0x08
#define TW98_VACTIVE_LO		0x09
#define TW98_HDELAY_LO		0x0A
#define TW98_HACTIVE_LO		0x0B
#define TW98_VSCALE_HI		0x0C
#define TW98_VSCALE_LO		0x0D
#define TW98_HSCALE_HI		0x0E
#define TW98_HSCALE_LO		0x0F
#define TW98_BRIGHTNESS		0x10
#define TW98_CONTRAST		0x11
#define TW98_SHARPNESS		0x12
#define TW98_SAT_U		0x13
#define TW98_SAT_V		0x14
#define TW98_HUE		0x15
#define TW98_CKILL		0x16
#define TW98_CORING		0x17
#define TW98_VBICNTL		0x19
#define TW98_CC_STATUS		0x1A
#define TW98_CC_DATA		0x1B
#define TW98_AGCGAIN		0x1C
#define TW98_GPIO		0x1D
#define TW98_TEST		0x1E
#define TW98_NOISE		0x1F

#endif
