/* 
 * SPCA506 chip based cameras initialization data
 *
 */
#ifndef SPCA506_INIT_H
#define SPCA506_INIT_H

static __u16 spca506_init_data[][3]=
{
  /* line       bmRequest,value,index */
  /* 1819 */ { SPCA50X_REG_GLOBAL,SPCA50X_GMISC3_SAA7113RST,SPCA50X_GLOBAL_MISC3 }, /* Sensor reset */
  /* 1822 */ { SPCA50X_REG_GLOBAL,0x0,SPCA50X_GLOBAL_MISC3 },
  /* 1825 */ { SPCA50X_REG_GLOBAL,0x0,SPCA50X_GLOBAL_MISC1 }, /* Block USB reset */
  /* 1828 */ { SPCA50X_REG_GLOBAL,SPCA50X_GMISC0_IDSEL,SPCA50X_GLOBAL_MISC0 },
  { 0,0,0 }
};

/*
 * Data to initialize the camera in external video mode
 */
static __u16 spca506_open_data_ext[][3]= {
  /* line       bmRequest,value,index */
  /* External video input dataset */
  /* 0808 */ { SPCA50X_REG_GLOBAL,0x4,SPCA50X_GLOBAL_MISC1 },
  /* 0809 */ { SPCA50X_REG_GLOBAL,0x0,SPCA50X_GLOBAL_MISC1 },

  /* 0810 */ { SPCA50X_REG_COMPRESS,0x10 | SPCA50X_CMISC1_TVFIELDPROCESS,SPCA50X_COMPRESS_MISC1 },
#if 0
  /* These registers are reserved on the 506 */
  /* 0811 */ { SPCA50X_REG_COMPRESS,0x0,0x4 },
  /* 0812 */ { SPCA50X_REG_COMPRESS,0xa,0x5 },
  /* 0813 */ { SPCA50X_REG_COMPRESS,0x20,0x6 },
  /* 0814 */ { SPCA50X_REG_COMPRESS,0x20,0x7 },
#endif

  /* 0815 */ { SPCA50X_REG_TV,SPCA50X_TMISC0_SINGLECHANNEL | SPCA50X_TMISC0_INVFIELD,SPCA50X_TV_MISC0 }, /* May not be correct */

#if 0
  /* SPCA506 doesn't have these registers */
  /* 0816 */ { 0x5,0x0,0x10 },
  /* 0817 */ { 0x5,0x0,0x11 },
#endif

  /* 0818 */ { SPCA50X_REG_GLOBAL,0x8,SPCA50X_GLOBAL_MISC3 }, /* Input select ? */
  /* 0819 */ { SPCA50X_REG_GLOBAL,0x28,SPCA50X_GLOBAL_MISC3 }, /* Enable SAA7113 ? */
  /* 0820 */ { SPCA50X_REG_GLOBAL,0x8,SPCA50X_GLOBAL_MISC1 }, /* ? */
  /* 0821 */ { SPCA50X_REG_GLOBAL,0x39,SPCA50X_GLOBAL_MISC0 }, /* ? */

#if 0
  /* SPCA506 doesn't have these registers */
  /* 0822 */ { 0x5,0x1,0xc0 },
  /* 0823 */ { 0x5,0x10,0xcb },
  /* 0824 */ { 0x5,0x80,0xc1 },
  /* 0825 */ { 0x5,0x5,0xc2 },
  /* 0826 */ { 0x5,0x0,0xca },
  /* 0827 */ { 0x5,0x0,0xc1 },
  /* 0828 */ { 0x5,0x1,0xc2 },
  /* 0829 */ { 0x5,0x0,0xca },
  /* 0830 */ { 0x5,0x1,0x10 },
  /* 0831 */ { 0x5,0xf,0x11 },
#endif
  { 0,0,0 }

};

/*
 * Additional data needed to initialze the camera in external mode
 */
static __u16 spca506_open_data2[][3]=
{
  /* line       bmRequest,value,index */
  /* 1384 */ { 0x3,0x68,0x3 },
  /* 1385 */ { 0x3,0x10,0x1 },
  /* 1386 */ { 0x8,0x4a,0x0 },
  /* 1387 */ { SPCA50X_REG_COMPRESS,0x0,SPCA50X_COMPRESS_ENABLE }, /* was 1 COMPRESSION ENABLE !*/
  /* 1388 */ { SPCA50X_REG_COMPRESS,0x12,0x9 }, /* Think these are the compression registers */
  /* 1389 */ { SPCA50X_REG_COMPRESS,0x21,0xa },
  /* 1390 */ { SPCA50X_REG_COMPRESS,0x10,0xb },
  /* 1391 */ { SPCA50X_REG_COMPRESS,0x21,0xc },
  /* 1392 */ { SPCA50X_REG_COMPRESS,0x5,0x0 }, /* This may be the picture type code (5=160x120 as YUV4:2:0) */
  /* 1393 */ { SPCA50X_REG_COMPRESS,0x0,0x1 },
#if 0
  /* SPCA506 doesn't have these registers */
  /* 1394 */ { 0x6,0x3f,0x1 },
  /* 1395 */ { 0x4,0x0,0x4 },
  /* 1396 */ { 0x4,0xa,0x5 },
  /* 1397 */ { 0x4,0x40,0x6 },
  /* 1398 */ { 0x4,0x40,0x7 },
  /* 1399 */ { 0x4,0x2,0x5 },
  /* 1400 */ { 0x4,0x0,0x4 },
#endif
  {0,0,0}
};

#endif /* SPCA506_INIT_H */
//eof
