/* $Id: linux_logo.h,v 1.5 1998/07/30 16:30:58 jj Exp $
 * include/linux/linux_logo.h: This is a linux logo
 *                             to be displayed on boot.
 *
 * Copyright (C) 1996 Larry Ewing (lewing@isc.tamu.edu)
 * Copyright (C) 1996,1998 Jakub Jelinek (jj@sunsite.mff.cuni.cz)
 *
 * You can put anything here, but:
 * LINUX_LOGO_COLORS has to be less than 224
 * image size has to be 80x80
 * values have to start from 0x20
 * (i.e. RGB(linux_logo_red[0],
 *           linux_logo_green[0],
 *           linux_logo_blue[0]) is color 0x20)
 * BW image has to be 80x80 as well, with MS bit
 * on the left
 * Serial_console ascii image can be any size,
 * but should contain %s to display the version
 */

#ifndef __HAVE_ARCH_LINUX_LOGO
#define LINUX_LOGO_COLORS	187
#endif

#ifdef INCLUDE_LINUX_LOGO_DATA

#ifndef __HAVE_ARCH_LINUX_LOGO

unsigned char linux_logo_red[] __initdata = {
  0x00, 0x29, 0x43, 0x6E, 0x81, 0x93, 0xA1, 0x97,
  0xA4, 0xC3, 0xBD, 0xA8, 0x9D, 0x77, 0x1B, 0xAF,
  0xB7, 0xC1, 0xC6, 0xCF, 0xD5, 0xDA, 0xDE, 0xDF,
  0xE9, 0xEB, 0xE7, 0xE3, 0xE0, 0xD8, 0xC8, 0x79,
  0x02, 0xB9, 0xCA, 0xD9, 0xEC, 0xF1, 0xF5, 0xF8,
  0xFB, 0xFD, 0xFE, 0xFA, 0xE5, 0xD7, 0xB4, 0x15,
  0x5C, 0x8A, 0xCC, 0xFF, 0xFC, 0xEF, 0x10, 0xF6,
  0xF4, 0xEC, 0xBA, 0xC4, 0xDB, 0xB2, 0x22, 0xBE,
  0xCA, 0xF3, 0xF2, 0xE2, 0xEE, 0xF9, 0xA9, 0xD3,
  0xE3, 0xF7, 0xFC, 0xF6, 0xFC, 0xF7, 0xF5, 0xFB,
  0xFD, 0xE1, 0xD7, 0xE7, 0xF1, 0xFF, 0xFF, 0xDD,
  0xD7, 0xE9, 0x35, 0xED, 0xFF, 0xFF, 0xC8, 0xF7,
  0xF4, 0xFF, 0xFD, 0xE8, 0xC7, 0xFE, 0xFF, 0xED,
  0xC9, 0xF1, 0xFF, 0xFF, 0xF0, 0xD2, 0xD7, 0xB4,
  0xFF, 0xFF, 0xF3, 0xD6, 0xCC, 0x87, 0xED, 0xFE,
  0xFF, 0xF4, 0xD8, 0xF0, 0xC4, 0x49, 0xF3, 0xFF,
  0xFF, 0x2E, 0xAC, 0xFF, 0xFF, 0xFC, 0xE4, 0xDF,
  0x50, 0x65, 0xF8, 0xFB, 0xFC, 0xFE, 0x2A, 0xBF,
  0xEA, 0xFC, 0xEE, 0xD9, 0xCA, 0xE6, 0x8A, 0x26,
  0xFA, 0x25, 0x5A, 0xF9, 0xDA, 0x7A, 0x1E, 0xF0,
  0xFA, 0x24, 0xE4, 0xD9, 0xFF, 0xE7, 0x1F, 0xF9,
  0x1C, 0x9A, 0xF6, 0xE9, 0x1B, 0xE4, 0xDC, 0x19,
  0x34, 0xC3, 0xCD, 0x1F, 0xBD, 0xB3, 0xAB, 0xCF,
  0xF6, 0x5A, 0x3C, 0xC0, 0xD5, 0x3C, 0xBA, 0xBE,
  0xB2, 0xFD, 0xB1, 0xB9, 0x20, 0x20, 0x21, 0xFE,
  0xCD, 0x22, 0xF2, 0xC5, 0xED, 0xF4, 0x78, 0xC2,
  0xFC, 0xFF,
};

unsigned char linux_logo_green[] __initdata = {
  0x00, 0x25, 0x3D, 0x63, 0x76, 0x86, 0x94, 0x96,
  0xA6, 0xBD, 0xB6, 0x9F, 0x8D, 0x6A, 0x18, 0xB0,
  0xB7, 0xC1, 0xC6, 0xCF, 0xD5, 0xDA, 0xDE, 0xDF,
  0xE9, 0xEB, 0xE8, 0xE4, 0xE0, 0xD6, 0xC1, 0x72,
  0x02, 0xB8, 0xCA, 0xD9, 0xEC, 0xF1, 0xF5, 0xF8,
  0xFB, 0xFD, 0xFE, 0xFA, 0xE5, 0xD1, 0xAB, 0x12,
  0x58, 0x7E, 0xCC, 0xFF, 0xFC, 0xEF, 0x0D, 0xF6,
  0xF4, 0xED, 0xAF, 0xC3, 0xDB, 0xA4, 0x1E, 0xBD,
  0xC7, 0xF3, 0xF2, 0xE2, 0xEE, 0xF9, 0x99, 0xD3,
  0xE3, 0xDE, 0xCD, 0xE3, 0xD7, 0xAE, 0xEF, 0xDB,
  0xC9, 0x9E, 0xCE, 0xE6, 0xD8, 0xD3, 0xBA, 0x9B,
  0xCA, 0xE0, 0x2F, 0xE2, 0xC6, 0xB3, 0xAA, 0xF7,
  0xF1, 0xCF, 0xB1, 0xA3, 0xA0, 0xC2, 0xB5, 0xA6,
  0x99, 0xF3, 0xB7, 0xB3, 0xA9, 0x93, 0xDB, 0xBD,
  0xBD, 0xB4, 0xAA, 0x96, 0xD1, 0x98, 0xDA, 0xD5,
  0xB6, 0xAB, 0x99, 0xF0, 0xC9, 0x62, 0xEA, 0xCB,
  0xB9, 0x4F, 0xB4, 0xBF, 0xB4, 0xB1, 0xA0, 0xE1,
  0x6C, 0x7D, 0xF0, 0xF5, 0xC3, 0xB2, 0x48, 0xC1,
  0xD3, 0xD1, 0xA7, 0xA0, 0xBA, 0xE6, 0x8A, 0x43,
  0xAF, 0x47, 0x6C, 0xAE, 0xAE, 0x8D, 0x3D, 0xA8,
  0xF7, 0x40, 0xA2, 0xC5, 0xFD, 0xE9, 0x40, 0xB9,
  0x3A, 0x9F, 0xAD, 0xDE, 0x37, 0xBA, 0xDD, 0x33,
  0x4C, 0x88, 0x8F, 0x3F, 0x84, 0x7D, 0x83, 0xC3,
  0xB4, 0x72, 0x56, 0xC0, 0xD7, 0x5B, 0xBA, 0xC4,
  0xB9, 0xFA, 0x7E, 0x99, 0x42, 0x43, 0x44, 0xFC,
  0xBE, 0x45, 0xAA, 0x9C, 0xEF, 0xF5, 0x7C, 0x98,
  0xF8, 0xFE,
};

unsigned char linux_logo_blue[] __initdata = {
  0x00, 0x1B, 0x2F, 0x49, 0x5E, 0x6A, 0x78, 0x97,
  0xA9, 0xB0, 0xA7, 0x8C, 0x6D, 0x50, 0x11, 0xB3,
  0xB7, 0xC1, 0xC6, 0xCF, 0xD5, 0xDA, 0xDE, 0xDF,
  0xE9, 0xEB, 0xE8, 0xE5, 0xE0, 0xD2, 0xB3, 0x61,
  0x01, 0xB8, 0xCA, 0xD9, 0xEC, 0xF1, 0xF5, 0xF8,
  0xFB, 0xFD, 0xFE, 0xFA, 0xE5, 0xC6, 0x96, 0x0D,
  0x4E, 0x64, 0xCC, 0xFF, 0xFC, 0xEF, 0x08, 0xF6,
  0xF4, 0xEE, 0x97, 0xC2, 0xDC, 0x87, 0x16, 0xBC,
  0xC2, 0xF3, 0xF2, 0xE2, 0xEE, 0xF9, 0x76, 0xD4,
  0xE3, 0xA7, 0x69, 0xBC, 0x85, 0x10, 0xE3, 0x95,
  0x59, 0x0E, 0xBA, 0xE6, 0xA1, 0x77, 0x28, 0x0E,
  0xAE, 0xCD, 0x23, 0xCC, 0x4D, 0x10, 0x6A, 0xF7,
  0xEC, 0x68, 0x10, 0x10, 0x4C, 0x40, 0x16, 0x0F,
  0x33, 0xF8, 0x1E, 0x11, 0x0F, 0x0D, 0xE5, 0xD3,
  0x2F, 0x12, 0x0F, 0x0E, 0xE0, 0xC4, 0xB1, 0x7D,
  0x19, 0x0F, 0x10, 0xF0, 0xD6, 0xA2, 0xD8, 0x5C,
  0x24, 0xA1, 0xC7, 0x35, 0x14, 0x10, 0x0E, 0xE6,
  0xB0, 0xBA, 0xDC, 0xEA, 0x49, 0x10, 0x94, 0xC5,
  0xA3, 0x75, 0x0F, 0x25, 0x98, 0xE6, 0x8D, 0x8B,
  0x10, 0x9E, 0x97, 0x10, 0x50, 0xBC, 0x8D, 0x0F,
  0xF0, 0x88, 0x17, 0x9A, 0xFA, 0xEF, 0x94, 0x30,
  0x86, 0xAC, 0x0F, 0xC6, 0x7F, 0x61, 0xE0, 0x77,
  0x87, 0x0C, 0x0D, 0x91, 0x0C, 0x0C, 0x31, 0xA8,
  0x27, 0xAD, 0x97, 0xC0, 0xDF, 0xA8, 0xBC, 0xD2,
  0xCC, 0xF3, 0x14, 0x55, 0x97, 0x9A, 0x9C, 0xF9,
  0x9F, 0x9B, 0x0F, 0x44, 0xF4, 0xF8, 0x89, 0x3D,
  0xEF, 0xFD,
};

unsigned char linux_logo[] __initdata = {
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x21,
  0x22, 0x23, 0x24, 0x25, 0x26, 0x27, 0x27, 0x28,
  0x28, 0x28, 0x28, 0x29, 0x2A, 0x2B, 0x2C, 0x2D,
  0x22, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x2E, 0x22, 0x2D, 0x25, 0x27,
  0x2F, 0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36,
  0x36, 0x37, 0x38, 0x39, 0x3A, 0x3B, 0x3C, 0x36,
  0x3D, 0x3E, 0x2B, 0x3F, 0x21, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x40, 0x22, 0x2D, 0x26, 0x28, 0x41, 0x42, 0x43,
  0x3B, 0x44, 0x45, 0x46, 0x47, 0x48, 0x49, 0x4A,
  0x4A, 0x4A, 0x4A, 0x49, 0x48, 0x4B, 0x47, 0x46,
  0x45, 0x39, 0x4C, 0x37, 0x4D, 0x4E, 0x2D, 0x40,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x4F, 0x50,
  0x51, 0x28, 0x41, 0x52, 0x37, 0x44, 0x46, 0x48,
  0x4A, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x4A, 0x54, 0x4B, 0x46, 0x55, 0x3A, 0x3C, 0x3E,
  0x51, 0x2E, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x56, 0x50, 0x25, 0x28,
  0x31, 0x43, 0x39, 0x57, 0x54, 0x4A, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x49, 0x4B, 0x58, 0x59,
  0x36, 0x5A, 0x2D, 0x56, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x22, 0x51, 0x28, 0x5B, 0x5C,
  0x55, 0x4B, 0x4A, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x4A, 0x54,
  0x46, 0x3B, 0x52, 0x5D, 0x23, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x5E, 0x2D, 0x2B, 0x5F, 0x35, 0x55, 0x4B,
  0x4A, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x4A, 0x4B, 0x59, 0x5C, 0x60, 0x2C, 0x21, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x22, 0x25, 0x2F, 0x33, 0x38, 0x47, 0x4A, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x49, 0x57, 0x38, 0x43, 0x5A, 0x23,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x50,
  0x2B, 0x5F, 0x36, 0x61, 0x49, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x4A, 0x48, 0x62, 0x63, 0x3E,
  0x24, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x56, 0x2D, 0x28,
  0x32, 0x3A, 0x47, 0x4A, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x49, 0x57, 0x3A,
  0x3D, 0x2C, 0x56, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x4F, 0x3F, 0x2F, 0x33,
  0x64, 0x48, 0x4A, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x4A, 0x65,
  0x64, 0x37, 0x66, 0x5E, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x2E, 0x24, 0x2F, 0x67, 0x62,
  0x49, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x4A,
  0x48, 0x45, 0x68, 0x5D, 0x5E, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x56, 0x24, 0x2F, 0x34, 0x61, 0x4A,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x4B, 0x69,
  0x6A, 0x4B, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x4A, 0x54, 0x62, 0x4C, 0x5D, 0x56, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x24, 0x30, 0x34, 0x61, 0x4A, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x54, 0x6B, 0x6C,
  0x6D, 0x64, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x4A, 0x54, 0x61, 0x3A, 0x66, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x24, 0x60, 0x37, 0x46, 0x4A, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x4A, 0x6E, 0x6F, 0x70,
  0x71, 0x72, 0x4A, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x4A, 0x54, 0x58, 0x73, 0x25, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x23, 0x60, 0x4C, 0x57, 0x4A, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x47, 0x74, 0x75, 0x76,
  0x77, 0x78, 0x48, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x4A, 0x48, 0x58, 0x79, 0x23,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x7A,
  0x2A, 0x63, 0x58, 0x49, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x49, 0x7B, 0x6C, 0x7C, 0x7D,
  0x71, 0x7E, 0x7F, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x4A, 0x48, 0x58, 0x78,
  0x7A, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x26,
  0x5C, 0x55, 0x54, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x4A, 0x80, 0x6F, 0x81, 0x76, 0x82,
  0x83, 0x84, 0x62, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x4A, 0x65, 0x62,
  0x5D, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x23, 0x33,
  0x38, 0x4B, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x4B, 0x69, 0x75, 0x85, 0x86, 0x7D,
  0x87, 0x88, 0x64, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x49, 0x47,
  0x6E, 0x2D, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x4F, 0x2A, 0x63,
  0x46, 0x4A, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x4A, 0x89, 0x4A, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x49, 0x7B, 0x6C, 0x70, 0x8A, 0x7D, 0x8B,
  0x8C, 0x8D, 0x38, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x4A, 0x49,
  0x47, 0x78, 0x4F, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x51, 0x35, 0x64,
  0x54, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x4A,
  0x8E, 0x8F, 0x54, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x4A, 0x80, 0x6F, 0x81, 0x90, 0x91, 0x7D, 0x7D,
  0x92, 0x93, 0x36, 0x4A, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x4A,
  0x48, 0x65, 0x2C, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x5E, 0x29, 0x4C, 0x47,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x49, 0x94,
  0x95, 0x55, 0x4B, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x48, 0x96, 0x97, 0x85, 0x98, 0x7D, 0x7D, 0x7D,
  0x99, 0x9A, 0x78, 0x49, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x4A, 0x49, 0x96, 0x5E, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x51, 0x5C, 0x9B, 0x49,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x49, 0x9C, 0x9D,
  0x63, 0x62, 0x49, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x49,
  0x9E, 0x6C, 0x9F, 0xA0, 0x8B, 0x7D, 0x7D, 0x7D,
  0x6D, 0x77, 0x7E, 0x47, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x4A, 0x4A, 0x4A, 0x2C, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x40, 0x2A, 0x4C, 0x47, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x49, 0x94, 0xA1, 0xA2,
  0x38, 0x48, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x4A, 0x80,
  0x6F, 0x81, 0xA3, 0xA4, 0x7D, 0x7D, 0x7D, 0x7D,
  0xA5, 0xA6, 0x7E, 0x58, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x4A, 0x53, 0x96, 0x40, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x23, 0x5C, 0x55, 0x49, 0x53,
  0x53, 0x53, 0x53, 0x4A, 0xA7, 0xA8, 0xA9, 0x35,
  0x7F, 0x53, 0x53, 0x48, 0x6B, 0x6F, 0x6F, 0x6F,
  0x69, 0x6B, 0xAA, 0xAB, 0x4A, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x48, 0x6B,
  0x97, 0xAC, 0x98, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0xAD, 0x83, 0x88, 0x9B, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x4A, 0x53, 0x53, 0x2D, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x2B, 0x68, 0x7F, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x7F, 0x95, 0xAE, 0xAF, 0x64,
  0x4A, 0x53, 0x53, 0x57, 0xB0, 0x90, 0xAC, 0x70,
  0x81, 0xB1, 0x75, 0x97, 0x97, 0x6F, 0x69, 0x6B,
  0xAA, 0xAB, 0x4A, 0x53, 0x53, 0x54, 0x7B, 0x6F,
  0x9F, 0xA0, 0x8B, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0xB2, 0xB3, 0x39, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0xB4, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x2E, 0x2A, 0xB5, 0x48, 0x53, 0x53,
  0x53, 0x53, 0x48, 0x8F, 0xA1, 0xB6, 0x3C, 0x48,
  0x53, 0x53, 0x53, 0x47, 0x43, 0x7E, 0xB2, 0xA5,
  0xA0, 0x90, 0xA3, 0x85, 0xAC, 0x7C, 0x9F, 0x81,
  0x75, 0x97, 0x97, 0x6F, 0x69, 0x69, 0x6F, 0x9F,
  0x90, 0xA4, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x8B, 0x92, 0x93, 0xB5, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x9E, 0x21, 0x20, 0x20,
  0x20, 0x20, 0x50, 0x5F, 0x38, 0x49, 0x53, 0x53,
  0x53, 0x4A, 0x3B, 0xA9, 0xB7, 0xAF, 0x62, 0x4A,
  0x53, 0x53, 0x53, 0x49, 0x55, 0x42, 0x84, 0x87,
  0x6D, 0xAD, 0x7D, 0x7D, 0x91, 0x98, 0xA0, 0x90,
  0xA3, 0x85, 0xAC, 0x7C, 0x9F, 0x9F, 0x85, 0x76,
  0xA4, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0xB8, 0xA6, 0x72, 0x4A, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x4A, 0x53, 0x53, 0x51, 0x20, 0x20,
  0x20, 0x20, 0x51, 0x42, 0x45, 0x4A, 0x53, 0x53,
  0x53, 0x65, 0xA2, 0xB9, 0xBA, 0x3C, 0x48, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x49, 0x38, 0x31, 0xB3,
  0x87, 0xBB, 0xAD, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x91, 0x86, 0x98, 0x98, 0xA4, 0x8B,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x6D, 0xBC, 0x47, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x78, 0x20, 0x20,
  0x20, 0x20, 0x2B, 0x34, 0x7F, 0x53, 0x53, 0x53,
  0x4A, 0xA7, 0xBD, 0xBE, 0x2F, 0x55, 0x4A, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x48, 0x68, 0x2A,
  0xB3, 0xBF, 0xB8, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x91, 0x86, 0x8A, 0xB1, 0xC0, 0x4A, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x4B, 0x6C, 0xAA, 0x4A, 0x53, 0x49, 0x6B,
  0x6A, 0x48, 0x53, 0x53, 0x53, 0xAA, 0x20, 0x20,
  0x20, 0x21, 0x41, 0x63, 0x48, 0x53, 0x53, 0x53,
  0x65, 0xA2, 0xA8, 0xC1, 0x43, 0x4B, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x65, 0x36,
  0x5A, 0xC2, 0x92, 0xA5, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x8B, 0xA4, 0xA0, 0x85, 0x9F, 0x6F, 0x6B,
  0xAA, 0x49, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x55, 0x6A, 0x70, 0x47, 0x4A, 0x80, 0x85,
  0xC3, 0x61, 0x53, 0x53, 0x53, 0xC4, 0x22, 0x20,
  0x20, 0x50, 0x5B, 0x44, 0x4A, 0x53, 0x53, 0x4A,
  0xC5, 0xBD, 0xC6, 0xBA, 0xB5, 0x4A, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x4A, 0x46,
  0x34, 0x7E, 0x83, 0x99, 0xA5, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x8B, 0x86, 0xA0, 0xA3, 0x7C, 0x9F,
  0x81, 0x75, 0x6F, 0x6B, 0xAA, 0x4A, 0x53, 0x53,
  0x53, 0x64, 0x72, 0xC7, 0x96, 0x47, 0x74, 0xB3,
  0x67, 0x46, 0x53, 0x53, 0x53, 0x53, 0x2C, 0x20,
  0x20, 0x24, 0x52, 0x62, 0x53, 0x53, 0x53, 0x48,
  0x8F, 0xA9, 0xC8, 0xC9, 0x55, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x4A,
  0x45, 0x52, 0x84, 0x83, 0xCA, 0xAD, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0xA4, 0x8A, 0x76,
  0xA3, 0xAC, 0x70, 0x81, 0x81, 0x97, 0x69, 0x6B,
  0xAB, 0x7F, 0x35, 0xC3, 0x90, 0xCB, 0xC7, 0xB4,
  0x4C, 0x49, 0x53, 0x53, 0x53, 0x53, 0xB4, 0x20,
  0x20, 0x2C, 0x67, 0x46, 0x53, 0x53, 0x53, 0x61,
  0x95, 0xA8, 0xCC, 0xAF, 0x57, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x49, 0x39, 0x5B, 0x88, 0x87, 0xBB, 0xAD, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x8B, 0x86, 0x8A, 0x90, 0x85, 0xAC, 0x9F, 0x81,
  0xB1, 0x6C, 0x74, 0xC3, 0xC7, 0xCD, 0xCD, 0x34,
  0x46, 0x53, 0x53, 0x53, 0x53, 0x53, 0xCB, 0x20,
  0x20, 0x2B, 0x35, 0x47, 0x53, 0x53, 0x4A, 0xCE,
  0xBD, 0xB9, 0xCF, 0x35, 0x48, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x48, 0xB5, 0x29, 0xB3, 0x8C, 0xB8, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x91, 0x86, 0xA0, 0x90,
  0x90, 0x76, 0x8A, 0xA5, 0xBC, 0x32, 0xCD, 0xCA,
  0xBB, 0xAD, 0xCA, 0xCD, 0x47, 0x8F, 0x7B, 0x20,
  0x20, 0x5A, 0x37, 0x4B, 0x53, 0x53, 0x48, 0x8F,
  0xA9, 0xC6, 0xD0, 0x63, 0x4A, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x4B, 0x3C, 0x5A, 0xC2, 0x99, 0xA5,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0xAD, 0x6D, 0x87,
  0x93, 0xD1, 0xD2, 0x84, 0xBC, 0xC3, 0xAC, 0x31,
  0x32, 0x32, 0x42, 0x36, 0x45, 0x46, 0x6E, 0x20,
  0x20, 0x2A, 0x68, 0x54, 0x53, 0x53, 0x46, 0x95,
  0xA9, 0xD3, 0xD0, 0x3A, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x4A, 0x57, 0x34, 0x7E, 0x8C, 0xB8,
  0xAD, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0xAD, 0xB8, 0x87, 0x93, 0xD4,
  0xD5, 0xD6, 0x2B, 0x5A, 0xA6, 0xD7, 0xD8, 0xCD,
  0x37, 0x68, 0x4C, 0x64, 0x47, 0x4B, 0xC0, 0x20,
  0x20, 0x5F, 0x3A, 0x49, 0x53, 0x53, 0x64, 0xBD,
  0xD9, 0xBE, 0xDA, 0x38, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x4A, 0x62, 0x33, 0xBC, 0x91,
  0x8B, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0xAD, 0xB8, 0xBF, 0x77, 0xD1, 0xD5, 0xD6,
  0x2B, 0xDB, 0x33, 0xC7, 0x84, 0x42, 0xB4, 0xAD,
  0x9E, 0x4A, 0x53, 0x53, 0x53, 0x53, 0xC4, 0x20,
  0x20, 0x31, 0x38, 0x4A, 0x53, 0x53, 0x3A, 0xA9,
  0xA8, 0xBE, 0xDA, 0x38, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x49, 0x38, 0xB4, 0xA3,
  0x8A, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0xAD,
  0xB8, 0xBF, 0x77, 0xD1, 0xD5, 0xD6, 0x2B, 0xDB,
  0x43, 0x39, 0x96, 0x87, 0x3E, 0x63, 0x33, 0xBC,
  0xBC, 0x47, 0x53, 0x53, 0x53, 0x53, 0x4A, 0x20,
  0x20, 0x5B, 0x44, 0x53, 0x53, 0x4A, 0xDC, 0xA9,
  0xDD, 0xBE, 0xDA, 0x38, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x58, 0xC3, 0x70,
  0x76, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0xAD, 0xB8, 0xBF,
  0x77, 0xD1, 0xD5, 0xD6, 0x66, 0xDE, 0x34, 0x44,
  0x65, 0x7F, 0xCD, 0x7E, 0x5C, 0x7F, 0x38, 0x3E,
  0xB3, 0x64, 0x53, 0x53, 0x53, 0x53, 0x4A, 0x20,
  0x20, 0x5B, 0x44, 0x53, 0x53, 0x48, 0xDF, 0xD9,
  0xDD, 0xD3, 0xDA, 0x38, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x62, 0x6C, 0x9F,
  0xA0, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0xA5, 0x8C, 0x77, 0xD1,
  0xD5, 0xD6, 0x66, 0x41, 0x67, 0x38, 0x7F, 0x4A,
  0x53, 0x57, 0x37, 0x43, 0x55, 0x4A, 0x65, 0x3C,
  0x34, 0x64, 0x53, 0x53, 0x53, 0x53, 0xC4, 0x20,
  0x20, 0x3E, 0x44, 0x4A, 0x53, 0x65, 0xE0, 0xA8,
  0xDD, 0xD3, 0xCC, 0x3A, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x49, 0x7B, 0x75, 0x7C,
  0x98, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x82, 0xB2, 0xD2, 0xD5, 0xD6,
  0x66, 0x41, 0x67, 0x3A, 0x7F, 0x49, 0x53, 0x53,
  0x53, 0x48, 0x58, 0x58, 0x48, 0x53, 0x4A, 0x7F,
  0x62, 0x65, 0x53, 0x53, 0x53, 0x53, 0xE1, 0x20,
  0x20, 0x2A, 0x38, 0x4A, 0x53, 0x47, 0xE0, 0xA8,
  0xDD, 0xC6, 0xCC, 0x4C, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x7F, 0x6F, 0x81, 0x90,
  0x91, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x6D, 0x93, 0xE2, 0x66, 0x41,
  0x67, 0x3A, 0x7F, 0x49, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0xAB, 0x20,
  0x20, 0x5A, 0xB5, 0x54, 0x53, 0x47, 0xE0, 0xA8,
  0xDD, 0xC6, 0xCC, 0xDC, 0x4A, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x49, 0x7B, 0x97, 0x7C, 0x98,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0xBF, 0xD1, 0xE3, 0x52, 0x3A,
  0x7F, 0x49, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x9E, 0x20,
  0x20, 0x66, 0x63, 0x4B, 0x53, 0x47, 0xE0, 0xA8,
  0xDD, 0xE4, 0xC8, 0xA2, 0x49, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x7F, 0x74, 0x81, 0x90, 0x91,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x87, 0xD1, 0x5F, 0x64, 0x49,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x72, 0x20,
  0x20, 0x25, 0x36, 0x47, 0x53, 0x47, 0xE0, 0xA8,
  0xDD, 0xE5, 0xBE, 0xBD, 0x47, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x49, 0xCB, 0x97, 0x7C, 0x98, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0xB2, 0xD2, 0x35, 0x48, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x5D, 0x20,
  0x20, 0x23, 0x5C, 0x7F, 0x53, 0x65, 0x9C, 0x9D,
  0xDD, 0xE6, 0xD3, 0xBA, 0x61, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x58, 0x6C, 0x81, 0x90, 0x91, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0xBF, 0xD2, 0x63, 0x4A, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x24, 0x20,
  0x20, 0x7A, 0x3D, 0x46, 0x53, 0x48, 0x5C, 0xDD,
  0xA1, 0xE6, 0xC6, 0xB7, 0x44, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x49, 0xCB, 0x75, 0xAC, 0x86, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0xAD, 0xB8, 0x99, 0xB2, 0x87,
  0x8C, 0xBB, 0xAD, 0x7D, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x8C, 0x8D, 0x72, 0x4A, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0xE7, 0x22, 0x20,
  0x20, 0x20, 0xE8, 0x55, 0x4A, 0x4A, 0x63, 0x9D,
  0xA1, 0xE9, 0xE5, 0xBE, 0xDF, 0x4A, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x58, 0x6C, 0x81, 0x76, 0x8B, 0x7D, 0x7D,
  0x7D, 0xA5, 0xCA, 0x87, 0x77, 0xD2, 0xD4, 0xD1,
  0xD2, 0xA6, 0x99, 0xA5, 0x7D, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0xEA, 0x8D, 0x78, 0x48, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x7B, 0x20, 0x20,
  0x20, 0x20, 0x66, 0x3A, 0x54, 0x53, 0x38, 0xA9,
  0xA1, 0xB9, 0xE6, 0xC6, 0xD9, 0x47, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x49, 0xCB, 0x75, 0xAC, 0x86, 0x7D, 0xAD, 0xBB,
  0xBF, 0x71, 0xD2, 0xD4, 0xD5, 0xD6, 0x2C, 0x66,
  0x66, 0x88, 0xA6, 0x92, 0xA5, 0x7D, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0xEA, 0x8D, 0xD7, 0x47, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0xE8, 0x20, 0x20,
  0x20, 0x20, 0x23, 0x68, 0x4B, 0x53, 0x55, 0xC9,
  0xA1, 0xB9, 0xE9, 0xE5, 0xD3, 0xDC, 0x4A, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x58, 0x6C, 0x81, 0x76, 0xA5, 0x99, 0x83, 0x93,
  0xD1, 0xD5, 0xE2, 0xE3, 0x2B, 0x41, 0x42, 0x33,
  0xBD, 0x28, 0xEB, 0xA6, 0x92, 0xA5, 0x7D, 0x7D,
  0x7D, 0x7D, 0x7D, 0x92, 0x93, 0xD7, 0x47, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x51, 0x20, 0x20,
  0x20, 0x20, 0x5E, 0x72, 0x58, 0x53, 0x7F, 0x67,
  0xA1, 0xE9, 0xE6, 0xE9, 0xE4, 0xD9, 0x65, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x49,
  0xCB, 0x75, 0xA3, 0x8C, 0x71, 0xD2, 0xD5, 0xD5,
  0xD6, 0x66, 0x2F, 0x32, 0x35, 0x3A, 0x94, 0xD9,
  0xDA, 0xA2, 0x5F, 0xEB, 0xA6, 0x92, 0xA5, 0x7D,
  0x7D, 0x7D, 0x7D, 0x99, 0x9A, 0xB4, 0x7F, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x6E, 0x21, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x5D, 0x59, 0x4A, 0x49, 0x63,
  0xD9, 0xE6, 0xE6, 0xE9, 0xE9, 0xE4, 0xA2, 0x49,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x58,
  0xB1, 0xA3, 0x77, 0xD4, 0xD5, 0xE2, 0x2C, 0x28,
  0x5F, 0x33, 0x68, 0x9B, 0xC5, 0x95, 0xB9, 0xBA,
  0xAF, 0x4C, 0x68, 0x31, 0xEB, 0xA6, 0x92, 0xA5,
  0x7D, 0x7D, 0x7D, 0x6D, 0x77, 0x7E, 0x46, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0xD7, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x23, 0x3A, 0x48, 0x53, 0x9B,
  0xA2, 0xE4, 0xE5, 0xE6, 0xB9, 0xB9, 0xA1, 0x94,
  0x4A, 0x53, 0x53, 0x53, 0x53, 0x53, 0x49, 0x74,
  0xA5, 0xD2, 0xE2, 0xD6, 0x2B, 0x2F, 0x32, 0x36,
  0x44, 0x46, 0xEC, 0x8F, 0x9D, 0xB7, 0x27, 0x32,
  0x3C, 0x46, 0x4B, 0xB5, 0x31, 0xEB, 0xA6, 0x92,
  0xA5, 0x7D, 0x7D, 0x6D, 0x77, 0x7E, 0x62, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x24, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x40, 0xD7, 0x46, 0x53, 0x4B,
  0x35, 0xBA, 0xE4, 0xE5, 0xE6, 0xB9, 0xA1, 0xDD,
  0xA2, 0x54, 0x53, 0x53, 0x53, 0x53, 0x7F, 0xC3,
  0xEB, 0x2C, 0x28, 0xDB, 0x34, 0xB5, 0x62, 0x4B,
  0xEC, 0x8F, 0xD9, 0xD3, 0xBA, 0x2F, 0x33, 0x38,
  0x4B, 0x4A, 0x53, 0x48, 0xB5, 0x31, 0xEB, 0xA6,
  0x92, 0xA5, 0x7D, 0x6D, 0x77, 0x7E, 0x45, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0xCB, 0x40, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x51, 0x64, 0x4A, 0x4A,
  0x64, 0xDE, 0xAE, 0xC6, 0xE5, 0xE9, 0xA1, 0xDD,
  0xA8, 0xBD, 0x8E, 0x49, 0x53, 0x53, 0x47, 0x3C,
  0x42, 0x33, 0x37, 0x64, 0x47, 0xED, 0x8E, 0xE0,
  0xA9, 0xC6, 0xD0, 0x27, 0x5B, 0x36, 0x58, 0x49,
  0x53, 0x53, 0x53, 0x53, 0x48, 0xB5, 0x31, 0xEB,
  0xA6, 0x92, 0xA5, 0xBB, 0x71, 0x7E, 0x45, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x26, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x2E, 0x78, 0x65, 0x53,
  0x48, 0x37, 0xC9, 0xBE, 0xC6, 0xE5, 0xE6, 0xB9,
  0xDD, 0xA8, 0xA9, 0x95, 0x8F, 0x8E, 0xA7, 0x59,
  0xA7, 0x8E, 0xDC, 0x9C, 0xE0, 0x95, 0xA8, 0xD3,
  0xC1, 0xEE, 0x41, 0x67, 0x39, 0x4B, 0x4A, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x48, 0xB5, 0x31,
  0xEB, 0xA6, 0x92, 0x6D, 0xA6, 0x84, 0x9B, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x7B, 0x5E, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x25, 0x61, 0x53,
  0x4A, 0x58, 0x67, 0xEE, 0xC8, 0xD3, 0xE4, 0xE6,
  0xB9, 0xA1, 0xDD, 0xA8, 0xA9, 0xBD, 0x95, 0x95,
  0x95, 0x95, 0xBD, 0xA8, 0xE4, 0xCC, 0xCF, 0xBA,
  0x2F, 0x52, 0x4C, 0x57, 0x49, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x48, 0xB5,
  0x31, 0xEB, 0xA6, 0xBF, 0xA6, 0x88, 0x44, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x26, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x4F, 0xD7, 0x48,
  0x53, 0x49, 0x55, 0x52, 0xEE, 0xCC, 0xC8, 0xBE,
  0xC6, 0xE4, 0xE4, 0xE5, 0xB9, 0xA1, 0xA1, 0xB9,
  0xE4, 0xBE, 0xCC, 0xCF, 0xD0, 0xEE, 0x2F, 0x32,
  0x3C, 0x61, 0x49, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x48,
  0xB5, 0x31, 0xEB, 0x71, 0x9A, 0xEF, 0x39, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0xCB, 0x4F, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x2D, 0x6E,
  0x53, 0x53, 0x49, 0x64, 0x52, 0x27, 0xD0, 0xCF,
  0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCC, 0xCF, 0xCF,
  0xCF, 0xCF, 0xBA, 0xB6, 0x30, 0x52, 0x63, 0x45,
  0x48, 0x4A, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x48, 0xB5, 0x31, 0xEB, 0xD2, 0xEF, 0x38, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0xE1, 0x24, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x5A,
  0x4A, 0x53, 0x53, 0x49, 0x9B, 0x34, 0xDE, 0x27,
  0xBA, 0xD0, 0xD0, 0xD0, 0xD0, 0xD0, 0xD0, 0xBA,
  0xB6, 0x2F, 0x5B, 0x34, 0x3A, 0x58, 0x49, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x48, 0xB5, 0x31, 0xE3, 0xE3, 0x39, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x2A, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x22,
  0x7B, 0x53, 0x53, 0x53, 0x4A, 0x7F, 0x38, 0x43,
  0x32, 0xDE, 0x41, 0x41, 0x41, 0x41, 0xDB, 0x42,
  0x43, 0x4C, 0x9B, 0x65, 0x4A, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x48, 0x3A, 0x33, 0x34, 0x62, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x79,
  0x7A, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x51, 0xAB, 0x53, 0x53, 0x53, 0x53, 0x4A, 0x65,
  0x62, 0x44, 0x38, 0x38, 0x38, 0x39, 0x64, 0x58,
  0x65, 0x4A, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x48, 0x58, 0x58, 0x48, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0xAB, 0x3F,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x5D, 0xC4, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0xC4, 0x2B, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0xD7, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x2A, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x2E, 0x78, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0xD7, 0x4F, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x21, 0x72, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x78, 0x21, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x21, 0x72, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x3E, 0x21, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x2E, 0xD7, 0xC4,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0xC4, 0x2A, 0x4F, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x5A,
  0xF0, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0xE1,
  0x2B, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x25, 0x9E, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x6E, 0x25,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x22, 0xB4, 0xF0, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0xE7, 0x72, 0x22, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x24, 0x96, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x9E, 0x26, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x4F, 0x26, 0x7B, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x6E, 0x4E, 0x2E, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x5E, 0x26,
  0xCB, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x6E,
  0x4E, 0x21, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x40, 0x24, 0xD7, 0x6E, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0xC0, 0x4D, 0x25, 0x40,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x21, 0x51, 0xE8, 0x9E, 0xC4,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53, 0x53,
  0xC4, 0x6E, 0x4D, 0x26, 0x7A, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x22,
  0x51, 0x4E, 0x78, 0x79, 0x6E, 0xF0, 0xE7, 0xF1,
  0xF1, 0xE7, 0xF0, 0x6E, 0x79, 0x72, 0x4E, 0x51,
  0x22, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
  0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20,
};
#endif /* !__HAVE_ARCH_LINUX_LOGO */

#ifndef __HAVE_ARCH_LINUX_LOGOBW

unsigned char linux_logo_bw[] __initdata = {
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xf0, 0x0f, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xcf, 0xf3, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xbf, 0xfc, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x7f, 0xff, 0x7f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfe, 0xff, 0xff, 0xbf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfd, 0xff, 0xf3, 0xdf, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfd, 0xff, 0xf7, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfd, 0xff, 0xff, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0xff, 0xff, 0xef, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0xff, 0xff, 0xf7, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0xff, 0xff, 0xf7, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0xff, 0xff, 0xf7, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0x9f, 0x87, 0xfb, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0x0f, 0x03, 0xfb, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0x67, 0x33, 0xfb, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0xe7, 0x79, 0xfb, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0xf7, 0x79, 0xfb, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0xff, 0xf9, 0xf7, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0x60, 0x3b, 0xf7, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0x89, 0x07, 0xfb, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0x00, 0x03, 0xfb, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0x00, 0x0d, 0xfb, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0x80, 0x33, 0xfd, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0xc0, 0xc3, 0xfd, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0xff, 0x0d, 0xdd, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xfb, 0x40, 0x31, 0xee, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf7, 0x20, 0xc1, 0xee, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf7, 0x1f, 0x00, 0xff, 0x7f, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xef, 0x00, 0x00, 0x7f, 0xbf, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xee, 0x00, 0x00, 0x7f, 0xbf, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xde, 0x00, 0x00, 0x7f, 0xdf, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xbc, 0x00, 0x00, 0x3f, 0xef, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x7c, 0x00, 0x00, 0x3f, 0xf7, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x7c, 0x00, 0x00, 0x1f, 0xf7, 0xff, 0xff,
    0xff, 0xff, 0xfe, 0xff, 0x1c, 0x07, 0xdf, 0xfb, 0xff, 0xff,
    0xff, 0xff, 0xfd, 0xfc, 0x08, 0x0f, 0xef, 0xfd, 0xff, 0xff,
    0xff, 0xff, 0xfd, 0xf8, 0x00, 0x01, 0xef, 0xfd, 0xff, 0xff,
    0xff, 0xff, 0xfb, 0xf0, 0x00, 0x00, 0x7f, 0xfe, 0xff, 0xff,
    0xff, 0xff, 0xfb, 0xe0, 0x00, 0x00, 0x1f, 0xfe, 0xff, 0xff,
    0xff, 0xff, 0xf7, 0xe0, 0x00, 0x00, 0x07, 0xbf, 0x7f, 0xff,
    0xff, 0xff, 0xf7, 0xc0, 0x00, 0x00, 0x03, 0xbf, 0x7f, 0xff,
    0xff, 0xff, 0xef, 0xc0, 0x00, 0x00, 0x03, 0xdf, 0xbf, 0xff,
    0xff, 0xff, 0xef, 0x80, 0x00, 0x00, 0x03, 0xdf, 0xbf, 0xff,
    0xff, 0xff, 0xdf, 0x80, 0x00, 0x00, 0x03, 0xdf, 0xbf, 0xff,
    0xff, 0xff, 0xdf, 0x80, 0x00, 0x00, 0x01, 0xef, 0xdf, 0xff,
    0xff, 0xff, 0xdf, 0x80, 0x00, 0x00, 0x01, 0xef, 0xdf, 0xff,
    0xff, 0xff, 0xbf, 0x00, 0x20, 0x00, 0x01, 0xef, 0xdf, 0xff,
    0xff, 0xff, 0xbf, 0x00, 0x20, 0x00, 0x01, 0xef, 0xdf, 0xff,
    0xff, 0xff, 0xbf, 0x00, 0x20, 0x00, 0x01, 0xef, 0xdf, 0xff,
    0xff, 0xff, 0xbf, 0x00, 0x20, 0x00, 0x01, 0xef, 0xdf, 0xff,
    0xff, 0xff, 0xbf, 0x00, 0x20, 0x00, 0x03, 0x03, 0xdf, 0xff,
    0xff, 0xff, 0xbf, 0x00, 0x20, 0x00, 0x02, 0xfd, 0xdf, 0xff,
    0xff, 0xff, 0xa3, 0x80, 0x00, 0x00, 0x1f, 0xff, 0xdf, 0xff,
    0xff, 0xff, 0xc1, 0xc0, 0x00, 0x00, 0x11, 0xff, 0x3f, 0xff,
    0xff, 0xff, 0x80, 0xe0, 0x00, 0x00, 0x21, 0xfe, 0x3f, 0xff,
    0xff, 0xff, 0x00, 0x70, 0x00, 0x00, 0x21, 0xfc, 0x3f, 0xff,
    0xff, 0xfe, 0x00, 0x3c, 0x00, 0x00, 0x20, 0xf8, 0x3f, 0xff,
    0xff, 0xf0, 0x00, 0x3e, 0x00, 0x00, 0x20, 0x00, 0x3f, 0xff,
    0xff, 0xc0, 0x00, 0x1f, 0x00, 0x00, 0x20, 0x00, 0x3f, 0xff,
    0xff, 0xc0, 0x00, 0x1f, 0x80, 0x00, 0x20, 0x00, 0x1f, 0xff,
    0xff, 0xc0, 0x00, 0x0f, 0x80, 0x00, 0x20, 0x00, 0x07, 0xff,
    0xff, 0xc0, 0x00, 0x07, 0x80, 0x00, 0x20, 0x00, 0x03, 0xff,
    0xff, 0xc0, 0x00, 0x07, 0x80, 0x00, 0x60, 0x00, 0x01, 0xff,
    0xff, 0xc0, 0x00, 0x02, 0x00, 0x00, 0xe0, 0x00, 0x01, 0xff,
    0xff, 0xc0, 0x00, 0x01, 0x00, 0x01, 0xe0, 0x00, 0x01, 0xff,
    0xff, 0xc0, 0x00, 0x00, 0x80, 0x07, 0xe0, 0x00, 0x03, 0xff,
    0xff, 0xc0, 0x00, 0x00, 0x80, 0x3f, 0xe0, 0x00, 0x0f, 0xff,
    0xff, 0xc0, 0x00, 0x00, 0x7f, 0xff, 0xc0, 0x00, 0x1f, 0xff,
    0xff, 0xc0, 0x00, 0x00, 0x7f, 0xff, 0xc0, 0x00, 0x7f, 0xff,
    0xff, 0xe0, 0x00, 0x00, 0x7f, 0xff, 0xc0, 0x00, 0xff, 0xff,
    0xff, 0xfc, 0x00, 0x00, 0x7f, 0xff, 0xc0, 0x03, 0xff, 0xff,
    0xff, 0xff, 0xc0, 0x00, 0x70, 0x00, 0xc0, 0x07, 0xff, 0xff,
    0xff, 0xff, 0xfc, 0x00, 0x8f, 0xff, 0x20, 0x0f, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x01, 0xff, 0xff, 0xe0, 0x1f, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
};

#endif /* !__HAVE_ARCH_LINUX_LOGOBW */

#ifndef __HAVE_ARCH_LINUX_LOGO16

unsigned char linux_logo16[] __initdata = {
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x88, 0x88, 0x88, 0x80, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x88, 0x80, 0x00, 0x00, 0x08, 0x88, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x88,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08,
    0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x88, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x87, 0x00,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x77, 0x80,
    0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x08, 0x70, 0x00, 0x00, 0x00, 0x77, 0x70, 0x00,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x87, 0x77, 0x00, 0x00, 0x07, 0xff, 0xf7, 0x00,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x08,
    0x77, 0xff, 0x00, 0x00, 0x7f, 0x77, 0xf7, 0x00,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x08,
    0x70, 0x0f, 0x80, 0x00, 0xf7, 0x08, 0x7f, 0x70,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x08,
    0x80, 0x07, 0x80, 0x00, 0xf8, 0x00, 0x8f, 0x70,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x08,
    0x70, 0x07, 0x88, 0x88, 0xf8, 0x00, 0x8f, 0x70,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0xf0, 0x06, 0xe6, 0xe6, 0xe6, 0x00, 0x8f, 0x00,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x77, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x77, 0x00,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x06, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0x00,
    0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x60,
    0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x80,
    0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0x60,
    0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x80,
    0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x66, 0x66, 0x80,
    0x08, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x80,
    0x86, 0xe6, 0xe6, 0xe6, 0x66, 0x66, 0x66, 0x80,
    0x08, 0x78, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x80,
    0x86, 0x66, 0x66, 0x66, 0x66, 0x66, 0x77, 0x70,
    0x00, 0x77, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x87, 0x66, 0x66, 0x66, 0x66, 0x77, 0x77, 0x78,
    0x00, 0x88, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x87, 0x76, 0x66, 0x66, 0x77, 0x77, 0xff, 0xf7,
    0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x08,
    0xff, 0x77, 0x77, 0x77, 0x77, 0xff, 0xff, 0xff,
    0x80, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x07,
    0xff, 0x77, 0x77, 0x77, 0x7f, 0xff, 0xff, 0xff,
    0x70, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x8f,
    0xff, 0xf7, 0x77, 0x77, 0xff, 0xff, 0xff, 0xff,
    0xf0, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x08, 0x7f,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf8, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x08, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf7, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x08, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x80, 0x00, 0x87, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x80, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x87, 0x77,
    0xff, 0xf7, 0x77, 0xff, 0xff, 0xff, 0x77, 0x77,
    0x77, 0x78, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x77, 0x7f,
    0xff, 0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0x77,
    0x77, 0x78, 0x00, 0x80, 0x00, 0x00, 0x00, 0x80,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x7f, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf7, 0x77, 0x00, 0x08, 0x80, 0x00, 0x00, 0x80,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x80, 0x80, 0x08, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x77, 0x80, 0x00, 0x08, 0x00, 0x00, 0x08,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x08, 0x00, 0x80, 0x07, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0x78, 0x00, 0x08, 0x80, 0x00, 0x08,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x08, 0x08, 0x00, 0x8f, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf7, 0x08, 0x80, 0x80, 0x00, 0x08,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x08, 0x08, 0x08, 0x7f, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xf7, 0x08, 0x80, 0x80, 0x00, 0x00,
    0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x80, 0x08, 0x07, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x80, 0x00, 0x08, 0x00, 0x00,
    0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x80, 0x80, 0x0f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x70, 0x00, 0x08, 0x00, 0x00,
    0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x08, 0x00, 0x80, 0x8f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x70, 0x00, 0x08, 0x00, 0x00,
    0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x08, 0x08, 0x00, 0x7f, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0x70, 0x00, 0x08, 0x00, 0x00,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x80, 0x08, 0x00, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf0, 0x00, 0x08, 0x00, 0x00,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x08, 0x00, 0x08, 0x00, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf0, 0x00, 0x08, 0x00, 0x00,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x08, 0x00, 0x08, 0x08, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf0, 0x00, 0x08, 0x00, 0x00,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x08, 0x00, 0x08, 0x08, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf0, 0x00, 0x08, 0x00, 0x00,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x08, 0x00, 0x00, 0x88, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf0, 0x00, 0x08, 0x00, 0x00,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x08, 0x00, 0x00, 0x08, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf0, 0x88, 0x88, 0x80, 0x00,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x08, 0x06, 0xe6, 0x00, 0x8f, 0xff, 0xff, 0xff,
    0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xf8, 0x00, 0x00, 0x08, 0x80,
    0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x6e, 0x6e, 0x60, 0x08, 0xff, 0xff, 0xff,
    0xff, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xe6, 0xe0, 0x00, 0x00, 0x00, 0x88,
    0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x06, 0xe6, 0xe6, 0xe6, 0x00, 0x8f, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xfe, 0x6e, 0x60, 0x00, 0x00, 0x00, 0x00,
    0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x6e, 0x6e, 0x6e, 0x6e, 0x60, 0x08, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xf6, 0xe6, 0xe0, 0x00, 0x00, 0x00, 0x06,
    0xe6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0xe6, 0xe6,
    0xe6, 0xe6, 0xe6, 0xe6, 0xe0, 0x00, 0x8f, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xfe, 0x6e, 0x60, 0x00, 0x00, 0x00, 0x0e,
    0x6e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x6e, 0x6e, 0x6e,
    0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x00, 0x08, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0x76, 0xe6, 0xe6, 0x00, 0x00, 0x00, 0xe6,
    0xe6, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xe6, 0xe6, 0xe6,
    0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe0, 0x00, 0x8f,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf7, 0x7e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e,
    0x6e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x6e, 0x6e, 0x6e,
    0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x60, 0x00, 0x08,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf7, 0x76, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6,
    0xe6, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xe6, 0xe6, 0xe6,
    0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0x00, 0x00,
    0x0f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf7, 0x7e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e,
    0x6e, 0x6e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x6e, 0x6e, 0x6e,
    0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x60, 0x00,
    0x0f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf7, 0x76, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6,
    0xe6, 0xe6, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xe6, 0xe6, 0xe6,
    0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe0, 0x00,
    0x8f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xf7, 0x8e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e,
    0x6e, 0x6e, 0x6e, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x6e, 0x6e, 0x6e,
    0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x88,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x78, 0x86, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6,
    0xe6, 0xe6, 0xe6, 0xe6, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xe6, 0xe6, 0xe6,
    0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xef,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf7,
    0x80, 0x06, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e,
    0x6e, 0x6e, 0x6e, 0x6e, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x6e, 0x6e, 0x6e,
    0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x78,
    0x00, 0x06, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6,
    0xe6, 0xe6, 0xe6, 0xe0, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xe6, 0xe6, 0xe6,
    0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6,
    0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0x78, 0x80,
    0x00, 0x06, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e,
    0x6e, 0x6e, 0x6e, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x0e, 0x6e, 0x6e, 0x6e,
    0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x66,
    0x67, 0xff, 0xff, 0xff, 0xff, 0x78, 0x80, 0x00,
    0x00, 0x86, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6,
    0xe6, 0xe6, 0xe0, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x06, 0xe6, 0xe6, 0xe6,
    0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6,
    0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x86, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e,
    0x66, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x0e, 0x6e, 0x6e, 0x6e,
    0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x66,
    0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x86, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6,
    0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0xe6, 0xe6, 0xe6,
    0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6, 0xe6,
    0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x86, 0x6e, 0x6e, 0x6e, 0x6e, 0x66, 0x66,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x66,
    0x66, 0x66, 0x6e, 0x6e, 0x6e, 0x6e, 0x6e, 0x66,
    0x60, 0x00, 0x88, 0x88, 0x88, 0x88, 0x88, 0x80,
    0x00, 0x06, 0x66, 0xe6, 0xe6, 0xe6, 0x66, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x66, 0x66, 0x66, 0x66, 0xe6, 0xe6, 0x66,
    0x88, 0x88, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08,
    0x88, 0x86, 0x66, 0x6e, 0x6e, 0x66, 0x60, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x06, 0x66, 0x66, 0x66, 0x66,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x06, 0x66, 0x66, 0x66, 0x66, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x06, 0x66, 0x66, 0x60,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x66, 0x66, 0x66, 0x60, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
};

#endif /* !__HAVE_ARCH_LINUX_LOGO16 */

#else /* !INCLUDE_LINUX_LOGO_DATA */

/* prototypes only */
extern unsigned char linux_logo_red[];
extern unsigned char linux_logo_green[];
extern unsigned char linux_logo_blue[];
extern unsigned char linux_logo[];
extern unsigned char linux_logo_bw[];
extern unsigned char linux_logo16[];

#endif /* !INCLUDE_LINUX_LOGO_DATA */

