#if defined(CONFIG_SUPERMOUNT) || defined(CONFIG_SUPERMOUNT_MODULE)

static inline int
supermount_usage_count(kdev_t dev, int count)
{
	struct super_block *sb = get_super(dev);

	if (sb) {
		if (count > 0 && sb->s_flags & MS_SUPERMOUNTED)
			count--;
		drop_super(sb);
	}

	return count;
}

static inline int
dev_is_supermounted(kdev_t dev)
{
	int rc = 0;
	struct super_block *sb = get_super(dev);

	if (sb) {
		rc = sb->s_flags & MS_SUPERMOUNTED;
		drop_super(sb);
	}

	return rc;
}

#else

static inline int
supermount_usage_count(kdev_t dev, int count)
{
	return count;
}

static inline int
dev_is_supermounted(kdev_t dev)
{
	return 0;
}

#endif /* SUPERMOUNT */
